// C Source File
// Created 2/3/2013; 4:41:31 AM
/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"


int object_list2[obj_list_size][obj_stat_size];

int object_ammount=0;

inline int get_object(int a, int b)
{

	if ((a<0) || (b<0) || (a>=obj_list_size) || (b>=obj_stat_size)) {return -6666;}
	return object_list2[a][b];
}// end get object

//============================================================================================


inline void set_object(int a, int b, int num)// use in place of mod_object()
{

	if ((a<0) || (b<0) || (a>=obj_list_size) || (b>=obj_stat_size)){return;}
		object_list2[a][b]=chk_num(num);
}// end get object

//============================================================================================


void increase_object(int a, int b, int num)
{// this was added b/c i didnt want to call 2 routines to do an object_list[a][b]++;
	if ((a<0) || (b<0) || (a>=obj_list_size) || (b>=obj_stat_size))
	{return;}// dont do anything if out of bounds
	num+=object_list2[a][b];
		object_list2[a][b]=chk_num(num);
}// end increase object
//============================================================================================

void obj_dir_set(int loc, int speed, int dir)
{
	
	if (dir==dir_return){qslope2(loc, speed, link_stat(inv_link_x)+8, link_stat(inv_link_y)+8, OBJECT);return;}
	//set_object(loc,obj_dir, dir);
	int dx=0, dy=0;
	switch (dir)
	{// make it move.
		case up: 		dy= speed*(-1); break;
		case down:	dy= speed;  	 	break;
		case left: 	dx= speed*(-1); break;
		case right: dx= speed;			break;
	}// end switch dir
		set_obj_speed(loc, dx, dy);
		//set_object(loc,obj_speed_x, dx);
		//set_object(loc,obj_speed_y, dy);
		set_object(loc,obj_dir, dir);
}
/*int fast_obj_move(int loc, int speed, int dir)
{
		int d1=obj_y, d2=obj_x;
	switch (dir)
	{// make it move.
		case up: speed= speed*(-1);
		case down: // d1=obj_y; d2=obj_x;
		break;
		case left: speed= speed*(-1);
		case right: d1=obj_x; d2=obj_y;
		break;
	}// end switch dir
	
		increase_object(loc, d1, speed);
		return d2;
}


int move_diag(int loc, int dir)
{

	int diag_dir=left, angle=0;//, dir2=0;

	switch (dir)
	{
		
			case up_30_left ... right_30_left:
					dir-=10; diag_dir=left; angle=2;
			break;
			case up_30_right ... right_30_right:
					dir-=20; diag_dir=right; angle=2;
			break;
			case up_45_left ... right_45_left:
					dir-=30; diag_dir=left; angle=5;
			break;
			case up_45_right ... right_45_right:
					dir-=40; diag_dir=right; angle=5;
			break;		
			default: return 0;
	}
		

		if (dir==left){	if (diag_dir==left){diag_dir=down;}else {diag_dir=up;}}
		if (dir==right){	if (diag_dir==right){diag_dir=up;}else {diag_dir=down;}}

		int d2=fast_obj_move(loc, angle, diag_dir);
		if (get_object(loc,obj_type)==arrow_foe_diagnal){increase_object(loc, d2, get_object(loc,obj_var2));}
	
		return dir;

}

void mv_object_old(int loc, int speed, int dir)
{// 36964 ->36944
//obj_num, obj_x, obj_y, obj_frame, obj_dir, obj_var1, obj_var2, obj_dam,obj_type
	if ((loc<0) || (loc>=obj_list_size)){return;}

		if (!((dir>=up) && (dir<=right))){dir=move_diag(loc, dir);}
		fast_obj_move(loc, speed, dir);


		int y=get_object(loc,obj_y);
		int x=get_object(loc,obj_x);
	//	int exec=FALSE;	
		if (x>object_x_max_oob){set_object(loc, obj_x, object_x_max_oob);}//exec=TRUE;}
		if (x<object_x_min_oob){set_object(loc, obj_x, object_x_min_oob);}//exec=TRUE;}
		if (y>object_y_max_oob){set_object(loc, obj_y, object_y_max_oob);}//exec=TRUE;}
		if (y<object_y_min_oob){set_object(loc, obj_y, object_y_min_oob);}//exec=TRUE;}
	//	if (exec){if (get_object(loc, obj_type)==spike)
		//					{set_object(loc,obj_dir, opposite_dir(dir));set_object(loc,obj_var1, 3);}}	
}// end move object*/
//============================================================================================

// 63325 ->63495 = 170 + 75 = 245 bytes for new move
void mv_object2(int loc)
{// 36964 ->36944
//obj_num, obj_x, obj_y, obj_frame, obj_dir, obj_var1, obj_var2, obj_dam,obj_type
	if ((loc<0) || (loc>=obj_list_size)){return;}

		increase_object(loc, obj_y, get_object(loc,obj_speed_y));
		increase_object(loc, obj_x, get_object(loc,obj_speed_x));

/*
		for all the new dir stuff, forget the object dir.
		just get obj_x/y and add obj_speed_x/y to both - always
		when the object is first initted, do the calcs for obj_speed_x/y
			- use the lrud switch to calculate and add the speeds
				- of up, then obj_speed_y= -4, obj_speed_x=0
					...
				- if diag, then obj_speed_x=4, obj_speed_y= qslope
				
				- also, mod the arrow_diagnal, to be arrow_at_link, based upon qslope of obj start and 
						link_x/y+8
*/
		int y=get_object(loc,obj_y);
		int x=get_object(loc,obj_x);
	//	int exec=FALSE;	
		if (x>object_x_max_oob){set_object(loc, obj_x, object_x_max_oob);}//exec=TRUE;}
		if (x<object_x_min_oob){set_object(loc, obj_x, object_x_min_oob);}//exec=TRUE;}
		if (y>object_y_max_oob){set_object(loc, obj_y, object_y_max_oob);}//exec=TRUE;}
		if (y<object_y_min_oob){set_object(loc, obj_y, object_y_min_oob);}//exec=TRUE;}
	//	if (exec){if (get_object(loc, obj_type)==spike)
		//					{set_object(loc,obj_dir, opposite_dir(dir));set_object(loc,obj_var1, 3);}}	
}// end move object


//============================================================================================
/*
void qslope(int loc, int speed, int lx, int ly)
{
	int ox=get_object(loc,obj_x), oy=get_object(loc,obj_y),s3=speed,s2=0;
//	if (ox>lx){s2=speed*-1;}
//	set_object(loc,obj_speed_x, s2);
	if (speed==0){goto skip;}
	if ((s2=(lx-ox))==0){s2=speed; s3=0; goto skip;};
	
	s2=((int)(s2 / speed));
	if (s2==0){s2=1;}//{goto skip;}
	if (s2<0){s2=s2*-1;}
	s2=((int)((ly-oy) / s2));
	if (s2>0 && s2>speed){s2=speed;}
	else if (s2<0 && s2<(speed*-1)){s2=speed*-1;}
	skip:
	
	if (ox>lx){s3=s3*-1;}
	set_object(loc,obj_speed_x, s3);
	if (oy>ly && s2>0){s2=s2*-1;}
	set_object(loc,obj_speed_y, s2);
}*/



//============================================================================================



void qslope2(int loc, int speed, int lx, int ly, int who)
{
	//qslope = (ly-oy) / abs((lx -ox)/speed)
	
	int ox=0, oy=0,sx=speed,sy=0;
	if (who==MOB){ox=get_mob_stat(loc,mob_x); oy=get_mob_stat(loc,mob_y);}
	else{ox=get_object(loc,obj_x); oy=get_object(loc,obj_y);}


	if (speed==0){goto skip;}
	if ((sy=(lx-ox))==0){sy=speed; sx=0; goto skip;};
	
	sy=((int)(sy / speed));
	if (sy==0){sy=1;}
	if (sy<0){sy=sy*-1;}
	sy=((int)((ly-oy) / sy));
	if (sy>0 && sy>speed){sy=speed;}
	else if (sy<0 && sy<(speed*-1)){sy=speed*-1;}
	
	skip:
	
	if (ox>lx){sx=sx*-1;}
	if (oy>ly && sy>0){sy=sy*-1;}
	
	if (who==MOB){mod_mob(loc,mob_x, sx, FALSE);mod_mob(loc,mob_y, sy, FALSE);}
	else {set_obj_speed(loc, sx, sy);}
	
}// end qslope2



//============================================================================================
void set_obj_speed(int loc, int x, int y)
{
	set_object(loc,obj_speed_x, x);
	set_object(loc,obj_speed_y, y);
}

/*void qlsope_to_link(int loc, int speed)
{//set the coordinates to follow link
	qslope(loc, speed, link_stat(inv_link_x)+8, link_stat(inv_link_y)+8);


}*/


//============================================================================================

/*
void roman_candle(int loc, int speed)
{// the oject will follow link
		
		
			int dir=left, old_speed=speed;
			int ox=get_object(loc,obj_x), oy=get_object(loc,obj_y), lx=link_stat(inv_link_x), ly=link_stat(inv_link_y);
			
			if (ox > lx){if ((ox-lx)<speed){speed=(ox-lx);}}
			else if (ox < lx)	{if ((lx-ox)<speed){speed=(lx-ox);}dir=right;}		
			if (ox != lx){set_object(loc,obj_dir, dir); mv_object( loc, speed, dir);}
			
			speed=old_speed;  // had problems when the above changed the speed to 0, then the below failed to move, so reset
			
			if (oy > ly){if ((oy-ly)<speed){speed=(oy-ly);}dir=up;}
			else if (oy < ly)	{if ((ly-oy)<speed){speed=(ly-oy);}dir=down;}

			if (oy != ly){set_object(loc,obj_dir, dir); mv_object( loc, speed, dir);}
			
			set_object(loc,obj_dir, dir_return);// reset it to dir_return, otherwise it does strange things...

}*/
//============================================================================================


void move_object(int loc, int speed, int dir)//object_list[loc][obj_dir]
{// 36964 ->36944
//obj_num, obj_x, obj_y, obj_frame, obj_dir, obj_var1, obj_var2, obj_dam,obj_type
//	if (dir==dir_return){roman_candle(loc, speed);}
//	else {mv_object(loc, speed, dir);}
	
	if (dir==dir_return){qslope2(loc, speed, link_stat(inv_link_x)+8, link_stat(inv_link_y)+8, OBJECT);}
	mv_object2(loc);
	
}// end move object

//============================================================================================
int duplicate_checker(int obj, int x, int y)//42979
{// this will check for duplicate items being added
	int i=0;
	while (i<obj_list_size){
		if ((x<=get_object(i,obj_x)+3 && x>=get_object(i,obj_x)-3)
				&& (y<=get_object(i,obj_y)+5 && y>=get_object(i,obj_y)-5))
				{// return that there is a duplicate of the exact same item in the vacinity.
					if (get_object(i,obj_num)==obj) {return TRUE;}
				}
				i++;
	}// end while
	return FALSE;
}

//============================================================================================
// 61861 ->61883 = 22 bytes. ->61789
int add_object(int object_number, int object_x, int object_y, int item)
{
//	printf("\nobj=%i, %i %i",object_number, object_x, object_y);wait_for_key(b_ko);
	int loc=0, pic=0;
	if (object_number<=0){return 555;}// this should prevent shadows from being added to the list.
	if (duplicate_checker(object_number,object_x, object_y)){return 555;}

	int h=0,w=0, typ=0;
	if ((loc = obj_loc(-1))!=555){// if you find a place, then insert
	

	object_ammount++;
	set_object(loc, obj_num, object_number);
	set_object(loc, obj_x, object_x); 
	set_object(loc, obj_y, object_y); 
	set_object(loc, obj_frame, 0);
	set_object(loc, obj_rotate, 0);
	set_object(loc, obj_draw_type, A_NORMAL);
	//set_object(loc, item_x_whitespace, 
			if (item>999){
				switch (item)
				{
					case item_fire:
						h=14;w=14;
						typ=fire;
					//	set_object(loc, obj_type, fire);
						set_object(loc, obj_dam, 4);
						pic=item_fire_pic;
					break;
					case item_leaf:
							//h=0;w=0;  
							//set_object(loc, obj_type, leaf);
							typ=leaf;
							pic=item_leaf_pic;
					break;
					case item_crystal_leaf:
							//h=0;w=0;  
							//set_object(loc, obj_type, leaf);
							typ=leaf;
							pic=item_crystal_leaf_pic;
					break;
					case item_shatter:
							//h=0;w=0;  
							//set_object(loc, obj_type, shatter);
							typ=shatter;
							pic=item_shatter_pic;
					break;
					case item_poof:
							//h=0;w=0;  
							//set_object(loc, obj_type, mob_poof);
							typ=mob_poof;
							pic=item_poof_pic;
					break;
					case item_bomb_explode:// has special x/y coords.  you will pass in the obj loc of the bomb via object_x
							w=32; h=32;
							pic=item_bomb_explode_pic;
							typ=explosion;
							//set_object(loc, obj_type, explosion);
							set_object(loc,obj_x, fix_xy(get_object(object_x,obj_x)-8,1));
							set_object(loc,obj_y, fix_xy(get_object(object_x,obj_y)-8,2));
					break;
					case item_wand_ammo:
							h=14;w=14;
							pic=item_wand_ammo_pic;
							//set_object(loc, obj_type, wand);
							typ=wand;
					break;
						
					default:
						h=get_item_info(item, item_H);
						w=get_item_info(item, item_W);
						pic=get_item_info(item, item_pic_id);
						typ=get_item_info(item,item_type);
						//set_object(loc, obj_type, get_item_info(item,item_type));
					break;
					
				}// end switch
				set_object(loc, obj_pic, pic);
				set_object(loc, obj_type, typ);
			}// end if item>999
//63419
			else 
			{
				switch (object_number)
					{
				//		case HEART1:	 h=6;  w=6;		break;
				//		case CRYSTAL1: h=12; w=6;		break;
				//		case BOMB2: 	 h=6;  w=6;		break;
				//		case ARROW2:   h=14; w=6;		break;
						case 500 ... 599:		h=w=16;	
							if (item_hookshot_chain==object_number)
							{set_object(loc, obj_pic, item_hookshot_chain-500);set_object(loc, obj_type, item_hookshot_chain);}
						
						break;
					}// end switch	
					
			}// end else
					set_object(loc, item_H,h);
					set_object(loc, item_W,w);
	}
	return loc;
}//and add object
//============================================================================================

int obj_loc(int id)
{
	int i=0;
	while (i<obj_list_size){if (get_object(i,obj_num) == id){return i;} i++;}// end while
	return 555;
}// find an object location
//============================================================================================


void clr_object()
{
	int i=0;
	while (i<obj_list_size){delete_obj(i);i++;}// end while
	object_ammount=0;
}// end clr object
//============================================================================================

void delete_obj(int loc)
{

	if ((loc<0) || (loc>=obj_list_size)){return;}// to prevent out of bounds errors.
	object_ammount--;
	int i=0;
	while (i<obj_stat_size){set_object(loc,i,-1);i++;}//object_list[loc][i] = -1; i++;}
	
}


//============================================================================================

int num_of_objects(){return object_ammount;}
/*{
	int i=0,k=0;
	while (i<obj_list_size){if (get_object(i,obj_num) >= 0){k++;}; i++;}
	return k;
}*/

//int num_of_atk_objects(){return object_ammount;}
/*{
	int i=0,k=0, typ=0;
	while (i<obj_list_size){if (get_object(i,obj_num) >= 0)
	{typ=get_object(i,obj_type);
	if (mob_weaps || (typ==boomerang) || (typ==arrow)) {k++;}}; i++;}
	return k;
}*/

//============================================================================================


int game_speed()
{
	int i=(250-((object_ammount+num_of_mobs())*15));
	if (i<0){i=0;}
	return i;
}//end game speed


