// C Source File
// Created 3/5/2015; 10:10:54 PM

#include <tigcclib.h>
#include "all.h"
extern int link_frame, link_direction, link_picture;

//============================================================================================


void animate_mob_weapons(int loc)
{
		//int dir=get_object(loc,obj_dir), spd=3;
		int dir=0, spd=3;
		switch (get_object(loc,obj_type))
		{
		//	case arrow_foe:
		//	case arrow_foe_rotate: spd=5;
			//	move_object( loc, 5, dir);
		//	break;
		//	case arrow_foe_multi_3:
		//	case arrow_foe_multi_5:
		//	case arrow_foe_diagnal:
			//	obj_move_diag(loc, 3);
			//	move_object( loc, 3, dir);
				// have it move in the normal direction, then just + or - the "y" loc as you move normally.
	//		break;
			case arrow_foe_rotate_follow:
			case arrow_foe_follow: spd=2; dir=dir_return;
			//	move_object( loc, 2, dir_return);
			break;
		}
		move_object( loc, spd, dir);

}// end animate mob weapons

//============================================================================================



void animate_mob_death(int loc) // the replacement for animate_explode
{
			int frame=get_object(loc, obj_frame);
				if ((frame==5) || (frame==10)){increase_object(loc, obj_pic, 1);}
				if (frame>15){set_object(loc, obj_frame, 200);}

}// end animate mob death

//============================================================================================


void animate_boom_bomb(int loc)
{
	
	int frame=get_object(loc,obj_frame);
	if (frame>35){obj_blink(loc,FALSE);}
	if (frame>53)
	{
		set_object(loc, obj_frame, 200);
		add_object(item_bomb_explode, loc,  loc,item_bomb_explode);
		terrain_wipe(link_loc(get_object(loc, obj_x)), link_loc(get_object(loc, obj_y)), 4);

	}//
	
	
}// end animate boom bomb


//============================================================================================


void terrain_wipe(int x, int y, int spaces)
{
	int i=0, k=0, i_max=0, k_max=0;
	i_max=k_max=(spaces/2);
	for (i=0;i<i_max;i++){for (k=0;k<k_max;k++){slash_terrain(y+i, x+k);}}
	
}// end terrain wipe


//============================================================================================


void animate_hookshot(int loc)// uses terrain contact
{

			int x=get_object(loc,obj_x);
			int y=get_object(loc,obj_y);
			int dir=get_object(loc,obj_dir);
			 mod_link(state,LINK_STUN,TRUE);
			 mod_link(dual_state,LINK_HOOKSHOT,TRUE);
			 link_frame=0;
			
				mod_link(link_rand_var1,-1,TRUE);
			 
			 switch (get_object(loc, obj_var1))
			 {
			 	case 33:
			 			mod_link(link_rand_var1,-33,TRUE);
					 	link_direction=dir;
						//link_picture=13;
					 	move_link(5);
						//link_direction=up;
						
			 	break;
			 	case 100: 
			 			obj_dir_set(loc, 5, opposite_dir(dir)); 
			 			set_object(loc, obj_var1, 101);
			 	break;
			 	case 101:break;
			 	default:
		 				if (get_object(loc,obj_frame)%2==0){// add the chain
							add_object(item_hookshot_chain, x, y,item_hookshot_chain);//this will add the chain
						}// end if frame is >=1
				
						if (touching_sprite_range(x, y,185, 191,FALSE))
						{
						/*
								WARNING    WARNING    WARNING    WARNING    WARNING    
								if you modify the 194 and 195 numbers then you will have to change them in the terrain_contact() routine as
								well.  i had to add in an exception that uses these numbers.  if you dont change them in both places then
								the hookshot will stop working right.  refer to "notes 	* 11/22/13 *"  for more info. - changed 194 to 191 due 
								to the fact that i added in bombable walls
						
						*/
								x=-2;
								if (dir==up || dir==left){x=2;}
								set_obj_opposite_dir(loc, x);
								move_object( loc, 0,0);
								
								set_object(loc, obj_var1, 33);
								obj_dir_set(loc, 0, dir);
						}// end if touching terrain						
			 	break;		
			 	
			 }
			 


}// end animate hookshot





void animate_throw_object(int loc)
{// 844,  - saved close to 300 bytes
	
	
	increase_object(loc, obj_var1, 1);
	int v1=	get_object(loc, obj_var1);
	int dir=get_object(loc, obj_dir);	

	if (v1<=8)// move the object
	{
		if (dir==right || dir==left){	if (v1==5){set_object(loc, obj_speed_y,4);}}
		move_object(loc,0,0);
		
	}// end if rand var1<=8
	
	int x=get_object(loc,obj_x);
	int y=get_object(loc,obj_y);
	

	obj_quickdraw(x, fix_row_gain(y+16-(v1)), 0, A_NORMAL, 0);
	
	if (get_object(loc,obj_type)==flying_bomb){

		int set=0;
		if (x<2){set_object(loc, obj_x ,6);set=TRUE;}
		else if (x >=144){set_object(loc, obj_x ,138);set=TRUE;}
		if (y<2) {set_object(loc, obj_y ,6);set=TRUE;}
		else if (y>=112 ){set_object(loc, obj_y ,106);set=TRUE;}
		if ((set) || (v1>8)){set_object(loc,obj_type, boom_bomb);return;}

	}// end if a bomb
	
	
		if (x<2 || x >=144 || y<2 || y>=112 || v1>8 )
			{
				add_object(item_shatter, x, y,item_shatter);
				drop_item(x, y,-1);
			 	delete_obj(loc);
			}
			
			
}//end animate throw object