// C Source File
// Created 2/3/2013; 1:32:54 AM

#include <tigcclib.h>
/* 135 zzp

		info about redoing this odd thingie
		file structure:
			maps - contains the maps of the world & dungeon 9(16x16) & the 8 other dungeons (8x8)
			rooms - holds the rooms
			main - holds zelda
			items - holds the item list
			gfx - holds the gfx files
		sav - holds the save files and inv[][]
			sl - stoyline files
			msg - for the messages files
			
		map info: the maping system will be redone similar to afw, but will be a bit different.
			- the main maps will simply lay out the rooms.  
			- the room maps will be 8x10.  all of them, but will probably will need an extra row or
				2 to symbolize sl files, mob list for room - no exit points needed, the main map will determine which
				room to goto next, warp points to warp to different map
			the mapping system will get the current room that you are in and then get the n,s,w,e rooms
			to that room and load them.  it will load the main room first along with mobs.  then will
			load the other rooms in sequiental order within the main loop (at seperate times) to make sure
			that there is next to no lagg.  the room that you goto will instantly transfer from the internal
			list to the current list.
			
			there exists and error though.  the mobs would repop instantly.  this could be a problem.
			not unless you wanted to create 8x8 maps that load everything all at once., but this rivals
			afw in size. (5120 bits to do this - just for gfx, doesnt include 2 extra lines per area 
				for extra.)  not unless you want to load a 4x4 area into mem. - you need to keep the loading
					very low to make sure you do not use dlls.
					
					
		arrays needed:
				light gfx array   300x16?   (134 gfxs already for main world.)
				dark gfx array - same size as light
				mask gfx array
				mobs list - for stats of mobs and how many mobs there are (you maxed out 60 for afw) - need
					a 64x16 list.
				mob gfx light list - 
				mob gfx dark list
				mob gfx mask list
				weapon list (would tell what the weapons do. - should not be too big. only a few weaps in zelda)
				save list
				shop item list.
				
				
				world map array [16][16] - this will be used for the world map as well as 4 dungeons per map
						so a total of 4 world maps needed, b/c 16x16 = 4 8x8.  and one big map for dungeon 9
				area array.  - this could be used to load a 4x4 area at once. (1300 bits?)	
					load a total of 64 mobs? - b/c a max of 4 mobs per room and 16 rooms loaded...
					- mobs need hp, damamge dealt, special (such as shooting objects or other incoded things)
						(other things include - take or destroy shield, chicken attack, move under sand, invis)
						, mob id, mob x, mob y, mob room id, 	immunity (such as immune attack b/c of shield when you
																												face the shield, or arrow type, immune stun)
						, dir facing (used for the correct sprite and for immunity), stun / mobile (for if they
							get hit by the boomerang, you dont want them to move if hit by it.), sets of pics
					(sets of pics, is the number of pics needed in order to animate the mob.  the number
						would range from 1 to 8. usually it should be a minimum of 2, just to properly animate
						the mob.  this will help determine how many pics to cycle through when animating the mob.)
						, mob pic # (you will have to make the mob sprites into seperate files and there will
						be 64 sprites loaded into an array, so the number would be between 0 and 63),
						defence (defence would be used to reduce the damage made by X hp. for example, lets
						say the wooden arrow only does 4 damage and you set the defence to 4 then the wooden 
						arrow would do 0 damamge.  this would be good to use with gannon, so only the silver
						arrow would hurt him. 
						
						
				- looking at at least 10 sections in the array per mob, but might need 15.  if 64 mobs, then
					you could assume around 1k for mob stats.
				
				- you need at most about 8 different pics per mob.  at least 2.  then you need 3 arrays, each 
				for the light,dark, and mask.  so if you assume 4 different mobs, you would need at least 24 pics
				- use an array for 64 different pics, to allow for at least 8 differnet mobs. 
					(about 3k would be needed for the gfx on these 3 arrays.  1k per array}
					 - use the afw collision tester to find out if the mobs collided.
						
						
				if you do use the 4x4 setup, then you will need to put the room  number into a certain place in 
				the last row of the array, so it knows to access it or delete it. it would scan through the 16 
				arrays and find out which one to use and then display it.  maybe use a 3d array, just to be
				simplistic, so you dont have to use 16 different arrays for it - that would be a pain and would
				actually take up more code just to do it.  remember it goes array[16][8][10] where 16 is the
				num of rooms for the 4x4 section, 8 is for the rows, 10 is for the collumns. it might need to be
				[16][10][10].  that would give you 20 spaces for added info and maybe make [x][9][0]=room number
				loop through that list to find the correct room number to obtain [x] and then use [x] to make
				modifications.
				when you travel to a new room, you will need to obtain the 4 rooms n,s,e, or w of what you have
				already achieved.  although a 4x4 setup might be a bit annoying to do, b/c you will not have
				a center room.  it will be offset by 2 on the n/w, or e/n, or s/w, or s/e.  if you have a 3x3
				setup, then you could always have the center location as the current room. 
				
				if you loaded a full 8x8 section, then it would load an entire map at a time.  this could be useful
				assuming that you make your world maps the size of 8x8 and not 16x16.  if they were 16x16 then
				obtaining the correct algo to do it would be nearly impossible, b/c you could set the map up
				in any random combination; thus, making it impossible to figure out what to load.  afw loads up
				a map that is similar in size.  the only problem i have is the simple fact that i may not have
				the memory in the calculator to do such a thing, not if i do not want to use the dll patch.
				also, using too much memory may prevent the greyscale from loading correctly.
				
				also, the problem that remains is the creatures.  you could keep the 64 creature list.  when
				you enter that room, check to see if any mobs for that room are in the creature list.  if they
				are, then place them on the map.  if not, then check the current room and see if a creature list
				for that room exists.  if it does, then load it.
				
				there exists a problem.  you do not have the mob gfx synced with the mob list.  actually, it 
				does not really know which mob pics to load.  you will actually need a 3d array for the mob
				gfx list.  -sigh-  the first collumn would be the id of the mob pic.  actually... you may not
				be able to make it work correctly with a 3d array.  you might actually need 2 arrays, 1 for
				the gfx while the other is a list, which keeps the ID synced with the row on the gfx array.
				
				
				ok here is a solution type:  you have a spot on the room arr[] that signifies which gfx
				file to use for the mobs in the room.  you have ceck run to see if mob_gfx matches the gfx
				file that the room wants to use.  if so, then do nothing.  if they are different, then load
				the new gfx file (this is fast b/c it is only about 1k in size.)  then do a check to see
				if the monsters are loaded in the monster list 

			hp will be based off of 128.  each heart will represent 8 hp.  half a heart is 4 hp.
			blue ring will reduce dmg by half.  red ring will reduce by 75%   

			weapons - id, type, damamge
					- type would be sword, master_sw, arrow, bomb, boomerang, bow, hookshot, 
							- as for each type, hard code in functionality.  
							- let the boomerang do damage and stun, so you could kill bats with it.
					- damage would be a small number like 4 to 12 (or so).  it removes exaclty that much hp
						from the mob whenever it hits.
			
			add in a screen that loads at the beginning, like in afw, so they can change the beginning 
			screen.
			
				
				items: id number, type, <other>, <other>
				
				
				types:
				
				ring - <damage reduction>
				
				compas - <map id> <room # to blink triforce>
							
				bottle -  <hold>  (4 bottles total)
					- 1 - red potion
					- 2 - fairy
					- 3 ???
					<scaleable>
					
				wand - <damage=8> <stun> deals master sword damage and starts a fire on the mob 
							and stuns mob, assuming that it is not immune wand/ stun
				feather - allows you to jump over holes
				hookshot - pulls mob toward you (you will need a range of gfx #s that allow you to hook
										onto it.)
				boomerang - flys over walkable - make an algo for it to follow you back.									
					
				link array:
				
				row 1 - hp, max hp, mana, max mana, gold, max_gold, loc_x, loc_y, map_id, room #
				row 2 .. 4 - items 
				row 5+ - treasure chest boxes gotten
				row ?? - triforce peices, magic?, 
					
			- other thoughts - remove the stupid mario crap in it.
			- make it so rooms can go dark, but you will need to flag the room so it will be dark until
				"torches" are lit.
				
				
			zelda will be hell to create.  ugh....  there are too many special things in it to keep it small.
			when you think about it though, you should only have to make 1 routine for each item type.
			as for your flying weapons and magic thingies, you should only have to create 1 method to make
			the item fly through the air and hit.  use the collision method to check a mob hit and if it is 
			immune to the weapon or not.  
			
			is there a way to force a sprite to rotate.  i know you can use shifting to make it go left
			or right, but to change the whole sprite.  if so, then you can use it for the boomerang.
			you should make a shift like this and force the sprite to rotate. if it doesnt take too
			much coding.  it should be as simple as adding 0x4000 to it? - not at all - this is complicated



			meh.  its like i need to recode the whole game just to make things work right.... -sigh-
			
			just remove the link_state and make it work later on.
			52891 - original size.
			43591
			43360 (with afw compile settings)
			we are looking at about 768 rooms along with ~12->14 world files.
*/




/*																			TODO LIST

	- done - first redo the map and world map into 8x8 sections.
	- done - continue with rewriting of the gfx sprite list. (most of it is planned out.)
	- done - renumber the gfx sprites
	- done - create the location_checker()
	- done - renumber the rooms
	- done - create the 4x4 room loader
	- removed - incomplete? - create the room scroller (removed 1k of code by doing it)
	- done - animate the terrain
	- removed - possibly remove the room scroller, b/c well it sucks and it goes so fast that it is
			irrelevant.
	- done - create a routine that auto creates rock objects and jar object
	- done - create a thing that auto replaces terrain with removed object - use last spot on rooms i guess.
	- go through all the code and make sure all your array access routines (like the get/set and mod_xxx) have
			out of bounds prevention code in it. - look in the .h files for the routines that you recognize and then
			change them
	----------------------------------------------------
	
	externalize the link gfx array
	- done - create the link gfx loader in the link_gfx area
	- done - add in routines to animate link in link_gfx
	- bad idea - remove old link animation routines and remove link animation in any other non specific 
		link animating routines. - works on a linier setup.  cannot do "on demand" gfx
		
	----------------------------------------------------
	externalize the mob gfx array && create the mob stats array
	- done -create the mob gfx array loader
	- done -create the mob stat array loader
	- done - create mob_list[64][x] - modded to [8][x] - load single rooms only.
	- done - create mob stat access and modification routines (2 needed)
	- add in routines that will specifically animate the mobs (mob stat access() will be needed for this)
	- remove original mob routines and remove mob stuff from other non specific routines.
	- create mob collison() - this will determine if mobs hit each other or link 
	
	----------------------------------------------------
	
	create start menu
	
	- done - create a no_save flag in the room that will allow you to save or not in that room.
	- create an inv_acess()
	- done - add in an object gfx loader
	- done - make the start menu load gfx that corresponds to the objects that are in the inventory
	- add in the following menues: main, quest, items (currently building), save, maps, settings
		* quest will shows the quest items you need to get
		* items will allow you to hold things
		* main is the main start menu that will allow you to go to other menus
		* save will call the save routine
		* maps will display the current dungeon map (will only disp if world_map = dung map (10->18)
		* settings will allow you to modify some settings like contrast, walking speed (2 or 4), 
				terrain animation speed, 
	
	----------------------------------------------------
	
	create the mapping system.
	- easy enough to do, figure it out later.  look at other comments to figure out how
		you wanted to do this. 	

you should probably put the objects gfx in the items folder. - just a thought
	- consider making a "speed" var to determine the speed that link goes (either 2 or 4) and 
			allow it to be adjusted in game.  in afw3, use this var for haste, which will either
			double you current walking speed, or add +2/4 to your speed - also have haste double
			your strokes.
			
	- done - create the warping system
	- done - create the treasure system
	- done - create the shop system
	- done - add chek_item_type_exists to sl
	- create dark room system (draw a reverse?)- might have to use 1 0xffff mask obj to make it work
		- this is partially done.  no matter what, i cold not reverse the pics.  in reality, just create
			an object or something that when fire hits it, it will light up and will disable dark_room
				- you could make this a "mob" that has a sl attached to it, so when it does get hit by fire
					it will change its gfx pic and will change the dark_room var.  also, make it invincible and
					nomove. in reality, the wand is already set up to stop when it hits the mobs, so this may not
					be a bad idea.  in order to do multiple torches to activate the room, you will somehow have to
					do a check to see which torches have been lit.  acutally, having torches as mobs is a bad idea, 
					b/c you are limited to 8 mobs.  so make it an object instead that has a sl attached to it.
					- oh make the object dissappear and then reset the floor sprite to a burning torch. - you will
					need to do a temp modify on the torch.  also, you could do a temp modify on the room_dark spec
					of the room to make it so that it will be light again, until you leave the world map.
			- i made it so that when labled as dark, it would display only black tiles, so #157 is a perm #
				for the tiles.  
	- create the locked doors
	- done - create the lifting of objects		
	- done - make fallable holes work
		
	- done - remove direct draw of terrain (not needed)
	- done - remove contrast menu and replace with f3/f5 buttons to adjust contrast	
			
	-----------------------------------------------------

		- done - addo shoot objects to creatures.
		- add in creatures bigger than 16x16, like 32x32, 16x32 and 32x16 (both diagonally and horizontally)
		- done - create bombs
		- done - create the wand
		- done - create bow and arrow 
		- create lift bracer
		- create boat/swimming gear
		- done - put shadow under link when standing in water
		- done - add arrows and bombs to random drop
		- done - create hookshot
		- test no_save - has issues... needs to display "cannot save here"
		- add the following item types: bottle, bomb bag, wallet, rock, boulder, push_stone
				lift_bracer/gauntlets, feather, boots?, tunic, ring?,
				- i will probably cancel the lift_bracer and just make them gauntlets/silver gauntlets
						like in zelda 64.  if you wanted to, you could do a check with the 2nd button 
						and if true, then execute msg, else if true lift/throw item, else use item.	
		- with lifting things, create a dual state.  the first state is your normal state.  the 2nd
					state will determine whether you are holding/lifting or throwing the object.
					it could also be used to use an item while walking. in the weapon section, adjust the
					routines to check to see if you are walking. if so, then set the 2nd state.  in the
					walk_state, check to see if a second state is active. if so, then execute that 2nd state.
					you could probably do away with the other 1st states, like slash, arrow, boomerang, and
					put all of those under a seperate routine and make them work either under normal_state or
					walking state (ie call teh routine under those cases.
					- for the dual state, with push, just keep it as a main state to avoid problems.
			- create a link hold state, where he is facing you, while holding the item.  have link stay
					that way for like 10 loops or something. (this state will be used for treasure chests and 
					buying items)
			- maybe attach a sl or goto to items.  this would be used for switches that make random parts of 
					the room replace themselves with other things.  for instance: hit the object and change all of
					the sprites that ==77 to 4. or something like that.  make it obj type switch and use var1 and
					var2 as the sl indicators on which sl to load and what section of code the execute (mabe use
					code marker 5000<>6000 for the markers.  then pull that sl and execute.  use obj_dam as the
					sl_file_id and var1 as the start poin and var2 as the end point.  only execute when damage by
					an object is done to it.
			- add the check to see if there is a non moveable item, like type rock, boulder, or push_stone
					object in the way of link. if so, then dont move, not unless type==push_stone and link state
					== push.  if you do push the object, then set var1 to "5".  make sure to check for that
					to see if it has numer "5" first and if it does, then dont move, else if it doesnt, then 
					move the object in a simple direction, but only 16 spaces.  once it goes that far, set the
					number to "5"
			
			- fixed - with the mobs, they do have collission testing against link.  it is when you updated the towns
					people and made it so that they cannot walk on you.  just make it so that it only checks for
					towns_people and not all types, b/c you are having mobs that get close to link and cannot move
					away; thus, causing link to die quickly.
			- with lifting objects:
					- change the object type to lifted/held.  make this item x=link_x and y=link_y-16  then draw the object
						- have the object follow you w/o bounds. 
						- make sure the object is not "gotten"
						- when you throw the object, change it to type "thrown" and have the object travel in an arch like
								fassion. (have x increase +3 for 5 loops, then adjust x and y for another 5 loops, both at +3)
								- do checking to see if it hits a mob or reaches the edge of the screen.  once it does
								then make it go boom.  once it does finish its 10 cycles, make it go boom.
								- make it do 4 damage.
								- use the same routines for bombs, but dont make them go boom.
								- you might need to change the thing to +4 for 4 loops each.
								- with bombs, once the cycles end, you will need to change the obj_type back to type bomb.
	-----------------------------------------------------
		
		DARK ROOMS:
		- with the dark rooms, you have 2 choices:  
			1) you can make it like the first zelda and run a check when the fire routine begins.  if it finds
					a dark room, then disable it.  this would be equivilant to just using the candle in any place 
					in the room (like in zelda 1) and have the room lit up.
					
			2) you can make objects that are torch stands.  when you hit one of these with fire, the fire stops and the
					torch stand will dissappear and display a lit torch. (you could have to modify the dark room check in
					the room drawing routine(s) to exempt the lit torch.)  then you would have to modify a counter on
					the room arr[][] which would keep track of how many torches you need to light.
						- with the lit torches, you have 2 choices... either you can keep a global var to see how many lit
							torches you have done and then compare it to how many needs to be lit or you can use 2 vars in the 
							room arr[][] - 1 for how many need to be lit and the second for how many have been lit.  if you use
							this, then it will keep track that the room has already been lit and does not need to be lit again.
							also, you could possibly use these same 2 vars to open secret doors and the other to open a dark room.
							however, in order to tell the difference between the 2, you will need some sort of special way to do this.
							either, you can secify this by doing a check to see if it is a dark room, or you can do this by
							using a 3rd var which will tell you which it is.  actually, using the dark room var and using 0 for normal
							room, 1 for dark room, 2 for open door, 3 for secret chest, 4 for secret stair way, etc.   then use the
							torch stand objects to increase the counter on the room.  then when the counter reaches full, it will 
							run a special routine that will check the current mod number and if it is dark room, then return the room to 
							normal, if it is for anything else, then execute a special line of code in the sl that will add or remove
							what needs to be added/removed.  set aside section 32000 to 32001 for this. in the sl.  that section of the
							sl should already be loaded at that time, so you should not have to load a new sl.  actually, you dont really
							have to use the numbers 2,3,4,5...  you can just use the #2 and have that number execute the sl.  it would allow
							for you to load other things like keys, hearts, special weapons, etc. as well.
					- i do beleive that it has been decided.  use 2 more vars in the room to decide if the torches have been lit.
	
	
	-----------------------------------------------------
				story line mods:
				
				- after all of the mobs have been killed, execute sl 31000 to 31001.  this will allow you to set and remove
					doors or special items.
				- look at the sl mod for 32000 in the dark room section.
				- added - check to see if roomx and roomy are correct. #201
				- add in a section that will activate and deactivate tradmills - actually, is this really needed, b/c you already
						have a gfx section for this pre defined.  you could just use this section to perform the treadmil action.
	-----------------------------------------------------	
			tradmills - 
				- this is an area on the ground where it forces link to move in a certain direction.
					- it will use the 4 walkable areas.  - starting at animation area 66.  these will lead link to whatever area
						they are set up to lead him.  it will not do a check to see if you are out of water mode, so it should continue
						to show the raft even after you enter onto it.  it will not do a check to force water mode, so make sure you put
						in a section of normal water before you hit this.
					
	
	-----------------------------------------------------	
			todo before next release:
				- done - imp treadmills
				- done - imp dungeon gfx
				- done / broke... -mod dark rooms and expand functionallity
						- technically, you could remove the torches lit and torches to be lit
							from the room info and just make them into global vars.
						- also, the wand takes a long time to light the torches. 
				- done - add in doors to dungeons
						- put into the door creation as: door that opens when all mobs are killed
							door that requires key
							door that requires boss key.
				- done - add in push stones.			
				- redesigned - add in sl where doors unlock and item drops work
				- done - add in treasure chest workings
				- broken - create a basic dungeon and link it.
				- done - add in beginning screen
				- no -add in saving screen?
				- done - add ability for link name?
				- add in chicken attack and give it to a "boss"
				- scrapped - add in jump and the jump feather?
				- done - tweak the terrain_checker() to allow link to move closer to objects on up, and l/r.
				- done - make the messages look better.
				- done - add silver gauntlets
					- may need to increase item gfx size to allow for more objects, especially the quest gfx.
				modding the map editor:
					- the crtl+s does not save the world info.  it only saves the map itself. - fix it
					- add in a section to convert to the arr[64][10][10];  this will make things easier for you.
						- look at the room_saver.c for more info. on how to make the 2d world[][] into a liniar room[][][]
					
	-----------------------------------------------------	
		finished - locked doors:(all the below is old ideas.  it no longer applies)
			consider this:
				- create arr[4]
				- it will be arranged like binary with each spot having either a 1 or a 0.  you can have up to 4 locked doors
					per room, so each spot in arr[] would let me know if the door is still locked (0) or if it is opened (1).
				- with the room arr[][], you will need to use one spot for this number, so the number will have the max of 1111 in 
					size.  1000 is for do0r #1.  100 is for door #2. 10 is for door #3. 1 is for door 4.  so if you have 1001, then
					doors 1 and 4 are unlocked while the rest of them are locked.
				- when trying to figure out if the door is locked, do the following:
					if doors_unlocked>=1000, arr[0]=1; doors_unlocked-=1000; else arr[0]=0;
					if doors_unloced>=100, arr[1]=1; doors_unlocked-=100; else arr[1]=0;
					... etc.
				- when retrieveing do the following: doors_unlocked=arr[0]*1000+arr[1]*100+arr[2]*10+arr[3];
						- do this when you leave the room.
				- when you load the room, you will pull the doors sl and run through it.  in the add_door()
						you will need to do a check to see if arr[x]==0.  if so, then add the door.  if not, then
						fail to load the door. - each door should be number from 1 to 4 so we know which door
						to associate the unlocking with.
				- when you unlock a door, automatically update arr[] with which one was unlocked.
				- when you leave the map, but before you pull the new one, retrieve the arr[] and save it into 
						room[][] and that way, it will remember which doors were unlocked while that map is loaded.
						(or until you leave that dungeon)
		
	-----------------------------------------------------	
	-----------------------------------------------------	
	-----------------------------------------------------	
		
	




	- done - create a beginning screen pic in a room file and load it in the beginning.
	- maybe figure out how to turn off greyscale in the game and still make it disp correclty - muddi.  cannot do with current 
			gfx list.  - would require different gfx list.
	- with the chicken attack, create a seperate arr[][] for it and cycle through those mobs
			when in "chicken attack" mode.
	
	
	-----------------------------------------------------
	modify these routines:
	- redo - SlashTerrain(short row, short col) - add in slashable_objects to the equ
	- deleted- void LoadRoom(int room) - this was left  behind to keep the mobs on the screen.... delete later

								BRoken stuff:
								
	- fixed - collision checking is signifigantly broken.  
				- fixed - so is the moving to new rooms...
	- fixed - mob loading is broken, probably b/c it is accessing the array out of bounds.  with the way
			the goy originally set it up, he was syncing room #s with array #'s.  well that isnt so
			anymore.							
	- fixed for now - the light plane mysteriously dissappears and only the dark plane is left, which is odd. - tends
			to happen when changing world maps.  might be an address error?
	- fixed - also, some rooms have odd sprites in them.  maybe the buffer is broken. (memory errors - fixed
			the errors- i think one of the arrays were not loading correctly.)
	- fixed- you broke animate object.  it originally kept the list w/o holes.  i am modifying it to allow
		holes.  now it doesnt display anything. - the non displaying is b/c you did not
		load the room vars?  odd huh?  whatever..  now you will always load the room vars, so
		this should not be a problem anymore.
	- fixed - the shadow "object" (probably via add object) is being added to the left corner when 
				you do a slash? - the problem was that drawobject was always being called even when there
				was no object.  adding if (itm>0){} statement fixed this problem.
	- can move needs to take into account whether the mob is type ghost or flyer to allow for any
				type of movement.  also it needs to take into account if you can move in water in the 
				event that you have item xxxx
	- fixed- when switching from inventory to the start menu, the menu gets a bit off... not sure why.
				fix it. - in the general selecting routine, i forgot to force b and a to change when
				x&y went over/under the max.  changing a/b with x/y fixed the problem.
	- fixed - the sword eventually stopps blinking after it charges too much. - this is b/c it hits the max of
			150 and thien quits stops.  i modded the thing so that once it hits 150, it resets to 50, so 
			it will have an infinite blink.
	- boomerang brings back any object.  this needs to be reduced to certain types of objects.
	- boomerang crashes the game when thrown at a mob at zero distance between link and mob
			- maybe just put in a thing in the return to not return if at place of link?
	- fixed - a shadow is added as an object i can pick up.  you should prevent this.		
============================================================

		Completed things (random)
		
		- added - spinslash and sword 8 (7-28-11) (this has been updated and modded since then)
		- added - afw message system.
		- finally removed all of his crappy headder files. *yay* :)
		- game is almost back to its original function *yay* :)
		- added hearts (fully functional)
		- added in the rotate image routine
		- added in the push state.
		- added direct draw
		- added arrows
		- added wand
		- added boomerang
		- added warping system
		- added shop system
		- added beginning screen (update this)
		- added saving capabilites
		- created dual_state for link.
		- added in the dungeon mapping system (infintly expandable) - only full dungeon map markers are limited to 10
		- added bombs.
		- added lift objects
		- added bomb to random drop
		- added hookshot
		- added numeric hearts for faster gameplay
		- added the ability for mobs to shoot objects
		- added treadmills
		- added autodetect of torches and rocks to be added to the sl
		-	made dark rooms light up when all torches are lit.
		- added start screen
		- added select link screen
		- added naming convention into it
		- added save/continue/quit screen
* 4.0* released
		- added holes
		- revamped how the game keeps track of the world and added a repop timer
		- tweaked button system
				- fixed the lifting system to be more precise and to allow for lifting when facing down.
				- made link to be able to move closer to objects.
		- added in treasure system
		- made pots liftable
		- added in mob doors to auto open when all mobs die.
		- added keys and lockable doors
		- added dungeon
*4.1b* released
		- added heart containers
		- added hover boots
		- added push stones
		- added bombable walls
		- added walkthrough walls
		- added tunic
		- added ring
		- added gauntlets
		- added bomb bag
		- added rupie bag
		- added raft
		
		
		
=================================================================================

			things to modify immeditaly
			
			- fix the part where items do not "fire" when on the far left and right side
			
			- when adding in the random shoot objects from the mobs, create an arrow_foe type.  this will be used to check
			to see if the arrow is hitting link or not, but deal no damage to mobs. - make arrow foe use var2 or something
			for the pic, so you can make the pic anything you want, or force it to be of a type of object w/ id of 1000+
			so you can at least declair the w/h/whitespace otherwise you will have to do it via the mob.
			
			- done - modify the lift routine, so that the 2nd buddon inits it but it is carried out by the link gfx routine.
					also add into the keys.c to check if state != link_lift1/2
					- it did - this should solve all of your problems with partial lifts and getting stuck.
					- done - add in the throw routine
					- done - add bombs, but make sure to increase the frame rate for the bombs even when held, so bombs go
							boom in your face. 
			
			- done - add in damage for mobs when hit by bomb
			- done - add in when a bomb blows a hole into the wall. - i will probably do sprite shift like the grass and slash
			- add in slashable terrain and make it slashable
			- done - add in the gauntlets and silver gauntlets.
			- add in the quest menu.
			
			int get_room_info(int x, int y,int which); - modify this.
			- done - redo the mob gfx routine and the mob_list and reduce their sizes to [24][16] and [8][~20]
			- done - then force the rooms load the mobs only if the mobs_killed==FALSE.  once you kill all of
								the mobs, then turn the mobs_killed room stat to true.
			- done - create a num_of_mobs() so you know when all of the mobs are dead.

			- done - fix built in gfx for themsg system.  you figured out how to not turn off the grey while doing
				the msgs, but you need to modify the clearing routine, b/c it is off a bit.

			- done - increase the size of world[][] to 12x8, so you can use the [9][x]
				to tell which other world file to go to in the event of n,s,e,w past the current
				world[][]
				
				
			- done - create a toggle for displaying hearts.  also, make it so that you can display hearts in
				the 4 different corners.  
			- done - create the settings section of the start menu so you can adjust the settings
			- fixed? - redo the heart displaying routine so it does it faster.  it is making the game too slow.	
			
			- fixed - redo the random direction changing of the generic mob.  it sucks really bad.  after a while, it
					sticks to the far right collumn and the very bottom row.. it is annoying.  it only moves
					in an _| fassion in the end.
					
			- fixed - fix the push gfx first.  
				-work on the bombs		
=================================================================================
			notes:
			
			- when stunning a mob, give it a time to be stunned (ie a number in the mob_stunned) section,
				like the number 50.  each loop, decrease mob_stunned by 1 and once it hits 0, then let it 
				move again.

			- here is a random thought: you could externalize the arrays for drawing the menu screens and
				then just call them up when needed.  that way, you could create all sorts of gfx, w/o having
				to use more space than you already have.
			- for the towns people, just use the mob list and add in a special type of mob (towns_person)
					and if a towns person , then attemt to get the message they will say.
					
			- no - use esc for the messages. - changed to 2nd
			
			- if you ever program in a reflect shield, then you could force the flying object to reverse its 
					direction if it hits the shield.
					
			- in order to create a shop, you will add the object then modify var1 to the amt of that object you want
					it to have.  make sure you add an object of idnumber 1000<>3000
			
			- instead of a compass, you will have a crystal detector (maybe)
			- make the maps for the item dungeons able to buy
			- make the castle maps in the castles.
			- the items will be stored in random dungeons.
			- the crystals will be stored in the castles.
			- heart containers will also be side quest items, just like the items.
			- the purpose of the castles will be for the obtaining of the crystals not items
			- it will slightly differ from the original zelda's, b/c the big items are obtained in the 
					dungeons along with the quest items.  however, all of the items will be stored in the
					random dungeons, while the quest items will be stored in castles or "major dungeons".
					the minor dungeons can be 8x8 in size, but the major dungeons will be much much bigger.
					the game should be substantially longer than normal.
			- make the enchanted forest.	
			- when you run out of room for the object gfx file, you can create a separate file for weapons
				and usable items.  about 25 in size.  - keep the main object file as a perm obj file that would not change.
				the other file could be changable.
	
	
==============================================================================
								total  overhead
==============================================================================
world gfx = 6408*2
link = 1928*3
obj = 1608*3
world map = 200
rooms = 208*16
sl = 508
save = 136	
msg = 1258
mobs = 456*2
=============
29766
gfx= 776*3  or 1552*3 (4656)
34422 overhead to load files
2328 less bytes for the 24 than 48 for a smaller mob gfx file. - i will attempt 48 to see if it will work




modifications from above:

- done - holes
- done - treasure
- done - dores
- done - sliding stones
- not happening -lock stones
- done - master key
- done - keys
- done - boss key
- done - bombable walls
multi sprite creatures
- done - lift bracer (gauntlets)
- done - swimming gear/boat - made raft instead
- done - kindof -remove "save" when nosave is active
bottle, 
- done - bomb bag, wallet, push_stone, tunics (ring)
drop items when mobs die (sl based)
- done - doors open when mobs die (sprite based - automatic)
- done - beginning screen, 
- done - link chooser screen
- done - name creation screen
chicken attack
- not happening - jumping/feather
-done -fix it where if the slash is done multiple times, then it will do multiple damage to the mobs
-done - fix it where if a mob walks into a fire, then it will do it damage
add quest menu
put object_list into dll, and force all object things to use g_object list
	- g_object list is needed, b/c you run into possibilities that you can go out of bounds
put item_list in the dll.  this will save more space, b/c space is running out.	

you can redo the heart thing, so that a loop runs to create a single sprite for the hearts
when you get hit, it redoes the sprite thing and redisplays the hearts.  this should
speed up the heart routine a lot, because it will only focus on 1 sprite instead of like 16.
- acutally with hearts, create like 16 sprites, which, hold 4 hearts (with each combination)
	then if you have more than 8*4 hp, then display the single sprite and then draw the sprites
	to the right of it.  if you have 16 hearts, then it will only need to display 4 sprites, instead of 
	16, which should increase the speed a lot.
					
- done - fix address errors (put arrays in lib file) - it should reduce errors.				


*---------------------------------------------------------------------------*
* 			problems to fix and design thoughts                                 *
*---------------------------------------------------------------------------*
maps:
- the dungeon map doesnt seem to save...
- might want to create a list to be able to see all the different maps you have currently mapped out.


holes:

- done -log the entry point of the room.  if you fall down a hole, then reset link to that entry point.
		* done * - call room_entry_x/y for the thing - it is under warper. (holes are 170->174)
- done - add in the link falling pics
- done - do 4 damage to link when falling into hole.
- hole gfx are set at 13 on link gfx.  it goes up, down, left. - using those 3 places for the falling
		down a hole - in that order, but always using position 13. 
		- this prevented me from make the array bigger and wasting an entire up position on this.


map changes:

- reduce to single room instead of a 4x4 room set.
	- you will need to fix the rmapx, rmapy stuff to look at the 8x8
- modify the dungeon map (ie the mapper) from 8x8 to 8x8x2	
	- 0 for room number
	- 1 for locked doors
			- format will be in 4 digits: abcd.  
					- 0 for door unlocked
					- 1 for door locked
					- 2 for boss door
					- 3 for perm sealed door.  (until mobs are all dead)
					- a is for left wall
					- b is for top wall
					- c is for right wall
					- d is for bottom wall.
					- format would look like 1111 for 4 locked doors.
					- 1033 would be 1 locked doors with 2 sealed doors and unlocked door on top.
					- once a door is unlocked, it stays perm
						- however, #3 will stay the same and if it finds #3 then it will check to see if all
							mobs are dead.  if they are, then the door will unlock.
- the defines for mobs_killed and locked_door_list are no longer needed.  instead, we will remove these
		and change them into a set where you have world_pos_x, world_pos_y, so we know where this map is located
		on the world map.  this will be automated, so you dont have to put them in yourself.  it will be used to
		check to see where we are located and make sure we are in the right place.  this will be used to make 
		sure that we do not have to reload the same map.  remember the world map can have as many of the same
		room maps that it wants.
- need to change the light/dark room things to incorporate into room_stats.  currently, it just looks at
		torches_to_be_lit to torches_lit.  however a new define is needed, like room_lit 1001.  this will be 
		activated when torches_lit == torches_to_be_lit.  - need to fix it in the routines.

- the defines of room_x and room_y may no longer be needed in the inventory array for link.

new array: room_stats 8x8x3  
	- put this array in eafw.
	- 0 for mobs dead.
		- when you reload this map, then all the mobs will repop.
		- 0 for mobs not killed
		- 1 for all mobs killed
		- 2 for key gotten?
	- 1 for room lit or not	
	- this array will clear out each time a new room map is loaded.
	- replace the following routines for this array (in ezelda)
					clr_world_mob_placement
						g_world_mob_placement
						s_world_mob_placement

mobs:
	- reduce the mob array to only keep track of mobs in current room
	- check the room_stats to see if all mobs have been killed.  if not, then load mobs.
   (fix mob_gfx_size, s_world_mob_placement, s_mob_list, rendom mob generator, 
	- max mobs are tied into both the mob file and number of mobs in a room.  this is done b/c
			you can place mobs to specific locations.  dont change this.	
	- you might want to redo the array back to original size.
	
				
rmapxy:

to remove rmapx and rmapy, you will need to change the following things:

room_maps- needs to be set to [10][10].  remove the 4x4
get_map_vars
get_room_maps
set_room_maps
get_room_info
set_room_info
clr_room
load_rooms - set up to populate the 4x4x10x10 rooms. - fix so 4x4 is gone - could be a problemschild				
		- there exists a section where it sets the current room number into the room itself in the array - it
			was used for the 4x4 array to make sure the room existed.  this is no longer needed, b/c you dont 
			run the 4x4 anymore.  if you load the room, then of course it exists.
get_map_vars - could be a problem child
- removed - room_exists - could be a problem child
SlashTerrain - could be a problem child
room_object_adder - could be a problem child
death - when you will set the mobs as dead - fix for room_stats
- fixed - story_checker #201 is broken now
scroll_room - could be a problem child

**warning** - i found variables that were no longer in existance, but were still declaired as extern xxx.
							you need to go through all the variables and make sure they have a beginning declariation
							with an initialization and are used in the code somewhere.  if not, then they need to be 
							removed.  this could be the cause of some of your address errors. - so you just need to do
							a code cleanup.

- maps, sls, mob files will all have to be fixed before running this game.
** note** - the main terrain gfx set has 62 unused slots.  the dungeon has like 90.  you
						could reduce the main gfx set by 50. - this would reduce about 3.2k overhead. - lots of work to fix that though.

- fixed - hookshot is not working correctly.  you can hold down the button to fire it and it has autofire.  this should end
						also, it messes up, b/c it only bearly goes out from link and pushes link in that direction (like it is caught on
						something?) and then goes back ril quick. - might be the fact that you changed the terrain testing ()

* for the msg system * - remove the top 3 rows of the screen (in direct draw) and instead draw white sprites.  after you draw, add
		the lines and then the text.  add in a message_write() in the midst of the main loop of animate_terrain() under zelda.c .  this
		will keep adding the lines and text until you press something.  the direct_draw()? will add in the white sprites as a replacement.
		you will use a variable to tell it that it is in message mode and to draw the sprites instead.  when the msg is over, return to
		normal. - this should make the message system much nicer. - game saved!, under the start menu will need some different work.

- fixed - walk into shops and no items. 
- i throw the boomerang and then walk into shop and the boomerang returns?
- fixed - the rang was a sl issue - boomerang comes to me when i enter the shop??? - the sl must be broken.
- created - i found that to get an item amt, you have to do g_inv(2,x).  instead of this, you might want to either add
		in a define for the item amt location or add in a routine in ezelda that returns the item amt
		
- the wand works better with b then a.... fix it.		
		
- done - i will create a new sprite id#.  this will be in the range of 500 or 5XX.  this sprite will be a special sprite
		that is for replacement.  for example, the scanner will scan the room for any objects with the # of 500+.  if it 
		finds it, then it will see replace with a liftable object, like a rock or a pot.  it will first exchange the
		500+ id number with base_sprite.  then it will add the object into that room... actually, this would be a bad idea
		b/c replacing it with base sprite would make all the objects dissappear in the event that you leave the room and 
		come back.  so to prevent this, you would change the direct_draw() to have a replacement effect of "if >=500, then
		sprite=get_room_info(base sprite).  - this would prevent the out of bounds error.  and it would allow for all the
		rocks to reappear.  however, when the rock is gone, the auto sprite replacement would take place; thus, allowing
		the room to save which rocks are thrown and which are not.
- if you decide to make a ball that raises and lowers the "gate" sprites, then you can use the replacement effect.
		- if hit, then scan for all the uppers and change to lowers, but at the same time, check for any lowers and change to
				uppers.  - also you can do the scan for the above and make it like the torches, but make them a 500+ object.
- done -since you decided to increase walkability, you will need to mod the warp points to have a wider range.  if not, then
			things will break.		
- done - mobs in editor - in the editor, mobs have a set gfx file.  you will need to change this so, you can use any gfx file.
			- this way, you can create an infite set of mob gfx files - just pass in the gfx location as well.
- the boggle - fire hurts you no matter where it is. - but this is only in the dungeon.  the dungeon seems to give
			you all sorts of address errors and wierdness.

- in next_world_map(), i defaulted file to 4 if it was <=0.  in the release you will need to change this to the new
			default world map.

aim for a release on nov 30th.
try to add in new areas for crimmas presents.
			
=================================================================================
				REDESIGNING THE MAP SYSTEM
=================================================================================
			- this will tell about the new mapping system.
			- the world[][] will be removed, but kept only for creating external maps
			- a new over_world[][] will be created.  it will be 20x4 instead of 12x8
			- the rooms will be converted into rsets (room sets).  each set will contain
					16 rooms - a 4x4 square.  it will be like the old rmapx/y system, but you will
					load the entire room with a single read command instead of looking for each room file
					and loading that.
			- the old wold[][] will be used to split the rooms[64] (in map editor) into 4 room sets.
			- in over_world[][] the first 4x4 section of numbers will be to hold the rset #s.
			- in theory, you will have 4 sets of 16, which means that each over_world[][] will have
					256 rooms instead of 64, but it will contain 16 rsets, which is 16x16
			- the last 16 rows of overworld[][] will be where the info for the world[][] files goes.
			- each 2x2 set of the overworld[][] will have its own 4 rows at the bottom to tell which
					gfx file to use, which mobs to use, timer, etc.  all of the old world[][] data will go
					into those sections, however, it will not need the map out of bounds data.
			- the warper will need to be modified so when you go out of bounds of the rset, it will
					look at the overworld[][] and pull the one to the lrud to it.
			- you can put about 4 dungeons into each over_world[][]
				- or maybe 2 castles.
				
			- this new system should eliminate the need for tmp rooms and the need for 1000 files.
			- instead you would have 9x4 rsets for the dungeons and maybe 4x4 rooms for the main world
			- maybe 100 rooms at most. - it will take up a lot more ram. that is the only thing, b/c it
					will include all the non existant rooms... oh well.  better than file system error due to
					the fact that it cant handle any more files.
			- it will still be around 500k for all the files.
			- decided to remove the room_stats[][] so i no longer have to deal with it.  return it back to the old way.
				- be sure to fix the lighting - actually, you could grey out most of the area with transistion() from
					extgraph???
			- remove the shift_image() and buffer_image[] and replace them with the shift_sprite() from extgraph.
world info:

	mod_link(save_map_id,g_world(10,7),TRUE);// make sure to put a number there, otherwise you will 
	mod_link(save_x, g_world(9,5),TRUE);// have problems.
	mod_link(save_y, g_world(9,6),TRUE);
	mod_link(save_map_x, g_world(10,5),TRUE);
	mod_link(save_map_y, g_world(10,6),TRUE);			
	
	
[8][5] will hold the current dungeon number
[8][6] will hold the world_mob_list file for the random mob generator
[8][7] will hold the gfx list for the world_mob_list for the random mob generator

						
[9][5] = link_x
[9][6]= link_y
[9][7]= repop timer.
[10][5] = beginning_warp_rmapx
[10][6]= beginning_warp_rmapy
[10][7]= set world - leave as 0 if you want it to stay default.
					otherwise you could force an override and make the 
					continueing link start elseware.
					
[11][7] will hold the gfx file needed. 					\

world[][] -> over_world[][]

first 4x4 ([0][0] -> [3][3]) is for rooms
[4][0] = gfx file to use
[4][1] = dungeon number
[4][2] = mob stat list
[4][3] = mob gfx file

[5][0] = repop timer
[5][1] = rset # where link starts
[5][2] = rmapx of room where link starts (inside of rset) (old world[10][5])
[5][3] = rmapy of room where link starts 

[6][0] = link starting X pos in room (old world[9][5])
[6][1] = link starting Y pos in room
[6][2] = set_world - world where link starts.
[6][3] =

[7][0] = left world warp
[7][1] = right world warp
[7][2] = up world warp
[7][3] = down world warp

4->7   world1 (top right corner)
8->11  world2 (top left corner)
12->15 world3 (bottom right corner)
16->19 world4 (bottom left corner)

total of 256 rooms, with 16 room sets. - each room set has 16 rooms.  
each world has a total of 4 room sets.  total of 4 worlds
=================================================================================
					THINGS TO FIX DUE TO THE REDESIGNING OF THE WORLD MAPS
=================================================================================

- fix - int current_room()
- fix - game_over() (especially in the save section)
- fix - save()
- every place that uses g/s_world()
- done - create a set of defines to access the overworld settings. (including world1, world2... world4)
			world1 -> world4 will help with determining which row set to use for the overworld settings
- fix warper()
- as for the transistion, creeate a transistion var.  when you load the world_init(), set the transistion
		var.  at the end of load_rset(), set the transistion var false.  that way it will only go off in the
		event that you change worlds and not rsets.  add the transistion lines in the midst of the for statments..
		you will probably have to use slow() in order to reduce the speed of it.  tell it to use the drawlines from 
		extgraph.
- g_link_pic is not used anywhere.  remove it entirely
- g_mob_pic is not used anywhere. remove it entirely.
remvoe the following entirely:
g_object_tmp_pic, s_object_tmp_pic, g_image_buffer, s_image_buffer, g_object_pic, repop
- fix mobs_killed to look back at the room[][] instead of room_stats[][](deleted)
=================================================================================
				TODO BEFORE 4.1 RELEASE:

			- done- mod warp points
			- done - add mobs to tmp dungeon
			- done - finish locked doors.
			- fixed - remove esc_ko doings. - moved to debug mode
			- done - test to make sure the adding of a lot of temp room files doesnt break the normal calculator

				TODO BEFORE 4.2 RELEASE:
			
			- done - add in section on room to tell whether room has a key in it.  if so, then randomly add it to mob.	
			- done - add push stones - uses sprite id 502
			- done - in gfx2- add walk through walls (put wall sprite in walkable area of arr)
			- done - add bombable walls - we will make 190+ sprites all bombable - originally was 195, but expanded for at least 2 
						dungeon wall sets to be bombable, plus 2 more spots, or maybe 3 spots each, with lru and skip down
						- you will need to make a walkable sprite soly for the bombed wall... actually, a total of about 4, for
							the 4 wall sides.
						- animated sprites of 46->49 are not used, so you can replace these with a bombed wall. - this will give
							4 spots.
							// 192 -> 199 = 8 spots for bombable area.
							you will have 2 sets of 4 bombable places - set 1: #192->195 will access sprite #46->49 in that order
							set 2: #196 -> 199 will access #46->49 in that order.  this will allow for 2 wall sets.  up, left, down, right.
							192 & 196 will replace with #46.
							193 & 197 will replace with #47 and so on.
							
			- done - add in gauntlets
			- done - add bomb bag
			- done - add heart containers
			- done - add wallet
			- done - add flying boots - has a timer for use.  when use is up, fall.
			- done - add a map.
			- doen - add raft
					- making a dual state called rafting
					- creating a rafting() (in link_gfx.c)
					- need to mod can_move() to allow for rafting. 
					- need to allow, in the event of rafting, you can travel the treadmills
					- we are making gfx spot 54 the place for water travel.
			- done - add ring
			- done - add tunic
			- done - add flowers back to main map (the sprite # was changed)
			- finish dungeon and add items to it
			- add 2nd dungeon. 
			- remove esc_ko doings
			
				TODO BEFORE 5.0 RELEASE:
				
			- done - test maps and warp points
			- done - add back in the mapping system that is broken.  under wold_init()
			- test on calculator
			- done - create a cleaner() to clean all the old stuff. - just delete each old folder. that is all.
			- if hw4 is too fast, then add in a thing so it will slow it down.	 
			- done - make new pics
			- done - logic o quit if missing main folders
			- done - fix door to the right
			- remove cheat stuff
			- done - fix map 4
			  
				TODO BEFORE 5.1 RELEASE: 
			
			- not needed - add in a place where a room will reset itself. (mainly for the push stones) - or prevent a save
			- done - test - done - add warping mob algos. - wizard
			- done - add circle mob algos (mobs that rotate in a circle - in line with one another)
					- for that mob, make the center eye something like a pede_body and then change it after
						all the mobs are dead. after each of that mob type dies, run a check to see if another one
							of those mobs exists.  if they dont, then change the center eye type and go from there.
					- use rand_var to decide when to make the circle mobs expand. - use rand(66) or something to 
							increase the rand_var, so it wont always be a constant when they expand or contract.
					- the circle mobs will move based on the main eye location. - make a routine set like the pede routines		
			- done - test - done - add bat flying algos
			- done - add ghost algos - needs to be able to travel diagnal - so mod mob_wander()??
			- done - add follow the leader algo- centepede algo
			- done - add in game speed modifier			
			- done - need to add "delete save"
			- done - modify touch object to include mobs and other objects. if obj==loc, then skip.
			- done - add bottles - need a lot of sprites for this (one for each object it can hold)
					- if you do different potions, then do 2001 for red potion, which turns to blue potion 2000, when used.
							- this would allow for 2 healings of one potion. - need 2 different sprites for this though. - light and dark.
							- need a sprite for a faerie in a bottle. - so maybe a max of 4 sprites
							- the item in the bottle would carry the sprite id#.  if no item, then disp bottle sprite id.
							- so you would have a bottle item and 3 other items that could "fit" into a bottle.
			- done - repair the follow object in link_rand_var1.  it seems to dissappear when you leave from room to room.
			- done - save config settings to inv[][] and restore when you get your save.
			- mostly fixed - the mob throw objects no longer hurt link. fix this - mainly pain() only did foe_arrow, not the rest,
													so the logic for all other arrow types were added and things work better.
			- done - add light orb
			- done - add wizard, bat, pede, ghost creatures.
			  
				TODO BEFORE 5.2 RELEASE: 

			- done - add faerie algo - if touch, heal and dissappear. -make it an object - when touch, display circle hearts around link
			- no - get mobs to hold and use weapons. - they have enough weapons to shoot at you.
			- test - done - add shield mob algos
			- no -add triceratops bombing algos
					- add creature type triceratop
						- if attacked by anything but bombs, then no damage
						- if bomb touches inside of sprite when link first layes it down, then make bomb dissappear and
								run routine that makes it explode inside of triceretops
								- need a chk_for_tri() to execute when link uses type bomb.
						- need routine for testing to see if a bomb exploded and hit a triceritops.  if it did, then pause the
								creature for like 6 seconds. - but during that time, you cant shove bombs in its mouth. - or make
								it the opposite - if it is not stunned, then you cant toss bombs into its mouth. 
					- for the back, use immortal creature type that does not move back.
						- might need a new type of immortal that does not move back, or you could attempt to use pede_body 
			- fixed - test - done - add multi shot boss aglos - broken as hell
			- test - done - add quiver (make this special, b/c the # of quivers you have = #*15+15=total number of arrows you can hold.)- so you can
					buy multiple quivers.	
			- test - done - add treadmill sprites to logic of link_rafting in dual_animation()
			- more maps and monsters
			- test - done - dungeon maps - only works with treasure chests
			- done - add compass.
			- multi sprite monsters - maybe add a boss 
			- add boss algos			
			- done - remove the link flip routine and sprites. - this will cause you to redesign the link gfx arr[]
			- done - all of the arrow_foe algos are broken and dont work right.  you need to fix this.  might be a problem with 9000+ item objects
								- problem what that i had to rewrite the whole thing from scratch
			- done - make it so that when you die, it will check to see if you have a faerie in a bottle, if so, display hearts around link
					and then restore hp.
			- test - done - make it so you buy faeries.
			- partially_done - add in the fade in/out to the sl and put it in the inn sl. (for the inn sl, ask if he wants to pay, if yes, remove money, 
						fade to black	then transfer link to the next room beside the bed and then fade in.
			- test - done - add replication mob type, where the mob adds more mobs (pulling from mob_list[0])
			- removed - test - done - added chicken attack - set chicken to hp of like 50 or something. or >0 for it to work
			- test - done - add special shield type: immune all but bombs & arrows.
			
			- test - done - add spider algo (like the ones that you can only kill via arrows in zelda 1)
			
			- done - when you get a new sword, delete out the old one
			- done - with the bombing routine, check to see if there is another bombing type sprite that is along the same x/y, but +- 1.  if
					so then change that one too. also, check the room to the lrud, to see if it is of the same type and change it.
			- works (kind of) test - done - make routine that will prevent you from getting stuck when walking into the next room
			- done - add ai random drop system
			
			TODO BEFORE 0.9.3 RELEASE: 
			
			- done - still need to fix the pede where it change the sprite when going l/r  and need to fix the walk sprite
			- already done - need fix the fliers so that they will do a random(80) with the dir change, to keep them from roaming around the walls
			- make a new installer system for the ti-89 - convert everything to the compressed 89y format
			- none exists - remove the global vars used for the old pede routines.
			
			Unplanned additions:
				- added fuzzballls that takes the sword away and gives it back.
				- added hand that takes link to the beginning
				- added "suprise" gfx
				- added sl to the inventory for extra quest items
				
			Extra additions:
				- add a way to catch faeries
					- make a "faerie mob"	
			
			TODO BEFORE 1.0 RELEASE: 
			
			- add algo for the hopping spiders/bunnies
			- done - add algo for the spikes (keep loc x/y a constant.  use var1/2 to move)
			- add mob_duplicate algo
			- done - code msg system to display @@@@@@ as link's name
			- done - add flute
			- done - add flute menu
			- done - add transistion effects that look good
			- done - add compass
			- done - add slah ball w/ blockers
			
			OPTOMIZATIONS TODO
			
			- done - recode object system
			- recode mob system
			- half done - recode link system. - the new system seems to have odd bugs, but it seems to be
					working great.
			- recode sl system
			- done - rewrite all of msg system.
			- add in mallocs
			- i need to go through all the vars and see which .c files use their variables and which dont.  no point in having
						extern vars in a file that doesnt use them.
			- after recoding the object system, i found that there were routines that were not used.  go 
				through each routine in the .h files and comment them out and recompile and see if the warning messages 
				increase.  if not, then it is unused, so delete it.			
			- done - under zelda.c, you could take "if (touch_mob(link_x, link_y, LINK)!=555){pain(LINK,0,0,0);}" and put it under
					the main animate_mob loop, like you did the sword contact.  it would remove about 8 extra loops
					then if you modified pain to accept the mobs location, then it would be able to remove another 8
					loops of mob searching. - you could mod pain() to use dam as the loc for the mob and deal direct pain.
					
			
			
			RANDOM OPTOMIZATIONS DONE
			
			- recoded the gfx slash and spinslash routines. - saved 1k.
			- recoded the pede.  now it is about 500 bytes smaller and it works better.
			- redid the obj move system
			
			
////////////////////////////////////////////////////////////////////
				TODO BEFORE simple RELEASE: 

	- done - add heart contaiener, test dungeon 9, zelda sls, add mobs, play all the way through.
	- done - test - done - add warps for one way out of dungeons
	- done - test - done - add treasure boxes for the rest of the items
	- done - add another heart container - 1 is missing.
	- done - make shops sls - nester broken.  keys dont work. - remove keys and add something else. - removed
	- done - test dungeons and make sure warps work.
	- done - make sure treasure boxes in dungeons work.
	- done - change dungeons to force the ow start and world start under the "world map info" tab.  change it to the dungeons themselves
			- and test them.
	- done - add mobs to everywhere
	- done - add in prologue to beginning sl
	- done - add - part done - add in ending sl that will execute the credits
	- done - add in alternate endinging if tyou kill zelda
	- done - play finished game all the way through to make sure it works.
	- done - delete out all cheat stuff.
	- done - make an basic installer
	- done - package for release
	- done - you got problems with nested if statements in the sl.  fix it - the nester works fine.  i forgot to update "either"
			in the sl defines.  it had changed from 4 to 6, which caused a perm false.

////////////////////////////////////////////////////////////////////			
								
				TODO BEFORE crystaline destiny RELEASE: 	
			
			- 
			- done- code msg system to display @@@@@@ as link's name
			- test - done - made a new routine for modding the treasure/story markers.  - imp this after the release.  it is pointless now.
			- done - prolog create	
			- done - make crystals and put them on beg screen 
			-	done - set up quest part on the menu - or make into flute/song displayer
			- final product estimated to be over 512k in size.	
			- done - add in a section where the mobs will skip a move (step), which will "slow" the movement of the mob down.
					- basically, it will skip X loops of movement in between each move.  this will allow you to slow mobs even
						further.  for example: make it move one pixel at a time, but make it move once every other cycle.	- you can
						make an algo for this or you can add in another variable to decide on movement skips.
			- done - add flute (10 songs max) - 1 song to warp to beginning of map., 1 to warp to seperate towns
					- with warp, use the transistion(), make one to stun all mobs
			- done - remove chicken/dog hop routine
			- done - remove chicken attack.	
			- done - add mod_marker() and remove g/set_treasure_marker() from ezelda		
			- done - make a new set of defines for immune_stun.  make them 10000+.  immune_stun_death_by_fire, etc
					- with that, make a single routine that will check to see if a mob is immune stun.  if it is then return,
						if not, then stun the mob
			- for quests, dont make individual items, instead use the quest part of the sl to determine whether you have the item or
					not.  when you get the "item" just display it in a msg() then modify the quest pointer
			-recode mob system.
			- done - add spikes
						
			Later Releases:
			
			
			- done? maybe - tweak message system
			- done - might need to add more to dll (so dll overhaul is in this area)
				- done - add logic to methods to prevent out of bounds errors. - really needed in the object section.
			- done - need to rewrite the can_move() to include all sprites surrounding link. then move based off of whether link is
					<6 spaces to the up or >12 to the down to see if he can move.  test multiple spots at the same time to see if
					he can move or not.  if he is partially walking on a movable sprite, then allow a move. - created triangulation detection 
					system. -read about it in can_move().

			- done - add an "ending" (prolauge) display for the message system
			- do a code cleanup.
				-done - under for each *.h attempt to find the method().  if it doesnt exist, then delete it.
			- delete this - added dbg[] and debug() - erase these later.

////////////////////////////////////////////////////////////////////
							broken things
			
		after move_obj rewrite:
		
			- fixed - animate_throw_object()
		
		
		other:	
			- if you get reeled_backed() into a warp point, it will freeze.  not sure why, but i added a temp
					thing where it will keep from freezing in warper()
			- fixed - bomb turns into a rock when walking to different rooms when carrying it
			- bomb doesnt blink when holding it.
			
			- fixedish - noticeable slowdowns when doing walking sword.  you need to speed this up.
			
			- fixed - link shield walking doesnt work anymore...
			- fixed - changed - the lrud + x_ko doesnt work.
			- the rafting system is broken.  the raft works, but you are moving like you do on land... also the waterway treadmills wont
					work right.
			- if object flying_bomb is blinking and then you toss it and it turns into a bomb, then it will reset the frame a bit
					and stop blinking.  then it will start blinking again and then explode.
			- fixed...raft doesnt turn when you turn.  also, the raft is a little behind.  is it an object or a quickdraw? needs to be a 
					quickdraw.
			- fixed - after the transistion effect, you are put back to speed 0, not your original speed.						
			- fixed - with the new system, if you died, then have the boomerang/hookshot return to you, then it will zero out the link_dead
					and replace it with link_normal.  you become immortal, until an object hits you.				
			- i removed debug, you wil have to uncomment it if you want to use it.
			- fixed - treasure markers dont work right past #30
			- fixed - ok you died and then saved.  then you went back and the mob from the shop did not repop.
					- it repopped when you stopped and restarted the game, though.
					** when you dided it set skip_animate_mob=true;  this prevented the mobs from being displayed.
							so i set it to: skip_animate_mob=FALSE;.  i also moved up the restart: label in zelda.c
							so when you save after deather, it will reset all vars and clear all arrays then reload everything
							from scratch.  this should prevent other odd unexpected errors.
			- fixed? - when warping with rock objects, it breaks things - like going up and down stairs with rock objects - fix this.		
			- check all maps to see if you can save there and what happens after you quit and restart.  some maps are not
					set up correctly to return you to that map if you saved, so you end up with a rill bad error.				
			- fixed - when you continue after you die, your config settings dissappear... like hearts dont show up.
			- since you changed everything (ie how the mapping system works) - when you die, it sets what world you default to
					not the ow...  you need both, to be able to continue correctly.
			- fixed - the if ((loc_in_pic_arr+gfx_size)>(mob_gfx_list_size-1)) statement in the pic_mobx() in the mob creator causes
					problems and does not allow for 4, 8 sprite mobs to be there.  you might need to remove the "-1" at the end
					of it to make it work.  it doesnt seem to break anything when you do this.
			- bug - what happens when you get hit by a mob while flying with the hookshot? reelback kicks in.  if on a non moveable area
						then what will happen?  you get stuck?		
			- link can get stuck if he hookshots onto something and it is in a nomove area.			
					
////////////////////////////////////////////////////////////////////

							AI drop system: (light orbs only drop in the event that the creature is carrying it.)
			
			- if hp<30%, then increase drop rate from rand(13) to rand(9)
			
			- if hp>50%, and bombs==0, then drop bomb
			- if hp>50%, and arrows==0, then drop arrow
			- if hp<max, then: if hp<30%, then if !rand(102) {drop faerie} else drop heart	
				- else if hp==100%:
					- if arrows == 100% and bombs<100%, then drop bombs
						- else if arrows < 100% and bombs == 100%, then drop arrows
						- else if arrows < max and bombs < max, then: if !rand(2), drop arrows, else drop bombs
						- else if arrows and bombs == max, drop rupies 


////////////////////////////////////////////////////////////////////
						
							optomization:
							
							or you could keep track of every single x/y coord of everything and see if
								any of the x/y's connect. if so, then get both "things" and call the correct
								routines.  arr locs[4] = who (link, mob, object), loc, x,y - even at 50 in size,
								that is 2500 loops...
							
							you could combine the item and mob animation routines - do one item and do one mob.
								check to see if item hit mob
								check to see if item hit link
								check to see if mob hit link
							- actually, number of mobs = 8, so you could run a "contact" mob, once each loop of an
									item.  dont do the "contact item" in the midst of the mob loopings.
							
							look at 	exp_gfx_load() to see an example of what the code would look like - basically, it will combine all
									gfx loading routines into one.  it will use the malloc and unmalloc routines to assign the arrays and
									destroy them at the end of the routine - hopefully, keeping reminents from lingering in ram.  also, it will
									only use one array (one for gfx, one for char (messages), one for all other ints[][], like the world, mob
									stats, link stats, etc...)  it will use the biggest array available to malloc out the array with.  then it will
									force load any smaller arrays into it.  depending on which file type you specify, will depend on which file it
									will load and distribute to the dll.  - 3 total routines will be needed.  it should reduce the mem errors and
									reduce the size of the game... hopefully.
									
							- NO - bad idea - turn all g/set() into mod_xxx() and use defines to turn the mod_xxx() into g/set() - 
										this should reduce the number of routines in ezelda by about 15.

							- recode the leaf_gfx() so it uses a loop and the rotate() and a single gfx to display the leafs.  this should reduce 
									the code by a little. - it should allow for a single object to be placed, or no objects at all :) - attempting
									to use the no object at all would probably be the best and link it to a perm object gfx #. no objects = less ram
									used then displaying the leafs. - hmm. then you could reduce the number of objects that could be placed on the 
									screen from 50 to say 25. - that would reduce the size of the game as well.
									- maybe make another perm obj gfx# and another perm terrain # for the crystals...
									- a problem would be keeping track of the markers of where the leaves are located.  a single array of arr[26][2]
											would be good enough to keep track of the leaves.  have arr[0][0] be a pointer whether leaves exists
											or not.  if not, then return w/o searching through the whole array for spots to display.  when the leaves
											are removed from the screen, delete  out the arr[][] and then do a scan to see if any more exists.  if not
											then change arr[0][0]=FALSE; - when a leaf is added, if arr[0][0]==false, then arr[0][0]=true;
											
							- force the max# of creature objects to 20. so if a mob is trying to shoot an object, then check to see 0->19 is used.
											if so, then dont add the objects.  if you reduce the objects to 25, then this would allow - in theory, to let
											link use at least 5 objects. - you could force link to only use the last 5 or 10, or first 5 to 10 objects.	
											
											
							- to optomize the object system: loop through all the objects[][] and display them.  then loop through all the objects[]
									and see if they hit anything, if so, then return true and execute the corresponding routine. - also check if oob at
									the same time, and if so, then delete.							
////////////////////////////////////////////////////////////////////
											file condensing
											
		you can make a single sl for each item chest type:
		one for maps,
		one for compasses
		one for boss keys
		one for special objects
		one for heart containers (dungeons)
		(only 5 sl files will be needed for the 8 dungeon treasure boxes)
		one or two for rupie boxes
		one or two for the final castles

		- combine all the gfx files (light, dark, mask) into a single file and then load it and separate it inside the game.


		need 5 heart containers to get aside from the 8 in the dungeons.
		- 1 will require gauntlets.
		- 1 will require raft
		- 1 will need hookshot
		- 1 will need hoverboots
		- 1 will need bombs
		you can put almost all the mini caves for the heart containers into one map and make a sl for the treasure boxes
		
////////////////////////////////////////////////////////////////////

										the flute
		
		
		name, notes, sl file, id # (id # will be to store in the inv[][].  if it exists, then it is displayed in the 
																song list.  there should be no need to up/down in the song list.  just disp and 
																exit.							
	you can create the flute, no problem.  it would be used to open the doors in the castles where the bosses are.
	also it would be used to teleport you to the individual towns.
	you would have an external array that would house the <name of the song>, <key combinations/notes to be played>,
			<warp to ow>, <warp to map>,mpax, mapy, xloc, yloc. (20 in length?)
						- with the flute, make a song that stuns all mobs for like 100 loops or something.  - however, to use this, it
								would set a var to like 1000.  then once you reach 0, then you can use the song again - this would prevent
								overuse and abuse of the song - also, think repop timer - it would use a similar thought for "cool down time"

/////////////////////////////////////////////////////////////////////
** WARNING ** 	- found discrepancies: built_in_gfx.h had refrences to obj_buffered() and dir_to_rotate().  they were removed.
				- you will need to go through all the .h files and make sure you dont attempt to redefine things that are in 
						the dll.  this should prevent errors.


- fixed - maybe - touch mob will not work with multi sprite creatures.  it is set to 14x14 creatures only.
- might want to fix case 17: in sl to be more right
- fixed - maybe - test - dungeon map had an issue - it used world[][] to write itself.  however, world[][] no longer exists.  you may need to
		create a new type of files (maps) that has an 8x8 of the map.  all you would have to do, is take world[][] in map
		editor and take the first 8x8 and name it mapxxx.zld.  then it would be able to pull the map of that dungeon.
		this might be useful for tracking link.
		- you might have to create a link_world_x/y vars in the inv to keep track of him though.
- fixed - need to do extra calculations to see if the sprite below you is water and draw the raft if it is.		
- fixed - fire doesnt work anymore - ie it doesnt animate.
- done - you will need to add in a section of map creator to remove all the worthless things automatically.
- fixed - hookshot is broken.... it doesnt blink right.
- test the other weapons.
- done - put all the houses into one rset.
- fixed?? - oddly enough, at 80,80 in the begging spot, link cant move left???? - there might be a problem with x==0 and y==0, so you might
		need to put a fourth if stmt in for the 0,0 to avoid the oddness of things.  - added in the fact that all the global vars for 
		triangulation checking reset themselves, to prevent vars from lingering around, which would cause extra checking.
- modify warp points, so they work again.
- opening unlockign door on the right doesnt work
- push stone doesnt work right...
-- remove terrain_contact()
- removed - mobs_collide() looks strange.  fix or remove
- technically, with the modifications i did to touch_object() i should be able to pass in OBJECT instead of boomerang.
- you need to check all of your collide() to make sure that things are evenly spaced - or add it directly into collide.
- fixed - continue still is broken - it loads the wrong stuff and doesnt seem to set the inv_x/y pos.
- the moving of spike with the shield no longer works...
- almost everything is back to the way it used to be...  need to finish checking the warping stuff.  need to mod the room files so they use
						the proper sprites.  - need to clean code.
- you need to fix world_init() to include loading the dungeon map.
- fixed - when you are holding an object, you cannot move up.
						
- in crystaline destiny, change the warp points to 10.
- 7 erros to fix so far.
- get rid of sword 6.  
- get rid of the explosion sides and replace it with the rotate.
- done - plan on adding in a projectile list for mobs.  you will need to modify AnimateMob() to make things work or
		you can modify get_item_info() to include the proj_list[][], just use "projectile_offset" to find out if
		the item is in the projectile list or not. all of your proj_xxxx defines are an offset of 20.  so if you
		pass in an item #id of >projectile_offset, then switch the item_xxxx defines for the proj_xxxx defines and
		call proj_list[][] instead.

- fixed - been having a hell of a time deleting a save.  instead i will move all the save items to their each own folder.
		there are multiple files for each save, so why not.  then just call folderclear() to delete a save.
		
		
the random move generator will randomly pick a move type :
		({MOB_WANDER, MOB_FLUTTER, MOB_HOP, MOB_FOLLOW, MOB_BAT, MOB_WIZARD, MOB_SPIKE)
		then it will keep that move type until var2 == 500 or soemthing and then it will change the move type using random()
		it will also change the speed.

the random attack generator will have a range you can pass in: low/high.  in between low and high, it will randomly
		choose an item from the proj_list[][].  then it will switch to that weapon and use it.  once var2==500, then it
		will randomly choose another weapon.		


#define arrow_foe  - generic enemy weapon
#define arrow_foe_rotate - generic rotating enemy weapon
#define arrow_foe_multi_3 - this will replicate the weapon twice, so you have a total of 3 objects on the board
		- one will go straight while the other 2 will go diagnal.
#define arrow_foe_multi_5 - this will replicate the weapon 4 times, so you have a total of 5 objects on the board.
		3 will go straight while the other 2 will go diagnal.
#define arrow_foe_follow - this will follow link around.
arrow_diagnal - this will have to find the slope, based off of link pos from its starting point and then move based 
		upon that slope, but these vars will need to be stored somewhere.

- execute sl when touching a sprite...
- move mob in sl
- test - done - execute sl after mob dies
- add mob in sl
- add object in sl???

- to move diagnal - x will remain a constant - always: x=+-speed;
		however, y will be the only thing that changes.  the change will depend on the current position and where
		you want the end pos.  if the corner wall, then take the corner wall pos - from current pos, calculate number of
		moves until you leave the screen (x_pos - wall)/ speed.  then divide num of moves by the difference of corner and 
		start pos.  then store that info in var2. and always move that many y in adidtion to the x
		if moving towards links pos, then calculate based off of links current y pos, instead of the corner, and then put that
		in the var2.
		
		if moving up or down, instead of left or right, then do the reverse and calcalte for x instead and store into var2.
		for the 3x object routines, use an end spot calculation that is about +-42 from start.
		use positives and negative numbers in var2 to distinguish whether you want to travel lrud.


- when you have more than 10 objects on the screen, it gets slow as hell - even when you have no speed limiter. - you need to
		split up animate object and optomize it so it will animate simple objects, like rocks and pots w/o slowing down the 
		game terribly.

- in rotate, use the flip instead of the rotate for the 180.

- the sl part for the shops dont seem to work right, so you need to check that and fix it.  it seems as though
		it is looking for an amt of 1, instead of checking to see if i have that item id in my inv reguardless of item ammount.
*/

/*
		when loading from a save, do the following:
		get from the link_stats:
		load_ow_map(link_stat(save_ow_id));
		search for save_rset_id.  when you find it, xpos and ypos into link_stat(ow_x/y)
		if it does not exist, then error out and display (corrupt save file)
		if it does exist, 
		thebn set link map_x/y
		then world_init() (which sould have oob in it.)
		then load_rset(link_stat(save_rset_id))
		then set linkx/y
		
*/

/*					centipede moving

main concept:
- the pede will have a head.  only the head can be attacked.  the rest is immortal.  once the head dies, it transfers its
	stats to the one behind it and it becomes the new head
- to make the pede, you will have to create an individual file with all 10 pede pieces, with the head at mob_id==0
		and then copies of all body parts below.


moving:
- the main routine will loop through the array to see what type of mob it is (head or body segment)

- if body segment, then do the following
	- check to see if (mob_id - 1) direction == mob_id direction.
		- if true, then move the 2 to 4 pixels like normal.
		- if false, then check the x/y coords to see if they are lined up with (mob_id - 1)
				- if mob_id-1 == up/down, then check to see if x coords == mob_id
						- if so, then change direction to up/down and then move up/down.
						- else, x++/--
				- if mob_id-1 == left/right, then check to see if y corrds == mob_id
						- if so, then change dir to left/right, and then move left/right
						- else, y++/--
	- in the event that mob_id - 1<0, mob_id=0.  and this becomes the head.
	- if mob_id-1 == dead, then this becomes the head. (this might solve the problems you have and might make
				everything work the way you want it to, in order to split.)


- if head, then do the following:
	- keep track of number of times moved with var1.  
		- if var>= 8/speed, then randomly decide to move.  do a collission check to see if the mob hits itself or an object
				or an item on the floor, or goes out of bounds.  if after 4 fails, then keep moving unless the mob collides with
				something in the room. - if the mob collides with something, and there is no way out, then it can step on top of itself
				to continue moving. - might want to make var2 dictate whether it can walk on top of itself or not - but reset this
				after it moves (var>= 8/speed)
				- reset var1=0
				
			
			
- if the head gets hit, it does not reel back.
- if the head dies, then it changes the sprite of mob_id+1 and gives it var1/2, and its attack, and its type
- each pede body part should have its own hp.  however that hp should not reduce when hit, until it becomes the head


- other sprites on multisprite creatures do not need to reel_back()
- create an m_sprite_invincible? for a multisprite creature whose other sprites do not get hurt
- create an m_sprite for a multisprite creature that gets hurt when hit.



    public float radius = 5;
    public float angle =0;
    public float period = 6f;
 
    // Update is called once per frame
    void Update () {
       angle += period*Time.deltaTime;
       float x = Mathf.Cos(angle)*radius + center.transform.position.x; //x=cos(angle)*R+a;
       float y = Mathf.Sin(angle)*radius + center.transform.position.y; //y=sin(angle)*R+b;
       this.gameObject.transform.position = new Vector2 (x,y);

technically it is:
			xpos= cos(angle)*radius + xpos_of_center_creature

*/
/*

centipede would be easy to make - 
use 8x8 sprites
have an world[][] of all sprites
you would have like 4 different sprites (or so) for the background - blank, and the different mushroom states
mushroom states would be 1->3.  3 being a full shroom.  2 is a half shroom. 1 is a almost gone shroom.  0 is the walkable
		background.
if a pede reaches the number 1->3 have it turn.
do collision tests for the lazer hitting the shroom.  if it does, then reduce shroom array by 1, until it hits 0


in the room array, preprocess any array changes, then use the extgraph.a 8x8 sprite tile mapper to display the tilemap.

use the zelda collision system for the snake and pede.

make the pede like 10 segments long, so have a mob list of 15->20? - use 2 mob lists.  one for pede and one for others.

the other mobs would drop in on the exact grid xy alignments

the pede would move slow at first then pick up speed later.  you would dictate speed by speed limiters, b/c the game
shoud be way overclocked, especially w/ extgraph.

after pede mob killed, then redo all sprites, which are >1 in the world[][] to=3.  give points for each one redone this way.

randomly add mobs to the screen.

make the pede only turn down, until it reaches the bottom and then turns up.  force the collision detection to only allow it
to follow the grid - moving one or <1 grid incriment at a time.
		
for super speed, allow for a 2nd "animate_pede()" to be called in the main routine... might lead to ghosting...

*/
