// C Source File
// Created 10/11/2012; 4:42:51 PM
/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"
//#include "defines.h"
//#/=include "link_stats.h"
//#define inv_rows 11
//#define inv_cols 30

int inv[inv_rows][inv_cols];



//=================================================================================================

inline int g_inv(int x, int y){
	if ((x<0)|| (y<0) || (x>=inv_rows) || (y>=inv_cols)) {return -6666;}
		return inv[x][y];
}// end ginv

//=================================================================================================

inline void s_inv(int x, int y, int num){
		if ((x<0)|| (y<0) || (x>=inv_rows) || (y>=inv_cols)) {return;}
		inv[x][y]=num;
}// end ginv
//=================================================================================================




int link_stat(int which)
{
	if (which>=(inv_cols*2)){return 0;}
	int a=0;
	if (which>=inv_cols)
	{
		which-=inv_cols;
		a=3;
	}
	
	int i= g_inv(a,which);
	
	return chk_num(i);
	
}// end link stat

//=================================================================================================

/*
void md_link(int which, int number, int replace)
{
// replace tells wether to just add or to replace
	int i=0, a=0; 
	if (!replace){i=link_stat(which);}// if you are not going to replace, then make i the current #
	i=chk_num(i+number);
	
	if (which<inv_cols){
		
	
			switch (which)
			{
				case hp: //a=inv[0][max_hp];
					// mod hearts full
					if (i<=0){}// gameover
					if (i>inv[0][max_hp]){i=inv[0][max_hp];}
				break;
				case max_hp: //a=8*16;
					if (i<8*3){i=8*3;}// at least 3 heart containers
					if (i>8*16){i=8*16;}// a max of 16 heart containers.
					// each heart container is 8 hp so 8*16=16 heart containers.
				break;
			//	case mana: a=inv[0][max_mana];
					//mod mana bar.
				//	if (i<0){i=0;}
				//	if (i>inv[0][max_mana]){i=inv[0][max_mana];}
			//	break;
				case map_x:
				//	if (i<0){i=0;}			
				//	if (i>7){i=7;}
				//break;
				case map_y: //a=7;
					if (i<0){i=0;}
					if (i>7){i=7;}
				break;
				case rupies:// a=inv[0][max_rupies];
					if (i<0){i=0;}
					if (i>inv[0][max_rupies]){i=inv[0][max_rupies];}
					
				break;
		
						
			}// end switch
		//	if (i<0){i=0;}
		//	if (i>a){i=a;}	a=0;
	}// end if which<30
	else if (which>=inv_cols && which <(inv_cols*2))
	{
		
		a=3;// the 2nd part of link uses line 3, but easily could be adjusted.
		which-=inv_cols;	// using inv_cols will allow this to still work in the event
		// that i change the inv_cols size.
	}
	else if (which>=(inv_cols*2)){return;}
	s_inv(a,which,chk_num(i));// oops forgot to put the stats into the inv
}// end mod link
*/


void md_link(int which, int number, int replace)
{
// replace tells wether to just add or to replace
	int i=0, a=0, b=(-66); 
	if (!replace){i=link_stat(which);}// if you are not going to replace, then make i the current #
	i=chk_num(i+number);
	
	if (which<inv_cols){
		
	
			switch (which)
			{
				case hp: b=inv[0][max_hp];							break;
				case max_hp: b=8*16;if (i<8*3){i=8*3;}	break;// at least 3 heart containers
				case map_x:	case map_y: b=7;						break;
				case rupies: b=inv[0][max_rupies];			break;
		
						
			}// end switch
			if (b!=(-66)){
				if (i<0){i=0;}
				if (i>b){i=b;}
			}	
	}// end if which<30
	else if (which>=inv_cols && which <(inv_cols*2))
	{
		
		a=3;// the 2nd part of link uses line 3, but easily could be adjusted.
		which-=inv_cols;	// using inv_cols will allow this to still work in the event
		// that i change the inv_cols size.
	}
	else if (which>=(inv_cols*2)){return;}
	s_inv(a,which,chk_num(i));// oops forgot to put the stats into the inv
}// end mod link

//*/
//=================================================================================================



void clr_inv()
{
	int i=0,k=0;
	while (i<inv_rows){
		while (k<inv_cols)
		{
			inv[i][k]=0;
			k++;
		}// end while k
		i++;k=0;
	}// end while i
}//end clr inv


//=================================================================================================

int get_treasure_marker(int which)
{// this function looks at the last 3 rows of inv[][].
/*
			the main idea is that i can use a number between 1 and 90 to represent a "used" treasure box.
			this means that you can only have 90 treasure boxes in the game.
			you send this number through this routine and it will check all 3 rows to see if that "spot"
			is "used" or not.  it should only return TRUE and FALSE

*/
if (which==8888){return FALSE;}// in the event that the treasure box can reappear, then return
	// that you have not gotten it.
which--;// it will allow from 1 to 90 in the sl section, so to prevent
// errors, do a -- on it so it will work with the array.
	if ((which<0) || (which>=(inv_cols*inv_treasure_rows))){return 555;}
//	if (which>=(inv_cols*3)){return 555;}// signal that it is out of bounds
	int a=inv_treasure_loc+((int)(which/inv_cols));// get the correct spot.
	//if (a>=inv_rows){a=inv_rows-1;} - not needed it is redundant.  g_inv() has error checking already
//	else if (which>=(inv_cols*2)){return 0;}
	while (which>=inv_cols){which-=inv_cols;}
	int i= g_inv(a,which);
	if (i>TRUE){i=TRUE;}// true for have gotten the treasure - flase for not have gotten it.
	else if (i<FALSE){i=FALSE;}// this is so it will only return true or false.
	// however, if it returns 555, then you have an error.
	// that should prevent stat issues.
	
	return i;
	
}// end get_treasure_marker


//=================================================================================================

void set_treasure_marker(int which, int num)
{
	if (which==8888){return;}
	which--;
	if ((which<0) || (which>=(inv_cols*inv_treasure_rows))){return;}// if out of bounds then do nothing
	int a=inv_treasure_loc+((int)(which/inv_cols));// get the correct spot.
	while (which>=inv_cols){which-=inv_cols;}


	if (num>TRUE){num=TRUE;}
	else if (num<FALSE){num=FALSE;}
	// that should prevent stat issues.
	
	s_inv(a,which,num);
	
}// end get_treasure_marker
//=================================================================================================



int mod_marker(int loc, int typ, int num, int mod)// dont forget to activate function_defines.h
{
/*
			this will do 2 things:
			
			1) return the current marker for either treasure or story marker
			2) store a number into the treasure or story marker
			
			if #1, then dont use num.
			
			- mod is used as a true/false variable.  if true, then it will modify the var.
			  																			 if false, then it will return the var.

*/
		if (loc==8888){return FALSE;}// in the event that the treasure box can reappear, then return
		// that you have not gotten it.
	
		int rows=0,col=0;
		switch (typ)
		{
			case treasure_marker: rows=inv_treasure_rows; col=inv_treasure_loc; 			break;
			case story_marker: rows=inv_story_marker_rows; col=inv_story_marker_loc;	break;
			default: return FALSE; break;
		}

	
	loc--;// to prevent errors, do a -- on it so it will work with the array.  (use 1->xxx) for the marker location
	if ((loc<0) || (loc>=(inv_cols*col))){return 555;}

	int a=col+((int)(loc/inv_cols));// get the correct spot.

	while (loc>=inv_cols){loc-=inv_cols;}
	int i= g_inv(a,loc);
	if (typ==treasure_marker){
		if (i>TRUE){i=TRUE;}// true for have gotten the treasure - flase for not have gotten it.
		else if (i<FALSE){i=FALSE;}
	}// end if treasure marker
	
	if (mod){s_inv(a,loc,num);}
	
	return i;
	
}// end mod_marker
//=================================================================================================


void delete_item_type(int typ)
{
	int item=item_type_exists(typ,3), i=0, area_amt=0, held=FALSE;
	
			if (item<1000){return;}
			if ((i=inv_item_loc(item,0))==555){
			//l
			if (item==link_stat(hold_a)){area_amt=hold_a;held=TRUE;}
			else if (item==link_stat(hold_b)){area_amt=hold_b;held=TRUE;}
			else {return;}// prevent bad juju from out of bounds errors
			}
			if (!held){if (i<inv_cols){s_inv(1,i,0);}}
		else {md_link(area_amt,0, TRUE);}
}

void add_item_inv(int item, int amt, int ext)
{
	/*
			this will add an item to the inventory or add more of that item to the inventory if it 
			already exists.  it can also remove those items.
			ext is for "exteneded" inventory - either true or false.  look at inv_item_loc(int item, int ext)
			for more info
			
			this also takes into account whether you are holding the item or not.  if so, then it will
			add to that item.
			
	*/
		int itm_type=get_item_info(item,item_type);
		int i=0,area_amt=0, held=FALSE;
		if (itm_type==sword){
			// check to see if the current sword has a greater power. if so, do nothig. if not, then delete the old and replace with new.
			if (get_item_info((item_type_exists(sword,3)),item_damage)>get_item_info(item,item_damage)){return;}
			else{	delete_item_type(sword);}// end else
			}
		
			
		
		
		if ((itm_type==hover_boots) || (itm_type==gauntlet) || (itm_type==tunic) || (itm_type==ring) || (itm_type==raft) ||
				(itm_type==bomb_bag) || (itm_type==rupie_bag) || (itm_type==key_normal) || (itm_type==key_boss) || 
				(itm_type==key_master) || (itm_type==quiver)){ext=TRUE;}// this will force it to work correctly every time
		
		if (itm_type==arrow_ammo && item_type_exists(arrow,either))
		{// the bow is defined as arrow.  this is a problem, b/c you can buy arrows in shops.
		// thus i needed to create arrow_ammo.  this converts arrow_ammo to the arrow item
		// however, the first of that item type will be taken into consideration, so you will need
		// to delete out the old bow and add in the new one in the event that you have more
		// than one bow.
			item=item_type_exists(arrow,3);
		}// end if
		if (itm_type==heart)
		{// i made this an item, so you could buy hearts like the original zelda
			md_link(hp,8,FALSE);
			goto end;
		}
		if (itm_type==potion)
		{
			i=hold_a;
			while (i<hold_d){
				if ((get_item_info(link_stat(i), item_type)==bottle) && (link_stat(i+18)<=0))
				{
					amt=get_item_info(item,item_hold);
					if (amt>3){amt=3;}if (amt<0){amt=0;}
					md_link(i+18,amt, TRUE);  
					goto end;
				}
				i++;
			}// end while
			return;// if it is a potion, make sure you never do anything.
		}// end if a potion.
		if ((i=inv_item_loc(item,ext))==555){
			//l
			if (item==link_stat(hold_a)){area_amt=hold_a_amt;held=TRUE;}
			else if (item==link_stat(hold_b)){area_amt=hold_b_amt;held=TRUE;}
			else if (item==link_stat(hold_c)){area_amt=hold_c_amt;held=TRUE;}
			else if (item==link_stat(hold_d)){area_amt=hold_d_amt;held=TRUE;}
			else {
				
					i=inv_item_loc(0,ext);
					if (i<inv_cols){s_inv(1,i,item);}// add the item to the inventory
					// the if <30 is here for 
				}// end else
			}// if cannot find the item, then find the
		// null spot
		if (!held){amt+=item_amt(item,ext);}//if (i<inv_cols){amt+=g_inv(2,i);}}// end if not holding the item
		else {amt+=link_stat(area_amt);}
		
		if (amt>99){amt=99;}
		if (amt<0){amt=0;}
		if (((itm_type==boomerang) || (itm_type==sword) || (itm_type==shield) 
					|| (itm_type==wand) || (itm_type==hookshot)) && (amt>0)){amt=0;}
		if ((itm_type==bottle) && (amt>3)){amt=3;}// fix for bottle to prevent oob errors
		if ((itm_type==bomb) && (amt>link_stat(max_bombs))){amt=link_stat(max_bombs);}
		if ((itm_type==arrow) && (amt>link_stat(max_arrows))){amt=link_stat(max_arrows);}
		//#define max_arrows 15
		if (!held){if (i<inv_cols){s_inv(2,i,amt);}}
		else {md_link(area_amt,amt, TRUE);}
	end:
}// end add item

//=================================================================================================


int inv_item_loc(int item, int ext)
{
	/*
			this will find the inv item loc.
			ext is for "extended".  the extended inventory is everything past 11, only 12
			spots for the orig inventory.  
	WARNING this does have redundant code in it.  item_loc has the same code so does other things
	*/
	
			int i=0, maxer=12;
			if (ext){i=12;maxer=inv_cols;}
	while (i<maxer)
	{
		if (item==g_inv(1,i)){return i;}
		i++;
		
	}// end while
	return 555;// item not found.
}// end inv item loc

//=================================================================================================

int item_amt(int item, int ext)//64815-> 64871
{// this will return the amount of items in the inventory
		int i=0,area_amt=0, held=FALSE;
		
		if ((i=inv_item_loc(item,ext))==555){
			if (item==link_stat(hold_a)){area_amt=hold_a_amt;held=TRUE;}
			else if (item==link_stat(hold_b)){area_amt=hold_b_amt;held=TRUE;}
		//	else if (item==link_stat(hold_c)){area_amt=hold_c_amt;held=TRUE;}
		//	else if (item==link_stat(hold_d)){area_amt=hold_d_amt;held=TRUE;}
			else {return 0;}
			}// end if 555
		if (held){return link_stat(area_amt);}
		if (i<inv_cols){return g_inv(2,i);}// end if not holding the item
		return 0;
}// end item ammount


//=================================================================================================


//=================================================================================================


//=================================================================================================


//=================================================================================================


//=================================================================================================

