// C Source File
// Created 8/10/2011; 11:46:35 PM
/*******************************************************************************/
/* Zelda Crystal Engine                                                       */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"


int get_item_list(int fle) {
 
   		int i=0, k=0;
  int tmp_list[max_list_size][max_item_stats];
  TRY
    FILE *f = NULL;
    
		char sav[5];
   // case save temp
    // open file for writing
    sprintf(sav,"zitm%i",fle);			
    FolderCur(SYMSTR("items"),TRUE);
    // open file for reading in binary mode
   //HSym sym = SymFind (SYMSTR (sav));
    if ((f = fopen(sav,"rb")) == NULL) { return FALSE;} else {
        if (fread(tmp_list,sizeof(tmp_list),1,f) != 1) {return FALSE;}
					
					for(i=0; i<max_list_size; i++){for(k=0; k<max_item_stats; k++){set_item(i,k, tmp_list[i][k]);}}

        fclose(f);
    }



	ONERR
	ENDTRY
    return TRUE;
}


int get_proj_list(int fle) {
 
   		int i=0, k=0;
  int tmp_list[max_projectiles_size][max_projectiles_stats];
  TRY
    FILE *f = NULL;
    
		char sav[5];
   // case save temp
    // open file for writing
    sprintf(sav,"zprj%i",fle);			
    FolderCur(SYMSTR("items"),TRUE);
    // open file for reading in binary mode
   //HSym sym = SymFind (SYMSTR (sav));
    if ((f = fopen(sav,"rb")) == NULL) { return FALSE;} else {
        if (fread(tmp_list,sizeof(tmp_list),1,f) != 1) {return FALSE;}
					
					for(i=0; i<max_projectiles_size; i++){for(k=0; k<max_projectiles_stats; k++){set_proj_list(i,k+20, tmp_list[i][k]);}}

        fclose(f);
    }



	ONERR
	ENDTRY
    return TRUE;
}


void add_special_item(int type, int item)
{
		switch(type)
		{
			case bomb_bag: mod_link(max_bombs,15,FALSE);break;
			case rupie_bag: mod_link(max_rupies,500,TRUE);break;
			case quiver: mod_link(max_arrows,15,FALSE);break;
			case heart_container: mod_link(max_hp,8,FALSE);mod_link(hp,512,FALSE); return; break;
			default: return; break;
		}
		add_item_inv(item, 1, TRUE);
}
