// C Source File
// Created 7/15/2011; 3:11:25 AM
/*******************************************************************************/
/* Zelda Crystal Engine                                                       */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"
#include "start.h"
/*

17965 -> 17979 -> 17964
		this is the file that will handle link gfx


*/


extern char *light, *dark;
extern int link_speed,link_direction,link_picture, link_x, link_y, link_speed_adjust,room_entry_x,room_entry_y;
extern int   link_frame,sword_charge,keyl, keyr, keyu, keyd,keya,keyb, link_frame2;                    //Keeps track of link's frame #.
int spins=0, spinslash_active=FALSE, disp_hearts=TRUE, heart_x=90, heart_y= -2, item_used=0,hover=0,heart_reverse=TRUE;
extern int dark_room,button_pressed,double_damamge,skip_animate_mob;
//=================================================================================================


//=================================================================================================
/*
void link_gfx_loader(int id)
{
	char messa[10];
	FolderCur(SYMSTR("gfx"),TRUE);// transfer to the mob filder.
	FILE *q = NULL;
	unsigned short tmp[4][link_gfx_size*3][16];
	int w=0, x=0, y=0;


	TRY

		q = NULL;

	sprintf(messa,"link%i",id);

    

    if ((q = fopen(messa,"rb")) == NULL) {return;} else {
        if (fread(tmp,sizeof(tmp),1,q) != 1) {return;}else{
        	for (w=0;w<4;w++){
	        	for (x=0;x<link_gfx_size;x++){
	        		for (y=0;y<16;y++){
	        			s_link_pic(w,x,y,tmp[w][x][y],1);
	        			s_link_pic(w,x,y,tmp[w][x+link_gfx_size][y],2);
	        			s_link_pic(w,x,y,tmp[w][x+(link_gfx_size*2)][y],3);
	        		}// 3nd for
	        	}// 2st for
	        }// 1st	for
        }
        fclose(q);
    }
 
 
	ONERR
	ENDTRY     
 

	
}// end link loader
*/

void link_gfx_loader(int id)
{
	char messa[10];
	FolderCur(SYMSTR("gfx"),TRUE);// transfer to the mob filder.
	FILE *q = NULL;
	unsigned short tmp[4][link_gfx_size][16];
	int w=0, x=0, y=0, loop=0;

redo:
	TRY

		q = NULL;

			switch(loop)
			{
				case 0: sprintf(messa,"linkl%i",id); break;
				case 1: sprintf(messa,"linkd%i",id); break;
				case 2: sprintf(messa,"linkm%i",id); break;
			}
    

    if ((q = fopen(messa,"rb")) == NULL) {return;} else {
        if (fread(tmp,sizeof(tmp),1,q) != 1) {return;}else{
        	for (w=0;w<4;w++){
	        	for (x=0;x<link_gfx_size;x++){
	        		for (y=0;y<16;y++){
	        			s_link_pic(w,x,y,tmp[w][x][y],loop+1);
	        		}// 3nd for
	        	}// 2st for
	        }// 1st	for
        }
        fclose(q);
    }
 
 
	ONERR
	ENDTRY     
 
		loop++;
		if (loop<3){goto redo;}
	
}// end link loader
//*/


//=============================================================================================




int dir_to_sprite_xy_modder(int dir, int xy, int sprite)
{
	/*
			this routine will find out how much to add to your current sprite based upon your x/y
			1 is for the x var, 2 is for the y var
	*/
	
	switch (dir)
	{
		case up:
			if (xy==1){	return 0;	}// if it is x
			else {return sprite*-1;} 
		break;
		case down:
			if (xy==1){	return 0;	}// if it is x
			else {return sprite+8;} 
		break;
		case left:
			if (xy==1){	return sprite*-1;	}// if it is x
			else {return 0;} 
		break;
		case right:
			if (xy==1){	return sprite+8;	}// if it is x
			else {return 0;} 
		break;
		default:
		return 0;
		break;
	}// end switch dir
	return 0;
}// end dir to sprite xy modder
//=================================================================================================


void gfx_slash(int weapon_type)
{// note: this only works with one sword.  if use use another sword of a different drawing, it wont work.
		
		int x=0,y=0,itm=1,x1=0,y1=0,w=0,h=0,ty=link_loc(link_y),tx=link_loc(link_x), rotate=0,walker=0,sub_frame=link_frame2;
		int type=A_NORMAL;
		int x_oof=0, y_oof=0;// this is for the offset of x/y for the width of the sword, b/c the sword wont start at 0,0
		// instead it will start at like 0,5.
		if (link_stat(state)==LINK_SPIN_SLASH){sub_frame=link_frame;}
		if (link_stat(dual_state)==LINK_WALKING_SWORD){sub_frame=2;walker=4;}
		if (link_stat(dual_state)==LINK_WAND && link_frame2<3){sub_frame=2;}
		/// magic appearing boomerange problem exists in here.  itm was set to 0.  then somehow it gets itm++, which puts the
		/// gfx pic at 1, which is the boomerang.  somehow, the item pic is not being gotten. itm=1 is a temp fix to this
		// issue, but it does not fix it.  you need to find the problem and location.  - somehow the sub frame is not starting
		// where you think it does, so maybe reset subframe to 0???  or adjust the itm++, to do it in the beginning and then do
		// a itm-- in the event it is not a "thurst"
		
		itm=get_item_info(item_used,item_pic_2);// this is where the sword starts
	switch (sub_frame)
			{
				case 0:// due to slow speed, this case will not be used in the spinslash - instead
				// the spinslash will start at 1 and continue from there.  using case 0 makes it look
				// choppy.  besides, case 0 doesnt use slash mob.
					link_picture = LINK_THRUST;
					itm++;//=SWORD3;
					//------------------------------------------------------
					// Draws the sword swinging. The random pixels off
					// link_x and link_y are just for display adjustments.
					//------------------------------------------------------
					switch (link_direction)
					{
						case up:
							rotate=rot_90;// rotate the picture 90 degrees
							x=link_x+16;y=link_y - 5;
						break;
						case right:
							x=link_x+2;y=link_y - 16;
						break;
						case down:
								rotate=rot_270;
								x=link_x-16;y=link_y;
						break;
						case left:
							x=link_x-2;y=link_y - 16;
						break;
					}// end switch
					break;
				case 1:
					link_picture = LINK_THRUST2;
					//itm=SWORD2;
					//---------------------------------------------
					// At this stage, the routine checks if Link
					// slashed any terrain or mobs.
					//---------------------------------------------
					switch (link_direction)
					{
						case up:
							ty--;w=13;h=13;
							x1=link_x+1;y1=link_y-18;//w=22;h=19;
							x=link_x+12;y=link_y - 14;// keep the same for spinslash
							x_oof=3; y_oof=8;
							 if (spinslash_active){tx++;}
							break;
						case right:
							tx++;
							x1=link_x+12;y1=link_y-12;//w=20;h=27;
							x=link_x+13;y=link_y - 13;w=13;h=13;
							x_oof= (-3); y_oof=2;
							 if (spinslash_active){rotate=rot_90;x=link_x+14;y=link_y + 13;//itm=SWORD8;itm+=2;
							 x1=link_x+11;y1=link_y+13;w=24;h=20;ty++;}// using sword 8 only here if spinslashing.
							break;
						case down:
							ty++;w=13;h=13;
							//itm++;//SWORD6;itm+=2;
							rotate=rot_180+1;// this rot is a glitch fixer.  making it go horizontal does not work, so this is used instead
							// it allows me to use 2 sprites for the sword instead of 3.
							//w=20;h=26;
							x1=link_x-10; y1=link_y+15;
							x=link_x-12;y=link_y + 13;// leave this part alone for spinslash
							if (spinslash_active){tx--;}
							break;
						case left:
							tx--;
							x1=link_x-20;y1=link_y-12;//w=20;h=26;
							x_oof=7;y_oof=2;
							rotate=rot_270;w=13;h=13;
							x=link_x-13;y=link_y - 13;// leave alone for spinslash
						if (spinslash_active){ty--;}
							break;
					}// end switch
						if (weapon_type==sword)
						{
							
							slash_terrain(ty, tx);
							if (double_damamge){slash_terrain(ty+1, tx); slash_terrain(ty, tx+1); slash_terrain(ty+1, tx+1);
																		slash_terrain(ty-1, tx); slash_terrain(ty, tx-1); slash_terrain(ty-1, tx-1);
																		w+=12;h+=12;	}
							SlashMob(x1+x_oof, y1+y_oof, w, h);
						}// end if a swrod
					break;
				case 2:
					link_picture = LINK_THRUST2;
				
					//--------------------------------------------
					// Link's position is slightly modified when
					// he as fully extended his sword.
					//--------------------------------------------
					
					// to blink
					itm++;//=SWORD3;
					if (weapon_type==wand){itm=WAND;}
					rotate=dir_to_rotate(link_direction);
					switch (link_direction)
					{
						case up:
							x=link_x-2;y=link_y - (16-walker);w=6;h=10;x_oof=5;
							x1=link_x;y1=y;
							 //x1=x;y1=y;//w=5;h=10;
							 if (spinslash_active){rotate=rot_90;x=link_x+16;y=link_y - 5;ty--;}//itm=SWORD1;
							break;
						case right:
						//	rotate=rot_90;
							x=link_x+(16-walker);y=link_y+4;w=13;h=6;y_oof=5;
							x1=x;y1=link_y;
							//x1=x;y1=y+9;//w=10;h=5;
							 if (spinslash_active){rotate=rot_180;x=link_x-1;y=link_y +16;
							x1=x;y1=y;w=5;h=10;tx++;}// end with sword of down.
							break;
						case down:
						//	rotate=rot_180;
							x=link_x+4;y=link_y +(16-walker);w=6;h=10;x_oof=5;
							x1=link_x;y1=y;
							//x1=x;y1=y;//w=5;h=10;
							 if (spinslash_active){rotate=rot_270;x=link_x-16;y=link_y;ty++;}//itm=SWORD5;
							break;
						case left:
					//		rotate=rot_270;
							x=link_x-(16-walker);y=link_y+4;w=15;h=6;y_oof=5;
							x1=x;y1=link_y;// the x-2 gives it a little more length
							//x1=x;y1=y+9;//w=10;h=5;
							 if (spinslash_active){rotate=0;x=link_x-2;y=link_y - 16;tx--;}//itm=SWORD3;
						break;
					}// end switch
						if (weapon_type==sword)
						{
							
							
							if (spinslash_active){slash_terrain(ty, tx);
								if (double_damamge){slash_terrain(ty+1, tx); slash_terrain(ty, tx+1); slash_terrain(ty+1, tx+1);
															slash_terrain(ty-1, tx); slash_terrain(ty, tx-1); slash_terrain(ty-1, tx-1);w+=12; h+=12;}}
							SlashMob(x1+x_oof, y1+y_oof, w, h);																		
							
						}// end if type == swrod
						
						if (weapon_type==wand && link_frame2==2){
								// spins=link_y;
							//	if (spins<2){spins=2;}// this will allow link to use the wand when at the very top of the screen.

								
								sword_charge=add_object(WAND, fix_xy(link_x, 1)+dir_to_sprite_xy_modder(link_direction, 1, 6)	, fix_xy(link_y, 2)+dir_to_sprite_xy_modder(link_direction, 2, 6),item_used);
								set_object(sword_charge, obj_dir, link_direction);// these set up the objects	
								set_object(sword_charge, obj_var2, get_item_info(item_used,item_pic_2));// set the pic of teh object.
								set_object(sword_charge, obj_dam, get_item_info(item_used,item_damage));// set the damage of the object.
								set_object(sword_charge, obj_type, wand);// set the damage of the object.
								sword_charge=0;// reset sword charge, so i dont have issues. i used the global var just so i didnt have to create
								spins=0;
								// new vars.
							//	set_object(id, obj_dam, get_item_info(item, item_damage));
						//	link_frame = -1;
						//	link_frame2 = -1;
							}//	id =add_object(WAND, link_x, link_y);		*/				
					break;
				//----------------------------------------------------------
				// Very short pause when Link has his sword fully extended
				//----------------------------------------------------------
				
				case 3:
						double_damamge=FALSE;
					break;
				default:	//Reset frame
					
					link_frame = -1;
					double_damamge=FALSE;
					if (link_stat(dual_state)==LINK_THRUST || link_stat(dual_state)==LINK_WAND){	mod_link(dual_state,0, TRUE);}	// end if not spin slash	
			/*		if (weapon_type==wand){
						sword_charge=add_object(WAND, link_x+dir_to_sprite_xy_modder(link_direction, 1, 6)	, link_y+dir_to_sprite_xy_modder(link_direction, 2, 6),item_used);
						set_object(sword_charge, obj_dir, link_direction);// these set up the objects	
						set_object(sword_charge, obj_var2, get_item_info(item_used,item_pic_2));// set the pic of teh object.
						set_object(sword_charge, obj_dam, get_item_info(item_used,item_damage));// set the damage of the object.
						set_object(sword_charge, obj_type, wand);// set the damage of the object.
						sword_charge=0;// reset sword charge, so i dont have issues. i used the global var just so i didnt have to create
						// new vars.
					//	set_object(id, obj_dam, get_item_info(item, item_damage));
					}//	id =add_object(WAND, link_x, link_y);*/
					link_frame2 = -1;
//	set_object(id, obj_dir, link_direction);// these set up the objects
//	set_object(id, obj_dam, get_item_info(item, item_damage));// might need damage type for afw3
				break;// end defaULT
			}
			
	//		if (link_stat(dual_state)==LINK_WALKING_SWORD){walking(0,link_speed);}
			if ((sword_charge>20)&&((sword_charge%2)==0) && (link_stat(hp)>=(int)(link_stat(max_hp)*.7))){type=A_REVERSE;}// this causes the sword to blink
			// also it has been fixed so that it will only blink in the event that hp is maxed.
			
			if (sub_frame<3){DrawImage(OBJECT, itm, x, y, type, TRUE,rotate);}// then slash
			link_frame++;
			link_frame2++;
}// end slash

//=================================================================================================

void hole_walkling()
{
	//	if ((touching_sprite(link_x, link_y, 170)) || (touching_sprite(link_x, link_y, 171)) || (touching_sprite(link_x, link_y, 172)) ||
	//			(touching_sprite(link_x, link_y, 173)) || (touching_sprite(link_x, link_y, 174)))
				if (link_stat(dual_state)==LINK_HOOKSHOT){return;}// dont fall down holes when using a hookshot
			//	int chk=FALSE, i=0;
				int i=0;
			//	for (i=170; i<175;i++){
				//if (touching_sprite(link_x, link_y, i))
				if	((i=touching_sprite_range(link_x, link_y, 170, 174, TRUE))>=170)
				{// if you are touching a hole, then fall into it.
//printf("toucing");			
					//chk=TRUE;
					if ((item_type_exists(hover_boots,4)) && (hover<9)){hover++;}
					else{
						set_link_sprite_loc(link_x, link_y, i);// align with the hole sprite (in ezelda) 
					
						link_x=link_stat(inv_link_x);// fix the stats from ezelda to here.
						link_y=link_stat(inv_link_y);
//printf("falling %i %i", link_x, link_y);wait_for_key(esc_ko);						
					//	link_x=gter(link_x+6)*16;
					//	link_y=gter(link_y+6)*16;// this should set the sprite about right in the center of that hole.
						mod_link(state,LINK_STUN,TRUE);
						mod_link(dual_state,LINK_HOLE_FALL,TRUE);
						link_frame=0;
						
					}// end if not hovering
				}// end if touching a hole.
				else {hover=0;}
		//	}//end for
			//	if (!chk){hover=0;}// if not touching a hole, then do not hover.
}// end hole walking

void change_link_frame(int pic){
			switch (link_frame)
			{
				case 0 ... 2:
					link_picture = pic;
					break;
				case 3 ... 5:
					link_picture = pic+1;
					break;
				default:	//Reset frame
					link_picture = pic;//LINK_WALK;
					link_frame = 0;
				break;	
			}// end switch
	}// end change link frame

void walking(int pic, int speed)
{
	// this is a generic routine for link walking.
//	int a=0;
	//	if (link_stat(state)==LINK_STUN){return;}
		
		change_link_frame(pic);
			int water=(touching_sprite(link_x, link_y, 54));
			int mv=can_move(LINK,link_direction);
//printf_xy(0,80,"%i",mv);	slow(7000);		
	if ((mv==TRUE) && (!water)){move_link(speed);//(link_stat(state)!=LINK_PUSH)
			if (link_stat(state)==LINK_PUSH){mod_link(state,LINK_WALK,TRUE);}
	 }// end if link can move.
	// the mod link to link walk exists to get rid of the annoying link push state once you move to a
	// place where he isnt pushing anymore.

	else if ((water) && (mv==TRUE)){
	//get_all_maps(rmapx, rmapy,gter(link_y),gter(link_x))==54){
	//		mod_link(state,LINK_NORMAL,TRUE);
			mod_link(dual_state,LINK_RAFTING,TRUE);
			link_picture = LINK_NORMAL;

			move_object(obj_loc(item_raft), speed, link_direction);
			move_link(speed);
		//	add_object(item_raft, link_x, link_y+8, item_raft);	
	 		if (obj_loc(item_raft)==555){mod_link(link_rand_var1,add_object(item_raft, link_x, link_y+8, item_raft),TRUE);}
	 		
		}// END IF ON WATER.
		else if (mv>=100)// made this modification specifically for push stones.
		{if (get_item_info(get_object(mv-100,OBJECT_NUMBER),item_type)==pushable){mod_link(state,LINK_PUSH,TRUE);move_push_stone(mv-100);}}
		
		else  {mod_link(state,LINK_PUSH,TRUE); }// mod the pic to make link push
/*	if ((touching_sprite(link_x, link_y, 170)) || (touching_sprite(link_x, link_y, 171)) || (touching_sprite(link_x, link_y, 172)) ||
				(touching_sprite(link_x, link_y, 173)) || (touching_sprite(link_x, link_y, 174)))
				{// if you are touching a hole, then fall into it.
					if ((item_type_exists(hover_boots,4)) && (hover<120)){hover++;}
					else{
						link_x=gter(link_x+6)*16;
						link_y=gter(link_y+6)*16;// this should set the sprite about right in the center of that hole.
						mod_link(state,LINK_STUN,TRUE);
						mod_link(dual_state,LINK_HOLE_FALL,TRUE);
						link_frame=0;
					}// end if not hovering
				}// end if touching a hole.
				else {hover=0;}// if not touching a hole, then do not hover.*/
		//	hole_walkling();// must keep this here, otherwise things break bad.
}// end walking

//=================================================================================================
/*void rafting(int speed)
{// when link is riding the raft, then do this:
// if link gets his by something or by a mob, then link tends to reel back.  if rafting, you need to prevent
// the reel effect.
link_picture = LINK_NORMAL;
	if (can_move(LINK,link_direction)){
			//	set_object(x,OBJECT_X,link_x);x=link_stat(link_rand_var1);set_object(x,OBJECT_Y,link_y-16);
			move_object(obj_loc(item_raft), speed, link_direction);
			move_link(speed);
		}// end if can move
	
	
	
	//void move_object(int loc, int speed, int dir);
	
	//obj_loc(int id)
	//move_object(link_dir, link speed, ob_id(item_raft));
	//mod_link(state,LINK_NORMAL,TRUE);
}// end rafting.*/

void set_inv_xy()
{
	mod_link(inv_link_x, link_x, TRUE);// make sure to add his x/y pos to the inv so it can be accessed in ezelda			
	mod_link(inv_link_y, link_y, TRUE);//			int which, int number, int replace

}

void move_link(int speed)
{
						switch (link_direction)
					{
						case up:
							link_y-=speed;
						break;
						case down:
							link_y+=speed;
						break;
						case left:
							link_x-=speed;
						break;
						case right:
							link_x+=speed;
						break;
					}// end switch
// prevent link from going too far out of bounds.					
if (link_y<(-16)){link_y=(-16);}
if (link_y>128){link_y=128;}
if (link_x<(-16)){link_x=(-16);}
if (link_x>160){link_x=160;}	
set_inv_xy();
}

//=================================================================================================

void generaic_item_use()
{
//	link_picture = LINK_THRUST2;
			switch (link_frame2)
			{
				case 0:
					link_picture = LINK_THRUST;
					break;
				case 1 ... 2:
					link_picture = LINK_THRUST2;
					break;
				default:	//Reset frame
						mod_link(dual_state,0, TRUE);//link_picture = pic;//LINK_WALK;
					link_frame2 = -1;
				break;	
			}// end switch
			link_frame2++;
}// end generic item useage

//=================================================================================================


void dual_animation()
{
		int x=0,y=0;
		switch(link_stat(dual_state))
		{
				case LINK_WALKING_SWORD:
				case LINK_THRUST:
						gfx_slash(sword);
				break; //end default.
			case 	LINK_WAND:
				gfx_slash(wand);
			break;
					case LINK_GENERIC_ITEM:
				generaic_item_use();
			break;
			case LINK_SHIELD:
			link_picture=8;
			break;
			case LINK_LIFT1:
				link_picture=10;
				if ((x=link_stat(link_rand_var1))==555)
				{mod_link(state,LINK_NORMAL,TRUE);mod_link(dual_state,LINK_NORMAL,TRUE);link_frame=0;break;}
				// i kept getting a shadow.  in reality,
				// i was getting a 555 null item, so this should prevent that
				
				y=get_object(x,OBJECT_Y);
				if (y<=(link_y-14))
				{
				// put this elsewhere.
					set_object(x,OBJECT_X,link_x);
					set_object(x,OBJECT_Y,link_y-16);
					if (get_object(x,obj_type)!=boom_bomb){	set_object(x,obj_type,follow_object);}
					mod_link(dual_state,LINK_LIFT2,TRUE);
					
				}
				else{
					set_object(x,OBJECT_Y,y-4);
				//	mod_link(state,LINK_NORMAL,TRUE);
				//	mod_link(dual_state,LINK_LIFT1,TRUE);
					link_frame=0;
				}	
			//	link_frame++;
			//	if (link_frame>5){mod_link(dual_state,LINK_LIFT2,TRUE);}
			break;
			case LINK_LIFT2:
				link_picture=11;

			break;
		case LINK_GET_ITEM:
			link_direction=down;
			link_picture=11;
			link_frame++;
			//	printf("%i, ",obj_loc(link_stat(link_rand_var1)));wait_for_key(b_ko);
			if (obj_loc(link_stat(link_rand_var1))==555){add_object(link_stat(link_rand_var1), link_x, link_y-13, 555);}// to make sure that link doesnt grab the object.}
			if (link_frame>20){	mod_link(state,LINK_NORMAL,TRUE);link_frame=0;delete_obj(obj_loc(link_stat(link_rand_var1)));}
		break;
		case LINK_HOLE_FALL:
			link_picture=13;
			link_direction=up;
			if (link_frame>10){link_direction=down;}
			if (link_frame>20){link_direction=left;}
			if (link_frame>30){// after you show the gfx of him falling, make him lose life and then repop.
				mod_link(state,LINK_NORMAL,TRUE);
				mod_link(hp,-4,FALSE);
				link_frame=-1;link_frame2=0;
				link_x=room_entry_x;
				link_y=room_entry_y;
				link_direction=down;
				dont_get_stuck();
				mod_link(dual_state,0,TRUE);
				hover=0;
				}
				link_frame++;
		break;
		case LINK_RAFTING:
			if ((!(touching_sprite(link_x, link_y, 54))) &&  (!(touching_sprite_range(link_x, link_y, 66, 81, FALSE)))){
		//	get_all_maps(rmapx, rmapy,gter(link_y),gter(link_x))!=54){// and does != treadmill sprites. - fix this later.
				mod_link(dual_state,0,TRUE);
				delete_obj(obj_loc(item_raft));
				mod_link(link_rand_var1,0,TRUE);
			}
		break;
		case LINK_DEAD:
			mod_link(state,LINK_DEAD,TRUE);
			if ((link_frame%5)==0){link_direction=circle_dir(link_direction);}
			link_frame++;
			if (link_direction>right){link_direction=up;}
			if (link_frame>45){
				for (x=0; x<3; x++)
				{if (item_amt(item_bottle_1+x, 0)==bottle_faerie)
				{mod_link(state,LINK_NORMAL,TRUE);mod_link(dual_state,0,TRUE);mod_link(hp,1,TRUE);use_faerie(item_bottle_1+x);return;}}
			game_over();
			}
			//	if ((x=item_type_exists(bottle_faerie,8))>999){use_faerie(x);}
			//	else if ((x=item_type_exists(bottle_faerie,9))>999){use_faerie(x);}
		//		else {game_over();}}
		break;


		}// end dual state
}// end dual animation


void AnimateLink()
{
	/*
	gah this routine sucks.  things to redo: item usage.  items should have their own special
	routines to do.  this tries to do everything...  jumping and falling do different things.
	lrud should be a simple routine (only 1 routine.  pass in the dir to know which way to go.)
	
	there should be a routine for button pressing.  just pass in which button was pressed (a or b)
	and find out which item link was holding in this pos.  after that call the routine to use 
	that item.  if a special item, then call the sl to find out if it will be used.
	
	too many global variables.  this takes up too much ram.  just pass the variables into the 
	routine.  i mean shit dude.
	*/
// if link is on a treadmill, then if (can_move(LINK,link_direction)){move_link(link_speed+2);
	if (touching_sprite(link_x, link_y, 66)){link_direction=up; move_link(link_speed);}
	if (touching_sprite(link_x, link_y, 70)){link_direction=right; move_link(link_speed);}
	if (touching_sprite(link_x, link_y, 74)){link_direction=down; move_link(link_speed);}
	if (touching_sprite(link_x, link_y, 78)){link_direction=left; move_link(link_speed);}
	
	// dir up, 70R, 74D, 78L
	
	
	
	switch (link_stat(state))
	{
		case LINK_NORMAL:
			if (link_stat(dual_state)>0){dual_animation();}
			else{	link_picture = LINK_NORMAL;	
			if (item_type_exists( shield, hold)){link_picture=4;}
			link_frame = 0;
			link_frame2 = 0;}
			break;

		//--------------------------------------------------------------------------
		// LINK_WALK scrolls through 6 frames - the first 3 showing Link walking,
		// the other 3 showing Link normal. This creates the illusion of walking
		//--------------------------------------------------------------------------
		case LINK_WALK:
			if (item_type_exists( shield, hold))// if link is hold a shield, then do the following:
			{link_picture=4;}else {	link_picture=0;}
			if (link_stat(dual_state)>0){dual_animation();}
			
			// make link face down and make pic==12 for when link holds an item after getting it.

		walking(link_picture,link_speed);
			
			
		/*	switch (link_frame)
			{
				case 0 ... 2:
					link_picture = LINK_WALK;
					break;
				case 3 ... 5:
					link_picture = LINK_NORMAL;
					break;
				default:	//Reset frame
					link_picture = LINK_WALK;
					link_frame = 0;
			}*/
			link_frame++;
			break;
		case LINK_RAFTING:
			link_picture = LINK_NORMAL;
		//	rafting(4);// always move 4 pixles
			link_frame = 0;
			walking(LINK_NORMAL, 4);
			dual_animation();// just to make sure the raft dissappears in the event that you get out of water.
		break;
/*			
		case LINK_WALKING_SWORD:
			//if (can_move(LINK,link_direction)){move_link(2);}
			gfx_slash(sword);
			//gfx_walking_sword();
			//link_frame++;
		break;
		*/
		case LINK_SPIN_SLASH:
			gfx_spin_slash();
		break;
		//------------------------------
		// When Link Jumps or falls
		//------------------------------
/*		case LINK_JUMP:
			link_direction = down;
			switch (link_frame)
			{
				case 0 ... 1:
				//	link_y += 4;// this might fix link from not jumping.
					link_picture = 21;//LINK_JUMP;
					break;
				case 2 ... 3:
					link_picture = 22;//LINK_JUMP2;
					break;
				case 4 ... 5:
					link_picture = 23;//LINK_JUMP3;
					break;
				default:
					link_frame=0;
					link_picture = 21;//LINK_JUMP;
				break;
			}
			if (link_y+2 > 8*16-16  +4)
				scroll_room(down);
				
				
//printf("%i",link_frame);wait_for_key(esc_ko);			wait_for_key(b_ko);		
		//if (CheckTerrainCollision(link_x, link_y, 16, 16))// basically this means
		// if you cannot move, then increase link, else when you hit a walkable sprite, then
		// stop and return to normal.
			link_frame++;
			
			if (!(can_move(LINK,down))){link_y += 4;}
			else
			{// when you removed this, it make link permantly jump.
				link_y += 8;// move a bit more, just b/c
				mod_link(state, LINK_NORMAL,TRUE);
				link_frame = 0;
				
			}//*/

/*			DrawImage(OBJECT, link_picture, link_x, link_y, A_NORMAL, TRUE,0);
			return;
		//	printf_xy(5,0,"jumping");
		//	link_frame++;
			break;
*/
		//--------------------------------------------------------------------------
		// NOTE: each direction link is facing has a different LINK_THRUST picture
		//--------------------------------------------------------------------------
	/*	case LINK_THRUST:
					gfx_slash(sword);
			break; //end default.
		case 	LINK_WAND:
			gfx_slash(wand);
		break;	
		*/		
	case LINK_REEL_BACK:
			mod_link(link_blink,10,TRUE);// make link blink around 5 times after he gets hit.
			mod_link(state,LINK_STUN,TRUE);
			if (link_stat(dual_state)==LINK_HOOKSHOT){return;}
			link_picture = LINK_NORMAL;
			//keyu=TRUE;keyd=TRUE;keyl=TRUE;keyr=TRUE;// disable the keys
			gfx_reel_back(LINK);
			//link_frame++;
			
			//if (link_stat(dual_state)!=LINK_RAFTING){
				
			mod_link(dual_state,0,TRUE);
			
			// now make link blink
		break;
		case LINK_REEL_BACK_NO_DAMAGE:
			gfx_reel_back(LINK);
		break;
		
		case LINK_STUN:// this is to prevent link from using any controlls after he is hit.
				if (link_stat(dual_state)>0){dual_animation();}
			else{
			link_frame++;
			if (link_frame>1){	mod_link(state,LINK_NORMAL,TRUE);}
		}
		break;

		case LINK_PUSH:
		/// add push stone here
	//	change_link_frame(6);
			walking(6, 0);// requires #7 in the gfx 
			link_frame++;
		break;
		case LINK_DEAD:
			if (link_stat(dual_state)!=LINK_DEAD)
			{
				//clr_mob_list(1);
				skip_animate_mob=TRUE;// instead of clearing the list, we will simply not display the mobs so if there is a faerie in
				// a bottle, then we can restore the mobs
				link_frame=0;
				mod_link(dual_state,LINK_DEAD,TRUE);
				link_picture = LINK_NORMAL;
				//mod_link(state,LINK_STUN,TRUE);
			}
			else {dual_animation();}
		//	game_over();
		break;
//		case LINK_ARROW:
//			generaic_item_use();
			//if link_frame>=2)
//		break;
	/*	case LINK_GENERIC_ITEM:
			generaic_item_use();
		break;*/
/*		case LINK_SHIELD:
			this is used in other parts.
			
		break;
*/		
	}
	if (disp_hearts){draw_hearts2(heart_x,heart_y,heart_reverse);}//gfx_disp_hearts(heart_x,heart_y);}//gfx_disp_hearts(90,-2);}
	int loc=link_stat(link_rand_var1);
	if (link_stat(dual_state)==LINK_LIFT2){
			set_object(loc,OBJECT_X,link_x);
			set_object(loc,OBJECT_Y,link_y-16);
			DrawImage(OBJECT, get_item_info(get_object(loc,OBJECT_NUMBER),item_pic_id),get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), A_NORMAL, TRUE,0);
	}// end if holding an item.
		DrawImage(LINK, link_picture, link_x, link_y, A_NORMAL, TRUE,0);
 	if (get_all_maps(rmapx, rmapy,gter(link_y),gter(link_x))==34){DrawImage(OBJECT, SHADOW1, link_x, link_y+1, A_NORMAL, TRUE, 0);}
}// end animate link

//=================================================================================================









//=================================================================================================


void gfx_spin_slash()
{	
	/*
	
	fyi: using this setup and the current slashing system will not at all work.
	
	ok problem of spinslash: you did not redo the vars for the gfx positioning.  
	however, you came accross something pretty cool.  b/c you did not readjust it, 
	you found a kuzuk ken move that you could put into afw3.  that is awesome.  use spin>6 for
	the kuzuk ken move.  and make him so the guy does not move.  maybe redo the gfx just a bit.
	*/
	//link_frame = 0;
//mod_link(state,LINK_SPIN_SLASH, TRUE);
//	mod_link(state,LINK_THRUST, TRUE);
	
	spinslash_active=TRUE;

	if (sword_charge>=20){sword_charge=2;}else{sword_charge=1;}// erase later.
	// this swordcharge will be used as a multiplier for the damage you do in slash mob.
	gfx_slash(sword);
if (link_frame>=3){
	/*switch (link_direction)
	{
		case up: link_direction=right;	break;// up will be the reverse
		case down: link_direction=left;	break;// down will be the reverse of the array
		case left: link_direction=up;	break;// left will be the reverse
		case right: link_direction=down;	break;// will need to be modified w/ pic 8 added, starting
		// with the end of right slash and ending with the end of the down slash
	}// end switch*/
	link_direction=circle_dir(link_direction);
	link_frame=1;spins++;
	if (spins>3){spins=0;spinslash_active=FALSE;double_damamge=FALSE;mod_link(state, LINK_NORMAL, TRUE);sword_charge=0;}
	}// end frame chk
	//if (link_direction>3){link_direction=0;}

	//slow();// 51 freezes
//	printf("%i",link_frame);
	//spin++;
}// end spin slash


//==================================================================================
extern int argh;
int chk_for_lift()
{

	if ((keya==TRUE) || (keyb==TRUE)){return FALSE;}
	if (!item_type_exists(gauntlet,4)){return FALSE;}
	
	int x=link_x;
	int y=link_y;
	int old_x=0;
	int old_y=0;
	int new_oj=0;// this is for the new object you are getting.
	switch (link_direction)
	{
		case up:
			y-=4;
		break;
		case down:// this was removed, because it kept on picking up the wrong objects
			y+=10;// you need to adjust x to a very slim section in order to make this work.
		//	x+=2;// you need this to prevent left or right pickup.		
		break;
		case left:
			x-=4;
		break;
		case right:
			x+=4;
		break;
	}// end switch
	/*if (!can_move(LINK, link_direction))
	{
		mod_link(dual_state,LINK_LIFT1,TRUE);
	}*/
	if (argh>3){return FALSE;}
	int obj=0, redoish=FALSE;
	if (link_stat(dual_state)!=LINK_LIFT2){
		if (link_stat(dual_state)==LINK_LIFT1){return TRUE;}// just do it quickly.
		if ((new_oj=touch_object(x, y, LINK, 0, TRUE))!=555)
		{


//char bb[30];
//sprintf(bb,"%i",new_oj);
//disp_error(bb);			
	//	printf("obj=%i",obj);wait_for_key(b_ko);
			obj=get_object(new_oj,obj_type);//get_item_info(get_object(new_oj, OBJECT_NUMBER),item_type);
			old_x=get_object(new_oj,OBJECT_X);
		  old_y=get_object(new_oj,OBJECT_Y);
		  // the below section is to fix grabbing the wrong object when facing down.

//printf_xy(0,12,"%i %i %i",obj, old_x, old_y);wait_for_key(esc_ko);
		  if ((link_direction==down) && (old_x>=link_x+11))// if touching to the right
		  {if ((new_oj=touch_object(x-10, y, LINK, 0, TRUE))!=555){redoish=TRUE;} }
		  else if ((link_direction==down) && (old_x<=link_x-9))// if touching to the left
		  {if ((new_oj=touch_object(x+10, y, LINK, 0, TRUE))!=555){redoish=TRUE;} }

		  if (((link_direction==right) || (link_direction==left)) && (old_y>=link_y+6))// if touching to the above
		  {if ((new_oj=touch_object(x, y-6, LINK, 0, TRUE))!=555){redoish=TRUE;} }
		  else if (((link_direction==right) || (link_direction==left))  && (old_y<=link_y-6))// if touching to the left
		  {if ((new_oj=touch_object(x, y+6, LINK, 0, TRUE))!=555){redoish=TRUE;} }
		 
		  if (redoish)
		  {// redo the object info if the wrong item was gotten.
			//	if ((new_oj=touch_object(x, y, LINK, 0, TRUE))!=555){
					obj=get_object(new_oj,obj_type);//get_item_info(get_object(new_oj, OBJECT_NUMBER),item_type);
					old_x=get_object(new_oj,OBJECT_X);
			  	old_y=get_object(new_oj,OBJECT_Y);
			//  }
			//  else {return FALSE;}
		  }
//printf_xy(0,0,"%i %i %i %i %i",new_oj, old_x, old_y, redoish, obj);wait_for_key(b_ko);		  
		  
			if (obj==rock || obj==boulder  || obj==boom_bomb){//|| obj==slashable_terrain || obj==pushable
				//set_object(x,obj_type, lift_object);
			//	y=get_object(x,OBJECT_Y);
				mod_link(dual_state,LINK_LIFT1,TRUE);
				mod_link(link_rand_var1,new_oj,TRUE);//store the object # so it can be used later
				if (link_direction==up)
				{//tokubetsu
				// when link is facing up, the obj is already -16 to him, so reduce the y to his, to make it look 
				// like he is actually lifting the object.
					set_object(new_oj,OBJECT_Y,link_y);
				}
			/*	if (y<=(link_y-14))
				{
				// put this elsewhere.
					set_object(x,OBJECT_X,link_x);
					set_object(x,OBJECT_Y,link_y-16);
					set_object(x,obj_type,follow_object);
					mod_link(dual_state,LINK_LIFT2,TRUE);
					mod_link(link_rand_var1,x,TRUE);//store the object # so it can be used later
					return TRUE;
				}
				else{
					set_object(x,OBJECT_Y,y-4);
					mod_link(state,LINK_NORMAL,TRUE);
					mod_link(dual_state,LINK_LIFT1,TRUE);
					link_frame=0;
				}	*/
				// add in the section where the sprite below the object will be replced with the default_sprite
			if (obj==rock){// || obj==pushable){
				//printf("x=%i, y=%i",gter(old_x),gter(old_y));wait_for_key(b_ko);
				set_all_maps(rmapx, rmapy,gter(old_y),gter(old_x), get_room_info(base_sprite));
				}
				//get_object(x,obj_x)
				//get_object(x,obj_y)
				//if  a rock or pushable or jug
			//	get_room_info(rmapx(),rmapy(),base_sprite); 89
				return TRUE;
			}// end if (obj==rock || obj==boulder || obj==slashable_terrain || obj==pushable
		}// end if you are touching the object
	}// end if not lift2
	else{
		new_oj=link_stat(link_rand_var1);
		set_object(new_oj, obj_dir, link_direction);// these set up the objects
		set_object(new_oj, obj_var1, 0);
		set_object(new_oj, obj_var2, 0);
		set_object(new_oj, OBJECT_FRAME, 0);
		if (get_object(new_oj,obj_type)==boom_bomb){set_object(new_oj,obj_type,flying_bomb);}		
		else {set_object(new_oj,obj_type,throw_object);}
		//set_object(x, obj_dam, get_item_info(get_object(x, OBJECT_NUMBER), item_damage));
		mod_link(link_rand_var1,0,TRUE);
		argh=15;
	//set_object(x, int stat, int num)
	link_frame = 0;mod_link(dual_state,LINK_GENERIC_ITEM, TRUE);
	}// if it is lift2, then throw the rock	
	
	
	
	
	
	return FALSE;
}// end chk for lift object



//==================================================================================
int chk_for_treasure()// this can be used for doors, too.
{
		if ((keya==TRUE) || (keyb==TRUE)){return FALSE;}
	int x=link_x;
	int y=link_y;
	int count1=0;
//	int old_x=0;
//	int old_y=0;
	switch (link_direction)
	{
		case up:
			y-=4;
		break;
//		case down:// this was removed, because it kept on picking up the wrong objects
//			y+=16;// you need to adjust x to a very slim section in order to make this work.
//		break;
		case left:
			x-=2;
		break;
		case right:
			x+=2;
		break;
	}// end switch
	/*if (!can_move(LINK, link_direction))
	{
		mod_link(dual_state,LINK_LIFT1,TRUE);
	}*/
//	if (argh>3){return FALSE;}
	int obj=0, obj_id=0, extended=FALSE, got=FALSE;
			if ((obj_id=touch_object(x, y, LINK, 0, TRUE))!=555)
		{


			
	//	printf("obj=%i",obj);wait_for_key(b_ko);
			obj=get_object(obj_id,obj_type);//get_item_info(get_object(x, OBJECT_NUMBER),item_type);
		//	old_x=get_object(x,OBJECT_X);
/*
							set_object(obj_id,obj_var1,story_line[i][3]);// mod the treasure box to have the correct items. -item
							set_object(obj_id,obj_var2,story_line[i][4]);//amt
							set_object(obj_id,obj_dam,story_line[i][5]);//slot

*/		
		
		
		 // old_y=get_object(x,OBJECT_Y);
			if (obj==treasure_box){
					
					x=get_object(obj_id,obj_var2);//treasure_amt);
					y=get_object(obj_id,obj_var1);//treasure_item);
			if (!(get_treasure_marker(get_object(obj_id,obj_dam)))){// if you have not gotten the treasure
			// im using obj_dam as treasure_slot
					if ((y==rupie) && (x>0))// assuming gold
					{
						mod_link(rupies, x,FALSE);// add the number of rupies to link
						// show link getting a rupie object
						got=TRUE;
			//				printf("x %i",x);wait_for_key(esc_ko);	
						//obj_id=CRYSTAL1;//this should fix the link get state.
			//	mod_link(link_rand_var1,x,TRUE);//store the object # so it can be used later
					}// end if rupies
					else if (y>=1000)
					{
					
					count1=get_item_info(y,item_type);
					
					x=1;
					if ((count1==bomb_bag) || (count1==rupie_bag) || (count1==heart_container) || (count1==quiver))
					{add_special_item(count1, y);got=TRUE;goto ending;}
		//			if(count1==heart_container){mod_link(max_hp,8,FALSE);mod_link(hp,512,FALSE);got=TRUE;goto ending;}
		//			else if(count1==bomb_bag){mod_link(max_bombs,16,FALSE);}// add 8 bombs to the thing.
		//			else if(count1==rupie_bag){mod_link(max_rupies,500,TRUE);}
		//			else if(count1==quiver){mod_link(max_arrows,15,FALSE);}
					
// a check here will have to be made for regular inventory or extended inventory.
// if wallet, gauntlets, keys, tunic are all extended inventory					
// for now, nothing extended exists.			
// bottles, sowrds, are main inventory. - need about 2 bottles. - maybe 3 - but only 4 inventory slots are left for main.	
				//		printf("x=%i %i %i",x,get_object(obj_id,treasure_amt), obj_id);wait_for_key(esc_ko);	
						got=TRUE;
						if (y>=5000){extended=TRUE;}// if the item has an id # of over 5k, then it is an extended item.
						if (count1==type_map){fill_dung_map(oob());}
						else {add_item_inv(y,x,extended);}//int item, int amt, int ext);
					}
					
					ending:
					if (got)
					{// if you got the treasure, then do this:
					//	link_direction=down;
				
						set_treasure_marker(get_object(obj_id,obj_dam),TRUE);// show that you got the treasure
						mod_link(dual_state,LINK_GET_ITEM,TRUE);
						mod_link(state,LINK_STUN,TRUE);// make it so that you cannot move for the time being.
						
				//		mod_link(link_rand_var3,-66,TRUE);// set the random var so we know we are holding.
						link_frame=0;
						// add the object above links head.
					//	old_y=link_y-16;
					//	old_x=link_x;
					//	if (old_x<0){old_x=0;} if (old_x>146){old_x=146;}
					//	if (old_y<0){old_y=0;} if (old_y>114){old_y=114;}
					//	obj_id=add_object(y,old_x,old_y,555);
					// funny, i already created a link_get_item with the shop system, which i forgot about.
					// so i just use that system and i will be fine.
					delete_obj(obj_id);// delete the treasure box
					if (y==rupie){y=CRYSTAL1;}// fix it for link_get_item
						mod_link(link_rand_var1,y,TRUE);//store the object # so we know what to delete later

					}// end got
				}// end if something is in the box or not.	
				
					// treasure boxes start at set 7, so you may want to hard code it here, or soft code it in ezelda.
					//	#define treasure_amt 3// for either gold or item amount.
					//	#define treasure_slot 4// for the inventory slot to say that the treasure has been gotten.
					//	#define treasure_item 5/
			}// end if a treasure box
		}// end checking to see if treasure box is there.	
		return got;
}// end check for treasure





//==================================================================================
//get_room_info(base_sprite) - use for doors - set_room_maps(gter(old_y),gter(old_x), get_room_info(base_sprite));
//==================================================================================
int unlock_door()// this can be used for doors, too.
{
		if ((keya==TRUE) || (keyb==TRUE)){return FALSE;}
	int x=link_x;
	int y=link_y;
	int un=FALSE;// for unlocked
	int chk=0;
//int chk=0;
//	int old_x=0;
//	int old_y=0;
	switch (link_direction)
	{
		case up:
			y-=9;
		break;
		case down:// this was removed, because it kept on picking up the wrong objects
			y+=21;// you need to adjust x to a very slim section in order to make this work.
		break;
		case left:
		//	y+=4;// b/c it messes up, deleting the wrong sprite.
			x-=9;
			
		break;
		case right:
	//		y+=4;
			x+=18;
		break;
	}// end switch
//175->182
		int mstr=item_type_exists(key_master,4);// let me know that the master key exists
		int i=175,bs=0;
		while (i<183)
		{
			if (touching_sprite(x, y, i)){
				if (i<179){
					if ((item_amt(item_key_normal, TRUE)>=1) || (mstr))
					{	
				
						chk=precision_sprite_find(x, y,i);
						if (chk>=100 && chk<200){x+=(chk-111);}
						else if (chk>=200){y+=(chk-211);}
						
					//	if (get_room_maps(gter(y),gter(x))==i) {}// attempt to get the right sprite
					//	else if (get_room_maps(gter(y+11),gter(x))==i){y+=11;}
					//	else if (get_room_maps(gter(y-11),gter(x))==i){y-=11;}
					//	else if (get_room_maps(gter(y),gter(x-11))==i){x-=11;}
					//	else if (get_room_maps(gter(y),gter(x+11))==i){x+=11;}
							y=gter(y);
							x=gter(x);
							bs=get_room_info(base_sprite);
						set_all_maps(rmapx, rmapy,y,x, bs );	
				
				// ================== added stuff =================================
				// this should check the next room to see if there is a locked door on the other side of the locked
				// door you are touching.  if so, then it will make it dissappear, too.  did this b/c the original zelda maps
				// would allow you to unlock the door from either side...  - this is not needed for the boss key, though.
							//y=gter(y);
							//x=gter(x);
							int rmapx2=rmapx, rmapy2=rmapy;
							
							if (y==0){y=7;rmapx2=rmapx-1;}
							else if (y==7){y=0;rmapx2=rmapx+1;}
							else if (x==0){x=9;rmapy2=rmapy-1;}
							else if (x==9){x=0;rmapy2=rmapy+1;}
							un=get_all_maps(rmapx2, rmapy2,y,x);
							if ((un<179) && (un>=175)){set_all_maps(rmapx2, rmapy2,y,x, bs);}
				//   ================== end added stuff =======================	
				
							bs=1;un=TRUE;
				
					}// end if master key
				}// end if <179
				else
				{
					if (((item_amt(item_key_boss, TRUE)>=1)) || (mstr))
					{	
						chk=precision_sprite_find(x, y,i);
						if (chk>=100 && chk<200){x+=(chk-111);}
						else if (chk>=200){y+=(chk-211);}
						
					
				//		if (get_room_maps(gter(y),gter(x))==i) {}// attempt to get the right sprite
				//		else if (get_room_maps(gter(y+11),gter(x))==i){y+=11;}
				//		else if (get_room_maps(gter(y-11),gter(x))==i){y-=11;}
				//		else if (get_room_maps(gter(y),gter(x-11))==i){x-=11;}
				//		else if (get_room_maps(gter(y),gter(x+11))==i){x+=11;}		
				set_all_maps(rmapx, rmapy,gter(y),gter(x), get_room_info(base_sprite));bs=2;un=TRUE;
		
						
						}// end if boss key
				}
				
				
				if (!mstr){
					if (bs==1){add_item_inv(item_key_normal,-1,TRUE);}
					else if (bs==2){add_item_inv(item_key_boss,-1,TRUE);}
					}// end if not master key
			}// end if touching the sprite
			i++;
		}// end while	
		return un;
}// end unlock door.

//==================================================================================
/*60787 ->60717*//* in ezelda
int precision_sprite_find(int x, int y, int sprite)
{// find the sprite in the correct way.
// will return 122 for x+=11
// 100 for -11
// basically, do x+=(precision_sprite()-111); if precision_sprite>=100
// if 200+. then do, y+=
	if (get_all_maps(rmapx, rmapy,gter(y),gter(x))==sprite) {return 0;}// attempt to get the right sprite
						else if (get_all_maps(rmapx, rmapy,gter(y+11),gter(x))==sprite){return 222;}//{y+=11;}
						else if (get_all_maps(rmapx, rmapy,gter(y-11),gter(x))==sprite){return 200;}//{y-=11;}
						else if (get_all_maps(rmapx, rmapy,gter(y),gter(x-11))==sprite){return 100;}//{x-=11;}
						else if (get_all_maps(rmapx, rmapy,gter(y),gter(x+11))==sprite){return 122;}//{x+=11;}
						return 0;	
}// end precision sprite find.
//*/
//==================================================================================

void mod_link(int which, int number, int replace)
{
// replace tells wether to just add or to replace
// created this routine so it would work with the ext one, b/c link frame is not in the ext thingie.
		if ((which ==dual_state) &&(number==0)){link_frame2 = 0;}// if you force the dual state to become 0,
			// then force the frame to be zero as well.  it cuts down on the global vars.

   md_link(which, number, replace);
}// end mod link


//==================================================================================

int link_facing(int who)
{
	/*
			this routine will check to see if the mob and link are facing eachother.  
			if they are then it will return true.  if not, then it will return false.
	*///27530 ->27479
	if (link_direction==opposite_dir(get_mob_stat(who,mob_dir))){return TRUE;}

	return FALSE;
}//end link_facing


//==================================================================================
int chk_for_message()
{
	int who=0;
	int modx=0, mody=0;
	switch (link_direction)
	{
		case up: 	   mody= -10;	break;
		case down:   mody=10; 		break;
		case left:   modx=-10;		break;
		case right:  modx=10;		break;
	}
//who=touch_mob(link_x+modx, link_y+mody, LINK)
	if ((who=touch_mob(link_x+modx, link_y+mody, LINK))!=555)
	{
//printf("who=%i w=%i id=%i x=%i y=%i, ",who,get_mob_stat(who,mob_type),get_mob_stat(who,mob_msg_id),get_mob_stat(who,mob_x),get_mob_stat(who,mob_y));
//wait_for_key(b_ko);
/*		if (get_mob_stat(who,mob_type)==towns_people)
		{
			if (get_mob_stat(who,mob_msg_id)>0)
			{
				msg(get_mob_stat(who,mob_msg_id),get_mob_stat(who,mob_msg_num), TRUE,message);
				return TRUE;
			}// end if it has a msg
		}// end if a towns person*/
		
		switch (get_mob_stat(who,mob_type))
		{
				case towns_people:
					if (get_mob_stat(who,mob_msg_id)>0)
					{
						msg(get_mob_stat(who,mob_msg_id),get_mob_stat(who,mob_msg_num), TRUE,message);
						return TRUE;
					}// end if it has a msg				
				break;
				
				case quest_master:
				// the doubles allows me to kill the quest master, too, thus allowing for 2 different sls to execute.
				// this was mainly done for zelda simple quest so i could have an alternate ending if zelda was killed.
					if (get_mob_stat(who,mob_msg_id)>0)
						{
							 get_story(get_mob_stat(who,mob_msg_id));// pull the storyline file	
							 story_main();// execute the storyline file.
							return TRUE;
						}// end if it has a sl
					else if (get_mob_stat(who,mob_sl_exec)>0)
						{
						 get_story(get_mob_stat(who,mob_sl_exec));// pull the storyline file	
						 story_main();// execute the storyline file.
						return TRUE;
						}// end if it has a sl							
				break;
		}// end switch		
	}// end if touching a mob.
	return FALSE;
}// end chk for message
//==================================================================================









