// C Source File
// Created 2/3/2013; 1:27:52 AM

#include <tigcclib.h>
// this just holds the unused routines after you created the rsets and overworld.

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//														From map gfx

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*

		this will handle the mapping system. including animation of the world.

		map info:
		20 slots for info in 8,9
		
		need for slots:
		- gfx file needed
		- mob gfx list needed
		- mob file (stats) to load for the room - avg of 4 mobs per room (could have more. i think i 
			will max it out at 8 mobs per room)
		- warp file
		- shop file
		- movable object list (objects can only move onto walkable areas and can only move once) - remove
				from list once moved. this list is loaded upon entering the room and deleted upon exit
		- town mob list (including the msgs that they will say)
		- treasure list (5 boxes at max)
		- room dark/light (whether the rooms displays dark or not.)
		
		9,9=room number. - make sure a number is not in there.  the below routine will automatically set the #
		
		- list for locked doors. (door loc (sprite id#), key (id #) needed to unlock) 
				(to crate this... give a sprite id# and if you come accross that sprite and you have the
					key, then auto unlock. and replace sprite with an opean door.)
					make one of the keys so that they are used upon opeaning the door, while all others
					are infinite use as long as you have it.




*/


// 43430 -> 41156 -> 38953 -> 37819 -> 18760





//unsigned short int gfx_light[gfx_list_size][16],gfx_dark[gfx_list_size][16];
//static int world[12][8], room_maps[4][4][10][10]; 

/*

info on world[][]
[0][0]->[7][7] (ie an 8x8 square) will be used to hold the room numbers
[8][0]->[8][4] will hold the up info if you go out of bounds of the map
[9][0]->[9][4] will hold the down info if you go out of bounds of the map
[10][0]->[10][4] will hold the left info if you go out of bounds of the map
[11][0]->[11][4] will hold the right info if you go out of bounds of the map
for example, look at the following code for more info:

						//next_world_map(g_world(8,0);}
						//if (g_world(8,1)!=555){link_x=g_world(8,1);}
						//if (g_world(8,2)!=555){link_y=g_world(8,2);}
						//if (g_world(8,3)!=555){rmap_x=g_world(8,3);}
						//if (g_world(8,4)!=555){rmap_y=g_world(8,4);}

[8][5] will hold the current dungeon number
[8][6] will hold the world_mob_list file for the random mob generator
[8][7] will hold the gfx list for the world_mob_list for the random mob generator

[11][7] will hold the gfx file needed. 						
[9][5] = link_x
[9][6]= link_y
[9][7]= repop timer.
[10][5] = beginning_warp_rmapx
[10][6]= beginning_warp_rmapy
[10][7]= set world - leave as 0 if you want it to stay default.
					otherwise you could force an override and make the 
					continueing link start elseware.

*/



//void delete_temp_rooms(){	FolderClear(SYMSTR ("tmp"));}// end delete temp rooms.

//int g_world(int x, int y){ return world[x][y];}
//void s_world(int x, int y, int amt){world[x][y]=amt;}


//================================================================================================
/*
void temp_save_room(int mx,int my)
{
    

	char sav[8];
	    FILE *f = NULL;
    int yn = TRUE;
// first get the room stats from the dll
			int temp_room[10][10];
  
				int	a=0,b=0; // zero these out to make sure things work right.
						
						while (a<10){
							
							while (b<10){
								
								temp_room[a][b]=get_room_maps(a,b);
								b++;
							}// end while b<10
								a++; b=0;					
						}// end while a<10
						
						
		FolderCur(SYMSTR("tmp"),TRUE);// then goto the tmp folder and see if the room is in there.
		
						sprintf(sav,"\0");
						sprintf(sav,"r_%i_%i",mx,my);
 
 TRY     
    if ((f = fopen(sav,"wb")) == NULL) {// write into temp - use the file saving routine for the
    // saving of the real file.  for everything else, use the temp file
        yn = FALSE;
    } else {
        // write inv data to the file
        if (fwrite(temp_room,sizeof(temp_room),1,f) != 1) {
            yn = FALSE;
        }
        // append the file ID tag
        // it is type AFW.  ie my game
        fputc(0,f);
        fputs("ZLD",f);
        fputc(0,f);
        fputc(OTH_TAG,f);

        // close the file
        fclose(f);
    }	

ONERR
ENDTRY		
}// end save temp room

*/



/*
	void next_world_map(int file)
	{
 
  //town_active=FALSE;
 // int k=0,q=0;
	//	if (get_world(59,107)==1){transistion();} - it is 40 bytes to add the leaving transistion
	//	if (get_world(59,108)!=1){clrscr();}
   	//while (k<60) {while (q<7){set_sprite_location(k,q,0);q++;}q=0;k++;}// clr out the sprite loc routine
 //printf("%i %i",current_world,i);  	wait_for_key(b_ko);wait_for_key(b_ko);
 		if (file<=0){file=4;}//defaulted the game to load world 4 - you will need to change this in the release.
   	if (current_world==file){goto end;}
   //	delete_temp_rooms();
   	clr_world();// clear out the current world map;
   	int tmp[12][8], i=0,k=0;;//, room_maps[4][4][10][10];

  // 	#define g_world(8,5) g_over_world_stat(overworld_dungeon_num,current_world)
   	 if (g_world(8,5)>0){// if it is a dungeon, then do the following:
   	 	// this can be of any number <1000
			// save the current dungeon map in the event that you are changing maps.
			save_dung_map(g_world(8,5));
   	 }// end if it is a dungeon.
   	
   	// to make sure you dont exp problems.
   	//deactive the active town whenever we change maps.
   	    FILE *f = NULL;
     int fileio = TRUE;
		char mapa[8];
   	
TRY


		sprintf(mapa,"zmp%i",file);
    FolderCur(SYMSTR("maps"),TRUE);
    //SymFind (SYMSTR (mapa));
    
    // open file for reading in binary mode
    if ((f = fopen(mapa,"rb")) == NULL) { // this opens up the temp inventory
        fileio = FALSE;
    } else {
        // read data from file into inv
        if (fread(tmp,sizeof(tmp),1,f) != 1) {// get the world file.
             fileio = FALSE;
        }
				 else{
        	// if successful, then transfer over the gfx file.
        	for (i=0;i<world_rows;i++) {for (k=0;k<world_cols;k++){s_world(i,k,tmp[i][k]);}}
        }// end if successful.
       // close the file
        fclose(f);
    }


ONERR
	fileio=FALSE;
ENDTRY

    if (fileio){//map=i;// if you got the map then set the map var to the current map to preent problems.
    //return fileio;
  //  if (get_world(59,108)==1){transistion();}// this makes it as leaving.
  		current_world=file;
  		mod_link(map_id,file,TRUE);// set the world map so link knows what it is in the event of saving.
   	 gfx_loader(g_world(11,7));// load the correct gfx file for this.
   	 if ((repop_max=g_world(9,7))<2000){repop_max=2000;}// force the repop time to have a low set to make sure
   	 // nothing bad happens.
 //printf("\nbefore dung map");wait_for_key(b_ko);  	 
   	 if (g_world(8,5)>0){// if it is a dungeon, then do the following:
   	 	// this can be of any number <1000
 //printf("\nqe=%i", quest_exists(dungeon_map, world[8][5])); wait_for_key(b_ko);  	 	
   	 	if (quest_exists(dungeon_map, g_world(8,5))){write_dung_map(g_world(8,5));}// this will also inadvertantly pull
   	 	else {get_dung_map(g_world(8,5));}
   	 }// end if it is a dungeon.	
   	 
   	 
   	 // load the world mob list file into this.
   	 
   	 clr_mob_list(2);
   	// clr_world_mob_placement();
   	 compile_mobs(g_world(8,6), 0, 0, 2, 0);
   	 mob_gfx_loader(g_world(8,7));// pull the gfx file just in case.
			}// end if the file transfer was successful.
				//disp();
			// do the 105 last b/c the world list shold stay active.  it should prevent lots of annoying
			// file access every time you attempt to move, which could cause addressing errors.
		//}// end if maps arent equal
	
		end:
	}// end next world map*/
	


//=================================================================================================

	/*
	
	-null - i will attempt to use the 8x8 array first and see if i get memory errors.
	
	use a 4d array such as arr[8][8][9][10]  (8x8 sections, but has 9 x10 sprite list)
	(could be [3][3][9][10] if using the 3x3 structure)
	
	- updated - i have decided to go with a 4x4 array to load the map.  this will require
	4 loadings of an 8x8 array.  it might take about 800->1600 bytes for this array.  this should
	load quickly. - technically 3200 bytes needed.  this was scrapped later on b/c of address errors.
	
	in reality, it should load a full 8x8 map and everything in them.
	
	ok this will check the current map and then load all adjacent maps to it in a 3x3 square.  
	it will check to see if any of the 3x3 maps are already loaded.  if they are, then it will
	skip loading those maps.  it will use the world map to know which mini maps to load.  if the 
	world map section is 0, then it will zero out all info in that array.
	
	each room in 8x10, but you will probably need 10x10 arrays, to allow for 20 spots for random
	room info.  maybe a 9x10 would be ok.  you do not need exit info, b/c it is decided by the
	world map.
	
	you will need a mob list for the room.  you will need a mob gfx set id # for the room.  the 
	mob gfx set id# should be the same for an entire set of 8 rooms.  if not, then there will be
	problems.  i think i will max out the mobs at 8 per room.  there will be a max of 64 mobs per
	section (4x4), which is 4 mobs per room, b/c 4*4=16 room *4 = 64 mobs, but in dungeons, you 
	may not use all 4x4 area of a map and this would allow you to add more mobs.  8 mobs would 
	be a pain to deal with anyways.
	
	the room will need to tell which gfx_light and gfx_dark set to use.  the gfx is set up to hold
	200 differnt sprites. (in theory, you should have one set for the world map and one set for the 
	dungeon maps.)  
	
	the room will also have a sl file to use for the current room.
	
	there will be a sl warp file that will be loaded for stairs.  it will warp you from room to room
	
	there will be a place to tell which room # this is.
	
	ther ewill be a slot for treasure box sl file. (max of 5 per room?)
	
	consider make a marker for transistion affect.(could be used to be scalable later on)
	
	there will be a spot for towns people to load, this includes harmless creatures. 
	(chickens and dogs are considered mobs, b/c they can be killed and attack back - special
	statutes need to be set up, such as a revenge statute)
	
	dark/light toggle - this will determine whether the room is lit up upon entree or not or 
		whether you need to light candles to see everything in the room.  (you could make a
		torch/candle that would illuminate 3x3 sprites and force all nocternal animals to 
		be invis and force charge if a light is in the room (would add more difficulty to the
		game.)
		
	
	mob list, mob gfx list, gfx light/dark list, stoyline file to use, warp file, room #, 
	treasure list, room dark/light, dungeon level (for mapping purposes) (0 for main world)
	
	
	the storyline might only be 30 lines of code or less, b/c there is so much to load already.
	
	the loading of mobs and citizens will happen when this is called, just to make sure that
	mobs will stay permantly dead and so will changes.  this prevents the automatic reloading of
	everything when you go back to the room.  also, when the grass is cut or the land dug up,
	you will simply modify the 4d array to keep those changes.  when a new world map is called,
	then this will be and everything will change.
	
	if using a 3x3 4d array, then you will search through the array for the room # to decide if the
	room already exists or not.  if it does, then bypass reloading.  if not, then load the 3
	new rooms.  each room is really small.  you will also link the mobs to each of the rooms,
	so when you delete out a room, then you will need to wipe out all mobs from the mob list
	that corresponds to that room.  same concept when you load the room, you will need to load 
	all of the mobs for that room as well.
	
	*/
/*
void load_rooms()
{
//printf("-");

		
			
	//++++	int x=link_stat(map_x);
	//++++	int y=link_stat(map_y);
		
		
////("\nx=%i, y=%i",x,y);
//wait_for_key(b_ko);		
	//++++	if (x<4){x=0;}else{x=4;}
		
	//++++	if (y<4){y=0;}else{y=4;}
//printf("\nx=%i, y=%i",x,y);
//wait_for_key(b_ko);			
//++++		int x2=x+4;
//++++		int y2=y+4;
	//	int a=0,b=0, map=0;
		

		int map=current_world;//current_room();// get the map
//printf("0");		
		if (map==current_map_set){goto end;}
//printf("0*");
		room_entry_x=link_x;
		room_entry_y=link_y;
				if ((get_room_info(world_pos_y)==link_stat(map_y)) && (get_room_info(world_pos_x)==link_stat(map_x))){return;}// prevent the map from refreshing itself in the event that 
				// it is already loaded. - you need to check old x and old y to make sure that link is in the same position
				// that he was in for this to work, otherwise, if the rooms are the same, then it will not reload.
				if (map<=0){clr_room();return;}// zero out the room and bypass all below - this is a
			//	if (current_world==file){goto end;}
				
						// error prevention technique so you dont attempt to load room 0
		// c corresponds with x and d corresponds with y
		FILE *f = NULL;
     int fileio = TRUE;
		char mapa[8];
		int temp_room[4][4][10][10];
//printf("1");		
// the below code has been revamped to allow for a temp file to be created to save the room info and then reload it instead
// of the archived room file.  this way, cut grass and moved items can be preserved.		
		
	//	FolderCur(SYMSTR("tmp"),TRUE);// first goto the tmp folder and see if the room is in there.
		
		//				sprintf(mapa,"\0");
			//			sprintf(mapa,"r_%i_%i",link_stat(map_x),link_stat(map_y));
   	
						TRY
				//		    if ((f = fopen(mapa,"rb")) == NULL) {// if we cannot find the temp room, then load the room
						    // from the archive.
						        FolderCur(SYMSTR("rooms"),TRUE);
						        sprintf(mapa,"\0");// clear out mapa
						        sprintf(mapa,"rset%i",map);
	        					    if ((f = fopen(mapa,"rb")) == NULL) { // this opens up the temp inventory
										        fileio = FALSE;
										    } else {
										        // read data from file into inv
										        if (fread(temp_room,sizeof(temp_room),1,f) != 1) { fileio = FALSE; }
											
										       // close the file
										        fclose(f);
										    }// end else
//printf("2");										    
					//	    } else {// if we find the file, then read from the file.
						        // read data from file into inv
					//	        if (fread(temp_room,sizeof(temp_room),1,f) != 1) { fileio = FALSE; }
							
						 //      // close the file
						 //       fclose(f);
						 //   }// end else
						
						
						ONERR
							//fileio=FALSE;
						ENDTRY
		
		/*
		FolderCur(SYMSTR("rooms"),TRUE);
		
		
		//link_stat(map_y)
		//sprintf(mapa,"r_%i_%i",link_stat(map_x),link_stat(map_y));
		
//++++		while (x<x2){
			
	//++++		while (y<y2){
		
				
					
					//f = NULL;
					sprintf(mapa,"\0");

   	
						TRY
						
								sprintf(mapa,"room%i",map);
						//		printf("\n%s",mapa);
						//		wait_for_key(b_ko);
						    if ((f = fopen(mapa,"rb")) == NULL) { // this opens up the temp inventory
						        fileio = FALSE;
						    } else {
						        // read data from file into inv
						        if (fread(temp_room,sizeof(temp_room),1,f) != 1) { fileio = FALSE; }
							
						       // close the file
						        fclose(f);
						    }// end else
						
						
						ONERR
							//fileio=FALSE;
						ENDTRY*/
/*						
					int	a=0,b=0, i=0, k=0; // zero these out to make sure things work right.
				while (i<4){
					while (k<4){	
						while (a<10){
							while (b<10){
								
								set_all_maps(i,k,a,b,temp_room[i][k][a][b]);
								b++;
							}// end while b<10
								a++; b=0;					
						}// end while a<10
							a=0;b=0;k++;
					}// end while k	
					i++;a=0;b=0;k=0;
				}	// end while i	
//printf("3");									
					//	set_room_maps(9,9,map);// this will set the room number into the the room arr.
							// it will be used to figure out if the room exists in the array. if not, then 
							// it will load a new set of 4x4 rooms. - technically since the 4x4 is gone, it is
							// no longer needed.- decided to use it to allow me to check to see if the room
							// is already loaded so i can bypass a second loading of it. - another loading of 
							// it might cause problems if you go into the start screen and then when you exit it
							// it will reload the room with all the mobs with it.  this could be a majorly bad bug.
				current_map_set=map;// set the map set to make sure i dont attempt to reload it.
					set_room_info(world_pos_y,link_stat(map_y));	// instead of using the above idea, i used these settings	
					set_room_info(world_pos_x,link_stat(map_x));	// instead to make sure i could identify that i was still 
					// in the same room and bypass this whole routine if i needed to.
			//			end:
//printf("4");								
	//++++					y++; d++;
		//++++		}// end while y<y2
		//++++				x++; c++; y=y2-4; d=0; 
	//++++		}// end while x<x2
	end:
//printf("5");
		get_map_vars();// load the vars for the room.
//printf("6");					
		// instantly pull the mobs for this room so they will display.  the rest of the mobs
		// will load room by room
}// end load rooms*/


//==================================================================================================

/*
			add the mapper into this area as well.

*/


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//														From mob gfx

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//================================================================================================




/*
#define mob_hp 0
#define mob_def 1
#define mob_dam 2
#define mob_x 3
#define mob_y 4
#define mob_pause 5// used for the movement to know if the mob is paused or not. 
#define mob_sprites 6 // # of frames
#define mob_walk_sprites 7 // # of frames to allocate to walking
#define mob_sprite_id 8
#define mob_special_atk 9
#define mob_shield 10
#define mob_item 11
#define mob_sl_exec 12
#define mob_stunned 13
#define mob_underground 14
#define mob_type 15 // like gohst(which can travel through walls)
#define mob_frame 16 // this is to let you know which pic to animate them with
#define mob_id 17
#define mob_dir 18
#define mob_rand_var1 19// used in the movement to set specific special movements 
#define mob_speed  20// tell the speed that the mob should move.  if 0, then dont move, but animate.
#define mob_stops 21 // 0 for constantly moving, 1 for random, 2 moves when link in proximety
#define mob_animation_type 22// 0 always animate, 1 animate when moving.
#define mob_rand_var2 23// used in the movement to set specific special movements 
#define mob_animation_speed 24// used to tell how fast to speed thorugh the frames.  
					// 1 will animate every frame.  2, every other frame ... 10 every 10 frames ... 20 every
					// 20 frames, etc.
#define mob_current_sprite 25
#define mob_move_type 26// tells how the mob should move, such as MOB_WANDER, MOB_FLUTTER, 
					//MOB_HOP, MOB_FOLLOW
*//*moved to ezelda
void animate_chicken(int loc){//22005->22630  gah...
				
				int pic=get_mob_stat(loc,mob_sprite_id);
				int dir = get_mob_stat(loc,mob_dir);
				int type=get_mob_stat(loc,mob_type);
				int frame=get_mob_stat(loc,mob_frame);
				//------------------------------------------------------------------
				// The chicken basically has the same program as the dog, but with 
				// very minor tweaks, which graphically make alot of difference.
				//------------------------------------------------------------------
				
				//------------------------------------------------------------------
				// count1 temporarily store direction offsets, which point DrawMob 
				// to the right picture to draw.
				//------------------------------------------------------------------
				int count1=0;
				switch(dir)//mob_list[loc][MOB_DIRECTION])
				{
					case up:
					case left:
						count1 += 2;
					default:
						break;
				}
				
				//------------------------------------------------------------------------
				// Checks if the chicken resumes movement. This is different from the dog 
				// in that it doesnt give the chicken a chance to animate when it is paused.
				// It also doesnt give him a new random direction.
				//------------------------------------------------------------------------
				if (get_mob_stat(loc,mob_pause) > 0)
				{
					
					mod_mob(loc,mob_pause,-1,FALSE);//mob_list[loc][MOB_PAUSE]--;
					if (type==dog){
						
						if (get_mob_stat(loc,mob_pause)  == 0){mod_mob(loc,mob_dir,random(4),TRUE);}
						//mob_list[loc][MOB_DIRECTION] = random(4);
					}// end if type==dog
					DrawImage(MOB, pic+count1, get_mob_stat(loc,mob_x), get_mob_stat(loc,mob_y)- get_mob_stat(loc,mob_rand_var1), A_NORMAL, TRUE,0);
					//break;
					goto end;
				}
				
				//-----------------------------------------------------------------------------
				// Draws whichever direction the chicken is facing. The mob_list[loc][MOB_VAR1] 
				// stores how high the chicken is jumping, and is generated by MOB_HOP from MoveMob().
				//-----------------------------------------------------------------------------
				switch(frame)//mob_list[loc][MOB_FRAME])
				{
					case 1 ... 4:	//Chicken's flapping wings doenst animate as fast as a dog walking
						pic+=count1;
						//pic=CHICKEN1+count1;
						if (type==dog)
						{
							if (frame>=3){pic++;}// end if >=3
						}
					//	DrawImage(MOB, CHICKEN1+count1, mob_list[loc][MOB_X], mob_list[loc][MOB_Y] - mob_list[loc][MOB_VAR1], A_NORMAL);
						break;
					case 5 ... 8:
						pic+=(1+count1);
						if (type==dog)
						{
							pic--;
							mod_mob(loc,mob_frame,0,TRUE);
						}
						//else {}
					//	pic=CHICKEN2+count1;
					//	DrawImage(MOB, CHICKEN2+count1, mob_list[loc][MOB_X], mob_list[loc][MOB_Y] - mob_list[loc][MOB_VAR1], A_NORMAL);
						break;
					default:	//This causes mob_frame reset when it has reached its max
					pic+=count1;//	pic=CHICKEN1+count1;
					//	DrawImage(MOB, CHICKEN1+count1, mob_list[loc][MOB_X], mob_list[loc][MOB_Y] - mob_list[loc][MOB_VAR1], A_NORMAL);
						mod_mob(loc,mob_frame,0,TRUE);
					//	mob_list[loc][MOB_FRAME] = 0;
					break;
				}//
			

			
			
				//pic =animation_pic_decider(loc,get_mob_stat(loc, mob_frame), get_mob_stat(loc, mob_animation_speed), get_mob_stat(loc, mob_sprites), pic,get_mob_stat(loc, mob_sprite_id));
				DrawImage(MOB, pic, get_mob_stat(loc,mob_x), get_mob_stat(loc,mob_y)- get_mob_stat(loc,mob_rand_var1), A_NORMAL, TRUE,0);
				//-------------------------------------------------------------------------------------
				// The chicken is sometimes traveling in two directions. This routine makes it so
				// when the chicken is facing left or right, it is still also traveling up and down,
				// and vice versa. MOB_VAR2 stores a number 0, 1 or 2, which is used to determine
				// whether the chicken will go up or down, and is chosen randomly when he stops moving.
				// If the variable is 2, it wont travel in 2 directions.
				//
				// NOTE: If the chicken is already moving up or down, it doesnt use MOB_VAR2; 
				// it just moves left or right according to which direction he is facing.
				//-------------------------------------------------------------------------------------
				if ((dir == left || dir == right) &&
				     get_mob_stat(loc,mob_pause) == 0 && get_mob_stat(loc,mob_rand_var2) != 2)
				{
					if (get_mob_stat(loc,mob_rand_var2) == up)
					{
					//	if (!CheckTerrainCollision(mob_list[loc][MOB_X], mob_list[loc][MOB_Y]-1, 16, 16))
							
							if (can_move(loc,up)){mod_mob(loc,mob_y,-1,FALSE);}//mob_list[loc][MOB_Y] -= 1;}
					}
					else
					{
					//	if (!CheckTerrainCollision(mob_list[loc][MOB_X], mob_list[loc][MOB_Y]+1, 16, 16))
							if (can_move(loc,down)){mod_mob(loc,mob_y,1,FALSE);}//mob_list[loc][MOB_Y] += 1;
					}
				}
				
				if ((dir == up || dir == down) &&
				     get_mob_stat(loc,mob_pause) == 0 && get_mob_stat(loc,mob_rand_var2) != 2)
				{
					if (dir == up)
					{
					//	if (!CheckTerrainCollision(mob_list[loc][MOB_X]-1, mob_list[loc][MOB_Y], 16, 16))
							if (can_move(loc,left)){mod_mob(loc,mob_x,-1,FALSE);}//mob_list[loc][MOB_X] -= 1;
					}
					else
					{
					//	if (!CheckTerrainCollision(mob_list[loc][MOB_X]+1, mob_list[loc][MOB_Y], 16, 16))
							if (can_move(loc,right)){mod_mob(loc,mob_x,1,FALSE);}//mob_list[loc][MOB_X] += 1;
					}
				}
				
				//--------------------------------------------------------------
				// Makes the chicken randomly stop moving.
				// 
				// The chicken randomly stops alot more than the dog, but for 
				// shorter periods of time.
				//--------------------------------------------------------------
				
				if (type==chicken){
				
						if (get_mob_stat(loc,mob_pause) <= 0 && !random(20))
						{
								mod_mob(loc,mob_pause,10,TRUE);
								mod_mob(loc,mob_rand_var2,3,TRUE);
							//	mob_list[loc][MOB_PAUSE] = 10;
							//	mob_list[loc][MOB_VAR2] = 3;
						}
				}// end if type == chicken
				else
				{
						if (get_mob_stat(loc,mob_pause) <= 0 && !random(50))
						{
								mod_mob(loc,mob_pause,random(15)+10,TRUE);
								mod_mob(loc,mob_rand_var2,random(3),TRUE);
							//	mob_list[loc][MOB_PAUSE] = 10;
							//	mob_list[loc][MOB_VAR2] = 3;
						}					
				}

				MoveMob(loc, MOB_HOP, 1);
				end:
}// end animate chicken				*/


//=================================================================================================
/* moved to ezelda

void mod_crab(int loc)
{// this just simply modifies the seed of the crab randomly
//	int speed=get_mob_stat(loc,mob_speed);
	int var=get_mob_stat(loc,mob_rand_var1);
	int core_speed=get_mob_stat(loc,mob_rand_var2);
	if (var == 0 && !random(50))
	{mod_mob(loc,mob_rand_var1, 90,TRUE);mod_mob(loc,mob_speed, core_speed,TRUE); }// set the old speed}
				if (var> 0){	mod_mob(loc,mob_rand_var1,-1,FALSE);}
					
				if (var==1){
						
						mod_mob(loc,mob_speed, core_speed*2,TRUE);
					}//end var==1
					if (var<0){mod_mob(loc,mob_rand_var1, 0,TRUE);}
		//	else 
					//MoveMob(loc, MOB_WANDER, 2);
		//		break;
		
	
		
}//

//=================================================================================================

void mod_digger(int loc)
{
					//------------------------------------------------------------
				// MOB_VAR1 stores how long hes in the ground. 0 if hes not.
				//------------------------------------------------------------
			
				randomize();
				if (get_mob_stat(loc, mob_rand_var1)<0){mod_mob(loc, mob_rand_var1, 0, TRUE);}
				//int var=get_mob_list(loc, mob_rand_var1);
				int q=0;
		if (get_mob_stat(loc,mob_underground)!=3)
				{
				mod_mob(loc, mob_rand_var1, random(loc)+1, FALSE);
			//	if (!random(77)){mod_mob(loc, , 2, FALSE);}
				switch (get_mob_stat(loc, mob_rand_var1))
				{
					case 0 ... 5:
						q=1;//mod_mob(loc,mob_underground, 1, TRUE);
					//	DrawImage(MOB, SANDMOB1, mob_list[loc][MOB_X], mob_list[loc][MOB_Y], A_NORMAL);
						break;
					case 6 ... 10:
						q=2;//	mod_mob(loc,mob_underground, 2, TRUE);
					//	DrawImage(MOB, SANDMOB2, mob_list[loc][MOB_X], mob_list[loc][MOB_Y], A_NORMAL);
						break;

					case 80 ... 85:
						q=2;//mod_mob(loc,mob_underground, 2, TRUE);
					//	DrawImage(MOB, SANDMOB2, mob_list[loc][MOB_X], mob_list[loc][MOB_Y], A_NORMAL);
						break;
					case 86 ... 90:
						q=1;//mod_mob(loc,mob_underground, 1, TRUE);
					//	DrawImage(MOB, SANDMOB1, mob_list[loc][MOB_X], mob_list[loc][MOB_Y], A_NORMAL);
						break;
						case 91 ... 1000:
							q=3;// it is fully underground.
							
							
						break;

					}// end switch
						mod_mob(loc,mob_underground, q, TRUE);
						
			}// end if underground.			
			else if (get_mob_stat(loc,mob_underground)>=3)
						{
							if (get_mob_stat(loc, mob_rand_var1)<=0){mod_mob(loc, mob_underground, 1, TRUE);}
							mod_mob(loc, mob_rand_var1, -2, FALSE);// make it randomly go above ground.
							
						}
						
						
						

}//*/
/*
int mob_collide(int x, int y,int who, int dir, int speed)
{
// this is used for the can_move(), which is why the false/true seems reversed.
	//speed++;
	switch (dir)
	{
		case up: y-=speed; break;
		case down: y+=speed; break;
		case left: x-=speed; break;
		case right: x+=speed; break;		
		
	}
		if (a_mob && get_mob_stat(who,mob_type)==towns_people){
		if (CheckAreaCollision(x, y, 13, 13, get_mob_stat(who,mob_x), get_mob_stat(who,mob_y), 16, 16)){return FALSE;}
	}
	
	int tmp=0;
		if ((tmp=touch_mob(x, y, who))!=555)
	{
		if (get_mob_stat(tmp,mob_type)==towns_people){return FALSE;}
	}
	return TRUE;
}

*/


/* moved to ezelda
void MoveMob(int loc, int move_type, int ani_speed)
{
	switch (move_type)
	{
		//-----------------------------------------------------------------------------
		// Constantly moves; if hit a wall, turn the opposite way - (example: CRAB1)
		//-----------------------------------------------------------------------------
		case MOB_WANDER:
			switch (get_mob_stat(loc,mob_dir))
			{
				case right:
					//----------------------------------------------
					// If the mob wont run into anything, move him
					//----------------------------------------------
				//	if (!CheckTerrainCollision(get_mob_stat(loc][MOB_X]+ani_speed, get_mob_stat(loc,mob_y), 16, 16))
						mod_mob(loc,mob_x, ani_speed,FALSE);
					//else
					//----------------------------------------------
					// Otherwise move him in the other direction
					//----------------------------------------------
					//	get_mob_stat(loc,mob_dir) = left;
					break;
				case left:
				//	if (!CheckTerrainCollision(get_mob_stat(loc,mob_x)-ani_speed, get_mob_stat(loc,mob_y), 16, 16))
						mod_mob(loc,mob_x, ani_speed * -1,FALSE);
				//	else
				//		get_mob_stat(loc,mob_dir) = right;
					break;
				case up:
				//	if (!CheckTerrainCollision(get_mob_stat(loc,mob_x), get_mob_stat(loc,mob_y)-ani_speed, 16, 16))
						mod_mob(loc,mob_y, ani_speed * -1, FALSE);
				//	else
				//		get_mob_stat(loc,mob_dir) = down;
					break;
				case down:
			//		if (!CheckTerrainCollision(get_mob_stat(loc,mob_x), get_mob_stat(loc,mob_y)+ani_speed, 16, 16))
						mod_mob(loc,mob_y, ani_speed, FALSE);
				//	else
					//	get_mob_stat(loc,mob_dir) = up;
					break;
			}
			
			//---------------------------------------------
			// Randomly change directions once in a while
			//---------------------------------------------
			if(!random(80))
			{
				change_dir(loc);
			//	mod_mob(loc,mob_dir, -1, FALSE);
			//	if (get_mob_stat(loc,mob_dir) < up)
			//		mod_mob(loc,mob_dir, right,TRUE);
			}
			break;
		
		//---------------------------------------------------------------------
		// Move randomly - doesnt check for collision - (example: BUTTERFLY1)
		//---------------------------------------------------------------------
		case MOB_FLUTTER:
			switch (get_mob_stat(loc,mob_dir))
			{
				//------------------------------------------------------------------------------------
				// These cases make the mob flutter towards a certain direction
				// 2-random(5) means the range of numbers is: -2 -1 0 1 2, meaning there is an equal opportunity to go any direction.
				// 2-random(2) means the range of numbers is: 1 2, meaning it moves toward a direction
				//------------------------------------------------------------------------------------
				case up:
					mod_mob(loc,mob_y, (2-random(2))* -1, FALSE);
					mod_mob(loc,mob_x, 2-random(5), FALSE);
					break;
				case right:
					mod_mob(loc,mob_y, 2-random(5), FALSE);
					mod_mob(loc,mob_x, 2-random(2), FALSE);
					break;
				case down:
					mod_mob(loc,mob_y, 2-random(2), FALSE);
					mod_mob(loc,mob_x, 2-random(5), FALSE);
					break;
				case left:
					mod_mob(loc,mob_y, 2-random(5), FALSE);
					mod_mob(loc,mob_x, (2-random(2))* -1, FALSE);
					break;
			}
			//---------------------------------------------
			// Randomly change directions once in a while
			//---------------------------------------------
			if(!random(20))
			{
				mod_mob(loc,mob_dir, -1, FALSE);
				if (get_mob_stat(loc,mob_dir) < up)
					mod_mob(loc,mob_dir, right, TRUE);
			}
			break;
		
		case MOB_HOP:
			//------------------------------------------------------------------------------
			// **NOTE**: To use this movement-type, MOB_VAR1 must be free. 
			//
			// MOB_HOP uses MOB_VAR1 to keep track of how many pixels a mob hops. To use
			// the hop, you actually have to add it to your mob defined in AnimateMob().
			//
			// This routine just constantly scrolls through MOB_VAR1, and draws a shadow
			// under the mob when it is high in the air (when MOB_VAR1 is 2)
			//------------------------------------------------------------------------------
			
			switch (get_mob_stat(loc,mob_rand_var1))
			{
				case 2://,button_pressed,light,dark, link_direction, dark_room,link_frame2
					DrawImage(OBJECT, SHADOW1, get_mob_stat(loc,mob_x), get_mob_stat(loc,mob_y), A_NORMAL, TRUE,0,button_pressed, link_direction, dark_room);
				case 0:
				case 1:
					mod_mob(loc,mob_rand_var1,1,FALSE);
					break;
				default:
					mod_mob(loc,mob_rand_var1,0,TRUE);	//mod_mob(loc][MOB_VAR1] = 0;
				break;
			}
			
			//--------------------------------------------------------------
			// Moves the mob (while hopping). It cannot 
			// move below pixel 2 since it is hopping 2 pixels each round.
			//--------------------------------------------------------------
			
			if (can_move(loc,get_mob_stat(loc,mob_dir))){
			switch (get_mob_stat(loc,mob_dir))
			{
				case right:
					//----------------------------------------------
					// If the mob wont run into anything, move him
					//----------------------------------------------
				//	if (!CheckTerrainCollision(get_mob_stat(loc,mob_x)+ani_speed, get_mob_stat(loc,mob_y), 16, 16))
						mod_mob(loc,mob_x, ani_speed, FALSE);
					break;
				case left:
			//		if (!CheckTerrainCollision(get_mob_stat(loc,mob_x)-ani_speed, get_mob_stat(loc,mob_y), 16, 16))
						mod_mob(loc,mob_x, ani_speed* -1, FALSE);
					break;
				case up:
			//		if (!CheckTerrainCollision(get_mob_stat(loc,mob_x), get_mob_stat(loc,mob_y)-ani_speed-2, 16, 16))
						mod_mob(loc,mob_y, ani_speed* -1, FALSE);
					break;
				case down:
			//		if (!CheckTerrainCollision(get_mob_stat(loc,mob_x), get_mob_stat(loc,mob_y)+ani_speed, 16, 16))
						mod_mob(loc,mob_y, ani_speed, FALSE);
					break;
			}// end switch
			}// end if you can move
			//---------------------------------------------
			// Randomly change directions once in a while
			//---------------------------------------------
			if(!random(40))
			{
				mod_mob(loc,mob_dir,-1, FALSE);
				if (get_mob_stat(loc,mob_dir) < up)
					mod_mob(loc,mob_dir, right, TRUE);
			}
			break;
		
		//---------------------------------------------------
		// Follow makes the mob move towards where Link is.
		//---------------------------------------------------
		case MOB_FOLLOW:
		
		    //--------------------------------------------------------------------
			// These routines are pretty simple. Move the mob toward link, while 
			// checking if it hit anything in its path. 
			//--------------------------------------------------------------------
			if (get_mob_stat(loc,mob_x) > link_x)
			{
				mod_mob(loc,mob_dir, left, TRUE);
			//	if (!CheckTerrainCollision(get_mob_stat(loc,mob_x)-ani_speed, get_mob_stat(loc,mob_y), 16, 16))
					mod_mob(loc,mob_x, ani_speed* -1, FALSE);
			}
			else
			{
				mod_mob(loc,mob_dir, right, TRUE);
		//		if (!CheckTerrainCollision(mod_mob(loc,mob_x)+ani_speed, mod_mob(loc,mob_y), 16, 16))
					mod_mob(loc,mob_x, ani_speed, FALSE);
			}
				
			if (get_mob_stat(loc,mob_y) > link_y)
			{
				mod_mob(loc,mob_dir, up,TRUE);
		//		if (!CheckTerrainCollision(get_mob_stat(loc,mob_x), get_mob_stat(loc,mob_y)-ani_speed-2, 16, 16))
					mod_mob(loc,mob_y, ani_speed* -1, FALSE);
			}
			else
			{
				mod_mob(loc,mob_dir, down, TRUE);
			//	if (!CheckTerrainCollision(get_mob_stat(loc,mob_x), get_mob_stat(loc,mob_y)+ani_speed, 16, 16))
					mod_mob(loc,mob_y, ani_speed, FALSE);
			}
			
			break;
	}
	
	//---------------------------------------------------------
	// In all cases, the mob must not go out of screen bounds
	// If the mob reaches edge of screen, walk other way
	//---------------------------------------------------------
	if (get_mob_stat(loc,mob_x) > 160-16)
	{
		mod_mob(loc,mob_x, 160-16, TRUE);
		change_dir(loc);
		//mod_mob(loc,mob_dir, left, TRUE);
	}
	if (get_mob_stat(loc,mob_x) < 0)
	{
		mod_mob(loc,mob_x, 0, TRUE);
		change_dir(loc);
		//mod_mob(loc,mob_dir, right, TRUE);
	}
	if (get_mob_stat(loc,mob_y) < 0)
	{
		mod_mob(loc,mob_y, 0,TRUE);
		change_dir(loc);
		//mod_mob(loc,mob_dir, down, TRUE);
	}
	if (get_mob_stat(loc,mob_y) > 8*16-16)
	{
		mod_mob(loc,mob_y, 8*16-16,TRUE);
		change_dir(loc);
		//mod_mob(loc,mob_dir, up, TRUE);
	}

//terrain_contact( qx,  qy,dir, 78, 66)

}//*


//================================================================================================




//================================================================================================
/*
#define mob_hp 0
#define mob_def 1
#define mob_dam 2
#define mob_x 3
#define mob_y 4
#define mob_pause 5// used for the movement to know if the mob is paused or not. 
#define mob_sprites 6 // # of frames
#define mob_walk_sprites 7 // # of frames to allocate to walking
#define mob_sprite_id 8
#define mob_special_atk 9
#define mob_shield 10
#define mob_item 11
#define mob_sl_exec 12
#define mob_stunned 13
#define mob_underground 14
#define mob_type 15 // like gohst(which can travel through walls)
#define mob_frame 16 // this is to let you know which pic to animate them with
#define mob_id 17
#define mob_dir 18
#define mob_rand_var1 19// used in the movement to set specific special movements 
#define mob_speed  20// tell the speed that the mob should move.  if 0, then dont move, but animate.
#define mob_stops 21 // 0 for constantly moving, 1 for random, 2 moves when link in proximety
#define mob_animation_type 22// 0 always animate, 1 animate when moving.
#define mob_rand_var2 23// used in the movement to set specific special movements 
#define mob_animation_speed 24// used to tell how fast to speed thorugh the frames.  
					// 1 will animate every frame.  2, every other frame ... 10 every 10 frames ... 20 every
					// 20 frames, etc.
#define mob_current_sprite 25
#define mob_move_type 26// tells how the mob should move, such as MOB_WANDER, MOB_FLUTTER, 
					//MOB_HOP, MOB_FOLLOW
*/
/* in ezelda
void change_dir(int who)
{
	int dir=get_mob_stat(who,mob_dir);
	int i=0, maxer=random(2)+1;// this will change the direction any random number of times.
	while (i<maxer){	dir++;i++;}
	if (dir>right){dir=up;}
	mod_mob(who,mob_dir,dir,TRUE);
	
}// end change dir
/*
int animation_pic_decider(int loc, int frame,int ani_speed, int sprites, int pic,int sprite_id)
{
				if ((frame>ani_speed) && (sprites>=2)){
					if (pic>=(sprites+sprite_id)-1){
						
						pic=sprite_id;// reset the pic to the original sprite
						//if (sprites==4)
					}// end if pic>sprites
					else {pic++;}
					mod_mob(loc,mob_frame,0,TRUE);
			}
			return pic;
}*/

//=================================================================================================



/* moved to ezelda
int touch_mob(int x, int y, int who)
{
	/*36992 ->36930
			this routines sees if one of the mobs are touching link, if so then return who
	45166 ->45114
	*//*
	// if not shield active and link_facing, then tell yes.
	//int x=link_stat(link_x)
	// link_x and link_y already defined.
	
	int a=13,b=13;
	switch (who)
	{
		case LINK:
			 a=b=13;
		break;
		case boomerang:
			a=b=8;
		break;
		case 0 ... 50:
			// in the event it is an object, use this
			if (get_object(who,OBJECT_NUMBER)>999){
				a=get_object(who,item_W);
				b=get_object(who,item_H);
				x+=get_object(who,item_x_whitespace);
				y+=get_object(who,item_y_whitespace);
			}// end if an item
		break;
		
	}// end switch who
	

	
	int i=0;
	while (i<max_mobs)
	{
		if (get_mob_stat(i,mob_id)>0)
		{//collide(int x, int x_w, int y, int y_w, int a, int a_w, int b, int b_w)
		//CheckAreaCollision(int area1_x, int area1_y, int area1_width, int area1_height, int area2_x, int area2_y, int area2_width, int area2_height)
		//	if (collide(x, a, y, b, get_mob_stat(i,mob_x), 14, get_mob_stat(i,mob_y), 14))
			if (CheckAreaCollision(x, y, a, b, get_mob_stat(i,mob_x), get_mob_stat(i,mob_y), 13, 13))
				{
					
		//			printf("collide detected");
			//		wait_for_key();
					if (get_mob_stat(i,mob_underground)<=0){return i;}// if the mob is not underground, then
					// send the location.
				}// end if they do collide
		}
		i++;
	}// end while <max_mobs
	return 555;
}// end touch_link
*/
//=================================================================================================




//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//														From item gfx

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


/* - in ezelda
int touch_object(int x, int y, int who, int loc, int ret)
{
	/*36992 ->36930 ->37477
			this routine attemts to find out if an object touches link or if
			the boomerang touches the object.
			ret has 2 settings
			if true, then return the id
			if false, then return whether the location has been touched or not.
			ret is to return the exact location or not.
	*//*
	// if not shield active and link_facing, then tell yes.
	//int x=link_stat(link_x)
	// link_x and link_y already defined.
	
	int a=0,b=0, i=0;
	a=b=15;
	
	if (who==boomerang){a=b=8;}
/*	switch (who)
	{
		case LINK:
			 a=b=15;
		break;
		case boomerang:
			a=b=8;
		break;
	
		
	}// end switch who
*//*
if (ret){i=0;loc=0;}else {i=obj_list_size-1;}

	while (i<obj_list_size)
	{
		//get_object(loc,item_W)
	if ((get_object(loc,OBJECT_NUMBER)>=0) &&  (get_object(loc,OBJECT_NUMBER)!=FIRE)){
		if (CheckAreaCollision(x, y, a, b,get_object(loc,OBJECT_X)+get_object(loc,item_x_whitespace), 
			get_object(loc,OBJECT_Y)+get_object(loc,item_y_whitespace), get_object(loc,item_W), get_object(loc,item_H)))
		
			
				{
						if (ret){if (get_object(loc,OBJECT_NUMBER)==BOOMERANG || get_object(loc,OBJECT_NUMBER)==HOOKSHOT)
						{}else {return loc;}}else {return TRUE;}
					}// end if collission.
			//	else{if (!ret){return FALSE;}}	
		}// end if object number >=0			
		i++;loc++;
		
		}// end while			
			//		printf("collide detected");
			//		wait_for_key();

	return 555;
}// end touch_link
*/
//============================================================================================

/* moved to ezelda
void animate_boomerang(int loc)
{
	//object_list[loc][obj_dir]//=which direction it is travelling
	int rotate=0;
	int o_touched=0, o_type=555;
	if (get_object(loc, obj_var2)>1)// this means that the boomerang is returining to link
	{
		if (get_object(loc,OBJECT_Y) > link_y){	set_object(loc, obj_dir, up);}//object_list[loc][obj_dir]=up;	}
			else{ set_object(loc, obj_dir, down);}//object_list[loc][obj_dir]=down;	}
			
		//	move_object(touch_object(get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), boomerang,  loc, TRUE), 6, object_list[loc][obj_dir])  ;
			o_touched= touch_object(get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), boomerang,  loc, TRUE);
			if (o_touched<obj_list_size) {o_type = get_object(o_touched, OBJECT_NUMBER);}//object_list[o_touched][OBJECT_NUMBER];}
			if ((o_type==BOMB2) || (o_type==ARROW2)  || (o_type==CRYSTAL1) || (o_type==HEART1))
			// this prevents anything but bombs, arrow, crystals, and hearts from moving.
			{		move_object(o_touched, 6, get_object(loc,obj_dir)) ; 
			//	printf("%i %i, xx", o_type, o_touched);
			}
			//	printf("%i %i, ", o_type, o_touched);wait_for_key(esc_ko);
	}// end if var2>1
	
/*	switch (get_object(loc,obj_dir))
	{// make it move.
		case up:
			object_list[loc][OBJECT_Y]-=6;// up by 2?
		break;
		case down:
			object_list[loc][OBJECT_Y]+=6;
		break;

	}// end switch ud*//*
		move_object( loc, 6, get_object(loc,obj_dir));
		
		
// these switches are seperate so that the boomerang can travel in 2 directions when returing to link.
	if (get_object(loc, obj_var2)>1)
	{
		if (get_object(loc,OBJECT_X) > link_x)	{	set_object(loc, obj_dir, left);}//object_list[loc][obj_dir]=left;	}
			else{	set_object(loc, obj_dir, right);}//object_list[loc][obj_dir]=right;	}
			
			o_touched= touch_object(get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), boomerang,  loc, TRUE);
			if (o_touched<obj_list_size) {o_type = get_object(o_touched, OBJECT_NUMBER);}//object_list[o_touched][OBJECT_NUMBER];}
			if ((o_type==BOMB2) || (o_type==ARROW2)  || (o_type==CRYSTAL1) || (o_type==HEART1))
			// this prevents anything but bombs, arrow, crystals, and hearts from moving.
			{		move_object(o_touched, 6, get_object(loc,obj_dir)) ; }
			
			move_object( loc, 6, get_object(loc,obj_dir));
			if (get_object(loc,OBJECT_Y)<link_y+11 &&  get_object(loc,OBJECT_Y)>link_y-6  &&
			get_object(loc,OBJECT_X)<link_x+11 &&  get_object(loc,OBJECT_X)>link_x-6)
			{      delete_obj(loc); return;}// if the boomerang manages to get back into links range, then delete it.
	}// end if var2>1
		

	
	
//	switch (get_object(loc,OBJECT_FRAME))
//	{
//		case 0 ... 1:
				switch (get_object(loc, obj_var1))
					{// make it move.
						case up:
							rotate=0;
						break;
						case down:
							rotate=rot_180;
						break;
						case left:
							rotate=rot_270;
						break;
						case right:
							rotate=rot_90;
						break;
					}// end switch			


			
//		break;
//		default:
//			object_list[loc][OBJECT_FRAME]=-1;
			set_object(loc, obj_var1,circle_dir(get_object(loc, obj_var1))); // object_list[loc][obj_var1]=circle_dir(get_object(loc, obj_var1));
//		break;
//	}// end switch frame
	 
	 int who=0;
	 if ((who=touch_mob(get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), boomerang))!=555)
	 {// ie if the boomerang hit a mob, then do the following:
	 	//	pain(who, get_object(loc, obj_dam),0,0);// for now it will do a perm 4 damamge
	 		mod_mob(who, mob_stunned, 30, TRUE);// stun the mob for 30 loops.
	 		set_object(loc, obj_var2, 2);
	 		//set_object(loc, obj_var2, 2);
	 }
	 else if (get_object(loc,OBJECT_X)<2 || get_object(loc,OBJECT_X) >=144 || get_object(loc,OBJECT_Y)<2 || get_object(loc,OBJECT_Y)>=112)
	 {// if the boomerang reaches the edge of the room, then do this.
	 	set_object(loc, obj_var2, 2);
	 }
	 else if (touch_object(get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), boomerang,  loc, TRUE)!=555)  
	 {
	 	set_object(loc, obj_var2, 2);
	 }
//	else {object_list[loc][obj_var2]=0;}
	// do a chec k to see if the boomerang hit the edge of the room or if it hit a mob.  if so, then do damamge/stun and then 
	// set var2==2.  else var2==0
	
	// once it hits something or it reaches the end of the screen, then return to link.
	/*
	
			if (get_object(loc,OBJECT_X) > link_x)	{	object_list[loc][obj_dir]=left;	}
			else{	object_list[loc][obj_dir]=right;	}
				
			if (get_object(loc,OBJECT_Y) > link_y){	object_list[loc][obj_dir]=up;	}
			else{ object_list[loc][obj_dir]=down;	}
			
			with the above code, you might want to put this above the switch stmt(s) at the top of
			this routine.  then break up the switch stmts with up/down and l/r.  then have these if 
			stmts in between them, so you can activate the ability for the boomerang to move
			in 2 directions at once in order to find link.
			
			but these if stmts only need to be active if the boomerang is on the return.
	
	*//*
//	object_list[loc][OBJECT_FRAME]++;
	DrawImage(OBJECT, BOOMERANG, get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), A_NORMAL,TRUE,rotate,button_pressed, link_direction, dark_room);
	
}// end animate boomerang
*/
//============================================================================================


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//														From items

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


//=================================================================================================
/* moved to ezelda
int item_type_exists( int type, int where)
{
	// where can be for the inventory or held.
	// search through the inventory/ held for get_item_info(inv(ixxX), item_type)==type.  if so, then return true
	// this is to let me know if i have the bow or bombs or any other random item type like shield equipped.
	int i=0,i_max=0;
	
	switch (where)
	{
		case hold:
		
					i=hold_a;
			while (i<=hold_d){	if (type==get_item_info(link_stat(i),item_type)){return TRUE;}i++;}
		break;
		case bag:
		case 4:
			i=0;i_max=12;
			if (where==4){i=12;i_max=inv_cols;}// added so i can check the external inventory.
			while (i<i_max){	if (type==get_item_info(g_inv(1,i),item_type)){return TRUE;}i++;}
			
		break;
		case 3: // this will find the exact location of that item and return the item number
		// it checks both the inventory and the hold.  although it may take a little more
		// ram, it does allow for the item number to be whatever i choose as long as the item
		// type is whatever.  - this is designed for infinity.
			i=0;//i_max=12;
			//if (where==4){i=12;i_max=30;}// added so i can check the external inventory.
			while (i<12){	if (type==get_item_info(g_inv(1,i),item_type)){return g_inv(1,i);}i++;}
			i=hold_a;
			while (i<=hold_d){	if (type==get_item_info(link_stat(i),item_type)){return link_stat(i);}i++;}
		break;
		case either:
			i=hold_a;
			while (i<=hold_d){	if (type==get_item_info(link_stat(i),item_type)){return TRUE;}i++;}
			i=0;
			while (i<12){	if (type==get_item_info(g_inv(1,i),item_type)){return TRUE;}i++;}
		break;
	}

	return FALSE;
}//end item type extists
*/
/*all moved to ezelda
int quest_loc(int type, int num)
{
// gets the location of the quest item and type.
		int i=type*10, maxer=10+(type*10);

	
	while (i<maxer)
	{
			if (g_inv(4,i)==num){return i;}
			i++;
	}// end while
	return 555;
}

void add_quest(int type, int num)
{// this just adds a quest item
	if (!quest_exists(type,num))
	{
		if (quest_loc(type,0)!=555)
		{
			s_inv(4,quest_loc(type,0),num);
		}// end if there exists a spot
	}// end if it doesnt already exist
}// end add quest.

int quest_exists(int type, int num)
{
	// this will just loop through to see if the dungeon map of the specified #
	// exists or not.
	//	[4]	level info: 0>9 (maps)***, 10>19 (compasses)***, 20>29 (triforce/ dungeon complete)***
	
	
	int i=type*10, maxer=10+(type*10);
	
	
	while (i<maxer)
	{
			if (g_inv(4,i)==num){return TRUE;}
			i++;
	}// end while

	
	return FALSE;
}// end dung map exists.
*/


/* in ezelda
int item_loc(int item)
{
	int i=0;
	while (i<max_list_size)
	{
		if (item==item_list[i][item_id]){return i;}
		i++;
		
	}// end while
	return 555;// item not found.
}// end item loc*/

//=================================================================================================

/* in ezelda
int get_item_info(int item,int stat)
{
	int i=0;
	if ((i=item_loc(item))<max_list_size)
	{
		return item_list[i][stat];
	}
	return 0;// no stat.  best to default it to 0
}// end get item stat

*/

//=================================================================================================




//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//														From inventory

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





/*void remove_item_inv(int item, int amt, int ext)
{
	add_item_inv(item, amt, ext);
	int i=inv_item_loc(item,ext);
	if (inv[2][i] <=0){inv[1][i]=0;}// remove the item if there are 0 items there
}// end remove item*/
/*in ezelda
void add_item_inv(int item, int amt, int ext)
{
	
//			this will add an item to the inventory or add more of that item to the inventory if it 
//			already exists.  it can also remove those items.
//			ext is for "exteneded" inventory - either true or false.  look at inv_item_loc(int item, int ext)
//			for more info
			
//			this also takes into account whether you are holding the item or not.  if so, then it will
//			add to that item.
			
	
		int i=0,area_amt=0, held=FALSE;
		if (get_item_info(item,item_type)==arrow_ammo && item_type_exists(arrow,either))
		{// the bow is defined as arrow.  this is a problem, b/c you can buy arrows in shops.
		// thus i needed to create arrow_ammo.  this converts arrow_ammo to the arrow item
		// however, the first of that item type will be taken into consideration, so you will need
		// to delete out the old bow and add in the new one in the event that you have more
		// than one bow.
			item=item_type_exists(arrow,3);
		}// end if
		if (get_item_info(item,item_type)==heart)
		{// i made this an item, so you could buy hearts like the original zelda
			mod_link(hp,8,FALSE);
			goto end;
		}
		
		if ((i=inv_item_loc(item,ext))==555){
			//l
			if (item==link_stat(hold_a)){area_amt=hold_a_amt;held=TRUE;}
			else if (item==link_stat(hold_b)){area_amt=hold_b_amt;held=TRUE;}
			else if (item==link_stat(hold_c)){area_amt=hold_c_amt;held=TRUE;}
			else if (item==link_stat(hold_d)){area_amt=hold_d_amt;held=TRUE;}
			else {
				
					i=inv_item_loc(0,ext);
					if (i<inv_cols){s_inv(1,i,item);}// add the item to the inventory
					// the if <30 is here for 
				}// end else
			}// if cannot find the item, then find the
		// null spot
		if (!held){amt+=item_amt(item,ext);}//if (i<inv_cols){amt+=g_inv(2,i);}}// end if not holding the item
		else {amt+=link_stat(area_amt);}
		
		if (amt>32000){amt=32000;}
		if (amt<0){amt=0;}
		if ((get_item_info(item,item_type)==bomb) && (amt>link_stat(max_bombs))){amt=link_stat(max_bombs);}
		if ((get_item_info(item,item_type)==arrow) && (amt>link_stat(max_arrows))){amt=link_stat(max_arrows);}
		//#define max_arrows 15
		if (!held){if (i<inv_cols){s_inv(2,i,amt);}}
		else {mod_link(area_amt,amt, TRUE);}
	end:
}// end add item*/

//=================================================================================================

/*in ezelda
int inv_item_loc(int item, int ext)
{

//			this will find the inv item loc.
//			ext is for "extended".  the extended inventory is everything past 11, only 12
//			spots for the orig inventory.  
//	WARNING this does have redundant code in it.  item_loc has the same code so does other things

	
			int i=0, maxer=12;
			if (ext){i=12;maxer=inv_cols;}
	while (i<maxer)
	{
		if (item==g_inv(1,i)){return i;}
		i++;
		
	}// end while
	return 555;// item not found.
}// end inv item loc*/


//=================================================================================================

/*in ezelda
int item_amt(int item, int ext)
{// this will return the amount of items in the inventory
		int i=0;
		if ((i=inv_item_loc(item,ext))==555){return 0;}
		if (i<inv_cols){return g_inv(2,i);}// end if not holding the item
		return 0;
}// end item ammount
*/






//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//														From keys

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


/* in ezelda
int touching_sprite(int qx, int qy, int sprite)
{// this lets you know if you can move or not.
	// do checks in the room files to see if there is a warp, b/c by default, this will not let
	// you move past an 8x8 room.
	//return TRUE;// just make this work.



	//	here is an issue for mobs:  you are using rmapx/y(). this only takes into acocunt link.
	//	you will need to only move those mobs, which are in the room.  if they are not in the room
	//	then do not move them.  maybe, you will not have to remove rmapx/y()

//37259
	//>=0 <50 = walkable area.
		int x=0,y=0,sprite1=0;//prox(link_x),q=0;



					y=gter(qy+6);
					x=gter(qx+6);
		// you are failing to realize the proximity of things, which are important.
		// the screen size is set to 8x10.  there are only 6x10 available. you need to take into
		// account 32 extra lines, which would make things work.  although you are only at 80,80, 
		// you are well past certain things.  adding or subtracting of xpos/ypos is important.

	
		sprite1=get_all_maps(rmapx, rmapy,y,x);
//		sprite2=get_room_maps(rmapx(),rmapy(),y2,x2);
//	if ((y>=0 && y<=7) && (x>=0 && x<=7)){
	if (sprite1==sprite){return TRUE;}
//	if ((sprite1 >=sprite_low && sprite1 <=sprite_high)&&(sprite2 >=sprite_low && sprite2 <=sprite_high)){return TRUE;}
	//if (((!mob_collide(who) && (who !=LINK )) || (who==LINK))){return TRUE;}}
	
	return FALSE;
	
}// end touch sprite

int precision_move(int x, int y, int dir, int amt)
{// this just attempts a precision move
//	int a=x,b=y;
	switch (dir)
	{// if the move thinks it is the same sprite then, force it to move one sprite in that direction.
		case up:
			if (gter(y-amt)==gter(y)){y-=16;}
			else {y-=amt;}
		//	if ((gter(b)-gter(y))>=2){y+=4;}
		break;
		case down:
			if (gter(y+amt)==gter(y)){y+=16;}
			else {y+=amt;}
		//	if ((gter(y)-gter(b))>=2){y-=4;}// try to even it out in the event that things go wrong.
		break;
		case left:
			if (gter(x-amt)==gter(x)){x-=16;}
			else {x-=amt;}
		//	if ((gter(a)-gter(x))>=2){x+=4;}
		break;
		case right:
			if (gter(x+amt)==gter(x)){x+=16;}
			else {x+=amt;}
		//	if ((gter(x)-gter(a))>=2){x-=4;}
		break;
	}// end switch
//printf("yp=%i xp=%i",gter(y),gter(x));wait_for_key(esc_ko);	
	
	int i=get_all_maps(rmapx, rmapy,gter(y),gter(x));
	//49, 0
	if (i>=0 && i<=49){return TRUE;}
	return FALSE;
}// end precision move
*/



//===============================================================================================
/* depreciated - use int touching_sprite_range(int qx, int qy, int sprite_low, int sprite_high) instead
int terrain_contact(int qx, int qy, int dir, int sprite_high, int sprite_low)
{// this lets you know if you can move or not.
	// do checks in the room files to see if there is a warp, b/c by default, this will not let
	// you move past an 8x8 room.
	//return TRUE;// just make this work.



	//	here is an issue for mobs:  you are using rmapx/y(). this only takes into acocunt link.
//		you will need to only move those mobs, which are in the room.  if they are not in the room
//		then do not move them.  maybe, you will not have to remove rmapx/y()

//37259
	//>=0 <50 = walkable area.
		int x=0,y=0,x2=0,y2=0,sprite1=0,sprite2=0;//prox(link_x),q=0;


/======================================================================

		base low and base high are important.  they are key walkable areas
		that is true in every circumstance.  this was added in to prevent
		errors when attempting to walk on odd areas, which are surrounded
		by walkables, but you cant walk, b/c of incorrect numbers.


======================================================================/

	int base_low=0;
		int base_high=49;


		// you are failing to realize the proximity of things, which are important.
		// the screen size is set to 8x10.  there are only 6x10 available. you need to take into
		// account 32 extra lines, which would make things work.  although you are only at 80,80, 
		// you are well past certain things.  adding or subtracting of xpos/ypos is important.
		
// if you are blow, then allow about 6 pixles of head walking
// if it is to the right or left, allow about 2 pixles (if walk sprite is at 6 bottom pixles of link, then walk) 
	//- (if walk sprite is at 6 or less top pixles of link, then walk) 
// if you are above, then allow 2 pixles		
// link left and right has 2 pixles of dead space.


// technically, if left or right, then do the qx-(gter(qx)*16) - if <=8 - then allow it.
//194, 185
//		y=gter(qy);
//	x=gter(qx);
	//	printf_xy(0,50,"x=%i, y=%i, %i %i",x,y,qx-x*16,qy-y*16);
	switch (dir)
	{
		case up:
			//		x3=qx-2;
			
					y=gter((qy+6));// make him able to move closer up to objects like in the real game.
					x=gter(qx+4);// +2 is the 2 pixles of white space that makes up the link sprite
					y2=gter(qy);
					x2=gter(qx+11);// to take care of the width
				//	if (a_mob && ((qy-get_mob_stat(who,mob_speed))<0)){return FALSE;}
				if (sprite_high==191 && sprite_low==185) {y=gter((qy-4));}// modded for the hookshot.
		break;
		case down:
				//x3=qx-2;
				y=gter((qy+12));
				x=gter(qx+4);
				y2=gter(qy+14);// this used to be 16, but there were issues.
				x2=gter(qx+11);

				if	(link_stat(state)==LINK_JUMP){// was having issues with jump, so i added this to
				// make jump work again.
							y=gter((qy+14));
					//	x=gter(qx-2);
						y2=gter(qy+17);// this used to be 16, but there were issues.
						x2=gter(qx+15);	
				}//y=gter((qy+16));y2=gter(qy+16);}	// fix for jumping
		break;
		case left:
			//	x3=qx-2;
		 		y=gter(qy+4);//((qy+1)/16)+1;// +1 in the end is for the current spot
				x=gter((qx-4+4));// +2 is for the link buffer
				y2=gter(qy+10);// for the heighth - might need to decrease to 15 to allow for more movable
				// room in tight spots
				x2=gter(qx-4+4);
			//	if (a_mob && ((qx-get_mob_stat(who,mob_speed))<0)){return FALSE;}

		break;
		case right:
		 	//  x3=qx+2;
		 	  y=gter(qy+4);//+4 is to get out of tight spots
				x=gter(qx+4+11);// +13 is to take into account the width of link
				y2=gter(qy+10);
				x2=gter(qx+13+2);
		//		if (a_mob && ((qx+get_mob_stat(who,mob_speed))>144)){return FALSE;}

		break;
	}//
	
		sprite1=get_all_maps(rmapx, rmapy,y,x);
		sprite2=get_all_maps(rmapx, rmapy,y2,x2);
		//printf_xy(0,60,"s= %i %i",sprite1, sprite2);
//	if ((y>=0 && y<=7) && (x>=0 && x<=7)){
	if ((sprite_high==191 && sprite_low==185) ) {// modded for the hookshot
			if ((sprite1 >=sprite_low && sprite1 <=sprite_high)&&(sprite2 >=sprite_low && sprite2 <=sprite_high)){return TRUE;}
			}else{
		 if (((sprite1 >=sprite_low && sprite1 <=sprite_high)&&(sprite2 >=sprite_low && sprite2 <=sprite_high)) ||
						((sprite1 >=base_low && sprite1 <=base_high)&&(sprite2 >=sprite_low && sprite2 <=sprite_high))  ||
						((sprite2 >=base_low && sprite2 <=base_high)&&(sprite1 >=sprite_low && sprite1 <=sprite_high))  ||
										
						((((dir==left) || (dir==right)) && ((qy-(gter(qy)*16))<12))&& // this section is to allow to pass by
						// objects when going left or right with the head to pass through a non walkable object.
				//		(((sprite1 >=base_low && sprite1 <=base_high)&&(!(sprite2 >=sprite_low && sprite2 <=sprite_high)))  ||
						((sprite2 >=base_low && sprite2 <=base_high)&&(!(sprite1 >=sprite_low && sprite1 <=sprite_high))))
						
				 )
			{return TRUE;}// so far, this mod has worked for holes and has not messed anything else up.
		//	((dir==left) || (dir==right)) && ((qy-(gter(qy)*16))<10) && 
	}// end else
	//if (((!mob_collide(who) && (who !=LINK )) || (who==LINK))){return TRUE;}}
	
	return FALSE;
	
}// */
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//														From items_gfx

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/* in ezelda
void exploding_bomb(int loc)
{
	int i=0,k=0,n=25,chk=0,x=0,y=0;
	//if (get_object(loc,OBJECT_FRAME)<5)
	int ax=0,ay=0;
	//{	
	while (i<2){
		while (k<2)
		{
			if (get_object(loc,OBJECT_FRAME)>=5 && get_object(loc,OBJECT_FRAME)<=7){n=29;}
			DrawImage(OBJECT,n , get_object(loc,OBJECT_X)+(k*16), get_object(loc,OBJECT_Y)+(i*16), A_NORMAL, TRUE,0);
			n++;
			k++;
		}// end while k
		i++;k=0;
	}// end while i	
//	}// end if <12


	//increase_object(list_num, OBJECT_FRAME, 1);
	increase_object(loc, OBJECT_FRAME, 1);
	
	 if (get_object(loc,OBJECT_FRAME)>=8){
	i=0;
		while (i<max_mobs)
			{// this will deal damage to each mob that is caught in the blast
				if (get_mob_stat(i,mob_id)>0)
				{
					if (CheckAreaCollision(get_object(loc,OBJECT_X),get_object(loc,OBJECT_Y),32, 32, get_mob_stat(i,mob_x), get_mob_stat(i,mob_y), 13, 13))
						{
							
					//		printf("collide detected");
					//		wait_for_key();
							if (get_mob_stat(i,mob_underground)<=0){pain(i, 8 , EXPLOSION,0);}// if the mob is not underground, then
					//		else {}//pain(int who, int dam, int dam_type)
							// send the location.
						}// end if they do collide
				}// end if stat>0
				i++;
			}// end while <max_mobs	
		
		if (CheckAreaCollision(get_object(loc,OBJECT_X),get_object(loc,OBJECT_Y),32, 32, link_x, link_y, 13, 13)){
			// if link is caught up in the explosion, then hurt him, too.
			pain(LINK, 8 , EXPLOSION,0);
		}// end if hits link
		i=192;
		while (i<200){// search through to see if a wall is bombed.
				ax=0;ay=0;
				while (ax<3){
				while (ay<3){
					if (touching_sprite( get_object(loc,OBJECT_X)+(ax*10)-2,get_object(loc,OBJECT_Y)+(ay*10)-2, i)){
							
							x=get_object(loc,OBJECT_X)+(ax*10)-2;
							y=get_object(loc,OBJECT_Y)+(ay*10)-2;	
							chk=precision_sprite_find(x, y,i);// get and fix the sprite location.
							if (chk>=100 && chk<200){x+=(chk-111);}
							else if (chk>=200){y+=(chk-211);}
							y=gter(y);x=gter(x);
							//60951 -> 60905
							if ((chk=get_all_maps(rmapx, rmapy,y,x))<196){chk+=4;}
							chk-=150;// this does the same thing as the switch below.

						
							if (chk>45 && chk<50){set_all_maps(rmapx, rmapy,y,x, chk);}// had strange atrifacts show up, so this will
							// prevent some odd out of bounds errors.
				}// end if touching sprite
				ay++;
			}// end ay
				ay=0;ax++;
			}//end while ax
			i++;
		}// end while search for wall bombed.
		
	delete_obj(loc);}
	
		
	//	memcpy(GetPlane(0),light,LCD_SIZE);
//	memcpy(GetPlane(1),dark,LCD_SIZE);
}// end exploding bomb
*/

//============================================================================================

/*in ezelda
void animate_fire(int loc) // uses pain - cant use it
{
			int draw_type=A_NORMAL, who=0;
		switch (get_object(loc,OBJECT_FRAME))
				{// makle it blink
					case 0 ... 2:
						draw_type=A_REVERSE;
					break;
					case 3 ... 4:
					break;
					default:
						increase_object(loc, OBJECT_FRAME, -1);//object_list[loc][OBJECT_FRAME]=-1;
					break;
									
				
				}// end switch
			//	increase_object(loc, obj_var1, 1);//
		increase_object(loc, obj_var1, 1);
		if (get_object(loc, obj_var1)>17){ delete_obj(loc);}// end if delete obj after 16 frames			
		if ((get_object(loc, obj_var1)%3)==0){
			if ((who=touch_mob(get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), boomerang))!=555)
				 { pain(who, 2, type_fire,0);}// for now it will do 2 damamge ever 3 fames.

		}// end if mod 3
				 //
	if	(touch_object(link_x, link_y, LINK, loc, FALSE)){}//pain(LINK,2,type_fire,0);}// if it touches link, then deal 4 damage
		DrawImage(OBJECT, 24, get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), draw_type,TRUE,0);
		increase_object(loc, OBJECT_FRAME, 1);
}// end animate fire*/
//============================================================================================

//============================================================================================
/* in ezelda
void animate_throw_object(int loc)// uses pain. cant use it
{
	//#define item_pic_2 7
//#define item_pic_3 8
	int i=0,who=0;
		increase_object(loc, obj_var1, 1);
	if (get_object(loc, obj_var1)<=8)// move the object
	{
		move_object(loc,5,get_object(loc, obj_dir));
	
	if (get_object(loc, obj_dir)==right || get_object(loc, obj_dir)==left){
		if (get_object(loc, obj_var1)>=5){move_object(loc,4,down);}
		}// end if moving right or left.
	}// end if rand var1<=8
//printf("var1=%i v2=%i",	get_object(loc, obj_var1),get_object(loc, obj_var2));wait_for_key(b_ko);
	
	if (get_object(loc,obj_type)==flying_bomb){
	// if it is a bomb, then do the following:	
	// make sure it doesnt go out of bounds and then bypass the flying object stuff.
		if (get_object(loc,OBJECT_X)<2){set_object(loc, OBJECT_X ,6);}
		if (get_object(loc,OBJECT_X) >=144){set_object(loc, OBJECT_X ,138);}
		if (get_object(loc,OBJECT_Y)<2) {set_object(loc, OBJECT_Y ,6);}
		if (get_object(loc,OBJECT_Y)>=112 ){set_object(loc, OBJECT_Y ,106);}
		increase_object(loc, OBJECT_FRAME, 1);// continue to increase the frame reguardless
		if (get_object(loc, obj_var1)>8){increase_object(loc, obj_var2, 1);}
		goto bypass; 
	}// end if a bomb
	
	
	if (get_object(loc,OBJECT_X)<2 || get_object(loc,OBJECT_X) >=144 || get_object(loc,OBJECT_Y)<2 || get_object(loc,OBJECT_Y)>=112 
			|| get_object(loc, obj_var1)>8 )
	{
	//	 animate_leaf(loc, get_item_info(get_object(loc,OBJECT_NUMBER),item_pic2), get_item_info(get_object(loc,OBJECT_NUMBER),item_pic2));
		 i=add_object(LEAF2, get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y),0);
		// set_object(i,obj_var1, 
		 set_object(i,obj_var1, get_item_info(get_object(loc,OBJECT_NUMBER),item_pic_2));// set the pic1
		 set_object(i,obj_var2, get_item_info(get_object(loc,OBJECT_NUMBER),item_pic_3));// set the pic2
		 
		 increase_object(loc, obj_var2, 1);
	}
	else if ((who=touch_mob(get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), loc))!=555)  
	 {
	 	 i=add_object(LEAF2, get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y),0);
	 	 set_object(i,obj_var1, get_item_info(get_object(loc,OBJECT_NUMBER),item_pic_2));// set the pic1
		 set_object(i,obj_var2, get_item_info(get_object(loc,OBJECT_NUMBER),item_pic_3));// set the pic2
		 increase_object(loc, obj_var2, 1);
		 pain(who,get_item_info(get_object(loc,OBJECT_NUMBER),item_damage),0,0);
	 }
	 
	 bypass:
	 
	 if (get_object(loc, obj_var2)<=0)
	 {// var2 is used to decide whether to draw the object or not.  if 0 or less, then draw it, otherwise delete the object.
	 	DrawImage(OBJECT, get_item_info(get_object(loc,OBJECT_NUMBER),item_pic_id), get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), A_NORMAL,TRUE,0);
	 	
	 	if (get_object(loc, obj_var1)<5)
	 	{// this will draw the shadow benieth the rock when thrown.  2 things needed b/c it first travels linear then diagnal.
	 		DrawImage(OBJECT, SHADOW1, get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y)+16, A_NORMAL,TRUE,0);
	 	}
	 	else{// this part is when the rock travels diagnal.
	 		DrawImage(OBJECT, SHADOW1, get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y)+(16-((get_object(loc, obj_var1)-5)*4)), A_NORMAL,TRUE,0);
	 	}// end else if the var>=5
	 	
	 }// end if var2<=0
	 // 5=+4  28
	 // 6=+8  24
	 //7=+12  20
	 //8=+16  16
	 //28-(var-5)*4
	 else  {// if var2>=1
//	 	printf("\nin here");wait_for_key(b_ko);
	 	if (get_object(loc,obj_type)==flying_bomb)
	 	{
	 		set_object(loc,obj_type, boom_bomb);// return the bomb back to normal.
	 		
	 	}
	 	else{
	 	drop_item(get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y),0);// chance of items being dropped once
	 	// a rock or jar explodes.	
	 	delete_obj(loc);}
	 }// end if var2>0
}
*/
//============================================================================================



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//														From link_gfx

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*rewritten in ezelda

void gfx_disp_hearts(int x, int y)
{// you could probably put this in ezelda - sent to ezelda-makes program bigger so dont do that.
// and it breaks the mob gfx...

/*
		this will display the hearts of link.  you should pass in coords to figure out where to disp
		the hearts.  it would allow you to change where they are disped on the screen.
		
		first get his max hp.  then /8 = # of hearts.
		get current_hp then /4 = # of half hearts
		
		x and y are the x/y coords which the hearts start at.
		
		i redid the loop so that it will draw the current hp first and then fill the rest with
		blank hearts
*/
/*
int m_hp=link_stat(max_hp);
int current_hp=link_stat(hp);
int m_hearts=m_hp/8;
int hearts=current_hp/8;

int a=x,b=y;
// 76 x 24

//while (i<m_hearts)
//{// each heart is 7 in size
		while (a<(x+(hearts*8)))
	{
		DrawImage(OBJECT, HEART1, a, b, A_NORMAL, FALSE,0);
		a+=8;// increase by 10 for each heart
		if (a>(x+(8*7))){a=x;b+=8;hearts-=8;m_hearts-=8;}
		
	}// end while a<(x+(m_hearts*10))
	if (current_hp%8!=0)
	{// this checks to see if you have half of a heart.
		DrawImage(OBJECT, half_heart, a, b,  A_NORMAL, FALSE,0);
		a+=8;
		if (a>(x+(8*7))){a=x;b+=8;m_hearts-=8;}
	}
	
	while (a<(x+(m_hearts*8)))
	{
		DrawImage(OBJECT, blk_heart, a, b,  A_NORMAL, FALSE,0);
		a+=8;// increase by 10 for each heart
		if (a>(x+(8*7))){a=x;b+=8;m_hearts-=8;}
		
	}// end while a<(x+(m_hearts*10))
//	a=x, b=y;
	

//	i++;
//}// end while <mhearts
	
}// end disp hearts*/


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//														From mathy

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*

char bb[6]={'0','0','0','0','0','\0'};

void lota(long int num)
{
	 if (num>65534){num=65534;}
	 if (num < 0){num=0;}
	 int i=0;
	 int a=0;
//	bb[5]={0,0,0,0,0};
	 while (i<7)
	 {
	 	if (num>10000){num-=10000;a++;}// reduce by 10000 and then increase a
	 	else if (num<10000){i+=10; bb[0]=a +'0';}
	 	i++;
	 }// end while i<7
	 
	 
	 i=0;a=0;
	 
	  while (i<10)
	 {
	 	if (num>1000){num-=1000;a++;}// reduce by 1000 and then increase a
	 	else if (num<1000){i+=10; bb[1]=a+'0';}
	 	i++;
	 }// end while i<10


	 
	 i=0;a=0;
	 
	  while (i<10)
	 {
	 	if (num>100){num-=100;a++;}// reduce by 1000 and then increase a
	 	else if (num<100){i+=10; bb[2]=a+'0';}
	 	i++;
	 }// end while i<10

	 
	 i=0;a=0;
	 
	  while (i<10)
	 {
	 	if (num>10){num-=10;a++;}// reduce by 1000 and then increase a
	 	else if (num<10){i+=10; bb[3]=a+'0';}
	 	i++;
	 }// end while i<10


	 
	 i=0;a=0;
	 
	  while (i<10)
	 {
	 	if (num>1){num-=1;a++;}// reduce by 1000 and then increase a
	 	else if (num<1){i+=10; bb[4]=a+'0';}
	 	i++;
	 }// end while i<10
		
	//	for (i=0;i<5;i++)	{str[i]=tmp[i];}
	//	return str;
}// end convert long to string.*/




/*int CheckAreaCollision(int area1_x, int area1_y, int area1_width, int area1_height, int area2_x, int area2_y, int area2_width, int area2_height)
{
//	 int collide(int x, int x_w, int y, int y_h, int a, int a_w, int b, int b_h)
	 // use BOUNDS_COLLIDE2HW(x0, y0, x1, y1, w0, w1, h0, h1) 
	 return collide(area1_x, area1_width, area1_y, area1_height, area2_x, area2_width, area2_y, area2_height);
	 
	     //Checks if the X coordinates of area2 intersect with area1
	if ( (((area1_x <= area2_x && area1_x+area1_width >= area2_x) ||
	     (area1_x <= area2_x+area2_width && area1_x+area1_width >= area2_x+area2_width)) ||
	     //Checks if the X coordinates of area1 intersect with area2
	     ((area2_x <= area1_x && area2_x+area2_width >= area1_x) ||
	     (area2_x <= area1_x+area1_width && area2_x+area2_width >= area1_x+area1_width))) &&

	     //Checks if the Y coordinates of area2 intersect with area1
	     (((area1_y <= area2_y && area1_y+area1_height >= area2_y) ||
	     (area1_y <= area2_y+area2_height && area1_y+area1_height >= area2_y+area2_height)) ||
	     //Checks if the Y coordinates of area1 intersect with area2
	     ((area2_y <= area1_y && area2_y+area2_height >= area1_y) ||
	     (area2_y <= area1_y+area1_height && area2_y+area2_height >= area1_y+area1_height))) )
		return 1;
	else
		return 0;
}*/


/*
char *strreverse (const char *s)
{
  char c;
  size_t i;
  register size_t len = strlen (s);
  register size_t mid = len / 2;

  for (i = 0; i < mid; i++)
    {
      c = s[i];
      s[i] = s[len - i - 1];
      s[len - i - 1] = c;
    }

  return s;
}
*/

/*

void reverse(char s[])
{
    int c, i, j;

    for (i = 0, j = strln(s)-1; i<j; i++, j--) {
        c = s[i];
        s[i] = s[j];
        s[j] = c;
   }
}

char *itoa (char *nptr, long int n)
{
  char *cptr = nptr;

  if (n < 0)
    *cptr++ = '-';

  while (n)
    {
      *cptr++ = '0' + abs (n) % 10;
      n /= 10;
    }

  *cptr = '\0';

  if (n < 0)
    cptr = nptr + 1;
  else
    cptr = nptr;

  reverse (cptr);

  return nptr;
}



int strln(const char *s)
 {
     int iter = 0;
     if (s == NULL)
        return 0;
     while (s[iter] != '\0') {
        iter++;
     }
     return iter;
 }

*/


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//														From rooms

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*

int get_room_info(int which)
{
/*

	this will get the info in the bottom part of the room map section that gives details about the
	room.  you will need to switch all of the get_room_maps() to this if they  are getting info on it.
	

*//*
	
	int i=0;
	switch (which)
	{
		case 0 ... 9:
			i=8;
		break;
		case 10 ... 19:
			i=9;
			which-=10;// reduce by 10
		break;
		case 1000 ... 1003:
		// this set assumes that the world and room stats are synced.
		// if not, then errors and all hell will ensue.
		/*
				this was set up so that i could still use get_room_info and still use the mobs_killed
				define to see if the mobs have been killed.  this prevents me from having to make another
				routine and should prevent me from having to recode a lot of stuff.
		*//*
			which-=1000;
			return g_room_stats(link_stat(map_x), link_stat(map_y), which);
		
		break;
	}// end switch
	return get_room_maps(i,which);
}// end get room info
*//*
void set_room_info(int which, int num)
{
/*

	this will get the info in the bottom part of the room map section that gives details about the
	room.  you will need to switch all of the get_room_maps() to this if they  are getting info on it.
	

*//*
	
	int i=0;
	switch (which)
	{
		case 0 ... 9:
			i=8;
		break;
		case 10 ... 19:
			i=9;
			which-=10;// reduce by 10
		break;
		case 1000 ... 1003:// this is for things like mobs_killed
			which-=1000;
			s_room_stats(link_stat(map_x), link_stat(map_y), which, num);
			return;
		break;
	}// end switch
 set_room_maps(i,which, num);
}// end get room info
*/








//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//														From built in gfx

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*
void menu_lines(int torp)
{
	
	
//		this will draw the lines of message or selector. it had to be split into at least
//		3 seperate parts so things would disp correctly.
	// 51652 ->52070 -> 51339
		int n=0; if (torp==3){n=30;torp=2;}
			int arr[2 * 8 * 4]=
			{6,0,152,0, 6,33,152,33, 8,2,150,2, 8,31,150,31, 5,1,5,32, 153,1,153,32, 7,3,7,30, 151,3,151,30, // torp ==1
			97,35,158,35, 97,98-n,158,98-n, 99,37,156,37, 99,96-n,156,96-n, 96,36,96,97-n, 159,36,159,97-n, 98,38,98,95-n, 157,38,157,95-n};// torp == 2
	 //		97,35,158,35, 97,68,158,68, 99,37,156,37, 99,66,156,66, 96,36,96,67, 159,36,159,67, 98,38,98,65, 157,38,157,65}// torp ==3		
			
	//		int arr[8][4]={{6,0,152,0},{6,33,152,33},{8,2,150,2},{8,31,150,31},
	//									{5,1,5,32},{153,1,153,32},{7,3,7,30},{151,3,151,30}};
			//if ((x==0) && (torp==2)){n=96;}
	//		int arr2[8][4]={{97-n,35,158-n,35},{97-n,98,158-n,98},{99-n,37,156-n,37},{99-n,96,156-n,96},
	//									 {96-n,36,96-n,97},{159-n,36,159-n,97},{98-n,38,98-n,95},{157-n,38,157-n,95}};
		
			int x=(torp-1)*8*4;
			while (x<torp*8*4)
			{	//COLOR_LIGHTGRAY,COLOR_WHITE, COLOR_DARKGRAY, COLOR_BLACK
			 //	GrayDrawLine(x0, y0, x1, y1, COLOR_DARKGRAY) ;
			 	// 51438 -> 51620
			 	GrayDrawLine(arr[x + 0],arr[x + 1],arr[x + 2],arr[x + 3], COLOR_DARKGRAY);
			 //	if (torp==1){GrayDrawLine(arr[x][0],arr[x][1],arr[x][2],arr[x][3], COLOR_DARKGRAY);}
			 //	else{GrayDrawLine(arr2[x][0],arr2[x][1],arr2[x][2],arr2[x][3], COLOR_DARKGRAY);}
			 //	if (torp==1){DrawLine(arr[x][0],arr[x][1],arr[x][2],arr[x][3],A_NORMAL);}
			 //	else {DrawLine(arr2[x][0],arr2[x][1],arr2[x][2],arr2[x][3],A_NORMAL);}
			 	x+=4;
			}// end while
}*/




/*
void bl_box()
{
// this could be reduced, b/c you could reduce it to an 8x8 thingie and then loop it though
// and force it to draw an array of lines?  put it in the blk menu.  just add an array and a 
// number to it and it will go over fine.

// box:
// 96, 35, ->159, 68

// lines:
// 97, 35, 158,35 ln
// 97, 68, 158,68 ln

//99 37 , 156 37
//99 66 , 156 66


// 96, 36 -> 96, 67
// 159, 36 -> 159, 67

// 98 38 -> 98, 65
// 157 38 -> 157, 65

// yes= 124,41
// no = 124, 55

		long int menu_yesnoL[]={
			
			 0x7fffffff, 0x80000000, 0x9fffffff, 0xa0000000, 0xa0000000, 0xa0000000, 0xa0000008,
			 0xa0000004, 0xa0000004, 0xa0000002, 0xa0000001, 0xa0000001, 0xa0000001, 0xa0000001,
			 0xa0000000, 0xa0000000, 0xa0000000, 0xa0000000, 0xa0000000, 0xa0000000, 0xa0000004,
			 0xa0000006, 0xa0000005, 0xa0000005, 0xa0000004, 0xa0000004, 0xa0000004, 0xa0000004,
			 0xa0000000, 0xa0000000, 0xa0000000, 0x9fffffff, 0x80000000, 0x7fffffff
			};
			
			long int menu_yesnoR[]={
				
			 0xfffffffe, 0x00000001, 0xfffffff9, 0x00000005, 0x00000005, 0x00000005, 0x20000005,
			 0x40000005, 0x471c0005, 0x88a20005, 0x0f980005, 0x08040005, 0x08a20005, 0x071c0005,
			 0x00000005, 0x00000005, 0x00000005, 0x00000005, 0x00000005, 0x00000005, 0x20000005,
			 0x20000005, 0x27000005, 0x28800005, 0xa8800005, 0xa8800005, 0x68800005, 0x27000005,
			 0x00000005, 0x00000005, 0x00000005, 0xfffffff9, 0x00000001, 0xfffffffe	
				
			};
	//		static unsigned char arrow[] = {0x0,0x30,0x38,0x3C,0x3e,0x3C,0x38,0x30};
//			static unsigned char clear[] = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	//		0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};
	//
	//static unsigned char clear[] = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};
	
			Sprite32(96,35, 34, menu_yesnoL , LCD_MEM, SPRT_AND);
			Sprite32(96,35, 34, menu_yesnoL , LCD_MEM, SPRT_OR);
			Sprite32(128,35, 34, menu_yesnoR , LCD_MEM, SPRT_AND);
			Sprite32(128,35, 34, menu_yesnoR , LCD_MEM, SPRT_OR);
}



*/
//=======================================================================================================

//gfx flipper both 90 deg and 270 deg  - 27580 -> 28099 (519 bytes.. not bad for image rotation.
// -> 28177 to add into draw image. ->29247 (1667 bytes to set this up.(just for the objects though))








//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//														From weapons

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/* in ezelda
int fix_xy(int x, int which)
{
	//else if (object_list[loc][OBJECT_X]<2 || object_list[loc][OBJECT_X] >144 || object_list[loc][OBJECT_Y]<2 || object_list[loc][OBJECT_Y]>112)
	if (x<2){x=2;}
	if (which==1)// for x.  any other number will be for y
	{	if (x>144){x=144;}}
	else if (which==2){if (x>112){x=112;}}// for y
	
	return x;
}
*/



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//														From failed pede routines

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*
int pede_header(int loc)
{
	// use mob_stops for the direction, that is only used in one routine in the entire game and this is not
	// using that routine.
	// mob_rand_var2 and mob_rand_var1 for x/y postion of the previous
// this works for the simple stuff.  need some more logic to keep the sprites exactly "8" pixels apart
// also, it doesnt work if the head changes the direction before the pede_body reaches its destination - need some logic
// for that too.	
	int i=loc+1;
	int px=0, py=0, dir=0;
		px=get_mob_stat(loc,mob_x);
		py=get_mob_stat(loc,mob_y);
		dir=get_mob_stat(loc,mob_dir);
		if (can_move(loc, get_mob_stat(loc,mob_dir)))
				{	move_mob(loc,  MOB_CONSTANT, get_mob_stat(loc,mob_speed));}
				else {change_dir(loc);
					mod_mob(i, mob_stops, get_mob_stat(loc,mob_dir), TRUE);
					mod_mob(i, mob_rand_var1, px, TRUE);
					mod_mob(i, mob_rand_var2, py, TRUE);
					
				}
				prevent_mob_oob(loc);
DrawImage(MOB, picture_rotator(loc, get_mob_stat(loc, mob_current_sprite)),get_mob_stat(loc,mob_x) , get_mob_stat(loc,mob_y), A_NORMAL, TRUE,0);

	if (i>=max_mobs){return loc;}


	while ((get_mob_stat(i,mob_type)==pede_body) && (i<max_mobs))
	{
//char bb[30];
//sprintf(bb,"%i %i %i %i %i %i %i %i",gg, a1, a2, mob_stat_flip(loc,wh), mob_stat_flip(who,wh),wh, offset_calculate(a2, wh2), offset_calculate(a1, wh1));
//28 = mob_h
//add_print(0,70,bb);				
//disp_error(bb);	
		if (dir!=get_mob_stat(i,mob_dir))
		{
			switch (get_mob_stat(i,mob_dir)){
			case up:
				//if (get_mob_stat(i,mob_y)>py){}
				if (get_mob_stat(i,mob_y)<=get_mob_stat(i,mob_rand_var2)) 
				{mod_mob(i, mob_dir,get_mob_stat(i,mob_stops),TRUE);mod_mob(i, mob_x,get_mob_stat(i,mob_rand_var1), TRUE); 
				if ((i+1)<max_mobs){
					if (get_mob_stat(i+1,mob_type)==pede_body){
					mod_mob(i+1, mob_stops, get_mob_stat(i,mob_stops), TRUE);
					mod_mob(i+1, mob_rand_var1, get_mob_stat(i,mob_rand_var1), TRUE);
					mod_mob(i+1, mob_rand_var2, get_mob_stat(i,mob_rand_var2), TRUE);
					}
				}
				}
		//		move_mob(i,  MOB_CONSTANT, get_mob_stat(i,mob_speed));
			break;
			case down:
				if (get_mob_stat(i,mob_y)>=get_mob_stat(i,mob_rand_var1)) 
				{mod_mob(i, mob_dir,get_mob_stat(i,mob_stops),TRUE);mod_mob(i, mob_x,get_mob_stat(i,mob_rand_var1), TRUE); 
				if ((i+1)<max_mobs){
					if (get_mob_stat(i+1,mob_type)==pede_body){
					mod_mob(i+1, mob_stops, get_mob_stat(i,mob_stops), TRUE);
					mod_mob(i+1, mob_rand_var1, get_mob_stat(i,mob_rand_var1), TRUE);
					mod_mob(i+1, mob_rand_var2, get_mob_stat(i,mob_rand_var2), TRUE);
					}			
				}
				}
			//	move_mob(i,  MOB_CONSTANT, get_mob_stat(i,mob_speed));				
			break;
			case left:
				if (get_mob_stat(i,mob_x)<=get_mob_stat(i,mob_rand_var1)) 
				{mod_mob(i, mob_dir,get_mob_stat(i,mob_stops),TRUE);mod_mob(i, mob_y,get_mob_stat(i,mob_rand_var2), TRUE); 
				if ((i+1)<max_mobs){
					
					if (get_mob_stat(i+1,mob_type)==pede_body){
					mod_mob(i+1, mob_stops, get_mob_stat(i,mob_stops), TRUE);
					mod_mob(i+1, mob_rand_var1, get_mob_stat(i,mob_rand_var1), TRUE);
					mod_mob(i+1, mob_rand_var2, get_mob_stat(i,mob_rand_var2), TRUE);
					}			
				}
				}
			//	move_mob(i,  MOB_CONSTANT, get_mob_stat(i,mob_speed));
			break;
			case right:
				if (get_mob_stat(i,mob_x)>=get_mob_stat(i,mob_rand_var1)) 
				{mod_mob(i, mob_dir,get_mob_stat(i,mob_stops),TRUE);mod_mob(i, mob_y,get_mob_stat(i,mob_rand_var2), TRUE); 
				if ((i+1)<max_mobs){
					if (get_mob_stat(i+1,mob_type)==pede_body){
					mod_mob(i+1, mob_stops, get_mob_stat(i,mob_stops), TRUE);
					mod_mob(i+1, mob_rand_var1, get_mob_stat(i,mob_rand_var1), TRUE);
					mod_mob(i+1, mob_rand_var2, get_mob_stat(i,mob_rand_var2), TRUE);
					}
					}			
				
				}
			//	move_mob(i,  MOB_CONSTANT, get_mob_stat(i,mob_speed));
			break;
			}// end switch
		}// end ifdir
		move_mob(i,  MOB_CONSTANT, get_mob_stat(i,mob_speed));
		DrawImage(MOB, picture_rotator(i, get_mob_stat(i, mob_current_sprite)),get_mob_stat(i,mob_x) , get_mob_stat(i,mob_y), A_NORMAL, TRUE,0);
		dir=get_mob_stat(i,mob_dir);
		i++;
		// only on the event of change dir, do we change the dir of the previous and the x/y coords
		
	}// end while
	return i-1;
}// end pede head




*/
/*
void align_followers(int loc, int who, int xy, int wh)
{
				int a1=0, a2=0, wh1=0, wh2=0, dir=0, mdir1=up, mdir2=down;
				
				a1=get_mob_stat(loc,xy);// loc is chasing who
				a2=get_mob_stat(who,xy);
				
				dir=get_mob_stat(who,mob_dir);
				
				wh1=mob_stat_flip(loc,wh);
				wh2=mob_stat_flip(who,wh);
				int gg=0;
			//	a1+=offset_calculate(a1, wh1);
			//	a2+=offset_calculate(a2, wh2);
				
				if (wh==mob_w){mdir1=left; mdir2=right;}
				
				if ((a1>=a2)&& (dir==mdir1))// if previous is to the left
				{
					gg=(a2-(offset_calculate(a2, wh2)-a2))-(offset_calculate(a1, wh1)-a1)+16+4;
			//		wh1=(a1-(a2+wh2));
			//		wh1-=8;
			//		wh1=wh1*(-1);
					mod_mob(loc, mob_dir,mdir1, TRUE);
				}
		//		else if (((a1>=a2)&& (dir==mdir2)) || ((a1<=a2)&&(dir==mdir1)))
		//		{wh1=(get_mob_stat(loc,mob_speed)*(-1))-2;}//keep the mob from moving. 
				else if ((a1<=a2)&&(dir==mdir2))
				{
					gg=(a2+(offset_calculate(a2, wh2)-a2))+(offset_calculate(a1, wh1)-a1)-16-4;
					// 16 is for sprite size.
					// 4 is for the pixels i want in between the different mobs.
				//	wh1=(a2-(a1+wh1));
				//	wh1-=8;
				//	wh1=wh1*(-1);
					mod_mob(loc, mob_dir,mdir2, TRUE);
				}
				else {return;}
//char bb[30];
//sprintf(bb,"%i %i %i %i %i %i %i %i",gg, a1, a2, mob_stat_flip(loc,wh), mob_stat_flip(who,wh),wh, offset_calculate(a2, wh2), offset_calculate(a1, wh1));
//28 = mob_h
//add_print(0,70,bb);				
//disp_error(bb);				
				mod_mob(loc,xy, gg, TRUE);
}


void pede_body_move(int loc)
{
	int previous_mob= (loc-1);
	
	if (previous_mob<0){pede_head_set(loc);return;}// set this as the head mob then and exit
	if (get_mob_stat(previous_mob,mob_type)<0){pede_head_set(loc);return;}
//	int space=get_mob_stat(previous_mob,mob_rand_var2);
//	int x1=get_mob_stat(loc,mob_x);
//	int y1=get_mob_stat(loc,mob_y);
	
//	int x2=get_mob_stat(previous_mob,mob_x);
//	int y2=get_mob_stat(previous_mob,mob_y);
	
	
	move_follow2(loc, get_mob_stat(loc,mob_speed), previous_mob);

	// this will keep the creatures evenly spaced apart - hopefully.
/*				if ((y1-y2)<space){	mod_mob(loc,mob_y,(space-(y1-y2)),FALSE); }// to go down, add to it
				if ((y2-y1)<space){	mod_mob(loc,mob_y,((y2-y1)-space),FALSE); }// to go up, subtract from it.
				if ((x1-x2)<space){	mod_mob(loc,mob_x,(space-(x1-x2)),FALSE); }// to go right, add to it
				if ((x2-x1)<space){	mod_mob(loc,mob_x,((x2-x1)-space),FALSE); }// to go left, subtract from it.
*//*
		switch (get_mob_stat(previous_mob,mob_dir))
		{
			case up:
				if ((y1-y2)<space){	mod_mob(loc,mob_y,(space-(y1-y2)),FALSE); }// to go down, add to it
			break;
			case down:
				if ((y2-y1)<space){	mod_mob(loc,mob_y,((y2-y1)-space),FALSE); }// to go up, subtract from it.
			break;
			case left:
				if ((x1-x2)<space){	mod_mob(loc,mob_x,(space-(x1-x2)),FALSE); }// to go right, add to it
			break;
			case right:
				if ((x2-x1)<space){	mod_mob(loc,mob_x,((x2-x1)-space),FALSE); }// to go left, subtract from it.
			break;

		}// end swich
//*//*
	
	DrawImage(MOB, picture_rotator(loc, get_mob_stat(loc, mob_current_sprite)), get_mob_stat(loc, mob_x), get_mob_stat(loc, mob_y), A_NORMAL, TRUE,0);
}// pede body move rewrite

/*
void pede_body_move2(int loc)
{
	int previous_mob= (loc-1);
//	if (previous_mob<0){previous_mob=0;}
	if (previous_mob<0){pede_head_set(loc);return;}// set this as the head mob then and exit
	if (get_mob_stat(previous_mob,mob_type)<0){pede_head_set(loc);return;}
	// you will need to move the head as well, otherwise the line bahind it will scrunch up.
	// or youw ill need to pause the line until the next round 
// crreated the default to always look ahead
// i could have usd a || statement instead of 2 iffs, but if i did that, then i could get an out of bounds error
// if the prevous mob was <0.  and if i prevented the oob error, then whether prevoius mob<=0, it would always fire, 
// even if there really was another head, meaning that 2 heads would almost always be created.
	int mob1_dir=get_mob_stat(loc,mob_dir);
	int mob2_dir=get_mob_stat(previous_mob,mob_dir);
	int pic=picture_rotator(loc, get_mob_stat(loc, mob_current_sprite));

	if (mob1_dir==mob2_dir){move_mob(loc, MOB_CONSTANT, get_mob_stat(loc,mob_speed));}
	else
	{
				
		switch (mob2_dir)
		{
			case up:
			case down:
				if (get_mob_stat(loc,mob_x) == get_mob_stat(previous_mob,mob_x))
						{mod_mob(loc,mob_dir,mob2_dir,TRUE);}// change the direction to the correct direction.
			break;

			case left:
			case right:
				if (get_mob_stat(loc,mob_y) == get_mob_stat(previous_mob,mob_y))
						{mod_mob(loc,mob_dir,mob2_dir,TRUE);}// change the direction to the correct direction.
			break;

		}// end swich

		move_mob(loc, MOB_CONSTANT, get_mob_stat(loc,mob_speed));

	}// end else
			DrawImage(MOB, pic, get_mob_stat(loc, mob_x), get_mob_stat(loc, mob_y), A_NORMAL, TRUE,0);
	/*
	
	
	
	
	moving:
- the main routine will loop through the array to see what type of mob it is (head or body segment)

- if body segment, then do the following
	- check to see if (mob_id - 1) direction == mob_id direction.
		- if true, then move the 2 to 4 pixels like normal.
		- if false, then check the x/y coords to see if they are lined up with (mob_id - 1)
				- if mob_id-1 == up/down, then check to see if x coords == mob_id
						- if so, then change direction to up/down and then move up/down.
						- else, x++/--
				- if mob_id-1 == left/right, then check to see if y corrds == mob_id
						- if so, then change dir to left/right, and then move left/right
						- else, y++/--
	- in the event that mob_id - 1<0, mob_id=0.  and this becomes the head.
	- if mob_id-1 == dead, then this becomes the head. (this might solve the problems you have and might make
				everything work the way you want it to, in order to split.)

	
	
	
	*//*
	
	
}// end pede body move*/
/*
void pede_head_move(int loc)
{
// 51891
	int x1=get_mob_stat(loc, mob_x);
	int y1=get_mob_stat(loc, mob_y);
	int next_mob= (loc+1);
	if (next_mob>=max_mobs){next_mob=max_mobs-1;}
	int mob1_dir=get_mob_stat(loc,mob_dir);
	int mob2_dir=get_mob_stat(next_mob,mob_dir);

	int pic=picture_rotator(loc, get_mob_stat(loc, mob_current_sprite));
	
	//if ((can_move(loc, get_mob_stat(loc,mob_dir))) && (touch_mob(x1, y1, loc+300)==555))  
	if (can_move(loc, get_mob_stat(loc,mob_dir)))
				{	move_mob(loc,  MOB_CONSTANT, get_mob_stat(loc,mob_speed));}
				else {change_dir(loc);}

	
//	if the stat == oposite dir, then do not travel.


	if (get_mob_stat(loc,mob_rand_var1)>=8) {
		if (!random(3)){	if (loc==next_mob){change_dir(loc);}
		else {while (get_mob_stat(loc,mob_dir)==mob2_dir){change_dir(loc);}}
		mod_mob(loc,mob_rand_var1, -1, TRUE);}}
	prevent_mob_oob(loc);
	DrawImage(MOB, pic,x1 , y1, A_NORMAL, TRUE,0);
	


//char bb[30];
//sprintf(bb,"%i",get_mob_stat(loc,mob_rand_var1));
//add_print(0,70,bb);	
	mod_mob(loc,mob_rand_var1, 1, FALSE);// increase the var by 1
	



/*
	- if head, then do the following:
	- keep track of number of times moved with var1.  
		- if var>= 8/speed, then randomly decide to move.  do a collission check to see if the mob hits itself or an object
				or an item on the floor, or goes out of bounds.  if after 4 fails, then keep moving unless the mob collides with
				something in the room. - if the mob collides with something, and there is no way out, then it can step on top of itself
				to continue moving. - might want to make var2 dictate whether it can walk on top of itself or not - but reset this
				after it moves (var>= 8/speed)
				- reset var1=0
				
				*//*
}// end pede head move
*/


//=================================================================================================
/*
		a modded version of move follow to allow for mobe to follow mobs
*/
//=================================================================================================

/*		//---------------------------------------------------
		// Follow makes the mob move towards where Link is.
		//---------------------------------------------------	
void move_follow2(int loc, int ani_speed, int who)
{
		    //--------------------------------------------------------------------
			// These routines are pretty simple. Move the mob toward link, while 
			// checking if it hit anything in its path. 
			//--------------------------------------------------------------------
			
			
			// loc is the for the mob wanting to move.  
			// who is for the mob it loc is chasing.
			int x1=0, y1=0, dir=0, spd=0, pdir=get_mob_stat(loc,mob_dir);
			
			if (who==LINK){x1=link_stat(inv_link_x); y1=link_stat(inv_link_y);}
			else{	x1=get_mob_stat(who,mob_x);	y1=get_mob_stat(who,mob_y);	}
			
// for the xpos			
			if (get_mob_stat(loc,mob_x) > x1) {dir=left; spd=ani_speed* -1;}
			else {dir=right; spd=ani_speed;}
			
			mod_mob(loc,mob_dir, dir, TRUE);
			
			if (who==LINK) {mod_mob(loc,mob_x, spd, FALSE);}
			else { 
				//if (can_move(loc, dir)){}
			//	mod_mob(loc,mob_x, spd, FALSE);
				
				align_followers(loc,who, mob_x, mob_w);
			//	align_followers(loc,who, mob_y, mob_h);
	/*			a1=get_mob_stat(loc,mob_x);
				a2=get_mob_stat(who,mob_x);
				
				wh1=mob_stat_flip(loc,mob_w);
				wh2=mob_stat_flip(who,mob_w);
				
				a1+=offset_calculate(a1, wh1);
				a2+=offset_calculate(a2, wh2);
				
				if (a1>a2)// if previous is to the left
				{
					wh1=(a1-(a2+wh2));
					wh1-=2;
					wh1=wh1*(-1);

				}
				else
				{
					wh1=(a2-(a1+wh1));
					wh1-=2;
					wh1=wh1*(-1);
				}
				mod_mob(loc,mob_x, wh1, FALSE);*//*
				//a1-(a2+wh2) = difference
					
				
				
			
			}

// for the ypos
			
			if (get_mob_stat(loc,mob_y) > y1) {dir=up; spd=ani_speed* -1;}
			else {dir=down; spd=ani_speed;}
			
			mod_mob(loc,mob_dir, dir, TRUE);
			
			if (who==LINK) {mod_mob(loc,mob_y, spd, FALSE);}
			else {
		//	mod_mob(loc,mob_y, spd, FALSE);
				
				align_followers(loc,who, mob_y, mob_h);
			//	align_followers(loc,who, mob_x, mob_w);
			}

		//	mod_mob(loc,mob_dir, pdir, TRUE);// reset the original travelling position.

/*
			
			{
				mod_mob(loc,mob_dir, left, TRUE);
			//	if (!CheckTerrainCollision(get_mob_stat(loc,mob_x)-ani_speed, get_mob_stat(loc,mob_y), 16, 16))
					mod_mob(loc,mob_x, ani_speed* -1, FALSE);
			}
			else {dir=right; spd=ani_speed;}
			{
				mod_mob(loc,mob_dir, right, TRUE);
		//		if (!CheckTerrainCollision(mod_mob(loc,mob_x)+ani_speed, mod_mob(loc,mob_y), 16, 16))
					mod_mob(loc,mob_x, ani_speed, FALSE);
			}
				
			if (get_mob_stat(loc,mob_y) > y1)
			{
				mod_mob(loc,mob_dir, up,TRUE);
		//		if (!CheckTerrainCollision(get_mob_stat(loc,mob_x), get_mob_stat(loc,mob_y)-ani_speed-2, 16, 16))
					mod_mob(loc,mob_y, ani_speed* -1, FALSE);
			}
			else
			{
				mod_mob(loc,mob_dir, down, TRUE);
			//	if (!CheckTerrainCollision(get_mob_stat(loc,mob_x), get_mob_stat(loc,mob_y)+ani_speed, 16, 16))
					mod_mob(loc,mob_y, ani_speed, FALSE);
			}	*//*
}// end move follow2
*/
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//														From mathy

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//														From mathy

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//														From mathy

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//														From mathy

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//														From mathy

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//														From mathy

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////










