// C Source File
// Created 2/3/2013; 5:23:09 AM

#include <tigcclib.h>
#include "new_mobs.h"

extern unsigned short mob_pic_light_any[mob_gfx_list_size][16];
extern unsigned short mob_pic_dark_any[mob_gfx_list_size][16];
extern unsigned short mob_pic_mask_any[mob_gfx_list_size][16];
extern int loc_in_pic_arr, mob_location;
extern int num_of_sprites, num_of_walk_sprites, creature_width, creature_height,creature_animation_speed;
//===================================================================================================================

void pic_spike2()// this is the original zelda spike, not the urchin.
{

	#undef gfx_size
	#define gfx_size 1

	num_of_sprites=gfx_size; num_of_walk_sprites=1;
	creature_animation_speed=0;
	creature_height=14;

	creature_width=14;
	
	if ((loc_in_pic_arr+gfx_size)>mob_gfx_list_size){return;}// dont write if the stated area goes out of bounds
	static unsigned short tmp_l[16]=// for the light

	// up light
	{0x0240,0x0240,0x0240,0x0240,0x0ff0,0x0ff0,0xffff,0x0ff0,0x0ff0,0xffff,0x0ff0,0x0ff0,0x0240,0x0240,0x0240,0x0240};

	static unsigned short tmp_d[16]=// for the dark
	
	// up dark
	{0x0000,0x0000,0x0000,0x0000,0x07e0,0x0bd0,0x0c30,0x0c30,0x0c30,0x0c30,0x0bd0,0x07e0,0x0000,0x0000,0x0000,0x0000};	
	

	static unsigned short tmp_m[16]=// for the mask
	
	{~0x0240,~0x0240,~0x0240,~0x0240,~0x0ff0,~0x0ff0,~0xffff,~0x0ff0,~0x0ff0,~0xffff,~0x0ff0,~0x0ff0,~0x0240,~0x0240,~0x0240,~0x0240};
	
	int k=0,p=0,oob=FALSE;
	while (p<gfx_size)
	{
		while (k<16)
		{
			if (loc_in_pic_arr<mob_gfx_list_size){
				mob_pic_light_any[loc_in_pic_arr][k]=tmp_l[k];
				mob_pic_dark_any[loc_in_pic_arr][k]=tmp_d[k];
				mob_pic_mask_any[loc_in_pic_arr][k]=tmp_m[k];
				}else{oob=TRUE;p=gfx_size;}
			k++;
		}// end while k
		k=0;p++;loc_in_pic_arr++;
	}// end while i
		if (oob){printf("spike2 out of bounds");}

}// end spike2



//===================================================================================================================


void pic_pede_head()
{


	#undef gfx_size
	#define gfx_size 2
	
	num_of_sprites=gfx_size; num_of_walk_sprites=1;
	creature_animation_speed=4;
	creature_height=8;

	creature_width=8;
	
		if ((loc_in_pic_arr+gfx_size)>mob_gfx_list_size){return;}// dont write if the stated area goes out of bounds
	static unsigned short tmp_l[gfx_size][16]={// for the light

	// up light
	{0x0000,0x0c30,0x0420,0x0000,0x0180,0x03c0,0x03c0,0x03c0,0x03c0,0x03c0,0x03c0,0x0180,0x0000,0x0420,0x0c30,0x0000},
	{0x0420,0x0420,0x0420,0x0000,0x0180,0x03c0,0x03c0,0x03c0,0x03c0,0x03c0,0x03c0,0x0180,0x0000,0x0420,0x0420,0x0420},


	// down light
	
	
	// left light
	
	
	// right light
	
	};// end light
	
	static unsigned short tmp_d[gfx_size][16]={// for the dark
	
	// up dark
	{0x0000,0x0000,0x03c0,0x07e0,0x0660,0x0c30,0x0db0,0x0db0,0x0db0,0x0db0,0x0c30,0x0660,0x07e0,0x03c0,0x0000,0x0000},
	{0x0000,0x0000,0x03c0,0x07e0,0x0660,0x0c30,0x0db0,0x0db0,0x0db0,0x0db0,0x0c30,0x0660,0x07e0,0x03c0,0x0000,0x0000}, 
 	
	// down dark
	
	
	// left dark
	
	
	// right dark
	
	};// end dark	
	
	static unsigned short tmp_m[gfx_size][16]={// for the mask
	
	// up mask
	{~0x0000,~0x0c30,~0x07e0,~0x07e0,~0x07e0,~0x0ff0,~0x0ff0,~0x0ff0,~0x0ff0,~0x0ff0,~0x0ff0,~0x07e0,~0x07e0,~0x07e0,~0x0c30,~0x0000},
	{~0x0420,~0x0420,~0x07e0,~0x07e0,~0x07e0,~0x0ff0,~0x0ff0,~0x0ff0,~0x0ff0,~0x0ff0,~0x0ff0,~0x07e0,~0x07e0,~0x07e0,~0x0420,~0x0420},
  	
	// down mask
	
	
	// left mask
	
	
	// right mask
	
	};	// end mask
	
	int k=0,p=0,oob=FALSE;
	while (p<gfx_size)
	{
		while (k<16)
		{
			if (loc_in_pic_arr<mob_gfx_list_size){
				mob_pic_light_any[loc_in_pic_arr][k]=tmp_l[p][k];
				mob_pic_dark_any[loc_in_pic_arr][k]=tmp_d[p][k];
				mob_pic_mask_any[loc_in_pic_arr][k]=tmp_m[p][k];
				}else{oob=TRUE;p=gfx_size;}
			k++;
		}// end while k
		k=0;p++;loc_in_pic_arr++;
	}// end while p
		if (oob){printf("pede head out of bounds");}

}// end pede head


//===================================================================================================================


void pic_pede_body()
{


	#undef gfx_size
	#define gfx_size 2

	num_of_sprites=gfx_size; num_of_walk_sprites=1;
	creature_animation_speed=4;
	creature_height=8;

	creature_width=8;
	
		if ((loc_in_pic_arr+gfx_size)>mob_gfx_list_size){return;}// dont write if the stated area goes out of bounds
	static unsigned short tmp_l[gfx_size][16]={// for the light

	// up light
{0x0300,0x0180,0x0080,0x0000,0x0280,0x01c0,0x03c0,0x0180,0x03c0,0x01c0,0x0380,0x0140,0x0000,0x0100,0x0180,0x00c0},
{0x0180,0x0300,0x0200,0x0000,0x0280,0x01c0,0x03c0,0x0180,0x03c0,0x01c0,0x0380,0x0140,0x0000,0x0040,0x00c0,0x0180},
 

	// down light
	
	
	// left light
	
	
	// right light
	
	};// end light
	
	static unsigned short tmp_d[gfx_size][16]={// for the dark
	
	// up dark
{0x0300,0x0180,0x02c0,0x07e0,0x0560,0x0e30,0x0420,0x0e70,0x0c30,0x0620,0x0c70,0x06a0,0x07e0,0x0340,0x0180,0x00c0},
{0x0180,0x0300,0x02c0,0x07e0,0x0560,0x0e30,0x0420,0x0e70,0x0c30,0x0620,0x0c70,0x06a0,0x07e0,0x0340,0x00c0,0x0180}, 	
	
	// down dark
	
	
	// left dark
	
	
	// right dark
	
	};// end dark	
	
	static unsigned short tmp_m[gfx_size][16]={// for the mask
	
	// up mask
{~0x0300,~0x0180,~0x02c0,~0x07e0,~0x07e0,~0x0ff0,~0x07e0,~0x0ff0,~0x0ff0,~0x07e0,~0x0ff0,~0x07e0,~0x07e0,~0x0340,~0x0180,~0x00c0},
{~0x0180,~0x0300,~0x02c0,~0x07e0,~0x07e0,~0x0ff0,~0x07e0,~0x0ff0,~0x0ff0,~0x07e0,~0x0ff0,~0x07e0,~0x07e0,~0x0340,~0x00c0,~0x0180}, 
	
	// down mask
	
	
	// left mask
	
	
	// right mask
	
	};	// end mask
	
	int k=0,p=0,oob=FALSE;
	while (p<gfx_size)
	{
		while (k<16)
		{
			if (loc_in_pic_arr<mob_gfx_list_size){
				mob_pic_light_any[loc_in_pic_arr][k]=tmp_l[p][k];
				mob_pic_dark_any[loc_in_pic_arr][k]=tmp_d[p][k];
				mob_pic_mask_any[loc_in_pic_arr][k]=tmp_m[p][k];
				}else{oob=TRUE;p=gfx_size;}
			k++;
		}// end while k
		k=0;p++;loc_in_pic_arr++;
	}// end while p
		if (oob){printf("pede body out of bounds");}

}// end pede body


//===================================================================================================================

void pic_pede_body_2()
{


	#undef gfx_size
	#define gfx_size 8
	
	num_of_sprites=gfx_size; num_of_walk_sprites=2;
	creature_animation_speed=4;
	creature_height=8;

	creature_width=8;
	
		if ((loc_in_pic_arr+gfx_size)>mob_gfx_list_size){return;}// dont write if the stated area goes out of bounds
	static unsigned short tmp_l[gfx_size][16]={// for the light

	// up light
	{0x0000,0x0000,0x0000,0x0000,0x0000,0xc000,0xe360,0x77fc,0x37ee,0x0557,0x0003,0x0000,0x0000,0x0000,0x0000,0x0000},
	{0x0000,0x0000,0x0000,0x0000,0x0000,0x0003,0x06c7,0x3fee,0x77ec,0xeaa0,0xc000,0x0000,0x0000,0x0000,0x0000,0x0000}, 

	// down light
	{0x0000,0x0000,0x0000,0x0000,0x0000,0xc000,0xe360,0x77fc,0x37ee,0x0557,0x0003,0x0000,0x0000,0x0000,0x0000,0x0000},
	{0x0000,0x0000,0x0000,0x0000,0x0000,0x0003,0x06c7,0x3fee,0x77ec,0xeaa0,0xc000,0x0000,0x0000,0x0000,0x0000,0x0000}, 

	
	// left light
	{0x0600,0x0700,0x0380,0x0180,0x0280,0x01c0,0x03c0,0x0180,0x03c0,0x01c0,0x0380,0x0000,0x0180,0x01c0,0x00e0,0x0060},
	{0x0060,0x00e0,0x01c0,0x0180,0x0140,0x0380,0x03c0,0x0180,0x03c0,0x0380,0x01c0,0x0000,0x0180,0x0380,0x0700,0x0600},	
	
	// right light
	{0x0600,0x0700,0x0380,0x0180,0x0280,0x01c0,0x03c0,0x0180,0x03c0,0x01c0,0x0380,0x0000,0x0180,0x01c0,0x00e0,0x0060},
	{0x0060,0x00e0,0x01c0,0x0180,0x0140,0x0380,0x03c0,0x0180,0x03c0,0x0380,0x01c0,0x0000,0x0180,0x0380,0x0700,0x0600},	

	
	};// end light
	
	static unsigned short tmp_d[gfx_size][16]={// for the dark
	
	// up dark
	{0x0000,0x0000,0x0000,0x0000,0x05a0,0xcff0,0xfc98,0x780c,0x381e,0x1aaf,0x0ff3,0x05a0,0x0000,0x0000,0x0000,0x0000},	
	{0x0000,0x0000,0x0000,0x0000,0x05a0,0x0ff3,0x193f,0x301e,0x781c,0xf558,0xcff0,0x05a0,0x0000,0x0000,0x0000,0x0000},
	
	// down dark
	{0x0000,0x0000,0x0000,0x0000,0x05a0,0xcff0,0xfc98,0x780c,0x381e,0x1aaf,0x0ff3,0x05a0,0x0000,0x0000,0x0000,0x0000},	
	{0x0000,0x0000,0x0000,0x0000,0x05a0,0x0ff3,0x193f,0x301e,0x781c,0xf558,0xcff0,0x05a0,0x0000,0x0000,0x0000,0x0000},
	
	
	// left dark
	{0x0600,0x0700,0x0380,0x03c0,0x0560,0x0e30,0x0420,0x0e70,0x0c30,0x0620,0x0c70,0x07e0,0x03c0,0x01c0,0x00e0,0x0060},	
	{0x0060,0x00e0,0x01c0,0x03c0,0x06a0,0x0c70,0x0420,0x0e70,0x0c30,0x0460,0x0e30,0x07e0,0x03c0,0x0380,0x0700,0x0600},
	
	// right dark
	{0x0600,0x0700,0x0380,0x03c0,0x0560,0x0e30,0x0420,0x0e70,0x0c30,0x0620,0x0c70,0x07e0,0x03c0,0x01c0,0x00e0,0x0060},	
	{0x0060,0x00e0,0x01c0,0x03c0,0x06a0,0x0c70,0x0420,0x0e70,0x0c30,0x0460,0x0e30,0x07e0,0x03c0,0x0380,0x0700,0x0600},
	
	};// end dark	
	
	static unsigned short tmp_m[gfx_size][16]={// for the mask
	
	// up mask
	{~0x0000,~0x0000,~0x0000,~0x0000,~0x05a0,~0xcff0,~0xfff8,~0x7ffc,~0x3ffe,~0x1fff,~0x0ff3,~0x05a0,~0x0000,~0x0000,~0x0000,~0x0000},	
	{~0x0000,~0x0000,~0x0000,~0x0000,~0x05a0,~0x0ff3,~0x1fff,~0x3ffe,~0x7ffc,~0xfff8,~0xcff0,~0x05a0,~0x0000,~0x0000,~0x0000,~0x0000},
	
	// down mask
	{~0x0000,~0x0000,~0x0000,~0x0000,~0x05a0,~0xcff0,~0xfff8,~0x7ffc,~0x3ffe,~0x1fff,~0x0ff3,~0x05a0,~0x0000,~0x0000,~0x0000,~0x0000},	
	{~0x0000,~0x0000,~0x0000,~0x0000,~0x05a0,~0x0ff3,~0x1fff,~0x3ffe,~0x7ffc,~0xfff8,~0xcff0,~0x05a0,~0x0000,~0x0000,~0x0000,~0x0000},
	
	
	// left mask
	{~0x0600,~0x0700,~0x0380,~0x03c0,~0x07e0,~0x0ff0,~0x07e0,~0x0ff0,~0x0ff0,~0x07e0,~0x0ff0,~0x07e0,~0x03c0,~0x01c0,~0x00e0,~0x0060},	
	{~0x0060,~0x00e0,~0x01c0,~0x03c0,~0x07e0,~0x0ff0,~0x07e0,~0x0ff0,~0x0ff0,~0x07e0,~0x0ff0,~0x07e0,~0x03c0,~0x0380,~0x0700,~0x0600},
	
	// right mask
	{~0x0600,~0x0700,~0x0380,~0x03c0,~0x07e0,~0x0ff0,~0x07e0,~0x0ff0,~0x0ff0,~0x07e0,~0x0ff0,~0x07e0,~0x03c0,~0x01c0,~0x00e0,~0x0060},	
	{~0x0060,~0x00e0,~0x01c0,~0x03c0,~0x07e0,~0x0ff0,~0x07e0,~0x0ff0,~0x0ff0,~0x07e0,~0x0ff0,~0x07e0,~0x03c0,~0x0380,~0x0700,~0x0600},
	
	};	// end mask
	
	int k=0,p=0,oob=FALSE;
	while (p<gfx_size)
	{
		while (k<16)
		{
			if (loc_in_pic_arr<mob_gfx_list_size){
				mob_pic_light_any[loc_in_pic_arr][k]=tmp_l[p][k];
				mob_pic_dark_any[loc_in_pic_arr][k]=tmp_d[p][k];
				mob_pic_mask_any[loc_in_pic_arr][k]=tmp_m[p][k];
				}else{oob=TRUE;p=gfx_size;}
			k++;
		}// end while k
		k=0;p++;loc_in_pic_arr++;
	}// end while p
		if (oob){printf("pede body2 out of bounds");}

}// end pic_pede_body_2()

//===================================================================================================================

void pic_pede_head_2()
{


	#undef gfx_size
	#define gfx_size 8
	
	num_of_sprites=gfx_size; num_of_walk_sprites=2;
	creature_animation_speed=4;
	creature_height=8;

	creature_width=8;
	
		if ((loc_in_pic_arr+gfx_size)>mob_gfx_list_size){return;}// dont write if the stated area goes out of bounds
	static unsigned short tmp_l[gfx_size][16]={// for the light

	// up light
	{0x0000,0x0000,0x2000,0x6000,0x6006,0x700e,0x77ee,0x0fe0,0x0fe0,0x07e0,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000},
	{0x0000,0x0000,0x0004,0x0006,0x6006,0x700e,0x77ee,0x07f0,0x07f0,0x07e0,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000},

	// down light
	{0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x07e0,0x07f0,0x07f0,0x77ee,0x700e,0x6006,0x0006,0x0004,0x0000,0x0000},	
	{0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x07e0,0x0fe0,0x0fe0,0x77ee,0x700e,0x6006,0x6000,0x2000,0x0000,0x0000},
	
	// left light
	{0x0000,0x1e00,0x3e00,0x0600,0x0180,0x03c0,0x03c0,0x03c0,0x03c0,0x03c0,0x03c0,0x0000,0x0600,0x0e00,0x0e00,0x0000},	
	{0x0000,0x0e00,0x0e00,0x0600,0x0000,0x03c0,0x03c0,0x03c0,0x03c0,0x03c0,0x03c0,0x0180,0x0600,0x3e00,0x1e00,0x0000},
	
	// right light
	{0x0000,0x0078,0x007c,0x0060,0x0180,0x03c0,0x03c0,0x03c0,0x03c0,0x03c0,0x03c0,0x0000,0x0060,0x0070,0x0070,0x0000},
	{0x0000,0x0070,0x0070,0x0060,0x0000,0x03c0,0x03c0,0x03c0,0x03c0,0x03c0,0x03c0,0x0180,0x0060,0x007c,0x0078,0x0000},
	
	};// end light
	
	static unsigned short tmp_d[gfx_size][16]={// for the dark
	
	// up dark
	{0x0000,0x0000,0x2000,0x6000,0x67e6,0x7ffe,0x781e,0x13d8,0x13d8,0x1818,0x0ff0,0x07e0,0x0000,0x0000,0x0000,0x0000},	
	{0x0000,0x0000,0x0004,0x0006,0x67e6,0x7ffe,0x781e,0x1bc8,0x1bc8,0x1818,0x0ff0,0x07e0,0x0000,0x0000,0x0000,0x0000},
	
	// down dark
	{0x0000,0x0000,0x0000,0x0000,0x07e0,0x0ff0,0x1818,0x1bc8,0x1bc8,0x781e,0x7ffe,0x67e6,0x0006,0x0004,0x0000,0x0000},	
	{0x0000,0x0000,0x0000,0x0000,0x07e0,0x0ff0,0x1818,0x13d8,0x13d8,0x781e,0x7ffe,0x67e6,0x6000,0x2000,0x0000,0x0000},
	
	// left dark
	{0x0000,0x1e00,0x3e00,0x07c0,0x0660,0x0c30,0x0db0,0x0db0,0x0db0,0x0db0,0x0c30,0x07e0,0x07c0,0x0e00,0x0e00,0x0000},	
	{0x0000,0x0e00,0x0e00,0x07c0,0x07e0,0x0c30,0x0db0,0x0db0,0x0db0,0x0db0,0x0c30,0x0660,0x07c0,0x3e00,0x1e00,0x0000},
	
	// right dark
	{0x0000,0x0078,0x007c,0x03e0,0x0660,0x0c30,0x0db0,0x0db0,0x0db0,0x0db0,0x0c30,0x07e0,0x03e0,0x0070,0x0070,0x0000},
	{0x0000,0x0070,0x0070,0x03e0,0x07e0,0x0c30,0x0db0,0x0db0,0x0db0,0x0db0,0x0c30,0x0660,0x03e0,0x007c,0x0078,0x0000},
	
	};// end dark	
	
	static unsigned short tmp_m[gfx_size][16]={// for the mask
	
	// up mask
	{~0x0000,~0x0000,~0x2000,~0x6000,~0x67e6,~0x7ffe,~0x7ffe,~0x1ff8,~0x1ff8,~0x1ff8,~0x0ff0,~0x07e0,~0x0000,~0x0000,~0x0000,~0x0000},	
	{~0x0000,~0x0000,~0x0004,~0x0006,~0x67e6,~0x7ffe,~0x7ffe,~0x1ff8,~0x1ff8,~0x1ff8,~0x0ff0,~0x07e0,~0x0000,~0x0000,~0x0000,~0x0000}, 
	
	// down mask
	{~0x0000,~0x0000,~0x0000,~0x0000,~0x07e0,~0x0ff0,~0x1ff8,~0x1ff8,~0x1ff8,~0x7ffe,~0x7ffe,~0x67e6,~0x0006,~0x0004,~0x0000,~0x0000},	
	{~0x0000,~0x0000,~0x0000,~0x0000,~0x07e0,~0x0ff0,~0x1ff8,~0x1ff8,~0x1ff8,~0x7ffe,~0x7ffe,~0x67e6,~0x6000,~0x2000,~0x0000,~0x0000},
	
	// left mask
	{~0x0000,~0x1e00,~0x3e00,~0x07c0,~0x07e0,~0x0ff0,~0x0ff0,~0x0ff0,~0x0ff0,~0x0ff0,~0x0ff0,~0x07e0,~0x07c0,~0x0e00,~0x0e00,~0x0000},	
	{~0x0000,~0x0e00,~0x0e00,~0x07c0,~0x07e0,~0x0ff0,~0x0ff0,~0x0ff0,~0x0ff0,~0x0ff0,~0x0ff0,~0x07e0,~0x07c0,~0x3e00,~0x1e00,~0x0000},
	
	// right mask
	{~0x0000,~0x0078,~0x007c,~0x03e0,~0x07e0,~0x0ff0,~0x0ff0,~0x0ff0,~0x0ff0,~0x0ff0,~0x0ff0,~0x07e0,~0x03e0,~0x0070,~0x0070,~0x0000},
	{~0x0000,~0x0070,~0x0070,~0x03e0,~0x07e0,~0x0ff0,~0x0ff0,~0x0ff0,~0x0ff0,~0x0ff0,~0x0ff0,~0x07e0,~0x03e0,~0x007c,~0x0078,~0x0000},
	
	};	// end mask
	
	int k=0,p=0,oob=FALSE;
	while (p<gfx_size)
	{
		while (k<16)
		{
			if (loc_in_pic_arr<mob_gfx_list_size){
				mob_pic_light_any[loc_in_pic_arr][k]=tmp_l[p][k];
				mob_pic_dark_any[loc_in_pic_arr][k]=tmp_d[p][k];
				mob_pic_mask_any[loc_in_pic_arr][k]=tmp_m[p][k];
				}else{oob=TRUE;p=gfx_size;}
			k++;
		}// end while k
		k=0;p++;loc_in_pic_arr++;
	}// end while p
		if (oob){printf("pede head2 out of bounds");}

}// end pic_pede_head_2()
//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================


//===================================================================================================================