// C Source File
// Created 10/10/2012; 7:20:32 PM
/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"

int mob_list[max_mobs][mob_num_of_stats];
int world_mob_list[max_mobs][mob_num_of_stats];// this exists so that i can pull a world mob file
// and then use it to load mobs randomly. - kept to maintian speed, but if still addr errors, then remove.
int exec_sl=0;
int mob_ammount=0;

int get_exec_sl(){return exec_sl;}
void clr_exec_sl(){exec_sl=0;}
//=================================================================================================



inline int g_mob_list(int x, int y){
		if ((x<0) || (x>max_mobs) || (y<0) || (y>mob_num_of_stats)){return -6666;}
		return mob_list[x][y];
}

//=================================================================================================


inline void s_mob_list(int x, int y, int num){
		if ((x<0) || (x>max_mobs) || (y<0) || (y>mob_num_of_stats)){return;}
		 mob_list[x][y] = chk_num(num);
}


//=================================================================================================


int g_world_mob_list(int x, int y){
		if ((x<0) || (x>max_mobs) || (y<0) || (y>mob_num_of_stats)){return -6666;}
		return world_mob_list[x][y];
}

//=================================================================================================


void s_world_mob_list(int x, int y, int num){
		if ((x<0) || (x>max_mobs) || (y<0) || (y>mob_num_of_stats)){return;}
		 world_mob_list[x][y] = chk_num(num);
}



//=================================================================================================


void clr_mob_list(int which)
{// which 1 = mob list
// which 2 = world mob list.
	int i=0,k=0;
	while (i<max_mobs){
		while (k<mob_num_of_stats)
		{
		 	if (which==1)	{mob_list[i][k]=(-100);}
		 	if (which==2)	{world_mob_list[i][k]=(-100);}
			k++;
		}// end while k<15
		if (which==1)	{mob_list[i][mob_frame]=0;}// make sure the frame is 0
		if (which==2)	{world_mob_list[i][mob_frame]=0;}
		i++;k=0;
	}// end while i<64
	if (which==1){mob_ammount=0;}
}// end clr mob list

//=================================================================================================

void delete_mob(int who)
{
	int k=0;
	mob_ammount--;
	exec_sl=g_mob_list(who, mob_sl_exec);// this
	while (k<mob_num_of_stats)
		{
			s_mob_list(who,k,(-100));
			k++;
		}// end while k<15
}// end delete mob


//=================================================================================================


int num_of_mobs(){return mob_ammount;}


void set_num_of_mobs()
{
		int i=0,k=0;
	while (i<max_mobs){

		if (mob_list[i][mob_id]>=0){k++;}
		i++;
	}// end while i<64
	mob_ammount=k;
}// end num of mobs

//=================================================================================================



void mod_mob(int who, int stat, int number, int replace)
{

	int i=0; 
	if (!replace){i=g_mob_list(who,stat);}// if you are not going to replace, then make i the current #
	i+=number;

	if ((stat==mob_hp) && (i<=0)){
		
		if (g_mob_list(who,mob_hp)==immortal){return;}// if invincible, then do nothing.
		//else {death(who);}// if not immortal, then kill it off.
		// you can make them uninvincible by adding hp and by forcing it to replace.
		//delete mob from the list.
	}// end if hp<0

		s_mob_list(who,stat,i);

}// end mod link


//=================================================================================================


/*
int mob_exists(int id)
{
	int i=0;
	while (i<max_mobs){if (mob_list[i][mob_id]==id){return TRUE;}i++;}
	return FALSE;
}//*/

int mob_exists(int id){	if (mob_loc(id)==555){return FALSE;}	return TRUE;}
//=================================================================================================



int mob_loc(int id)
{
	int i=0;
	while (i<max_mobs){if (mob_list[i][mob_id]==id){return i;}i++;}
	return 555;// 555 is to symbolize no location.
}// end mob loc


//=================================================================================================


void stun_mob(int who, int time)
{
	
	if (get_mob_stat(who, mob_shield)>=nostun){return;}
	mod_mob(who, mob_stunned, time,TRUE);
}// end mob stun

