// C Source File
// Created 7/15/2011; 3:33:30 AM
/*******************************************************************************/
/* Zelda Crystal Engine                                                       */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
/*
		this will include the random spawn of crap when mobs dies and will disp the objects.
		this should have a gfx file all to itself.  i think the objects are 8x8?
		
		

*/ 
#include "all.h"






extern int link_y, link_x, link_picture, shop_active,link_direction, //item_used, 
						link_frame,  button_pressed, dark_room,skip_animate_mob;




//=================================================================================================


void object_gfx_loader(int id)
{
		char messa[10];
		FolderCur(SYMSTR("gfx"),TRUE);
		FILE *q = NULL;
		int x=0,y=0,loop=0;
		unsigned short tmp[object_gfx_size][16];
		
redo:

	TRY

		q = NULL;

			switch(loop)
			{
				case 0: sprintf(messa,"objl%i",id); break;
				case 1: sprintf(messa,"objd%i",id); break;
				case 2: sprintf(messa,"objm%i",id); break;
			}

    // open file for reading in binary mode
    if ((q = fopen(messa,"rb")) == NULL) {return;}else{
       if (fread(tmp,sizeof(tmp),1,q) != 1) {return;}else{
        	for (x=0;x<object_gfx_size;x++){for (y=0;y<16;y++){
        			s_object_pic(x,y,tmp[x][y],loop+1);
        		}}// end fors
        }
        fclose(q);
    }
 
	ONERR
	ENDTRY     
 
		loop++;
		if (loop<3){goto redo;}

}// end object loader


//=================================================================================================

void move_push_stone(int loc)
{
	 	if (get_object(loc,obj_dir)==(-66))
 		{
 			set_object(loc, obj_dir, link_direction);

 		}// end if obj dir
 		if ((get_object(loc,obj_dir)==link_direction) && (get_object(loc, obj_var1)<16)) {
 			
 		// only move is direction is the same dir as link
 	
 						if ((precision_move(get_object(loc,obj_x), get_object(loc,obj_y), get_object(loc,obj_dir), 2)) ||
 						 (get_object(loc,obj_var2)==88))
 						{// if you can move, then let the move stay and move link with it.  otherwise, move it back
 						// to the original spot.
								 						
 							move_object(loc, 2, get_object(loc,obj_dir));
 							increase_object(loc, obj_var1, 2); //keep track of the 16 places   
 							set_object(loc, obj_var2, 88); // signal that we are already moving. - this should help with the fact that precision
 							// move() will not allow you to move onto walls.  we just need the first check of precision move and then move the object.
 							move_link(2);

 					}

 			}// end if the same direction
}// end move push stone


void chk_obj_oob(int loc)
{
			
			int x=get_object(loc,obj_x), y=get_object(loc,obj_y);
		
			if (x<=object_x_min_oob || x >=object_x_max_oob || 
					y<=object_y_min_oob || y >=object_y_max_oob)
			 		  {		  
				 		 				 		 
					 		 switch (get_object(loc,obj_type))
					 		 {
					 		 	case hookshot: set_object(loc,obj_var1, 100);break;
					 		 	//obj_dir_set(loc, 5, opposite_dir(get_object(loc,obj_dir))); break;
					 		 	case boomerang:
					 		 			set_object(loc,obj_dir, dir_return);
					 		 	break;
					 		 	case spike:  	reset_spike(loc);
					 		 	//	set_object(loc,obj_dir, opposite_dir(get_object(loc,obj_dir)));
					 		 	//	set_object(loc,obj_var1, 3); 
					 		 	break;
					 		 	case explosion:							return;
					 		 	default:  delete_obj(loc); 	break;
					 		 }

				 		 }// end if oob
}// end chk obj oob

//============================================================================================

//extern short screen_row_gain, screen_shift;

void draw_prices()
{//get_object(i,obj_num)
	if (g_transistion_active()>0){return;} 
	int i=0, cst=0, modder=0;
	// not having add_print here decreases the size by 400 bytes...
	char c[5];
	while (i<obj_list_size){
			if (get_object(i,obj_num) >= 1000)
			{
				cst=get_item_info(get_object(i,obj_num),item_cost);
				modder=4;
				if (cst>9){modder-=3;}// this will center the cost of the object up to 999
				if (cst>99){modder-=3;}
				sprintf(c,"%i",cst);
				add_print(get_object(i,obj_x)+modder,(get_object(i,obj_y)+18)	- (g_screen_shift()+g_screen_row_gain()*16),c);
			//	printf_xy(get_object(i,obj_x)+modder,(get_object(i,obj_y)+18)	- (g_screen_shift()+g_screen_row_gain()*16),"%i",cst);
			}
			i++;
	}// end while
}// end clr object




//============================================================================================

/*

void remove_hookshot()
{// this was made to completly remove all hookshot stuff.
//printf("im deleted");wait_for_key(esc_ko);
	delete_obj(obj_loc(item_hookshot));
	int i=0;
	int objn=get_item_info(item_type_exists(hookshot,3),item_pic_3);
		while (i<obj_list_size)
	{
		if (get_object(i,obj_num) == objn){delete_obj(i);} 
		//add_object(get_item_info(item_type_exists(hookshot,3),item_pic_3), get_object(loc,obj_x), get_object(loc,obj_y)
		i++;
	}// end while
	link_state_reset();mod_link(link_rand_var1,-1,TRUE);
	//mod_link(state,LINK_NORMAL,TRUE);
}//end remove hookshot.*/


//============================================================================================

//============================================================================================

/*
void obj_move_diag(int loc, int speed)
{// 59927 -> 59671
	// angle is to move the object + or - a certain amount on the x/y - so +2 will move it slightly, while +5 will move it at a wider 
	// angle
	// diag_dir is to let me know whether i want to move it left or right of the original position.  only use left or right
	int diag_dir=left, angle=0;//, dir2=0;
	int dir=get_object(loc,obj_dir);
	int diagnal=TRUE;
//		sprintf(dbg,"%i", dir );debug();
	switch (dir)
	{
			case up ... right: diagnal=FALSE;		break;
			case up_30_left ... right_30_left:
					dir-=10; diag_dir=left; angle=2;
			break;
			case up_30_right ... right_30_right:
					dir-=20; diag_dir=right; angle=2;
			break;
			case up_45_left ... right_45_left:
					dir-=30; diag_dir=left; angle=5;
			break;
			case up_45_right ... right_45_right:
					dir-=40; diag_dir=right; angle=5;
			break;		
			default: dir=0; diagnal=FALSE; break;
	}

	
	if (diagnal){
		
		int dir2=diag_dir;
		if (dir==left){	if (diag_dir==left){dir2=down;}else {dir2=up;}}
		if (dir==right){	if (diag_dir==right){dir2=up;}else {dir2=down;}}
		fast_obj_move( loc, angle, dir2);
	}
	move_object( loc, speed, dir);
// up_30_left+dir = the flying weapon direction
}// end obj move diag*/



int xXx(int i, int dir, int num, int num2)
{
/*
		couldnt think of a name for it.  basically, you pass in 2 numbers (one for the x var and one for the y var)
		then you tell it which var (x or y) you need it to choose for.  then it will look at the direction you pass it
		and then will return the number based off of what direction and what var you want.
		
		it is used to choose the correct x/y pos of the multi_shooter mob weapons.  i needed even spacing for these objects
		but it proved to be a pain, so i just made this.

*/

	switch (i)
	{
	case 1:// if x
		if (dir==up || dir==down){return num;}
		else {return num2;}
	break;
	case 2:
		if (dir==left || dir==right){return num;}
		else {return num2;}
	break;
//	case 3:// for y
//		if (dir==down || dir==right){return num;}
//		else {return num2;}
//	break;
	}
	return 0;
}

//============================================================================================

/*
void init_multi_weapons(int loc, int item)
{
/*
	
	to make it work pass in the location of the object


	int typ=get_item_info(item,item_type), num=0;
	if (typ==arrow_foe_multi_3){num=2;}
	else if (typ==arrow_foe_multi_5){num=4;}
	else {return;}
	
	int x=get_object(loc,obj_x), y=get_object(loc,obj_y);
	int x2=x, y2=y;
	int dir=get_object(loc,obj_dir);
	int dam=get_item_info(item,item_damage);
	int pc=get_item_info(item,item_pic_id);
	int obj=0;
	redo:
	switch (num)
	{// this chooses the correct spacing for the new objects.
		case 2:
			x2=xXx(1, dir, x+8,x);
			y2=xXx(2, dir, y+8,y);
		break;
		case 1:
			x2=xXx(1, dir, x-8,x);
			y2=xXx(2, dir, y-8,y);
		break;
		case 4:
			x2=xXx(1, dir, x+16,x);
			y2=xXx(2, dir, y+16,y);
		break;
		case 3:
			x2=xXx(1, dir, x-16,x);
			y2=xXx(2, dir, y-16,y);
		break;		
	}
		if ((obj=add_object(item, x2, y2,item))!=555)
		{
				set_object(obj,obj_dir, (up_30_left*num)+dir);
				set_object(obj,obj_dam, dam);
				set_object(obj,obj_var2, pc);
				set_object(obj,obj_type, typ);	
				set_object(loc,obj_var1,random(right)); 
		}
	num--;
	if (num>0){goto redo;}
}*/


//============================================================================================

void init_super_weap(int loc, int item)
{
int typ=get_item_info(item,item_type), num=0;
	if (typ==arrow_foe_multi_3){num=2;}
	else if (typ==arrow_foe_multi_5){num=4;}
	else {return;}
	
	int x=get_object(loc,obj_x), y=get_object(loc,obj_y);
	int x2=x, y2=y;
	int dir=get_object(loc,obj_dir);
	int dam=get_item_info(item,item_damage);
	int pc=get_item_info(item,item_pic_id);
	int obj=0, nx=0, ny=0, adder=0, ex=0, ang=1, nang=-1;
redo:	
	switch (num)
	{// this chooses the correct spacing for the new objects.
		case 1: 	nx=-8; break;//x2= x-8;	y2= y-8;
		case 2:		nx=8;	break; //x2= x+8;	y2= y+8;
		case 3:		nx=-16;	adder=2;break;// x2= x-16;	y2= y-16;
		case 4:		nx=16;	adder=2;break;//x2= x+16;	y2= y+16;				
	}
	x2=xXx(1, dir, x+nx,x);
	y2=xXx(2, dir, y+nx,y);
	//if ((nx==16) || (nx==-16)){adder=2; }
	ang=1+adder; nang=-1-adder;
	switch (dir)
	{
		case up:
		if (nx>0){ny=nang;nx=ang;}else{ny=nang;nx=nang;}
		ex=-3;
		break;
		case down:ex=3;
		if (nx>0){ny=ang;nx=ang;}else{ny=ang;nx=nang;}
		break;
		case left:
		if (nx>0){ny=ang;nx=nang;}else{ny=nang;nx=nang;}
		break;
		case right:
		if (nx>0){ny=ang;nx=ang;}else{ny=nang;nx=ang;}
		break;
	}
	
	//ny=xXx(3, dir, nx,nx*-1);
	//ny=((y2-y)/2);
	//if (ny==0){ny=nx;}
	//if (((x2-x)/2)!=0){nx=((x2-x)/2);}
	//nx=xXx(3, dir, nx*-1,nx);
	if ((obj=add_object(item, x2, y2,item))!=555)
	{
		qslope(obj, 3, x2+nx,y2+ny,OBJECT);
		increase_object(obj, obj_speed_y, ex);
		set_obj_stats(obj, dam, typ, random(right), pc);
	}
	num--;
	if (num>0){goto redo;}
}// end super weap



//============================================================================================


//============================================================================================


//============================================================================================


//============================================================================================


/*
void print_objs()
{// jsut a simple routine to help troublshoot objects.  it prints everything in the object list.
	int i=0;
	while (i<7)
	{
		printf("\nobj =%i, type = %i",get_object(i,obj_num),object_list[i][obj_type]);
		i++;
	}
	wait_for_key(a_ko);
}// end print obj*/