// C Source File
// Created 7/20/2011; 3:40:15 AM
/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"
//#include "ext_vars.h"


extern char *light, *dark;
int current_mob_gfx=0,double_damamge=FALSE, skip_animate_mob=FALSE;
extern int link_direction, link_x, link_y, link_picture, button_pressed, spinslash_active;
extern int dark_room;
//=================================================================================================




//=================================================================================================



void mob_gfx_loader(int id)
{
	char messa[10];
	if ((id==current_mob_gfx) || (id<=0)){return;}// bypass if it is already loaded
	else {current_mob_gfx=id;}
	FolderCur(SYMSTR("mobs"),TRUE);// transfer to the mob filder.
	unsigned short tmp[mob_gfx_list_size*3][16];
	int x=0, y=0;
	FILE *q = NULL;
//55190  ->55172
TRY

	sprintf(messa,"zmb%i",id);
	q = NULL;

 if ((q = fopen(messa,"rb")) == NULL) {return;} else {
	        if (fread(tmp,sizeof(tmp),1,q) != 1) {return;}else{
	        	for (x=0;x<mob_gfx_list_size;x++){
	        		for (y=0;y<16;y++){
	        			s_mob_pic(x,y,tmp[x][y],1);
	        			s_mob_pic(x,y,tmp[x+mob_gfx_list_size][y],2);
	        			s_mob_pic(x,y,tmp[x+(mob_gfx_list_size*2)][y],3);
	        		}// 2nd for
	        	}// 1st for
	        }
	        fclose(q);
	        }
	 ONERR
	 ENDTRY 


}// end mob loader



//================================================================================================





//=================================================================================================


//================================================================================================




//================================================================================================




//================================================================================================




//================================================================================================




//================================================================================================
int rand_diag_dir(){return (((random(4)+1)*10)+random(4));}

void mob_attack(int i)
{
		int obj=0,item=0,typ=0;

		switch ((item=get_mob_stat(i,mob_special_atk)))
		{
			case 9000 ... 10000:// basically, just add an item to the mob and it will shoot it.
//disp_error("mob item");											
				if (random(67)==13)// && get_mob_stat(i,mob_rand_var2)<=0)
					{
						//	item=get_mob_stat(i,mob_special_atk);
//printf_xy(0,67," i=%i", item);							
					if ((obj=add_object(item, get_mob_stat(i,mob_x), get_mob_stat(i,mob_y),item))!=555)
						{
							set_object(obj, obj_rotate, dir_to_rotate(get_mob_stat(i,mob_dir)));
							obj_dir_set(obj,4, fix_diag_dir(get_mob_stat(i,mob_dir)));
							//set_object(obj,obj_dir, fix_diag_dir(get_mob_stat(i,mob_dir)));
							set_object(obj,obj_dam, get_item_info(item,item_damage));
						//	set_object(obj,obj_var2, get_item_info(item,item_pic_id));
							set_object(obj,obj_type, (typ=get_item_info(item,item_type)));
							set_object(obj,obj_draw_type, A_NORMAL);
//sprintf(dbg, "%i",get_object(obj,obj_type));debug();
							if mob_rotate_weaps {set_object(obj,obj_rotate,random(right));}
							if (typ==arrow_foe_at_link){qslope(obj, 4, link_x+8, link_y+8,OBJECT);}
							//init_multi_weapons(obj, item);
							init_super_weap(obj, item);
						//	arrow_modder(obj);
////printf_xy(0,80,"o=%i, t=%i, i=%i", obj, get_object(obj, obj_type), item);wait_for_key(esc_ko);								
						}// end if we added an item
//printf_xy(0,80,"it=%i o=%i d=%i p=%i", item, obj, get_item_info(item,item_damage), get_item_info(item,item_pic_id));wait_for_key(esc_ko);							
						//	mod_mob(i, mob_rand_var2,5,TRUE);
							//add_object(1009,5*16,4*16,1009);
		//	set_object(keye,obj_var1,50);
						}//end random
						break;
					case mob_replicator:
						add_a_mob(get_mob_stat(i,mob_x), get_mob_stat(i,mob_y), 0, get_room_info(mob_file));
					break;
				/*	case chicken_attack:
						mod_mob(i,mob_special_atk, 0,TRUE); 
						disp_error("in here");
						
						item=i;
						for (i=0;i<max_mobs;i++)
						{// technically this is not the location of the mob, b/c i is from the mob list, not the ow mob file.
							if (add_a_mob(get_mob_stat(item,mob_x), get_mob_stat(item,mob_y), get_mob_stat(item,mob_sl_exec), get_room_info(mob_file)))
							{
								mod_mob(i,mob_hp, 24,TRUE);
								mod_mob(i,mob_dam, 4,TRUE);
								mod_mob(i,mob_move_type, MOB_FOLLOW,TRUE); 
							}// end if
							
						}// end for	
					break;*/
					default:
					break;	
		}// end special attack switch
					
}

//================================================================================================

int fix_diag_dir(int dir)
{
	switch (dir)
	{
		case up ... right: return dir; 		break;
		case upleft: 
			case downleft:	 return left; 	break;
		case upright: 
			case downright:	 return right; 	break;
	}
	return up;
}

// the rotator is taken out of the animate generic, b/c it was used by more than one routine.
// it basically just rotates the pictures so the mob looks animated.
int picture_rotator(int loc, int pic)
{
//			int pic=get_mob_stat(loc, mob_current_sprite);
			int sprites=get_mob_stat(loc,mob_sprites);
			int sprite_id=get_mob_stat(loc, mob_sprite_id);
			int ani_speed=get_mob_stat(loc,mob_animation_speed);
			int frame=get_mob_stat(loc, mob_frame);
			if (frame<0){mod_mob(loc,mob_frame,0,TRUE);frame=0;}
			
			if ((sprites>=8) && (get_mob_stat(loc,mob_walk_sprites)==2))
			{
				pic=sprite_id+(fix_diag_dir(get_mob_stat(loc,mob_dir))*2);
				if (frame>ani_speed){	pic++;}
				if (frame>(ani_speed*2)){	mod_mob(loc,mob_frame,0,TRUE);}
			}
			else	if ((frame>ani_speed) && (sprites>=2)){
					if (pic>=(sprites+sprite_id)-1){
						
						pic=sprite_id;// reset the pic to the original sprite
						if (get_mob_stat(loc,mob_type)==digger){pic+=2;}
						//if (sprites==4)
					}// end if pic>sprites
					else {pic++;}
					mod_mob(loc,mob_frame,0,TRUE);
			}//*/
			return pic;
}// end picture rotator

//================================================================================================

void try_to_move_mob(int loc)
{
		if (get_mob_stat(loc,mob_speed)>0){
			
		int r=0,typ=0;
		
		redo:
			typ=get_mob_stat(loc, mob_move_type);
		
			if (can_move(loc, get_mob_stat(loc,mob_dir)))  {
				//this section determines if the mob can move on the map or not.
				// it does need to be modified so it takes in account flyers and ghosts.
			
				move_mob(loc, typ, get_mob_stat(loc,mob_speed));}
				else {change_dir(loc);
					if ((typ==MOB_FOLLOW) || (typ=MOB_BAT)){return;}//prevent the 5 loops
					r++;if (r<5){goto redo;}}
				//try to change the direction 5 times to see if the mob can move, if not, then carry on.
			}// end if mob speed >0
}

void animate_generic1(int loc)// use mob_loc(<mob id>) to get the loc.
{
		/*
				this routine animates a generic mob.
		
		
		*/
		
		
			int pic=get_mob_stat(loc, mob_current_sprite);
	//		int sprites=get_mob_stat(loc,mob_sprites);
			int sprite_id=get_mob_stat(loc, mob_sprite_id);
	//		int ani_speed=get_mob_stat(loc,mob_animation_speed);
	//		int frame=get_mob_stat(loc, mob_frame);
	//		int under=get_mob_stat(loc, mob_underground);
	//		if (frame<0){mod_mob(loc,mob_frame,0,TRUE);frame=0;}
			
			
			// the above if stmt exists b/c soemtimes we forget to set the mob frames in the mob list
			// and the mob tends to start at frame -100; thus, preventing the mob from moving for a 
			// while.  this will prevent that stall from happening.
			
		//	DrawImage(MOB, pic, get_mob_stat(loc, mob_x), get_mob_stat(loc, mob_y), A_NORMAL);
				if (get_mob_stat(loc,mob_pause) > 0)
					{
				//	mob_list[loc][MOB_PAUSE]--;
							mod_mob(loc,mob_pause,-1,FALSE);
					//DrawImage(MOB, MONSTER1+count1, mob_list[loc][MOB_X], mob_list[loc][MOB_Y], A_NORMAL);
							DrawImage(MOB, pic, get_mob_stat(loc, mob_x), get_mob_stat(loc, mob_y), loc, TRUE,0);
							 goto end;
					}// end if pause>0
//hajimaddu			
			pic=picture_rotator(loc, pic);
/*			if ((sprites>=8) && (get_mob_stat(loc,mob_walk_sprites)==2))
			{
				pic=sprite_id+(get_mob_stat(loc,mob_dir)*2);
				if (frame>ani_speed){	pic++;mod_mob(loc,mob_frame,0,TRUE);}
			
			}
		//	if (sprites==4){pic+=get_mob_stat(loc,mob_dir);}
			// if there are more than 4 sprites and there are 2
			// walking sprites, then add the direction to the up*2=0, down*2=2, left*2=4, right*2=6//
//if (loc==0){printf_xy(0,0,"%i %i %i %i %i",loc, frame, ani_speed, sprites, pic 		);}
//else {printf_xy(0,8,"%i %i %i %i %i",loc, frame, ani_speed, sprites, pic 		);}
			else	if ((frame>ani_speed) && (sprites>=2)){
					if (pic>=(sprites+sprite_id)-1){
						
						pic=sprite_id;// reset the pic to the original sprite
						if (get_mob_stat(loc,mob_type)==digger){pic+=2;}
						//if (sprites==4)
					}// end if pic>sprites
					else {pic++;}
					mod_mob(loc,mob_frame,0,TRUE);
			}//*/
		//	pic=animation_pic_decider(loc, frame,ani_speed, sprites, pic, sprite_id);
	/*		switch (sprites)
			{
				case 0 ... 1:	break;// do nothing.
				case 2: 
						if frame>ani_speed)
						pic++;
						mod_mob(loc,mob_frame,0,TRUE);
						pic=get_mob_stat(loc, mob_sprite_id);
				break;
				case 3:
			}
			
			switch(get_mob_stat(loc, mob_frame))
				{
					case 0 ... 2:
					break;
					case 3 ... 4:
						pic++;
						//DrawImage(MOB, CRAB2, mob_list[loc][MOB_X], mob_list[loc,mob_y), A_NORMAL);
						break;
					default:	//This causes mob_frame reset when it has reached its max
					//pic=CRAB1;
					//	DrawImage(MOB, CRAB1, mob_list[loc][MOB_X], mob_list[loc][MOB_Y], A_NORMAL);
						mod_mob(loc,mob_frame,0,TRUE);
					//	set_mob_list[loc][MOB_FRAME] = 0;
						break;
				}*/
				int draw=TRUE;
				int typ=get_mob_stat(loc,mob_type);
				if ((typ==digger)|| (typ==wizard)){
						switch (get_mob_stat(loc, mob_underground))
						{

							case 1:
								pic=sprite_id;
							break;
							case 2:
								pic=sprite_id+1;
							break;
							case 3:
								draw=FALSE;
							break;
						}// end switch	
				
				}// end if type digger


				mod_mob(loc,mob_current_sprite,pic,TRUE);// reset the current mob sprite.
				if (draw){DrawImage(MOB, pic, get_mob_stat(loc, mob_x), get_mob_stat(loc, mob_y), loc, TRUE,0);}
			/*	if (get_mob_stat(loc,mob_pause) > 0)
					{
				//	mob_list[loc][MOB_PAUSE]--;
							mod_mob(loc,mob_pause,-1,FALSE);
					//DrawImage(MOB, MONSTER1+count1, mob_list[loc][MOB_X], mob_list[loc][MOB_Y], A_NORMAL);
							goto end;
					}// end if pause>0*/
				if (get_mob_stat(loc,mob_stops)==sometimes){
					if (get_mob_stat(loc,mob_pause)  <= 0 && !random(50)){mod_mob(loc,mob_pause,random(50)+25,FALSE);}
						//	mob_list[loc][MOB_PAUSE] = 10;
					
				}// end if mob stops sometimes.
				
			//	MoveMob(loc, MOB_FLUTTER, 2);
			try_to_move_mob(loc);
/*				if (get_mob_stat(loc,mob_speed)>0){
					
				r=0;
				
				redo:
				if (can_move(loc, get_mob_stat(loc,mob_dir)))  {
					//this section determines if the mob can move on the map or not.
					// it does need to be modified so it takes in account flyers and ghosts.
				
					move_mob(loc, get_mob_stat(loc,mob_move_type), get_mob_stat(loc,mob_speed));}
					else {change_dir(loc);r++;if (r<5){goto redo;}}
					//try to change the direction 5 times to see if the mob can move, if not, then carry on.
					}// end if mob speed >0*/
				end:
}





void animate_evil_eye(int loc)
{
	
	animate_generic1(loc);
	//move_ghost(loc, ani_speed);// make it so it can move diagnal
	int i=get_mob_stat(loc,mob_rand_var1);
	int var2=get_mob_stat(loc,mob_rand_var2);
	int radius=24;
	switch (var2)
	{
		case 0 ... 12: break;// do nothing
		case 13 ... 100: radius+=((var2-12)/2); 	break;
		case 101 ... 180: radius=68; break;
		case 181 ... 268: radius=68-((var2-179)/2); break;
		case 269 ... 290: break;
		default: mod_mob(loc,mob_rand_var2, 0, TRUE); break;
	}// end switch
	
	if ((num_of_mobs()==1) && (get_mob_stat(loc,mob_rand_var1)!=(-88)))// this creature should be immortal then after you kill all
			{mod_mob(loc, mob_shield, immune_magic, TRUE); mod_mob(loc, mob_rand_var1, -88, TRUE);}// other mobs, it should become killable.
	else if (get_mob_stat(loc,mob_rand_var1)!=(-88))
				{mod_mob(loc,mob_rand_var1, disp_circle_mobs(get_mob_stat(loc,mob_x), get_mob_stat(loc,mob_y), radius, i),TRUE);}

	mod_mob(loc,mob_rand_var2, 1, FALSE);
	}

void animate_multi_sprite(int loc)
{
	// if 4, then loop through all 4
	// for now, there will not be any direction changing stuff, except it will make the mob go in reverse. otherwise
	// it will always point down.
	//mob_h, mob_w
	int w=get_mob_stat(loc,mob_w), max_i=0, max_k=0, i=0;
	int h=get_mob_stat(loc,mob_h);
	if ((w>16) && (w<=32)){max_i=2;}
	if ((w>32) && (w<=48)){max_i=3;}
	if ((h>16) && (h<=32)){max_k=2;}
	
	
			int sprite_id=get_mob_stat(loc, mob_sprite_id);
			int ani_speed=get_mob_stat(loc,mob_animation_speed);
			int frame=get_mob_stat(loc, mob_frame);
			int pic=sprite_id;
			if (frame<0){mod_mob(loc,mob_frame,0,TRUE);frame=0;}
			
			if (get_mob_stat(loc,mob_walk_sprites)==2)
			{
				
				if (frame>ani_speed){	pic=sprite_id+max_i+max_k;}
				if (frame>(ani_speed*2)){	mod_mob(loc,mob_frame,0,TRUE);}
			}
			

	/*
			the routine is set up like this:  
			
			if 16h x 32w, then it will pull gfx[i] & gfx[i+1]
			if 32h x 32w, then it will pull gfx[i] & gfx[i+1] (for row 1) i+=2; then ull gfx[i] & gfx[i+1](for row 2)
			in theory, there could be: if 32h x 16w, then it will pull: i+=2; gfx[i] & gfx[i+1]
	
	
	*/
	for (i=0;i<max_i;i++){DrawImage(MOB, pic+i, get_mob_stat(loc, mob_x), get_mob_stat(loc, mob_y), loc, TRUE,0);}
	for (i=0;i<max_k;i++){DrawImage(MOB, pic+max_i+i, get_mob_stat(loc, mob_x), get_mob_stat(loc, mob_y), loc, TRUE,0);}

}

void animate_spider(int loc)
{
			int sprites=get_mob_stat(loc,mob_sprites);
			int v1=0;
			//if (v1<0){v1=0;}//if (v1>=mob_gfx_list_size){v1=(mob_gfx_list_size-1);}// prevent oob errors
			switch (get_mob_stat(loc, mob_frame))
			{
				
				case 41: if (sprites>=3)	{v1=3;  mod_mob(loc,mob_shield, immortal, TRUE);}  break;
				case 52: if (sprites>=6)	{v1=3; } break;
				case 63: if (sprites>=9)	{v1=3; } break;
				case 70: v1=(sprites * (-1)); mod_mob(loc,mob_shield, death_by_arrow, TRUE); break;
			}// end switch
			mod_mob(loc,mob_sprite_id, v1, FALSE);
			try_to_move_mob(loc);
			animate_multi_sprite(loc);
}// end animate spider

void animate_warp_hand(int loc)
{
	mod_mob(loc,mob_underground,1,FALSE);
	
	int under=get_mob_stat(loc, mob_underground);
	if (under>200){move_follow(loc, 1);}
	if (under>500){
		
		int a=mob_x,b=mob_y,c=random(80)+3;
		
		if (!random(2)){a=mob_y;b=mob_x;c=random(150)+3;}

			mod_mob(loc,a, 0, TRUE);
			mod_mob(loc,b, c, TRUE);
			mod_mob(loc,mob_underground,0,TRUE);
		
	}// end if under>500
}// end enimate warp hand

void AnimateMob(void)
{
	//- you still need to determine if the mob is stunned, b/c if so, then it should not move
	// take into consideration mob_animation_type  and mob_stops
	// mob type should be taken into consideration when moving the mob, such as ghost.  if a ghost
	// then move through non-movable things.  fish to move through water, land to move only on land
	// flyer to be able to move through anything, but walls, digger to go underground, 
//	if (skip_animate_mob){return;}
	if (g_transistion_active()>0){return;} 
	int i=0; //animate=TRUE;//,move_type=0;
	int typ=0, hit=0;
	while (i<max_mobs){
		
		typ=get_mob_stat(i,mob_type);
		if (typ>=0){
				hit=get_mob_stat(i,mob_hit);
				if (hit<=0){mob_slashed(i);hit=get_mob_stat(i,mob_hit);}
	//34829			
				
				
				//		if the mob has been hit by a weapon, then force it to reel back
				//		instead of normal animation.
			
				
				
				
				if ((hit>=0) && (typ!=pede_body))	{	gfx_reel_back(i); }//if(hit>4){goto end;}}
				// if the mob has a stunned status >0, then make sure it doesnt move.
				if (get_mob_stat(i,mob_stunned)>0){mod_mob(i,mob_stunned,-1,FALSE);
				DrawImage(MOB, get_mob_stat(i,mob_sprite_id), get_mob_stat(i,mob_x), get_mob_stat(i,mob_y), i, TRUE,0);
				
				goto end;}
							
		//		else {			
							
				switch (typ)
				{
				//	case chicken:// dog and chicken in same routine.
				//		case dog:	animate_chicken(i);										break;
					case digger: mod_digger(i);	animate_generic1(i); 	break;
					case evil_eye: animate_evil_eye(i);      					break;
					case pede_head:	pede_head_3(i); break;//i=pede_header(i);								break;
					case circle_eye:  break;
					case pede_body: pede_body_3(i);break;
					case spider: animate_spider(i);									break;
					case warp_hand: animate_warp_hand(i); break;
					case crab: mod_crab(i);// no break, so it will continue to default.
						default:	animate_generic1(i);									break;
				}// end switch
				
				
					mob_attack(i);
					mod_mob(i,mob_frame,1,FALSE);// increase the frame of the mob.
					end: 
					if (!skip_animate_mob){if (moby_contact(i, link_x+1, 14, link_y+1, 14)){pain(LINK,i,0,0);}}
		}// end if mob_type>=0
		
		
		i++;
	}// end while i
	
				
}// end animate mob*/


void gfx_reel_back(int who)
{
/*
		
		reel back simply animates the player/mob after it gets hit.  it makes link go back 21 spaces
		while the mob goes back maybe 6, however this is called like 5 times for the mob, while it is
		called only once for the player.
*/
		int i=0,dir=0,amt=0, shield_used=0;//, dmg_type=0;// 28548 -> 28534
		int info=get_mob_stat(who,mob_hit);
		int ld=link_direction;// so i can restore link dir after i tinker with it.
		int move=link_direction;
	//	int mob=touch_mob(link_x, link_y, LINK);//touch_link();// having this here makes it 100 bytes less?
		int maxer=6;
		if a_player{
		//	if (link_stat(dual_state)==LINK_HOOKSHOT){return;}// this will make sure link reaches his destination
			if (get_object(link_stat(hold_carry), obj_num)>0){toss_object();}
			// if hookshooting around.  but link will still take damage.  this is here to prevent errors in the water world
			info=1;move=link_direction=opposite_dir(link_direction);maxer=21;
		//	md_link(state, LINK_NORMAL, TRUE);md_link(dual_state, 0, TRUE);
	//	link_state_reset();
			//if (obj_loc(HOOKSHOT)!=555){remove_hookshot();} - made this so it would delete the hookshot if link got hit
		}
		else if a_mob{
			if (get_mob_stat(who,mob_type)==pede_head){ mod_mob(who,mob_hit,-1,TRUE); info=0;}
		}// end else if a mob
		
		
		if (info>0)//mod_mob(count1,mob_pause,-3,TRUE);// and to force it to reel back < 0)
		{
				if a_mob {mod_mob(who,mob_hit,-1,FALSE);}// increase the pause by 1
				while (i<maxer){
						if (can_move(who,move)){
								if a_mob {
										switch (move)
										{
											case up: dir=mob_y;	amt=-1;	break;
											case down:	dir=mob_y; amt=1;	break;
											case left:	dir=mob_x; amt=-1; break;
											case right:	dir=mob_x; amt=1;	break;
										}// end switch
										if (!spinslash_active){mod_mob(who,dir,amt,FALSE);prevent_mob_oob(who);}}// this is a lot smaller than movemob?
								else if a_player {walking(LINK_NORMAL, 1);oob_reel_chk();}
						}// end if can move
						else {i+=100;}// if the mob cant move, then get out of the loop
				//	if a_mob {if ((get_mob_stat(who,mob_hit)%2)==0){type=A_REVERSE;}else {type=A_NORMAL;}}
					//DrawImage(MOB, get_mob_stat(who,mob_current_sprite), get_mob_stat(who,mob_x), get_mob_stat(who,mob_y),type, TRUE);
					i++;
				}// end while i<10
			}// end if pause <0
			if a_mob{DrawImage(MOB, get_mob_stat(who,mob_current_sprite), get_mob_stat(who,mob_x), get_mob_stat(who,mob_y), who, TRUE,0);}
			else if a_player{link_direction=ld;DrawImage(LINK, link_picture, link_x, link_y, A_NORMAL, TRUE,0);link_state_reset();}
		//	printf("hit=%i hp=%i",get_mob_stat(who,mob_hit),get_mob_stat(who,mob_hp));
		//	wait_for_key();
			//---------------------------------------------------------------------
			// Once mob recovers from the blow, make him explode if he dies.
			//---------------------------------------------------------------------
			if a_mob{
			shield_used=get_mob_stat(who,mob_shield);
			if ((shield_used==immortal) || (shield_used==death_by_fire)|| (shield_used==death_by_arrow)|| 
					(shield_used==death_by_bomb)|| (shield_used==immune_magic))
			 {mod_mob(who,mob_hit,-1,TRUE);}// this makes the mob
			// just reel back a little and not be harmed
				if (get_mob_stat(who,mob_hit) <= 0)// used to be zero.  adjust this lower if the mob is taking
				/// too much damage., b/c there is a bad part when a mob gets hit, it will be stunned so if you
				// can minister multiple hits to him, then he will permantly stay stunned.
				{
			//		printf("koko ");
				//	if ((get_item_info(link_stat(button_pressed), item_type)==sword) && (double_damamge==TRUE))
				//	{// if you are doing spinslash, you want to do double the damage to the creature, so
					//this routine will do double the damage
				//		item_damage=item_damage*2;
						//if (double_damamge==TRUE){pain(who,get_item_info(link_stat(button_pressed), item_damage) ,0,0 );}
				//	}
				/*	switch (get_item_info(link_stat(button_pressed), item_type))
					{
						case arrow:
						case arrow_ammo:  dmg_type=type_arrow; break;
						case wand: dmg_type=type_magic; break;
					}
				  sprintf(dbg,"%i %i %i", link_stat(button_pressed), get_item_info(link_stat(button_pressed), item_damage), dmg_type );debug();
					*/
					pain(who,get_item_info(link_stat(button_pressed), item_damage) ,0,double_damamge );
					if (get_mob_stat(who,mob_hit)<=0){mod_mob(who,mob_hit,-1,TRUE);}// make it so that mob hit
					// only gets adjusted in the event that the mob is not stunned.  this way, the mob will
					// not stay in perm_stun state.
				}// end if the mob hit==0
			}// end if a mob
	//	}//end if pause*/
}// end hit mob


