// C Source File
// Created 8/6/2011; 1:58:39 AM
/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
/*
	*7/15/11*
		- closest estimate that i began working on this
		- so add a week or two worth of days working on this.


	* 8/6/11 *
		- modified the generic mob gfx routine and added in a mob animation speed variable.
				this variable will determine how fast a mob will animate.  1 is the fastest while
				antything greater than this is slower animation.  the speed variable tends to 
				switch animation picture every X frames, so a mob_animation_Speed of 4 means that
				it will switch the mob picture every 6 frames, b/c it starts at 0 and goes to 5; therefore,
				6 frames.
		- increased the mob stat list to 27.  i added in the frames and 2 X_vars, which could be used
				for anything.  i left the xvars in, b/c it was used in animating the mobs.
		- added in mob_move_type into the mob list.  this is so you can set the move type yourself
				and makes the mob switch case a lot smaller.  allows for generic mobs to be made.
		- you still need to determine if the mob is stunned, b/c if so, then it should not move
		
		
		
		
		
		&& i think it might be best to make the switch case stmt in the mob_gfx only switch those which
		do require special treatment, otherwise, default to generic movement., like the  butterfly and 
		the urchine could do generic movement, although it might be better to add in a spot in the 
		mob list to tell which type of movement to do.		


	* 8/8/11 *
		- played around with the gfx of the mobs.  i imped the chicken/dog routines (the routines got
					combined into 1; thus, taking less space.
		- imped the crab gfx, but it is untested.  
		- fixed the 8 sprite/2 walk gfx disp
		- modded the generic routine and added things in
		- added in can_move() to the mobs, so they walk correctly
		- programmed in flyer and ghost to walk through anything.
		- mob collission does not work too well right now.  it has issues... mobs dont like to move
				with checking mob_collission() - fix this later
		- added back slashmob(), but it just lets you know if you did hit a mob or not.
				- you need it to send back a loc of which mob you hit if you did hit a mob or 555 if not.
				- you need to imp use_item() so you can use your sword.  
				- you need to imp the weapons list, so you can do damage with your sword.
				- imp the shield (imp=todo) (imped=added)
				- imp the digger and the other mob.
				- modify the can_move, to include the fish and swimming gear (item xxxx)
				- imp the shooting of random objects from the mobs.
		- fixed - monster 1 still has some loading issues.  not sure why.  the gfx tends to cycle through a lot 
				before the real ones show up  - i added in the new gfx set and the new mob stat files and then
				it stopped cycling through the gfx.


	* 8/11/11 *
		- messed around with the start menu.  modded the menu to allow for the selecting.
				i have attempted to make things disp in the menu, but the displaying is not
				working correctly.  actually, the disp image is set on a plane that is out of bounds
				and based off of links posistin.
				- well i went in and modified drawimage and forced it to either allow for the special 
						shifting or not.  now things slightly draw correctly.  there are still some issues 
						though.
						- i might have fixd the issues, b/c it was drawing them @ 108, when there are only 
								99 lines... so obviously out of the picture it was drawing the items.
								this seems to be fixed.
		- added in the inventory routines to add to the inventory.
		- created the item list, so now i can create the items when necessary.
		
	* 8/16/11 *
		- fooled around with the start menu.  
		- created the main menu
		- created the general menu selector
		- played around with the saving thingie, but there are errors
				- the main problem is that when you call the msg and then a disp box afterwards, the msg
					is deleted, same with the lines you drew.  actaully, you need to draw the blank parts
					of the msg box and the selector box (like yn_box or saver_box) and then disp the lines
					for the msg and selector boxes.  then disp the msg from messages.. you will need to do
					some recoding with msg and include the yn_box and selector_box inside of msg as an option.
		- i added in the hearts so the hearts will disp correctly.  this is hopeful, but it slows down
					the system.  create a switch to toggle it on and off and to display in any random corner.
		- i added in a switching routine for the inventory() so now you can choose items for a and b
		- added in the numbers for the items in the inventory
		- i removed the esc key from exiting the game.  instead, use the start menu to leave the game
		- i am over 28k now... sigh.  i running out of room, or at least i feel that way.  32k is the
				half way point though.  but when i think about it, i only need to fix the mob killing.  make
				mobs randomly shoot things.  make the other objects and their animations.  finish the start
				menu.  create the shops.  add in the sl routine.  add in the towns people.  also do some mods
				on the room loading and the world[][] map.  hopefully shops wont take too much ram.  and do 
				mob collission.  fix the holes.  add in push and lift object.
	
	* 8/17/11 *
			today was a busy day
			- made the mobs die correctly.  
			- created pain, although it is incomplete
			- made link get hurt by the mobs
			- made both the mobs and link blink when they got hit
			- created the reel_back() which makes the mobs and link "reel back" after getting hit.
					although, it could be better if they didnt die off the screen.  might want to prevent them
					from going past the edge of the screen when they reel back.  i could probably just
					modify the can_move() to prevent mobs from going past the boundries.
			- can move was modded so the mobs dont go out of bounds when hit.  also, i found an error and 
					fixed it in the can move (the mobs got stuck, but that was b/c i had an all purpose
					if stmt that prevented movement and i forgot to include the mob direction in the statement)
			- created death of a mob.  
			- created an all purpose drop_item routine.
			- removed the scroll room logic, b/c it moved hyper fast anyways; thus, being useless
			- created a blinking state for link, which makes him immortal.
			- created a stun state for link so he cannot use any keys.	
			- created touch_link() which detects if a mob hits link or not. i will need to do the same
					things w/ dangerous objects.  (touch link() also returns the mob that hit him)
			- added in immortal mobs and "death by fire only" mobs.	
			- increased the size of mob_list to 28 stats per mob.
			- fooled around with the msg system a little.  fixed it so that the selector box and message
					will both show up correctly. i need to create the message set though.

	* 8/23/11 *
			- added 25 sprites to the game.  
			- modded the editor for all but world_gfx to auto archive and unarchive stuff.
			- added in push ability.
			- moved the link falling sprites to the object[][].  
			- there are still issues with the pushing to display correctly.
			- need to put the correct mask for sword 8
			- still need to add the shield use gfx of link and the boomerang.
			- need to remove arrow from its current spot and add 3 other arrows for lrud to be complete

	* 8/24/11 *
			- lots of things completed
			- created the rotate image routine.  now i can rotate a 16x16 sprite 90, 180, and 270 degrees
					the routine was slow on the 90 and 270, so i created a buffer to store objects that have
					already been rotated 90 and 270 degrees. now if the roate() is called, then it will check
					to see if the buffer has the sprite or not.  if it does then it will transfer the sprite
					from the rotate buffer to the image buffer.  this spead up the game.  i didint bother 
					adding in the 180 deg to the rotate buffer, b/c 180 deg only had to go through 2 loops
					in order to finish, so it was fast enough.
			- i increased the size of the item stats, so i could have a 2nd picture for the items, so
					i could rotate that picture and store it in the rotate buffer.  (this was specifically
					done for the sword, b/c it had at least 2 different sprites)(the current sword needs
					3 different sprites to work correctly.  odly, one of the slash sprites did not want to
					rotate correctly, so i needed a 2nd one to make it disp correctly., but in the end, i
					reduced the number of sword sprites from 8 to 3.  pretty good if you ask me.)
			- the rotate buffer only holds those items which are held in button a and button b.  (8
					sprites each, although only about 6 are really needed...)
			- i modified the walking routines.  i stored the increase of link_x/y in the link_gfx.c
					instead of keys.  i created a routine called move_link(int speed).  this will move
					link a certain speed that you wish.  (it can be later on used for the sl, which would
					be helpful. - actually, use walking() instead - see below)
			- i created a walking(), which animates the link walking.  the code was beginning to 
					be used a lot in different areas.  it integrates move_link().  it would be best
					to use walking() instead of move_link() in the sl., b/c walking() takes into 
					consideration can_move().
			- i combined slash and walking_slash.  this removed about 400 bytes of info.  yay!
			- i created the boomerang gfx routines.  the damamge still needs to be modified to take
					into account the actual damage from item_stats().  right now, it is hard coded in
					at 4 damage.  also, stun does not seemed to be programmed in.	 the boomerang does
					not make the mob reel back.  the wand should make the mob reel back, though.
			- probably coded in about 2.5k today.
			- modded link_touch() to be more robust so even the boomerang can use it. it got renamed, too.
			- added in defines for the keys (a, b, start, esc, etc.)  
			- made the main key routine a little smaller and effecient.

	* 8/26?/11 *
			- created the config menu.
				- added the ability to adjust contrast
				- added ability to choose which corner hearts disped in.
				- added ability to remove the displaying of hearts
				- added in ability to adjust the speed of terrain animation
				
	* 8/28/11 *
			- fixed the problem with rooms not loading correctly.  i actually made y reset back to 0 instead
					of forcing it to go to y2-4.  this caused it to recopy the left side of the world map. once
					i made y=y2-4, then everything worked.  also, that adjustment got rid of the gfx error that
					made the light plane dissappear.  i dont know how long you have to play it for the light
					plane to dissappear, though.  (fixed the problem in load rooms)
			- added in the ability to make world[][] maps switch from one to another when going out of
					the boundries of the world[][] map. (unfinished though)
			- once i create the correct mob lists and add in the shield, then the game will be distributed
					as beta just to see what the kids think of it.  besides, im at the half way point of 32k
					worth of code.  at this point i can only add 32k more before i cannot add anymore code.

  * 8/31/11 *
			- i finished off the random things i needed to do and i published the program :)
			- i know i made shield work and boomerang work before publishing the program, although i dont think
					i documented this.	

	* 9/1/11 *
			- i didnt add in info here until the 4th, so i will attempt to remember what i did.
			- i created direct draw.  everything has sped up by a lot.  getting rid of double buffering
					helps i suppose :P
			- i removed the contrast part of the config menu and made contrast adjustable via f3/f5
			- updated the buffering of rotate, now it just adds to the rotate buffer when it is first used.		 	
	
	
	* 9/4/11 *
			- added in a whole bunch of sprites today. (for link lifting, bombs, bomb explosion, arrows, wand, 
						generic magic pics, etc)
			- i made the arrows and the wand work.  I added around 1k to do this.
					what i did was, i created a generic damage routine that would both work for arrows and random shooting
					things.  come to think of it, i can add in the random shooting of objects from the mobs.
			- i made the "immune to all but fire" mobs die to the fire.  the fire has been created and animated.		
			&& i still need to add in arrows and bombs as random drop objects.


	* 9/5/11 *
			- added in towns_people type of mob - just use -77 hp and 0 speed for them.  they default to generic 
					mob gfx handling, so you dont really need to add in a special type of routine to handle them.
			- made it so that you could not walk on top of a towns_people type mob.  - untested, but i dont think
					they can walk on you either.
			- added in merin sprites to test the mobs.
			- i set up special places for the towns_people in the mob_list.  i subbed mob_def and mob_shield for
					the messages that the towns_people would use.
						- you do need to add in the message system, though.
			- added in the arrow for random drop item if you have a type arrow in your inv or holding it.
			- added in the sl and it is working.
			- i moved the main gfx file to world[][] instead of room[][].  so 1 gfx file per world[][]
					i made it so that [11][7] was the place to look for the gfx file to load.
			- also, i updated documentation of world[][] under the static int world[][] in the map gfx.c
			- i made the shell for warper(), but you need to actually code it in.
			- modded gfx_slash() to take pic2 of the item and use that instead of the SWORD# define. this
					will allow you to use any sword gfx you want in order to make slash work as long as you have
					the sword pics in the right order :P
	
	* 9/6/11 *
			- basic msg completed and working.  
			- added in esc to talk to mobs, but it only checks to see if there is a msg for towns people and
					nothing else.  you will need to modify it to check to see if there is a msg in the sl (like signs)
			- made the boomerang pick up objects - basically i added in a routine to make any object move a certain amt.
			- added in touch object() which detects if link or an object(boomerang for now) is touching another object
					if it is, then it will return the object id of what it is touching.
			- used touch object and move_object() together in the boomerang routine to make field objects sync their
					movement to the boomerang.  originally, fire seemed to move with the boomerang as well, but i made it
					so that it wouldnot move anymore.  
			- i added in the shop system.  it was really easy.  i modded the animate_drop_obj() and added in a section
					where it searched for items.  if it did find an item, then it would draw it and keep it permanent.
					this is updated to the point where rocks could be added w/ minor code modifications in order to "lift"
					and toss the rocks, otherwise rocks will display just fine.
					- since animate_drop_obj() already takes into account link travelling over the items, it made it default
						that shop objects would automatically be gotten in the event they were walked over and there are
						enough rupies to buy it.		
			- i added in the cost of the items (below the shop object) in the event that shop_active=TRUE,  so when 
					creating the shops via the sl, just use add_object and be sure to set the shop active.  shop stops being
					active as soon as a new room is loaded, but can be reactivated via the sl.  		
			- i added about 1.1k to program in this stuff.
			- added in keyf3 and keyf5 to make sure f3 and f5 would not adjust the contrast super fast, but only 1 
					incriment per push.
			- added in the shadow when link walks in water, but i might need a different gfx for it.

	* 9/7/11 *
			- created the warping system.  and used the model of the mob creation for the wapr point creation.
					it really does cut down on the annoying long defines.
			- redesigned the the rest of the room creation system to include the shops and houses.  all houses
					and shops are now in world 11 and start in room 300.
			- fixed the saving system.  only really had to add in mod_link(map_id,i) to the get_next_world()
					to make sure that link's map_id was saved, so it could be recalled when pulling up his save file.
			- created a temp beginning screen using text.  i will imp a graphical thing later.
			- i fixed a major buy in the sl system.  it didnt like nested if statements, so i fixed that here and
					in afw as well.  now i can program in a proper shop script, while testing what items link does
					and does not have.
			- added in arrow_ammo as an item type.  it will add arrows to the bow.  I specifically did this so
					you could buy arrows and not end up with a bow and arrow as seperate items.  the downside is 
					that it will add arrows to the first bow it finds in your inventory, so be sure to delete out
					old bows if you ever create more than 1 and decide to add the new one on top of the old one.
			- added in heart type item.  this allows you to buy hearts.  remember: item hearts are different
					from the basic object hearts that randomly pop up on the field, but still recover 8 hp. i also
					modded the add_item_inv() so that the heart item would add hp and not show up in your inventory.
			- the thing is finally ready for its 2nd release.  YAY.

	* 9/7/11 - pre release*
			- i discovered an error in the saving, which could be annoying. - you could save, but link_x/y would
					not save, meaning you could save and then start a new game then exit and continue from the save
					but you would still have the link_x/y from the new game still in it, which could magically start
					you off walking on a tree or something, which would be bad.  so i added to the maps link_x/y
					map_x/y and world number.  this would allow you to start back at the "beginning" of a world[][]
					but in reality is a predestined point of start.  this point of start does not affect warping.
					it only exists when continueing and affects nothing else.
			- in order to create these saving points, i had to expand the sav[][] from 10 to 11.  now link has
					30 extra slots of info that could be saved, such as a name.		
			- in all, around 500 bytes were use to fix the errors.
			- i had to mod link_stat() and mod_link() to take into consideration the 2nd array or stats.
	
	* 9/8/11 *
			- added in a dual state for link.  now link can have 2 states at once.  he can be walking and
					using an object at the same time.  i had to add in the stat "dual_state" for link and link_frame2
					to keep track of the dual state.
					- originally, i had a lot of rapid fire of weapons.  this was toublesome, so what i did was i used
							an argh var to keep track of how many loops use_item() went though.  well i found out that
							about every 7 loops = 1 fire of the weapon, so i maxed it out at 14, so the weapons could
							fire twice.  when no buttons were pressed, i had argh-=3;  this allowed time for "recharging"
							of the weapon.  as for the arrow, i made it do argh+=7, to make sure it only fired once.
			- i made the wand damager start about 6 from the beginning of the wand instead of 16.  this allowed
					for creatures to be hit by fire when touched by the wand.	
			- modified the collission detection for mobs and made it only so that towns_people cannot walk into link
					while all others could.  - this fixed mobs from being stationary near link, while killing him.
			- not much done today, but i did use today as a day off.  i might do the same for tomorrow as well.
		
	* 9/15/11 *
			- been a while since i have touched this.  actually, i have been studying win azure for a job, so
					it couldnt be helped.
			- i added in the mapping system.  originally, i had 2 different room pics, however, they looked
					too similar and it was hard on the eyes.  instead i simply went with the crude method and 
					A_reversed the "walked on room" sprite for the non walked on room.  it is all b&w now, but it works.
					- also, if the room is flagged as hidden, then it will not show up.
			- i added in g_inv	
			- added in type LINK for the pointer.  this gives a 4x4 pixle dot for the room to tell what room
					link is in.  ( i still need to create one for the quest item (triforce)
			- the mapping sysem will auto save the current dungeon map when the world maps change.
			- i added in the locate/get/add quest item routines, their defines, and the part in the sl, for them
					to work.
			- it took almost 2k to make the mapping system work.
			- i also added in the current_game var so you know which save file to use.  this will be useful
					when you set up the traditional zelda start/continue
			- i had to seperate out the disp_start_menu() into about 3 different methods just to get the
					mapping system to work, b/c recalling the start menu kept on erasing the map.
			- added in link_get_item state.  this causes link to be stunned and to display the object that link gets
					on the ground (if item>999) above his head like normally.  if the shop is active, then it will 
					also clear out the item list and then add the item.
						- originally, i had a problem, b/c the bow and arrows were deleteing themselves after i got them
								but the other objects would not delete themselves, so i went ahead and created a rand_var1
								for link and threw in the item # into that var.  then during the link_get_item dual_state
								it checked to see if the item existed. if not, then it would add it back.  problem solved with
								dissappearing objects.
			- i added in the lift states, but i have not added in the logic to do the lifting of objects.  heck
						i have no objects to lift yet.  haha.			
			- fixed an error with the inventory getting the wrong object or putting the object in the wrong place.
						originally, i used the algo (x*y)-1 to change out the objects, but i redid that and came up with
						(x-1)+((y-1)*4).  now things work correctly.  i must have been tired that day.		
			- added in the no_save flag for the rooms, so you can flag rooms so you cannot use save in the start menu.
						- should be fully functional - need to test it later on.


	* 9/17/11 *
			- modified the animate_leaf so it would animate any random set of 4 gfx items.  now i can use it
					to animate rocks and pots "exploding" - just use pic2 for the id# of the "exploding pieces"
			- added in object type of rock, boulder, slashable terrain, pushable.
			- i modified can_move() to include the above 4 new obj types.  if it is one of those types, then link
					will not be able to move.  for future reference, if the object creates "stuck points" then just
					modify the w/h and whitespace of the object instead of fooling around with the main code.  the main
					code is tweaked just right, so just fool around with w/h & whitespace.		 
				- i also modded touch_object to include mobs as well, so mobs should not be able to move upon
						objects that are type rock, boulder, slashable terrain, or pushable. - i had to change the
						boomerang define from 5 to 205 to make sure it would work right. funny enough, adding in the
						mobs to touch_object() reduced the size of the game.
						
	* 9/18/11 *
			- added more sprites (i custom made a new set of sprites for the dungeon crystals for thier explosions.)
					- oddly enough, i only needed 1 sprite for the exploding of rocks and jars.  this seems to help a bit.
						since that was the case, i modded animate_leaf() so that you could pass in how many pics there were for
						the object to animate.  (either 1 or 4)
			- added in object type of follow_object.  this will allow the object to follow link at y-16, ie
					above his head.  i had to go in and add draw object() to links routine in order to get it to
					work correctly.  before, the object lagged behind, because of the offset of the timing of the 
					drawing of objects compared to drawing link in the main routine.  forcing the object to draw
					1 line of code before drawing link solved the problem of the lagging object.
			- modded delete obj to delete all vars in the object stats. - i had to do this, b/c the throw type 
					objects stayed in the que for some reason and kept on reappearing
			- i made it so that you could lift objects (rocks && boulders) - soon bombs will be added.
					- keep in mind that only objects can be lifted.  rocks that are drawn on the terrain cannot be lifted
						b/c they are part of the terrain, not an object on the field.  you will need to add rocks to the
						field via the sl.  you will need to add in the logic of "chk_room" to make sure you are in the
						correct room.  then add all of the rock objects you want.
			- you still need to add in the logic of whether you have the gauntlets or not before lifting.
			- i had to make can move() ignore type float_object, b/c link couldnt move up when carrying objects.

	* 9/19/11 *
			- finished up the throwing of objects.
			- modded touch_mob to include random objects in the object list.  oddly, this shrunk the size of the game.
				- now if an object is passed into touch_mob() then it will take its h/w and its whitespace offset
					and use that for collission detection, so you can throw things like pebbles and it should hit right.
			- found an error where the boomerang did not work.  i forgot that i redefined boomerang, but didnt update
					it in the editor, so after updateing it in the editor, it fixed the boomerang problem.
			- 44881 bytes so far.  i might be able to finish zelda before reaching the 65k limit :)  even with 90k ram
					free, i am not having any issues.  i will try to max out the ram until i get constant address errors
					- works fine on 70k of ram. - does not work at 50k  - works with 57k (this is assumming that it is unarchived)
					- ok 100k is needed for safe running if the program is archived.  if unarchived, then 57k is needed.
					- with external files, you are pulling up at least 32k into ram.  then you need to take into consideration 
							the rest of the overhead, which is what? 22k or more?
			- bombs work now.  all i need to do, is to add in damage dealt
					- using 4 touch mobs might be helpful, b/c you could get back multiple mobs.  better yet, just create a multi
							scan, ie scan though all of the mobs and see if the bomb touched them and if it did, then damage the mob.
							then continue scanning where you left off.				
			- damage to the bombs have been added, although it does not hurt the mobs yet.. only link gets hurt
			- also, there is an issue with throwing the bombs as well... -fixed the part where bombs are picked up but yet others
					added.  i basically went in and modded the routines so that it checked argh and at the end of throwing and object,
					argh=15, so other objects couldnt be dropped.  this seemed to prevent bombs being thrown and tossed out at the same
					time, but the objects keep having issues w/ not becoming a boom_bomb again.  - fixed - heh i forgot to add in var2++
					into the flying_bomb check.  hahaha.
			- bombs fully working.  yay!
			- i redid the timing of the wand again.  now i can get single shots for every time i press the button.  before, you would
					have to pause and hold down the button a little bit for it to shoot.  now it works just fine.  what i forgot is that 
					the wand stays on "frame" ==2, so putting the wand in frame 2 made it do a tri fire.  so i added if type==wand and 
					link_frame==2.  this prevented the wand from tri fireing.

	* 9/24/11 *
			- first week of training at job complete, so i decided to play a little with zelda
			- fixed the issue where the bombs did not kill the mobs.  actually, i had the cheking stmt wrong when trying to deal
					damage to the mob.  i had the check statment check to see if the mob was not underground then do nothing.  else
					deal damage.  so i i had to reverse this.  now the bomb deals damage do mobs above ground instead of underground.
			- added bombs to the random drop list.
			- added w/h/whitespace to the objects bomb2 and arrow2 (drop items)
			- added random drop to throwable items, like rocks,pots, etc after they hit the ground and explode. (just like in z64)
			- discovered a problem with the add_leaf();  this actaully added an extra leaf at 0,0. this is because delete object
					now deletes all info about the object instead of the object number.  before i was checking to see if object
					frame<5.  since the object info is all -1, it was a true stmt, so it displayed a leaf at 0,0.  instead, i added
					a return stmt after deleteing the object; thus, preventing the blow code from executing and displaying the object.
					after that, i went ahead and deleted the if stmt around the displaying of the object, b/c it was pointless at that
					time.
			- modded the test shop and added bombs behind the boomerang.
			- up to 46177 bytes
			- i may not imp the shovel.  i havent found a need for it for this version.


	* 9/25/11 *
			- there was a problem with bombs randomly appearing (in drop_obj)  w/o existing in the inventory. - well come to find 
					out, bomb was set to 0.  of course when you search in an arr of 0's you would get 0 back, so i change the value of 
					bomb to 20 which solved the problem of bombs random pop w/o it existing in the inventory.
			- in another effort to speed up the game, i added the config of making your hp display as hearts or as a number.
					if you choose a number, then your rupies will also display as well.  - the game does show speed improvements
					when you use a number instead of hearts, b/c it removes the drawing of the hearts.  also, it is configured that
					it uses the global hearts positioning system, so it will show up in the 4 corners if you want, although i did
					have to do minor adjusting of the numbers to get it to display correctly.
					- the annoying part of the emulator is the fact that it will be the same speed no matter what you throw onto
					the screen, so w or w/o hearts looks the same.  blah.
			- there was an error when link was as the very top of the screen that caused link to not throw the boomerang.
					more specifically, the y was set to <2, so the return of the boomerang kicked in and foced the boomerang to retun
					after it was thrown, so i modded item_boomerang() to check to see if the y pos of the boomerang (when added via
					addobject) was <2. if it was, then i forcted it to be 2.  this fixed the problem.
			- up to 46587 bytes after additions and fixings 
			- fixed the draw_image() so it would not go out of bounds. - i had to create defines for all of the sizes of the arrays,
					but it is worth it in the end.  it makes things easier like that.  - this will prevent memory errors
			- modded the wand and arrows to do the same thing as the boomerang: shoot when at the top of the screen.
			- added in the hookshot, although, the hookshot can only "hook" to 1 item right now: the treasure chest
				- you need to mod it to check for hookable objects as well.
				- i modded generic item to take into account hookshot, although the hookshot mods are in a seperate routime.
			- i modded can_move().  i seperated it out into 2 routines.  the new routine is terrain_contact().  this will check an area
					and return whether an object has touched a certain area on the map.  this is used in can_move() and for the hookshot.
					it will also be used to test whether a bomb hit a bombable area, like a wall.
			- up to 48182 bytes
					
	* 10/01/11 *
			- added in the ability for mobs to shoot objects out randomly.
			- in order to get mobs to shoot objects, give them an item in the special_atk.  it will
					see the item as a generic_damager() and will add the object to the list.
					it will do whatever damage you assigned to the item.
					- other special atks like chicken_attack and revenge_attack will <1000
			- there seems to be an issue where this shooting of objects by mobs causes slow downs. not
					sure why as of yet.
			- the forcing of object pics to not go out of bounds has caused some minor issues
					such as forcing link to not display correctly when in link_jump state.  well i did
					do some mods.  i am now forcing the drawobject in link_jump instead of at the
					end of animate_link(). then i did a return.  the hearts dont show up, but it does
					display the correct things for link falling.

	* 10/02/11 *
			- modded addobject so that it would search to see if an exact duplicate item is in the same
					place.  if it is, then it will not add another object of the exact same type within that
					area. (meaning that you wont drop double bombs on top of each other)
			- added in fix_xy().  this will allow objects that are thrown by link to stay on the screen
					and not be immediatly removed.  meaning that link can throw a boomerang in the far left
					bottom, top, and right of the screen w/o it being deleted directy after creation.
			- switched the talk and lift button to the diamond key.  this will prevent link from
					using an object while trying to throw one.
			- hookshot added to the shop
			- shield made a default item (for now)
			- removed merin (for the beta. - replace later on)
			- looks like it is ready for release.
			- up to 48665 bytes
			
	* 04/14/12 *
			been a while since i have poked at this.
			- made it so that the rooms would show up dark if the dark_room flag was true.



	* 04/17/12 *
		- added these 2 defines to the rooms:
				#define torches_to_be_lit 15
				#define torches_lit 16
				- this enables the rooms to have a ceratian ammount of torches to be lit in order to
					make something special happen within that room.
				- need to change dark_room to include the execution of the sl so that when the torches 
					are lit, this var can do more than one thing, such as open doors, add chests, hearts,
					special items, stairways, etc.
		- added the ability to modify the current room into the sl. #17
		- added the option to do set_room_info into the sl, in the event you wanted to do defines.
				just uncomment if you want it available.		
		- added in the ability to check to see if the current x/y coords of the room inside of the world map
				were the same you are standing in. - this will be used to unlock doors.	
		- worked on adding dungeon sprites.
		- seperated out the world gfx sprites and the other external files.  - the main editor file got 4 kb 
				too big to handle it in one file.  so not the external file are about 70k in size.  not bad i guess.
		- planned out some future additions, like execution of the sl after all creatures die and the modifications
				needed to be done to the dark room procedure to make it more expandable and teadmills.
		- created the blank terrain gfx list for future lists.
		- most of the sprites converted to hex.
		- seems as though the shovel idea will be cancelled. - maybe ill add some new things into it.
		- 48865


	* 04/19/12 *
		- added about 97 sprites to the dungeon gfx list.
		- created a test dungeon and found some more errors with my map editor.  - will fix this later.
		- created a universal map saver for tigcc.  this will help out in the future to make things go a lot faster
				when adding new world maps.  
		- did more planning on how the locked door system will work.		
		- this does not look like a lot, but adding in the sprites takes a really long time.
		- about 6+ hours of work put into this today.		



	* 04/20/12 *
		- added touching_sprite() to know what sprite i am standing on. - needed for treadmills
		- added treadmills
		- linked up the temp dungeon.
			- dark room and no_save flags are working.
			- no save message does not work correctly, though.

	* 10/06/12 *
		- been a while since ive played
		- thought of a new thing to do: allow it to randomly generate mobs for the rooms.  This way,
				i do not have to worry about as many mob lists and it makes making the game easier if it
				is auto generated.  - it added 1.2k to the code.
		- modded the mob gfx list from 24 sprites to 48.
		- modded world[][] to have a main mob list on it, which the mobs are generated from.
		- added num_of_mobs to the individual room stats.
		- -88 means randomly generate mobs.  - you still use the mob range, but add in num_of_mobs to get an
				amount of mobs in the room.
		- the mobs currently do not copy over from world_mob_list[][] to mob_list[][], so this needs to be fixed.
		- added in world_mob_list[][] and modded clr_mob_list() to include world_mob_list[][]
		- read random_mob_generator() for more info on how it works.

	* 10/07/12 *
		- fixed the rest of the random mob genertor, now it works
		- added in "super mobs" for fun and testing the dungeon and the random mob generator.
		- keep getting address errors - probably due to out of memory errors
			- in order to fix this, i will need to malloc all of the arrays and release them after
				the game ends.
		- modified the part where the sword only partially swings.  now you get a full swing after
				pressing 2nd once. - had to make it think that it was continusly being pressed.
		- added random super mobs to the test dungeon for extra fun.
		- released version 2.3


	* 10/08/12 *
		- worked on doing memory allocation today.  it ended in a whole lot of address errors
				i decided it was best to just let the calculator deal with the memory isses and not
				try to allocate anymore ram than the initial light and dark needed for greyscale. - 
				actually i might attempt to remove those if i can.
		- added in base sprite.		
		- error found - switching to  new world map may not work... it needs to be tested when walking
				from world map 1 to 2... etc.
		- found another error - lifting an object from above does not work - it was commented out, b/c
				it would lift objects to the side of link, which was very odd.  need to readjust x positioning
				to make it work.
		- allowed the room to check for rocks and autoplace them into the object list to be picked up by link.
		- im always getting address errors when i quit, though.
		- made the room auto check, check for if the room was a dark room.  if it was, then it would place
				torches.  also added it in so that if all torches were lit, then it would make it a lit room.
				- still seems to be an issue with the testing to see if the wand item is hitting the torch or
					not.  it usually takes quite a few tries before it finally hits the torch to light it.  it is
					pretty annoying.  i might need to set in a thing where if it is aiming for a torch object
					then maybe expand the range.

	* 10/09/12 *
		- added beginning screen and sprites for it. blah
		- modified it so that mobs would get double damage if spinslash == true
		- modified it so that mobs could take damage when they are in "reel back" state.
				- the state starts at 5, but you had to wait til 0 before you could do more
					damage to it.  it has been adjusted so that you can do damamge if state is <=2.
		- fixed it so that the mob will not stay in perm stunned state if you keep hitting it.
		- added in sprites and world map for the "choose which link" screen.
		- the beginning screen and choose link screen works.  i just need to add in the code
				for the pointer, nameing, name getting/displaying, hearts displaying, new saving conventions.
		- i did disable the game ending when link dies, however, i did make link burst into nothingness
				well... acutally, i just added the object, but link may still display.  i need to add in
				the continue/save asker.  i did find that the yn asker is worthless, so dispose of it.
				instead, use the msg box creator to make and display the yn and cont/save boxes as well.
				all you need to do, is specify which area to display it.  delete the ynbox and the blank_box()
				that is used by yn asker.
	  - world 999 and room 900/901 are reserved for the start screens.
	  - i had to separate out the world gfx files, world map files, and other files in separate editors
	  		they were just getting too big.

	* 10/10/12 *
			- been a nightmare of a day.
			- recoded most of the gfx arrays for the dll.
			- got link, mob, item gfx recoded for the dll
			- im not getting address errors anymore.. yay - well at least for now.
			- it seems as though the sword does constant double damage.  fix the routine so it will
					not always do double damage.  use another var or something.  make a new one if needed.
			- kept getting address errors, but learned that it was b/c i needed to run hw3patch.
			- also, learned that you could not do rom calls, b/c you are using a ro area.  how fascinating.
			- but a lot got done.  i would like to attempt to get the main gfx arrays and routines into
					the dll.  if that happens, then the main overhead should drop substantially.

	* 10/11/12 *
			- expanded the size of rotate list and gfx.
			- expanded size of mob gfx size to 48 from 39.
			- finally exported most of the arrays over to the dll.
				- all gfx arrays and methods are in the dll now.
			- searched and found code for strenlen and int to ascii, b/c rom calls are not supported
					so i just coded them in myself - how lame.
			- added in a double damage var, but it did not prevent the doulbe damamge.  however, 
					i went ahead and reduced the damamge done by half with the sword.  problem solved.
					it probably does double, b/c im forcing the 2nd to hold down.
			- address error 1111 when i used the wand with b.  i have to fire it a lot and afterwards, it
					errors.  old 8086 talks about array out of bounds errors.  not sure about that though.
					- fixed - origianlly, wierd things happened when i attempted to spilt the array into 2
							sections- 1 for a_ko and one for b_ko.  once i combined them and enlarged the array,
							well no more address errors. yay :)
			- got the select screen animated, but not fully working.  i still need to load the save info
					into it, hearts, and rupies, and name.  then display them.
			- got the name screen animated and working.  still need to have the f1 key store the name and
					then return to the select screen.
			- need to add a delete function into the select screen.  or just tell people how to do it manually.
			- added more gfx to the beg screen.  made room 902 (name creation)
			- still need to make a "game over" room (903) and put into it "continue/save"
			- i think i will release it after getting those screens working.		

	* 10/12/12 *
			- fixed boomerang so it will only return crystals, hearts, bombs, and arrows.
			- incresed random drop by 1 (8->7) - random drop of 0 = 100% chance of drop.
			- finished selection screen
			- finished death screen
			- need to create a LINK_DEATH state, so he will be animated to explode and then
					after that state is over, display to game over screen.  then it should be ready for release.
			- carry object is broken, however, you can create an array for only the carry object.
					so when you go into another room, it will not be deleted.  the carry object array will not erase
					when you change room to room and when you lift it, put it into the special array.  when you
					throw it, delete it from the special array and put it into the object array.
			- changed the word "exit" to "quit" in the start menu.

	* 10/08/13 *
			- looked for a solution for why the game would crash on the second attempt to run it. Found that 
					it was because of all the statics i had, so i removed all the static arrays, so they would not
					sit in ram.  this should allow the calculator the allocate the memory better and prevent the 
					address errors.
					- removed from both ezelda and zelda main code.  Funny, it reduced the program size in both...
						- if you still have issues, then attempt to use dynamic arrays.
			- created plan for locked doors.  look in the locked door section for more info.

	* 11/08/13 *
			- changed mob_gfx_size to 32 from 48 - this will allow for 4 mobs (8 sprites each).
			- changed max_mobs from 8 to 6
			- removed world_mob_placement (ezelda).  this is the 4x4x8 mob set.
			- removed the following dead routines in ezelda (fix later)
						clr_world_mob_placement
						g_world_mob_placement
						s_world_mob_placement
			- modded random_mob_generator - needs to be tested. - need to mod rmapy/x and then add
					in the new array "room_stats".  you need to check room_stats to see if to load mobs
					or not.
			- changed the x_mob_placement routines into x_room_stats routines and placed them into the correct c file.
			- 39 errors, which are all related to: rmapx(),rmapy(),  this should be removed and the errors should be 
					fixed so it can compile.  however, other coding is needed to make sure things work.
			- ezelda went down over 4k from removing the large arrays. 	
			- maps, sls, mob files will all have to be fixed before running this game.	
			- changed the ezelda dll version and id number

	* 11/09/13 *

			- fixed the compile errors; however, major coding issues still exists im sure.
				- about 1k lost from main code by removing code
			- removed the rmapx/y routines. - still need to remove from ezelda
			- some of the room loading routines need to be tested and recoded for the new way of doing things.

	* 11/10/13 *

			- modded the s/get_room_info() so it would allow for the modding of the s/g_room_stats(). 
			- had to remove the defines for locked_door_list and mobs_killed.  replaced with world_pos_x
				and world_pos_y.  the world_pos_x/y is used to put the current x/y location of this room
				on the world_map.  that location is compared to the current link location on the world map
				when attempting to load a room.  if they are the same, then they do not reload - this prevents
				a room from refreshing itself with mobs, sl, etc.  when you come out of something like the
				start menu.
			- kept the mobs_killed define and changed it to 1000 for the room_stats arr.
			- modded scroll_room() to always load_rooms if the room is different.
			- removed room_exists().  it was only used in scroll_room, which was delted out of scroll_room.
			- searched through main world for mob list conflicts and fixed them.  - added in 3 new mob lists.
			- found errors in the mapper and made sure the propper amount of elements were in the gfx arrays 
					for mobs and objects.
			- added in some logic to prevent out of bounds errors for the mob start/end.  found that the variable
					end was the same as a goto.  i attempted to remove the goto's, b/c it might cause addr errors.
					- you may need to search for more like this.
			-call_new_world_map() removed - was never used... wasted space from the old days - even before this 
					revamp.
			- fixed the error where the mobs would not repop in the event that you change world maps. - fixed under
						warper()
			- modded the spinslash where it will only blink and do double damage if you have max hp.
			- game is back in running condition.	
			- made it so that the field will automatically repop after about 12 to 15 minutes.  and made it so that
					the repop counter will reset in the event that you enter into another world[][].  this will prevent
					the annoyance of getting into a dungeon and having it repop on you 5 minutes into the dungeon.  
					- you might want to make it so that repop has different time spans based upon world map and dungeon 
							maps.  or make it scalable based upon the world map, so you can have a different repop rate
							for each map.

	* 11/16/13 *

			- removed all the shorts.  changed them to ints in order to avoid addr errors.
			- finnaly found the error that kept it crashing: i forgot to unload the dll at the end of the game.
			- now the main game is fixed and doesnt crash anymore.  however... i didnt need to make all these
					changes.  however, i may just keep them.  - i might have the room to load all the rooms into a single
					array.  it would take about 13k of space in the dll file to do so. - also, mobs could return to a
					set of 8 if i wanted to...  however, i might want a larger gfx file for link and objects.
						- in order to allow the rooms to stay static, just save them to a file in a tmp folder and
							when your repop timer goes off, simply delete all the tmp files.
							- test to see if the temp file exists, if not, then load the archived file. - always save after
								you exit the room. - this technique will prevent the dll from getting too big.
		
		*released 4.0*
								
			- added back the ability for rooms to remeber what changes were made to it, via the temp room idea.
				- created delete_temp_rooms() and temp_save_room();
				- modified scroll_room(), load_rooms(), and next_world_map();  					
			- added in the repop timer for rooms and modified the rooms for the repop timer.
					- set the repop timer to be a minimun of 2k, which is about 1.5 min or so. - if a room reads 0, then
						it would always reset on each loop, which is a pain.
					- repop timer is located at world[9][7] now.	
			- i allowed the terrain to repop with the mobs - for now.  
			- removed excess commented out code that has no more use.  if you need that later on, then pull up a
					archived version before this.
			- tweaked the terrain_contact() to allow me to walk into holes and to allow me to walk closer to objects.
			- added in the logging of where you enter the room for the hole falling stuff.
			- added LINK_HOLE_FALL define for his animation. - will be set as dual state, and link_stun as main state.
			- made it so link can fall down the holes.  
			- found error with link gfx file where the mask for the active shiled did not exist, so i added it.
			- added a check where link will only lift the rock with diamond and not a or b.
			- room lit still works.


	* 11/17/13 *

			- modded mod_obj() to prevent out of bounds errors.
			- removed the code from keys.c that checked for lift while pressing a or b.
			- added #20 into the sl_checker() to allow for the adding of treasure boxes.
			- changed SHADOW1 define, so it would not add to the object list.  
			- added code in AddObject() so it would not add an object with the id code of 0 or less
			- modded DrawImage() so SHADOW1 would convert back to 0, with the pic_num, to prevent errors.
			- modded chk_for_lift() to prevent keya or keyb from lifting the rocks. - now the rocks no longer lift under a or b
			- modded the link_stat() and added in inv_cols instead of the set number 30/60.  this will allow the code to change
					itself in the event that inv_cols ever changes in size. (done in ezelda)  
			- added in clear_inv() during the creation of a character to prevent overlapping of saves.  it also zeroes everything
					out, so it will prevent problems with getting treasure chests or problems with SL.
			- added s/get_treasure_marker() in ezelda and finally removed rmapx/y()
			
	* 11/19/13 *		
			- added mob gfx sprites. (about 6 mobs) - getting sprite maps off the net helped out a lot.
			- redesigned the mob gfx builder to use routines to add the mob gfx to the list, instead of having to make a whole
					bunch of lists individually.  now i can just call the routines and make any amount of lists i need just by calling
					routines to add the gfx to the lists. - this is much easier and much less insanity.

			
	* 11/21/13 *			
			- finished adding in extra mobs.  there are a total of 13 enemy sprites now with one towns people mob. - 14 total.
			- added over 1000 lines of code.
			- made the routine to setup and create the gfx files. - untested though.
			
	* 11/22/13 *			
			- extended inventory has been defined as an id over 5000.  normal inventory is now ID 1k to 5k
			- added rupie define and changed the treasure reoutine to accept rupie or an item.
			- i forgot that the item got stuff was already coded.  - done in 2011.  so i modded the code to use it, instead
					of recreating it. - the treasure box should work now... in theory...
			- modded the sl to only add a treasure box if it has not been gotten, so you can just put an open box on the map.
					or if you dont, then the box will dissappear. - you will need to mod the hookshot to accept connecting to an
					object treasure box - if you want.
			- fixed errors when pressing b and a at the same time would make the boomerang display. - im still not sure why the 
					boomerang displayes like that, so i just modded it so it would not happen.
			- hookshot has issues still.. - it still collapses after the release when facing left or right, but not on up or down.
						- here is the odd thing - it adds the pic of up. - maybe the direction is not correct - but it works sometimes...
						- it is not hitting a mob
						- it is still in existance at the end of animate_generic_damager().
						- it does not change to 51, but stays 33.
						- the x/y do not go out of bounds.
						- remove_hookshot() is called after leaving link from right or left
						- link is moving right or left with the hookshot (depending on dir facing) - this is what is causing the
								hookshot to end.  fix this and it might work right.
							- odd thing is, is that obj_var1 =33, which means he is trying to return to the hookshot.  so why is 
									the hookshot starting out at 33.  it shouldnt be at 33.  it should be different.
			- fixed the hookshot.  the terrain_contact() had to be modded back to the original for the hookshot to work, so 
					i simply added an exception into it so i wouldnt have to write a new routine.  - the exception uses the 
					#194, 185 pre defined	sprites to determine if it is the hookshot or not. so if you change this, then you will
					have to modify in both places.
			
	* 11/23/13 *			
			- fixed the sl issue with the shop not working.  - i did not update the editor to include sl_width define in both
					sl files.  this caused the problem (most likely) 
			- fixed #201 on sl. - make sure you use the real map locations without taking into consideration of rmapy/x
			- tested and fixed treasure boxes.  i messed up b/c i added an object of treasure box, but i thought it was
					an item, so instead of using object defines i was using item defines, which messed up everything.
					- i used obj_var1/2 and obj_dam for the slots for the treasure box.  obj_dam for the sl_slot
			- added in the 3 keys - boss, master, and normal (including defines)
			- added the keys to the inventory main screen.
			- created item_amt() - this will give the ammount of items that item has.  - it will be used for the keys
					- it will deterime if you have enough keys to open the door.  if not, then you wont open the door.
			- planning on making the routine for automatic door release when all mobs die. - this can be created soon.
			- this was a trial and error day.  lots of testing.  not much progress, but things work.
			
			
	* 11/24/13 *
			- made lift pot work
			- tweaked a lot of things so link could pick up an object better.
			- fixed the down object pickup. - had to add in +x and increased +y by 2.  now it is more specific and should
					pick up only the object to the south of link and not to either side.	- now he can pick up way far below...		
					- 2nd tweak.  redused y to +12 insteadl of +18.  this still picks up the object below him, but he has to be 
							pretty close to it
			- tweaked one of the warp points.  i was getting too far left or right and then going to the second room below
					(maybe that is the reason), but hopefully this tweak will prevent that from happening.
			- finally found the problem where the shadow appears. - i was getting 555 and trying to create an object
					with that.  so in the lift secion of dual_animation() i made it so that if var1 was 555, then it would
					not attempt to add an object, instead it would reset the link state and break out.
			- tweaked the terrain checker some more to let link move in more places.  fixed the point where link can go all
					the way down and then move left or right. before he couldnt do this. - lots of terrain stuff fixed.
			- made the mob doors auto open when all mobs are dead.
					- also added in a section where it would move link in the event he entered the room and there was a locked door
							in the area where he was standing.
			- g/set_room_info() moved to ezelda
			- door_scan() created in ezelda.
			- made the rock and pots have an id of 500+ - they are no longer in the world gfx system
					- instead i modded the routine to add the rocks and pots if it saw 500+.
					- modded the gfx system so if it saw 500+, then it would print the base_sprite instead, however, since you are
							adding an object over the top of it, the base sprite doesnt matter that much. - need to change the rock
							and pot in the item jpegs to 500+
			- added in the ability for locked doors to unlock. - unlock_door() was added to link_gfx.c
			
			
	* 11/25/13 *
			- jump was broken, so i modded terrain_contact() and added numbers specifically for jump. now link can jump again
					however, you need a running start sometimes.
			- added new mobs to the dungeon - you can fire the sword w/o issues
			- made it so that you could not walk on the treasure chest objects.					
			
			
	* 11/26/13 *	
			- worked on the map making ide today.
					- currently working on the "redo room numbers ()" under world_saver.h
					- need to create input box.		
			- fixed it so that the settings for your save folder and image folder are saved under the main room list 
					file that you currently work with
			- redesigned the thing, so it will save the room files as one large arr that is in [64][10][10]
			- made it so that [64] would be variable based upon how many rooms there are
			- still need to create the thing that will copy a single room.
			- still need to create a thing that will update the world[][] based upon the textbox world area, which would
					grab every input and put it into world[][]
			- all you need to do, is to pull a world file and it will pull the corresponding room_set[][] and autoload.
			- the thing now just stores info in the main arr[][][][] and the world[][] instead of pulling gfx files
					and reloading them all the time.  this should make things a bit better when saving.  hopefully, it will
					fix all the saving errors.
			- it is now set up, so all you have to do, is to open the room_set_x and world_x files and do a copy and paste
					into the external room editor.  then run a loop to create all the room files and the world file. - very easy setup.
			- new way should allow for hyper map creation, especially dungeons.
					- still need to create a dungeon viewer - figure out how to align all the pics in a single picbox
			
	* 11/27/13 *
			- fixed issues with the key in the menu always showing no matter what menu im in.  			
			- modded the warp points
			- mooded the world files.
			- fire still hitting link in the dungeon. - so fire damage to link temporally removed.
			- tested on normal calc. - worked fine
			- added in some logic so if you loaded the wrong dll, then it would quit instead of infinit loop.
			
		-failed - *released 4.1b* - internet too slow - times out.  will retry monday.	
			
			- add_key added to defines for the room[][]
			
			
			
	* 11/28/13 * -> 	* 11/29/13 *
			- mostly finished the ide for making maps.
			- updated the room and world stats on the ide
			- added in map viewer
			- added in undo and redo (for each room)
			- added in settings saver
			- added in ability to save various sprite lists for quick access
			- ide should be usuable w/o issues
	

	* 11/30/13 *
			- added in debug option for start menu - remove for release
			- added clear out stats and delete temp rooms when you die and decide to continue.
			- redid the world map and added the temp one i created while working at microsoft.
			- found an error in the map creating routine in mapper.tpr and fixed it so the rooms would
					load correctly.
			- tweaked and modded the new dungeon and world map to work right
					- had to redo the warps on most things.					
			- fixed - found a bug - you can fall down a hole when a sealed door exists and it will drop you right
					- onto that door, then you can exit to the <direction> and leave the sealed room. this is bad.
			- fixed - found a bug - doors dont open when all mobs are already dead. - added in door_scan() under
					get_map_vars to check for doors in the event all mobs are dead.
			- modded the random mob placer to look at the sprite in the room arr itself instead of relying on
					can_move().  this prevents mobs from showing up in strange places.  however, some of the mobs tend
					to stay grouped together until you hit them.
			- added key_gotten define
			- modded get_map_vars() and made it so that if you have not gotten the key and a key exists in the
					room, then it will automatically reload the mobs.
			- the unlocking of the doors didnt work right - it would remove a non door sprite and leave the door.
					- i adjusted the numbers and added some logic to attempt to make it work right. - needs more testing
						- left door works right
						- up working
						- right untested
						- down untested
			- bug - if world map==0, then it atempts to load it.  this is an issue. - need to fix it.
					- in next_world_map(), i defaulted file to 4 if it was <=0.  in the release you will need to change this to the new
						default world map.
			- forced the game_over area to force save the current world map to link to prevent it from loading 0.
			- fixed - bug - if you dont kill all the mobs when you get the key, then it will reload the mobs with another key, 
						so infini keys
			- added num_of_room_stats define in ezelda
			- fixed errors in ide 
						- tried to load from file instead of looking at arr[][], so i made it look at arr[][]
						- saving sprite lists had issues, so it is fixed
						- the ide is in 64 bit.  need to make it 32 instead.
						- added in ability to add a base sprite to everything.
						- other things tweaked/fixed that i cant remember.
						- works great.

	* 12/2/13 *			
			
			*released 4.1b/c*
			
			- fixed the place in ezelda where the animated sprites start at 34 instead of 30, now all walkthoguh walls work.
			- updated the main work place to be in zelda 4.1c instead of the old folder. - this prevents me from having to erase
					all .s and .pdf files from the old stuff.  - makes it faster for release.
			- added in the new sprite list for the newer update.		
			
	* 12/7/13 *
			- added in sprites for heart container, gauntlets and bomb bag
			- added in items for heart container, gauntlets and bomb bag
			- added in ability to get heart containers, gauntlets and bomb bag
			- added defines for heart container, gauntlets and bomb bag			
			- added defines for tunic, ring, and raft.
			- imped the fact that you cant lift things without the gauntlets.
			- added gauntlets to the start menu.
			- added bomb bag to the start menu
			- defines added for tunic, ring, rupie bag
			- items added for tunic, ring, rupie bag
			- added tunic, ring, rupie bag to the sart menu
			- added in damage reducer if you have the tunic and / or the ring. (in pain())
			- added in room sprite 502.  - this is the pushable stone thingie.
			- made the push stones - used 502 for the sprite id
			- modified rom_obj_adder() to auto add in push stone objects to the room.
			- modded can_move() to allow sprite# 502 to be walked upon.
			- added in precision_move() for the stone moving ability.
			- modded the animate_object() with a set of x/y modifiers for touch_object() just like can_move() has, so it would
						act the same with objects.  in fact, can_move() was preventing push stones from working b/c it had increased the
						boundries, so the touch_object() in animate_object() would never fire; thus, preventing you from getting close 
						enough to the push stones.
			- tested the tunic and ring combo.  it reduces damage by 75%.
			- increased item_gfx list to 60 - will have to expand more later.
			
			
	* 12/8/13 *			
			- had clr_inv() below get_name() which is the reason why the name kept on blanking out.  so i reversed.
					this should fix the no name issue.
			- decided to use sprite #46 to 49 for the replace sprite for the bombed wall
			- allocated #192 -> 199 for bombable walls (2 sets of 4)
			- bombable walls work like this:
					- 2 sets of 4 sprites.  
					- #192 & #196 gets replaced with #46
					- #193 & #197 gets replaced with #47
						... and so on.
			- added in the sprite sets for the overworld and the dungeon sprite list for the bombable walls
			- added in the replacement sprites for both gfx files, b/c they are the same.
			- added in precision_sprite_find() to allow me to see if i am touching the correct sprite. - will be needed
					for locked doors and bombable walls.
			- found animate_terrain stuff in DrawTerrain() so i fixed it to only allow the new animation.
			- added in the ability for bombs to blow holes in the walls. - under exploding_bomb()
			- added hover_boots define and gfx
			- added hole_walkling() and moved code from walking() to hole_walkling().  then put hole_walking() in the main 
					routine, so it would always run and not just have a certain amount of steps you can take before falling into 
					the hole.  this prevents people from walking onto a hole and attacking mobs. - it is an exploit. - this prevents
					that exploit.
			- hole_walking() made the game freeze when you fell down a hole b/c it kept rewriting links stats, so i put it to
					only activate in the event that link is not falling down a hole.
			- tweaked the hover boots to walk over 2 holes and have enough time to get back to safe ground in the event that 
					a mob hits you into a hole, but you have to be fast. any stopping or detours over the 2 holes will make you fall.
			- added raft sprite and item.	
			- added raft to the start menu.
			- tweaked start menu to look better.	
			- added rafting() but incomplete.
			- left errors to know where i left off.  just compile and fix. - or comment out error to compile correctly.
			- fixed the main map flower sprites. - now the flowers display again.
			- will make the bottles in the next release. - adjusted todo list for this.
			- modded 4.1 to 4.2 in the beginning screen.
			
	* 12/9/13 *				
			- modded move_link() to prevent him from going too far out of bounds.
			- found discrepancies: built_in_gfx.h had refrences to obj_buffered() and dir_to_rotate().  they were removed.
			- found an error from 11-23-13 where i modded hookshot.  well originally the hookshot was predefined up to
					sprite 194.  since i put bombable walls in this area, i had to modify the predefined hookshot sprites from 
					194 to 191. - hopefully, this will prevent odd errors.
			- game crashed like crazy when doing the raft.  however, i discovered that the raft object would delete and when
					i attempted to get its location, it would return 555, and move_object() would attempt to get loc 555, which is
					way out of bounds, thus, crash.  so i added in logic in move_object() to not do anything if loc was out of bounds.
			- added logic to prevent out of bounds errors in delete_object()
			- made the raft work - but it took all day long.  my mind was not working today.
			- gfx id# 54 is now a special sprite for water only. - this is used by the raft.
			- fixed things so max hp does not go over 8*16 (16 heart contaiers) - in ezelda
			- found that getting my newly added items (12-7-13)(raft, heart container, tunic,etc...) did not "get" when 
					getting out of a treasure chest.  modified chk_for_treasure() and added the items to it.
			- added links name to the start menu.
			
			
			
	* 12/13/13 *	- insanity begins - the recode:
		
			- i discovered that i could pass in the addresses of the light/dark plane once in the beginning and then it would
					work for the rest of the game (tabune).	- however, i will add it into the main loop to be sure it always is correct.		
			- added the following routines to ezelda:
			
			objects:
			&get_object, &set_object, &move_object, &duplicate_checker, &add_object,
			&obj_loc, &clr_object, &delete_obj, &num_of_objects, &increase_object,
			
			// items
			&get_item, &set_item, &item_loc, &get_item_info, &item_type_exists, 
			&quest_loc, &add_quest, &quest_exists,
			
			//animations
			&animate_leaf_1, &drop_item, &slash_terrain, &set_object_animate_info, &animate_bomb,
			&fix_xy, &animate_explode,
						
			// new room stuff
			&set_all_maps, &get_all_maps
			
			- added about 7k to ezelda.  but i also added a full room set 8x8x10x10 as well, so ezelda is up to 62k.
			
			- major modifications to mod_mob() - need to test it
			- although i transferred a whole bunch of code to ezelda, the main game came out 500 bytes larger?  probably due to
					all the s/get_objects().  attempt to transfer over as much of the gfx animation as possible.  this may reduce size.
					- also, remove as many ezelda dll defines from the main zelda game.
					
			- i deleted the main define.h file from ezelda then forced it to point to the defines.h file in the z_source. - this
					should help with a lot of errors with defines being wrong.
			- i went through the ezelda code and updated all the get/set routines so that it prevented out of bounds errors. in fact,
					the new set routines do nothing if out of bounds.  all it does is break out of that routine in the event of out of
					bounds setting of an array, so the array never gets updated.  so if you attempt to set something and it does not change
					then check the bounds of it and see if it is oob.
					
			- now it is time to create precision sprite collision detection. - or create your new heart routine.
			

	* 12/14/13 *

			- found that the gfx routines in ezelda used type int instead of 	unsigned short.  so i change them all
			- you still need to compare the .h routines to the .c routines.  there were inconsistancies in ezelda too.
					- also, compare the dll defines in zelda to the .c routines as well.
			- collide() created in eafw.  now it is time to remove the CheckAreaCollision(). 
			- mob height and width created - this will be used to help calculate how many sprites there are.
				- also, all the mobs will need to be changed as well as the routines. - especially the ones that use
						collide()
			- mod_stats increased to 30 to add in the height and width. - you need to mod all the mobs in editor();
			- mob_h and mob_w defines added
			- crerated movable() - but you need to add in link_x/y one way or another.
			- defines inv_link_x/y, which replace the room_x/y defines.  now, you will put the pos of link into 
					the stats of link, so it can be accessable through the rest of the routine. - i think i will half-ass
					the coding and just force the inv_link_x/y to update via the main routine, right before animate_link()
					- or maybe just add it to move_link() - added it to move_link() and get_inv() (where the save file is loaded)
						- this should take care of the link moving issues.
			- added inv_link_speed define so i could access the speed of link via ezelda
			- added touch_object and touch_mob to ezelda
			- after insane amount of address errors, it was discovered that adding the 8x8x10x10 to the ezelda was a really
					bad idea, b/c it took too much memory.  in reality, zelda couldnt load something that big, due to memory restrictions.
					things are now a 4x4x10x10 so it is 10k less, but be careful, b/c 10k more and it crashes... maybe.
			- i checked some new stuff.  it seems i can get eafw up to 64k, but i just cant load any large arrays in zelda.
					this takes too much ram.  so, i can move routines to eafw, but just not get any more large arrays.

	* 12/15/13 *
		- decided on the design for the overworld. - see upper part of zelda.c for details
		- rewrote the map editor to combine 4 world files into one overworld and output rset files (which contain
				16 rooms).  now we no longer have 1k files to deal with.

	* 12/18/13 *
			- added in extgraph into ezelda, following Lionel's advice.  Graphics speedups are a lot.  I will have to add in
					a gfx speed throttler (new menu item in start menu) to adjust the speed of the game.  however, the mask routine
					does not work well with the blinking of the mobs and link.  this will have to be fixed.
			- planning.c created.  this was so i could move 1000+ lines of comments of planning from zelda to somewhere else.
					- this helps to clean up code.
	
	* 12/20/13 *	
			- added ow_x/y to the defines.  this is used for the overworld[][] x/ypos.  
			- added oob()			
			- redid warper() to auto set the x/y low/high coordinates based off of the sprite location.
			- redesigned the warp[][] defines, so the format of warp[][] has changed.		
			- decided to remove the room_stats[][] so i no longer have to deal with it.  return it back to the old way.
			- repop timer removed due to the fact that room_stats[][] no longer exists.
			- removed current_locked_doors - so make sure it doesnt exist somewhere else.
			- removed current_world - depreciated and removed.
			- found a whole bunch of get/set routines in ezelda that were worthless and never used. - they need to be removed
					entirely.  - see planning.c for more info on which ones to remove.
			- went through ezelda some more and made the get routines return -6666 in the event that it was out of bounds instead of
					attempting to fix the bounds.  this should prevent some strange errors and give you a new error code to let you
					know that the get() is out of bounds. 
			- ezelda went down about 1k after doing the returns in the get()s and commenting out the worthless get/set routines that
					were never used.	
			- changed current_room() to current_rset()	
			- removed repop entirely.  hopefully all variables associated with it are gone now.
			- added in: pull_new_map(), world_init(), init_terrain(), load_rset(), load_ow_map(), 
			- removed: next_world_map() (replaced by init_terrain(), world_init(), pull_new_map())
			- removed load_rooms() (replaced by load_rset() and the rest was put into get_map_vars())
			- now do a pull_new_map, then world_init, then get_map_vars()
					- or pull init_terrain() and it should do everything. - if checks were put into the
						loading of the maps, so if either the ow map or the rset does not load, then
						it will do nothing.
			- modded the get_map_vars() and removed the while loop. this may have broken some things, but it reduced the
					lines of code.
			- modded scroll_room() - added in the logic to pass between rsets and worlds into it. - lots of testing needed
			- finally got it to compile, but it seems as though things are not loading correctly. - well at least the terrain
					doesnt show up... its 1 am... time for bed

	* 12/21/13 *
			- added in better crash handling for failed attempt at loading the dll.
			- map editor had an issue and teneded to clear out the world file before it set the world stats.  so the world stat setting
					was put before the clearing out of the world.  now the world settings in the overworld work right.
			- load_rset() had a,b and i,k reversed with the setting of the rset.  this caused odd problems
			- created "err" sprite. - current location is at sprite 0 of beg screen gfx set. 
			- forced world_map[11][6] to be the rset of where link starts. - this did not exist before, so it is quite important
					that you imp it in every map.
			- forgot to load the ow_id and rset_id in the "open save".  now the save will open properly.
			- finally got the new rooms and world sets to load properly. - warper still messed up...
			- removed shift_image from draw_terrain.  replaced with GrayClipSprite16_XOR_R().  
			- added the following to ezelda:
					&move_mob,&change_dir,&mod_digger,&mod_crab,&animate_chicken
			- removed a bunch of worhtless routines in ezelda.  follow the errors on compile and replace with the new routines.
					- dont forget the check for the .h declarations...
			- shortened the arguments needed for draw image and drawterrain()
			- modified drawimage and got rid of shiftimage()
			- the new rotate still does not work...
			- modified the collide routine.  you need to check to see if the bounds work on it or not...

	* 12/22/13 *
			- fixed the errors i created when moving stuff to ezelda... - 2k up in ezelda and 3k down in zelda... not bad
			- created LINK_DEAD attribute and modified pain to modify link_state instead of calling death();
			- moved pain and death to ezelda.  link_frame=0 was removed from pain, so you will have to fiddle with it to make things
						look and work right.
			- link state LINK_REEL_BACK_NO_DAMAGE was added so i could "call" gfx_reel_back() in ezelda
			- double damage was removed from pain.  you will need to figure out another way to deal double damage.
			- added clr_planes()
			- added in fastmemcopy - which included in adding in extgraph to this.
			- found that i could just memset light/dark, instead of the getplanes.  this makes things easier...
			- created draw_hearts() in ezelda.  it now has sped up the game a bit more.  it appears that it is faster to draw
					7 hearts then it is to draw the printf_xy(<hp> ,<rupies>).  This is a good speedup.  Even in debug mode, it runs
					faster than it did normally.  - it removed about 200 bytes from the main but added about 900 to ezelda.
			- added the following to ezelda, which replaced routine_x()...  format <new> - <old>:
						
						add_item_inv - s_object_tmp_pic
						inv_item_loc - s_image_buffer
						item_amt - rotate_image
			
						exploding_bomb - g_object_pic
						animate_fire - g_image_buffer
						animate_throw_object - ShiftImage
						
						touching_sprite - clr_room_stats
						precision_move - g_room_stats
						precision_sprite_find - s_room_stats
						
						move_mob, - mob_direct_draw
						change_dir, - g_link_pic
						mod_digger, - buffer_obj_direct_draw
						mod_crab, - link_direct_draw
						animate_chicken - obj_direct_draw
						
						death - g_mob_pic
						pain - g_object_tmp_pic

			- reduced the zelda down to 51492.  increased ezelda 56827
			- the above replaced routines were old and worthless after the recode.  some of them were never used... you need to go
						through all the ext_vars and see if they are used in zelda.  if not, then remove them.
			- tried to make the set_gfx routines to be passed in unsigned shorts.  double check this to make sure it is true.
			- its late. time for bed.


	* 12/23/13 *
			- figured out how rotate works from extgraph.  it is about the same speed as though the rotate never happened.
			- redesigned the rotate sequence - removed the rotate buffer - fast enough, no longer needed.
			- redesigned the blink - made it stop displaying instead of changing the mask.  actually, making it blink the old
					way, i could not figure out, so i made a temporary stop in displaying the sprite in order to obtain a "blink"
					effect.
			- redesigning the above removed about 3k worth of stuff from ezelda.  i might be able to handle a whole 8x8 world
					in ezelda.
			- changed max mobs to 8 and obj gfx list to 75
			- changed circle_dir to clockwise instead of counter clockwise
			- added in death animation to link.  - it should also remove all monsters from the room when you die.
			- added LINK_DEAD to dual state and state
			- enabled the thing to load a full 8x8 map of world rooms into ezelda - this is slow, though.
			- tossed room_entry_x/y into scroll room.  hopefully it will work right.


	* 12/24/13 *
			- at 2am, i asked God to show me how to rewrite can_move to be perfect.  he gave me the idea and how to do
					triangular checking.  i wrote it down and then coded it today.  it is tweaked for near perfection.
			- wrote the explanation on how the triangular checking system worked (in mathy - in ezelda)
			- not much done today - family reunion and still tired from all the cleaning.  still more to do.

	* 12/25/13 *
			- added in the ability to press the esc key during the name_screen() so i could cancel making a name.
			- played with the message system today.
				- redesigned the system so that it would display on the current set of planes.  now things dont dissappear when you
						get a message or call msg().
			- removed bl_box(). - it held a perm 32x sprite in it.  now i use the drawbox??? functions from extgraph and then draw lines
					around it to make it look pretty.  
			- i recoded all the message box gfx to include the drawbox??? functions and the greydrawline()s. 
			- i tried to use the GrayDrawStr(), but this did not do what i wanted, so i created my own, using code from timiner.
					now the things draws the print to the planes instead of the lcd, like print_xy() did.  also, it takes less overhead
					to use the new function: add_print() instead of print_xy().  almost all printf_xy() are gone and replaced with add_print().
		  - used GrayDrawStr() on the beginning screens, b/c it printed white on black.  It was the only places that it mattered, even
		  		though it does take up a little bit more space.		- however, the compiler optomized it and it went lower after adding it
		  		to the continue screen. cool...
		  - recoded the start menu system to include add_print() and the greyline draw routines. 


	* 12/26/13 *
			- modded room_object_adder() in the torch section to 58, b/c 54 is used for rafting. 
			- found that scroll_room() didnt have set_room_vars(), so i added it.  this allowed things to load again.
			- the mobs didnt load, b/c the old mob files failed to load, so after i added the new ones, they loaded again.
					this was due to size difference (b/c i changed the size of moblist again.)
			- created set_link_sprite_loc() that will set links x/y corrds to a sprite (if he is touching it.) - this was created
					b/c the touch_sprite() is more exact and sensative, so hole_walking() would put link in the wrong place for the
					falling hole.  so i created the new routine to put him in the correct location.
			- i tweaked the sword system to not hit mobs that it does not touch.
			- i found that the game_over() screen didnt load, so i had to force load it again. 
			- i cant get the link_jump to work, so i will just remove it entirely.


	* 12/27/13 *
			- redefined key gotten
			- set_oob() had the wrong values, so it was set correctly.
			- made clr_scr a define.
			- created set_rset()
			- created disp_error() to handle displaying of in game errors. - although, i could use msg() to do the same thing.
			- modded init_terrain() and load_rset() to handle error handling better and to make the "loading...." do better.
			- the "choose game" in the select_menu() in the beginning of the game would not load the ow file and the map file,
					b/c it would load the inv[][], which contained the ow_id definition, which happened to be the file i was trying to
					load.  since load_ow_file() has an if stmt in it that says: if ow_id == file, then dont load, the file refused to 
					load.  so what i did was i forced ow_id to be 32k, which you should never obtain, and did a  mod_link(ow_id, 32000,TRUE);
					bafore the init_terrain().  this should change the ow_id, which loaded with the save and then allow the save_ow_id 
					to actually load.   
			- moved disp_hearts() to zelda. - increased size by 1k as expected, but i will attempt a reverse routine.
			- added the ability to offset the heart displaying, so it draws on the edge of the screen instead of the center of the screen.
			- removed the numeric hearts. - this is pointless now, b/c hearts display fast enough with the current routine.
			- redid world_loc and set_link_sprite_loc defines. 
			- moved current_rset() to zelda
			- fixed the can_move() in ezelda and replaced with movable()
			
	* 12/28/13 *		- about 70 days int total ive worked on this.	- avg of 10 hours per day, so about 700 hours invested. - about 17
										work weeks...
			- found that i was still trying to pull warp and sl files using the var "i", which was part of an old removed loop. i replaced
					those i's with get_room_stat(xxx), which pulls the correct file.
			- found that i did not already have the map_x/y set in the start(), which caused me problems, b/c i attempted to load the 
					map_xy, via set_oob(), which was bad for start.  instead i changed things around to test to see if oob ==new map, if not, 
					then i would attempt to find the world map and then load it if i could.
			- found mistype in move_link() where it should have been link_x instead of link_y with the out of bounds errors. 
			- found why load_rset() would not work.  in place of the 0,0 or 0,2 params i passed in, i passed in i,k.  this didnt work,
					b/c i needed a constant, not a variable.  now the maps load right via warper.
			- mapper changes worlds like it should now....
			- modded touch object so it would flip the width and height of an object in the event it was travelling left/right.
					- also modded things so it would accept a 32x32 or 32x16 or 16x32 sprite. - although, there are no plans for that large of
							an object???...
			- created object_stat_flip() in ezelda to allow for the reversing the w/height of an object when it is facing left or right.
			- modded touch_mob() to be similar to touch object.  it can compensate for 32x32 mobs and such
			- tested touch_mob() and it seems to work
			- gfx_reel_back() had issues.  first off, it would push link into a non movable zone, so i modded it to use move_link() instead
						of forcing link to move.  this standardized the bounds for link.  also, i recoded it, so it was more effencient.  now
						it is 600 bytes less in size...
			- found a lot of redundancy in add_object(), so i removed it.  saved 230 bytes or so.  also removed all teh whitespace stuff.			
			- removed the whitespace defines. - no compile errors.			
			- added the obj_x/y_oob defines.  these will tell you how far the objects can go out of bounds.  - they were in at least
					3 locations.  this is an annoying issue.  so i created the defines for them.
			- hookshot is broken.... it doesnt blink right.
			


	* 12/29/13 *
			- added into map editor the scan ability that it will scan and if all rooms are blank, then it will not created the rset.
			- now only 16 rsets exists - so about 52k worth of maps
			- redid world11, so all the houses are in one rset.
			- fixed fill dungeon map, so it will grab the world map and then fill dung_map with the world[][] info.
			- added get_any_room_info(), so i could get the info of any room currently loaded. - untested.
			- forced triangulation checker to reset the global vals, to make sure that values do not linger around, which would cause
					irrigular checking.
			- made adjustments to the warper to make it work better.
			- adjusted the warp points to work right.
			- need to test more with the warper.

	* 12/30/13 *
			- tweaked the oob for the scroll_room().  adjusted all ranges to be ouside of the map by 8 pixels on all sides before
					scroll room takes effect.  this essentially broke the triangulation detection system a little, so i added in some
					logic that prevented the get_all_maps() from going out of bounds.  now there are no more errors.
			- tweaked the warper to include x==0.  now you can move further left before you warp.
			- created create_warp_point_set() in the map editor to automatically create a set up a return warp point for me.
					now you can do 2 warp points in one call instead of trying to figure out 2 calls.
			- created same_map define and modded warper that if you were warping in the same map, then you would not even attempt to
					find out if you were in the same rset  or same ow - instead it will simply readjust links coords and then load
					the room - makes things faster and so i dont have to figure out the stupid ow and rsets.
			- reduced warp_points to 11 from 16. found that my warping problem was b/c i had warp points for other dungeons in other
					dungeons.  when it checked for the current room #id, it was good, but now it checks for xy coords, which can apply to
					any dungeon.  now i just need more warp files, say 1 per dungeon, instead of grouping multiple dungeons together.
					- you can still use multiple warp files per map if you really need to, like for the warper castle.		
			- changed the warping from a specific rset to a world #.  this makes my life easier than attempting to calcualte rsets		
			- some warp points working.  more testing needed.		
					

	* 1/1/14 *

			- modded touch_object() to include mobs.
			- added touch_object() to movable(), so mobs or link wont wonder onto objects.					
			- created offset_calculate() to calculate the ofset of w/h to the x/y coords. - this allows me to modify one spot 
					in order to add things like 48x48 sprites.
			- the boundscollide() did not work the way i wanted it to, so i ask God to show me the best way to do it and he did. praise Jesus.
					it works perfectly for this game.  it tests if 2 things have collided by checking to see if they did not collide, which takes
					less detection techniques than if you attempted to check all corners if they collided.
			- animate_explode() modded.
			- changed the w/h of the drop objects again. - to work better with the new collide routine.
			- modded walking() to add touch sprite(54) in attempt to do rafting.  this should fix the rafting problems... or create more
			- removed rafting() and put some of the stuff in walking() - added more logic to walking as well, to take into account rafting.
					- now rafting works flawlessly.  - had to add !=raft into touch object, so remove the fact that i was touching the raft.
			- made the movable() do less calculations, so things should go a little faster. - but added teh touch object stuff, so it might
					move at the same speed or slower now...
			- modded touch_object() to be able to detect if one object hits another.
			- found the reason why link would stop spinning mid spin cycle - his frame was reset when touched by a mob, so this was
					removed. - it was annoying when being touched by butterflys when doing spinslash...
			- finally got the push stones working right again.  - removed the main push stone routine from animate object to its own 
					seperate routine and it is called in walking().


	* 1/3/14 *
			- removed terrain contact.  replaced with touching_sprite_range(). - saved about 100 bytes.
			- added in link_dir in sl and modded the x/y setting to include the mod_link().
			- the hookshot seems to work out with using touching_sprite_range().
			- modded the beginning sl to load correctly. 
			- managed to get things to blink like in the old days... - i forced the planes to switch if i wanted to draw A_reverse.  
					this gave an impression of "blinking" and it only took 4 bytes to accomplish this.  yay.
			- modded draw_prices() to use add_print() instead of printf_xy().
			- found the issue with fire not blinking- i used increase_object, instead of set_object
			- modded fire to blink differently.
			- added a 2nd blink state "A_XOR", which prevents the object from displaying, so you can pass in A_XOR and keep an image from 
					being displayed.
			- fixed it so that the hookshot would not put you inside of the sprite, but right on the outside of it.
			- added out of bounds protections for terrain gfx.
			- added in some logic to prevent an object from testing to see if it will collide with itself.
			- cleaned up animate_drop_obj() a little and reduced size by 200 bytes....
			- modded check_for_treasure() and animate_drop_obj() again to get rid of the checks for the external inventory items.
			- forced add_item_inv() to automatically add external items to the external part.  this should make it so that there is only 
					one routine that deals with the external items.
			- found that hole walking interferred with hookshot, so i hole_walking() to ignore dual_state==hookshot
			- changed links hookshot travelling pic to the hole falling pic, b/c it is funnier.
			- created reload(), which is all the stuff from the loading of a save file.  then i used this routine for continue and for 
					loading a saved game.
			- almost everything is back to the way it used to be...  need to finish checking the warping stuff.  need to mod the room 
					files so they use	the proper sprites.  - need to clean code.

	* 1/4/14 *
			- checked the header file prototypes for consistancy with the functions throughout zelda.  everything is now in check
					- removed the link_stats.c/h files.  it only contained 1 routine - moved to link_gfx.
					- removed a whole bunch of mathy stuff that wasnt used.
			- modded scroll_room() to have less code.
			- modded gfx_loader() to be more effecient
			- modded mob_gfx_loader() and saved over 200 bytes
			- modded link_gfx_loader() and saved a whole bunch.  modding the 3 gfx loaders saved about 1k



	* 1/5/14 *
			- i tried putting all vars into 1 .h file, but it increased the size by 2k.  so this is bad, so forget it.
			- optomized draw_gotten_objects()
			- tweaked slow() so it would work about right with the speed limiter
			- imped the speed limiter and added slow() after every single animate routine in DrawScreen() to make sure it
					would slow down every aspect and not just 1 aspect.  if you place one slow() at the top, then it will be choppy,
					however, if you have 5 sets of slows(), then it will equalize everything and will not be choppy.
			- fixed the torches==54 to 58.  in both ezelda and zelda.  now the torches display like they used to.  thanks to the
					modding of touch object, the generic damager now will touch the torches and light them.
			- modded the dungeon maps from #54 to #58.

	* 1/6/14 *
			- added about 10 mob sprite sets. (about 87 sprites)
			- added bottle sprites and quiver sprites. - about 10 sprites.


	* 1/7/14 *
			- fixed the innability to move up when holding an object - i forgot an if statment, so i pulled it from the old code and
					now it works again.
			- decided to add a new array... it will be a list of projectiles for a mob to use.  it will have the ID range of 9000+.
					- it will take less room, b/c it will need 5 stats instead of 11.  this should save space.  it will use the item
							sprites, though.


	* 1/10/14 *
			- changed directory layout of the saves.  each save now has its own dir, mainly because each save will have multiple
					files within it.  Also, trying to remove individual files didnt really work, so i used folderclear() to delete all
					contents of the save info.
			- fixed the ability to delete a save.  required the above directory structure change.
			- found that the hole walking used a for loop and touch_sprite().  i changed it by removing the for loop and adding in
					touch_sprite_range().  i had to mod touch_sprite_range() to return what sprite i was touching for this to work.
					This should use less cpu cycles to figure out if i am walking on a hole or not.
			- created add_special_item().  this will add any special type of object like heart containers, bomb bags, quivers, etc. 
					this was made so i could put everything in one place instead of multiple places.
			- combined code in keys that was redundant.  also, it fixed the strange issues of a and b acting differently.  now they
					both act the same.- now there is cleaner code in keys.c
			- code cleanup on mob_stats.c
			- quiver added in theory, but not tested.
			- created name() in inventory.c.  this will sprtinf() the name of link. to a char[].  it will be useful in the msg()
					system.

	* 1/11/14 *
			- removed link_gfx from ezelda and merged with map_gfx - b/c there was only 1 routine in link_gfx.
			- modded drawimage to return if pic_num<=0, so i should not see the shadow error anymore.
			- checked and mathect the prototypes in ezelda.
			- remove mob_gfx and from ezelda and merged with map_gfx - b/c there was only 1 routine in mob_gfx
			- modded touching_sprite() to use touching_sprite_range() and saved a couple hundred bytes
			- modded move_mob() to be more optomized.
			- todo: modify move_mob() and split into multiple routines and put the main move_mob() (if you can) back
					into zelda.

  * 1/12/14 *
  		- noticed a slowdown when link was walking over a mob that dealt no damamge, so i added in a return in pain()
  				if dam<=0.
  		- removed move_mob() from ezelda and put it in zelda.  i also broke it up into multiple routines.  this makes
  				things a lot easier to read and to maintain, b/c i dont need a routine that has 1k lines of code in it.
  		- had to increase hole walking from 8 to 9.  it seems as though the game sped up a bit and i cant make it over 
  				2 holes in time.		
  		- created move_bat() to move the bat in the event that link is within 30 pixels radius of the bat.
  		- modded drawimage() again by removing the if pic_num==0.  i hoped that this would remove the shadow from 
  				displaying in strange places, but it only messed up link.		
  		- changed the beginning screen loop>350 to loop>500.  not bad.  the speed increased by about 150 loops.		
  		- fixed the fact that i had to press 2nd 2x in order to get ynbox() to accept my decision.  now i only have
  				to press 2nd once.		
  		- imped the enemy projectile list and integrated it with the item_list[][] routines, so i can call the item
  				list routines and it will access the projectile list in the event that the item_id >=projectile_offset 	
  		- added another stat for the projectile: proj_type.  this allows for me to speicify arrow_foe or arrow_foe_rotate
  				the arrow_foe sends the projectile flying in a straight direction.  the arrow_foe_rotate tells the generic animate()
  				to rotate the image of an enemy.  - now there can be more animation of the objects that mobs throw around.		
  		- made the octi-ball a arrow_foe_rotate, although you cant tell too much.		
  		- moving of wizard created in concept.		
  		- modded move_object() to handle diagnal directions (used for diagnal enemy weapons) - i also optamized it, so
  				it ended up being less bytes in compiled size then before.		
  		- added the following mob weapon types: (not tested)
  				arrow_foe, arrow_foe_rotate, arrow_foe_multi_3, arrow_foe_multi_5, arrow_foe_diagnal, arrow_foe_at_link,
			- these wepon types are not imped yet:
					arrow_foe_rotate_follow, arrow_foe_follow 		
  				
  * 1/14/14 * 
  		- added a check to see if the folders existed.  if they didn't then exit out so you dont error yourself. 				
  		- fixed the torches again.  found another 54 lingering around in drawterrain(). changed it to 58.  modded
  				the get/set_room_info() to include the room_lit concept.  
  		- found an error in a warp and fixed it.  all warps working now.	
  		- i found that i renamed write_dung_map() to fill_dung_map(), so i uncommented the stuff in world_init() and
  				changed the names and then it created new world maps :)
  		- the world maps were not saving so i added in the save to pull_new_map().  now the dungeon map remembers itself.
  		- forgot to archive the saved map files... oops.  now they archive
  		- found that the test dungeon has the same dungeon# as a real dungeon, so i changed the dungeon id of the test dungeon.
  		- tweaked the right door unlock and made the offset smaller, b/c you can move in further into the door with the new
  				collission detection system.		
  				
   * 1/15/14 *  				
			-	reprogrammed the mob_pic system again in editor.  i added in a global var to keep track of the current position of the
			 		pic and the arrays.  now all i have to do, is to call the things in order and it will place them automatically
			 		based upon their size.  this should prevent issues in the future. 	
			-	changed the mob weapons using under AnimateMob() to start with weapon 9000+.  i will have to use 1000-8000 
 					for a different weapon type.  either make them hold the thing or make them randomly use it.	
			- found the error for the mobs not shooting the correct item was b/c i didnt set it to create mob sets 101+.
			- created the pictures for the new sets.
			- added the ability to exit out of the start menu with the B key.
			- found that all items were free when testing, so i fixed this error and made another release.
			- tested the thing on the calculator. - it works. 
			- i will leave the default of the speed limiter at 2.
			- redid the max value of rupies to 500.

   * 6/29/14 * 
   		- added in pede_body_move() and pede_head_set().
   		- added to the defines: pede_body and pede_head.
   		- doing this to make ready the routines for pede boss.
   		
    * 6/30/14 *   
   		- fixed animate mob so mob_type of pede does not do a gfx reel back when hit.
   		- finished, but untested, the pede_body_move and pede_head_set().
   		- added define MOB_CONSTANT.
   		- broke move_wander() into 2 routines, thus creating, move_constant().
   				- needed move constant for the pedes, so it does not randomly move the pede body segments.
   		- broke animate_generic1() into 2 routines, thus creating, picture_rotator().
   				- picture rotator was needed, b/c i needed to animate the pede body segments w/o having them move
   						in a strange way that the animate_generic1() would do to them.  - this might be good for the 
   						circular movement of mobs, too.
   		- put pede_head_set() into ezelda so i could call it from death().
   		- removed get_mob_stat() from ezelda and made it into a define. - it was updated with g_mob_list() a long time
   					ago.  about 50 places use get_mob_stat.
   		- noticed an error with mob directions.  the mob creator is set to fix the mob dir to up.  however, if this is
   					not used, then it would foce set it to an unkown number, so the mob may not move.  so logic was added in so
   					if the dir<0, then make it move down.
   		- tested the wizard algo.  had to rewrite the whole thing and base it off of var2 instead of random().  now it works the
   					way i want it. - mostly.
   					- known errors: the dissappearing blink is not a constant, due to the fact of random(66) increasing v at odd intervals
   							so the blinking is off a little.  also, the wizards shoot weapons when "invis"
   		- modded movable() in ezelda so that wizards could move wherever they wanted.	
   		- added wizard mob_type
   		- tested the bat algo.  seems to work - only issue is that it may not loop through the pictures right...
   		- fixed it where the rocks dissappeared when you carried them into another room.  come to find out, i did not reset
   				link_rand_var1 after i added the rock back to the room in get_map_vars().  this led to out of bounds errors, b/c
   				i was still looking in the object[] where the object used to be, but was deleted out, so it always returned -6666.			
   		- made the pede_body invicible in pain().		
   		- added in the ability for a mob to execute a sl after it dies.  - it required me to set up the exec_sl set in ezelda.			
   		- added in the ability for touch_mob() to detect if a mob was touching a mob.			
   					
    * 7/1-11/14 *
    	- been working for the past 2 weeks on a pede algorithm to make the body follow the head.  im making very little
    			progress.  seems that people want to do the pede where it is in one big array (ie the map array), but this
    			would require considerable rewrites or code adding.  searching for an easier way to do this.  found a way but 
    			it only works if the pede head doesnt make too many turns.  if it does, then the body segments separate and
    			go their own way. - needs more logic... sigh.  ive already written like 5 different routines for this so far...  					
   					
   	* 7/12/14 *
   		- got the pede working at 90% accuracy.  it has its quarks here and there, but it seems to realign itself after a
   				while.  with that, i will leave it as is.  it might be an extra challange for those who fight against it.  
   				a simple warning though: dont add too many obsticales in the room where it causes the pede to turn so much, b/c
   				the pede turning can only handle 3 turns, before its pieces begin to get lost.
   		- fixed the errors where i could not hit the pede head.  
   		- prevented the pede head from reeling back if hit.
   		- fixed the errors where the pede head would transfer to the next mob down
   		- split up the animatemob() and created a mob_attack().  this will allow me to let the pedes use attacks, instead of
   				just running around. - this should add for more of a challange.	
   					
   					
   	* 7/13/14 *  					
   		- added save_link_config() and restore_link_config().   these are used to save and restore the config settings
   				under the start menu for your particular save.  that way, each save can have its own config settings.			
   		- added mob_ghost as a type.
   		- created the move_ghost() so the mob can move diagnally.
   		- modded can_move() so it can take into consideration the new diagnonal directions, but only if it is a ghost
   		- added fix_diag_dir() - this will force either right or left in the event of a diagnal direction - prevents
   				odd mistakes when displaying mobs and when mobs use weapons.
   		- modded the mob_attack() to use fix_diag_dir(). 			
   					
   					
   	* 10/8-11/14 *
   		- added ff town map
   		- added ff cave map
   		- created 5 npcs - 4 "humans" and a sheep
   		- created new sprites for the ff maps - this caused me to create gfx set 4				
   					
    * 10/12/14 *
    	- added 7 more npcs - total of 15 npcs for now.  got 10 normal ones, princess zelda, and 4 animals
    	- the plan is to have about 40 mobs and 15 npcs and then bosses on top of that.  					
   		- split external file editor into 2 files: editor and mobs.  mobs only makes mob files.  the external file editor
   				does everything else.  i needed to do this, b/c it will get close to 50k just to have all the mobs in one file.			
   		- removed link_jump.  this routine had issues and i had no plan to use it, other than for "it was already there"
   		- reduced link_gfx_size to 13 from 15.  this should reduce the gfz size required for link a little, so less ram needed.	
   					
   	* 10/13-16/14 *
   		- added more mobs.  now the mobs are up to 41 non boss mobs.  this should be enough to do the entire game
   		
    * 10/16/14 *
    	- added quest_master define for mob type.  this will execute a storyline if you talk to it, instead of pulling
    			up a message. 	   								
   		- removed butterfly and urchin mob_type - they were not used.
   		- found an error in the picture_rotator().  the 2nd picture only lasted for 1 frame; thus making things look bad.
   				another if stmt was added to make sure that sprite #2 would last an equal amount of time as sprite #1
   		- made it easier to design mobs:
   				- created new generic routines that can be used over and over again, so i dont have to make a new routine
   						every single time i want to make a new mob.  instead, i just pull the function and it adds the mob.  all
   						i have to do, is change the picture.  basically, the mobs use the same routines anyways, so why not.
   				- made it so that i can call a routine and then a pic of that mob.  that way, it will automatically update
   						the gfx position of the mob.  this prevents me from having to figure out where its gfx location is all
   						the time, which is so annoying.  it will save a lot of time in the end.  the new mob setup will be like
   						this:
   						
   									mob_generic(0, 0, 0, weak, mob_ball, weak, slow_speed);
										mob_generic(1, 0, 0, weak, mob_ball, weak, slow_speed);
										mob_generic(2, 0, 0, weak, mob_ball, weak, slow_speed);
										pic_octipus();
										mob_gen_flyer(3, 0, 0, weak, 0, weak, slow_speed, MOB_GHOST);
										mob_gen_flyer(4, 0, 0, weak, 0, weak, slow_speed, MOB_GHOST);
										pic_ghost();
										mob_gen_flyer(5, 0, 0, weak, 0, weak, slow_speed, MOB_WIZARD);
										pic_wizard();
										no_mob(6);
								  	no_mob(7);		
   				
   						** note: this is for 3 octipus mobs, 2 different ghosts and one wizard.  and they are to be
   											placed randomly
   						- be sure to place the pic() after the mob(), so it will loop through all the pics of that mob
   								and then set the gfx postion of the next mob().
   			- created the mob fireball.	
   			- created mob magic atack
   			- created light_orb routines and define, but not the gfx or item yet.
   			- added in the light orb message showing that the room is already lit.
   			- started testing the arrow_3/5 & rotating...  they are horribly broken...
   				
    * 10/17/14 *
    		- finished the light orb - removed the msg() warning, b/c it was annoying and could interfere with button b
    		- modded the add_item_inv() to only allow a max of 99 items, instead of 32000.   				
   			- added bottles and imped their usability.  however, i have not imped the refilling of them yet.	
   			- fixed some oob errors with the bottles, b/c i could add more than 3 "items" to the bottle, so it would always produce
   					the wrong picture, so i modded it so that it would not go past 3.  
   			- added a check in add_item_inv() to prevent swords, wands, shields, boomerangs, and hookshots from getting more than 0
   					"items."	
   			- modded add_item_inv() again to allow potions to modify whatever link is holding - starting with A and looping to button D.
   						- did this to add expandability if i ever decided to use c_ko or d_ko.	
   			- modded animate object so that link would not buy or pick up a potion item if he does not have an empty jar in hand.	
   			- bottles are finally added and functioning. - might want to add in the fact that a faerie will auto revive link if he dies.	
   				
   				
    * 10/19/14 *   				
   				- got the upsidedown mask routine fixed and added to ez_source.  now the annoying white line issue with a 180 degree 
   						flip is solved.
   				- wrote part of the msgs that the npcs will have.
   				
   				
    * 10/20/14 *     				
   				- added warp points... things seem broken...  maybe my define is bad...
   				- the individual points dont seem to work right with the dual points - fix this
   				
    * 12/30/14 *   
    			- fixed warp points - i entered them in wrong.  the return point (ie last argument) is to tell what direction the warp
    					point is, not whether you end up to the lrud of the warp point.  you simply put in the points to tell it from 
    					what point to what point to warp to, then the final direction is used to determine the reverse warp point.
    			- found some errors in the main warper().  i redid the checks and made it compare if link_x/y+8 (ie the center of link)
    					is inside the sprite.  also, i reduced the sprite warp area to a 14x14 square inside the warp sprite.  things
    					seem to work flawlessly right now.
    			- upped the warp points to 12, due to laziness.
    			- added more checks inside the warp creator (ext file) to make sure i dont go out of bounds of the warp.
    			- discovered that i needed to input the ow number into the warp, when switching to a different map in the ow, instead of
    					the "same_map" var.  this prevents extra coding and does the same thing that i needed to accomplish. 				
   				
    * 12/31/14 *  				
   				- added mobs to the town.
   				- modded the message system to allow for one extra letter.
   						- expanded the msg box to fill the whole screen
   								- modded the box for easy size changing.
   				- modded the mob adding routine to allow you to choose one mob, or a range of mobs and then tell how many you
   						want within that range.  this only works if the number of mobs to be placed is greater than the range.
   				- added in the ability for mobs to move even slower.  - use mob_stops >=5 to slow the mob down - it was modded
   							in the move_mob()									
   				- modded animate_generic_mob() and made it so that the pause for random stops had a random number attribute to
   							it, instead of just 25 loops every time it stops.
   				- found an error in the map creator.  i still used rmapy() to convert the >4 numbers to <4 numbers when doing the
   							rmap x/y defins in the world[10][5/6].  this is no longer needed.  it causes problems if you do it.  just go
   							to a max of 7 and you will be fine.
   				
    * 1/1/15 *     				
   				- added a 1 in 17 chance of getting 5 rupies and added a 1 in 120 chance in getting 10 rupies.
   				- modded chk_room in the sl to include what ow # to look at, so i can use the same sl file for multiple maps
   				- added item_bottle_x defines.
   				- added in the shops into room 20 (ff town)
   						- discovered that i could do multiple shops per sl for different maps
   				- changed the floor #10 in ff sprites to lighter color.
   				- added in flor # 29 (which is blank) - for the shops, to display things correctly.
   				- modded pain() so you will take at least 1 damage.  i found this necessary, b/c the bats would hit you but not
   						hurt you, so i had to make them hurt you.
   				- reduced the super spin slash from max hp to >=70%.
   				- redid the spin slash to slash up to double the radius, if you have hp >=70% (ie double_damage==true)
   				- extended spin slash radius of creatures when double_damage==true.
   				- fixed the error where if you try to save, it will break your stats and put you on the beg screen.
   						- basically, you were saving the stats after loading room 999.  i added some error checking to make sure
   							you dont save links stats when you go into 999.  this causes a slew of problems.
   				- released 5.1b

    * 1/2/15 * 
					- merged the 3 mob gfx files (light,dark,mask) into one file.
					- fixed the mob weapon shooting types.  all of them work now.
						- removed: multi_shooter(), diag_chooser(), arrow_modder(), diagnal_set()
						- replaced with: roman_candle(), obj_move_diag(), animate_mob_weapons(), xXx(), init_multi_weapons()
						- took about 1k more to make work, but oh well... it works now.
					- i split the animate_generic_damager() up
						- added: chk_obj_oob(), chk_obj_hit_link()
					- added 4 more mob wepaons to the item list. - only 4 left i can make.
					- added 16 lrud_(30/45)_(left/right) defines - these are for the diagnal weapons 	
					- added dbg[] and debug() - erase these later.
					- made the circle_x/y routines needed to be able to make objects rotate in a circle - seems slow though.
					- added the circle eyes gfx

    * 1/3/15 *
    			- made the evil eye and circle eyes mob work.
					- created disp_circle_mobs(), fill_circle_values(), circle_y/x(), circle_v[2][32], animate_evil_eye()
					- now we have the ability to make objects circle through.  however, it is set for 7 objects - no more, no less.
							otherwise the spacing will be messed up.

    * 1/4/15 *
    			- found that the fade routines in extgraph did not meet my needs. - they were too fast and didnt go completly to
    					black.  however, there might be a possibility to use them for a "dark room" or "night time" effect.
					- added in the transistion() from afw to here and modded it to make it work with zelda.
					- the transistion effect only works in the sl (for now).
					- added the circling object routine disp_circle_object() to let 7 objects circle link.  right now, it is only used
							for hearts
					- added map object and faerie object and sprites
					- added in the ability to get a map from a treasure chest.  adding it as an item in a room looks like it will always
							repop, due to the lack of logic to make it not repop.
					- modded blk_menu() to work with the prologue background. - added in the torp 4 to use the prologue background.


    * 1/5/15 *
    			- added crystals to beginning screen
    			- prologue() added and working with 2 modes: scrolling and 1 letter at a time
   				- added mob_replicator define and mob attack - it will place a mob on the screen - actually, mob position 0			
   				- added chicken attack - only required like 300 bytes after mob_replicator was created, so i said why not.	
   				- changed settings to use compression for it to be easier for the old calc users to use		
   							
    * 1/6/15 *  
    			- fixed debug mode so i can see the coordinates better 
    			- redid the mob_shield stat.  it now will tell whether the mob is immortal, dies only to fire, dies to arrow, or dies
   						only to bombs. it also lets you know if the mob has a shield equipped or not. 			
    			- added in death_by_xxx defines and shield_equipped define. - use this for the mob_shield location
    			- added in type_magic damage define.  now gannon can be immune magic - immune_magic makes the mobs immune to fire
    					as well.
    			- added in spider routine and disp multi sprite routine
  
    * 1/24/15 *
  				- started organizing the mobs. like which dungeons they will be in and their hp and damage - made a stat excel file for them
  				- added item_bomb to the defines, but this conflicted with item_bomb(). so i changed it to use_bomb()
  				- attempted to add in the ai for item drop, but it puts the dll over the limit.
  				- added in the gfx_walk_sprites, m_height, and m_width defines in the mobs editor
  				- modded the mob editor to have pre_generic_mobs() routines.  so you call the picture first and then the pre_gen()s
  						this will preset the walk sprites, height and width of the mob.  
   				- i realized that i need to make the hopping spider routine - used for the bunny too.

    * 1/25/15 *
    			- depreciated and deleted mob_type "ghost".  -> use flyer and move_type==MOB_GHOST instead
    			- created the crystal_mobs.c to have all the mobs for crystalline destiny.
    			- most of the mobs have been set and created.  
    			- combined both the mob_stats and mob_gfx routines into on in the mob editor.
    			- modded the mob editor to use compression, so the old ti users will have an easier time.
    			 			
    			 			
    * 1/30/15 *    			 			
    			- moved exploding_bomb() from ezelda to zelda.  
    			- modded exploding_bomb() so it would check to see if the other side of the wall was also bombable. if it was
    					then it would blow a hole in it too, if the bomb went off on one side of the wall. 			
    			- modded the unlock_door() to check the door behind it to see if it was a locked door, too.  if it is, then 
    					unlock it also. - did this b/c zelda maps had a locked door on both sides and was accessable on either side.
 					- put together all dungeons cept 8 and 9.
 					- separated the maps file into 2.  now there is dungeons and maps.
 					- modded room_object_adder() and changed the door section (case 166 ... 169).  changed to "case 89 ... 169" to
 							include all unwalkable things.  this way i can do one way doors. - bad idea. didnt work right. - make new routine
 					- added in the ai item drop in ezelda
 
 
    * 1/31/15 *  
 					- created the dont_get_stuck() routine.  it seems to work right now.  need to do more testing - was able to remove
 							the dungeon door routine in room_object_adder() b/c dont_get_stuck() works for it too.
 					- modded scroll_room() and removed some pointless? code and added in some more.  it seems to work and it seems to 
 							prevent oob errors and prevents the calc from crashing when i went oob of the 8x8 world[][]		
					- finished dungeon 8 and 9
				

    * 2/1/15 *
    			- added zelda_game_number define to link_stat.  this will return what version of the zelda game we are playing.
    					if the numbers do not match, then delete the save.  this will prevent cheating.
					- created the warp points for the dungeons.  just need to set up the warping for the returning to the ow. - need ow first
					- created boss key and heart container sls for the dungeons
					- created special item sls for dungeons
					- added more item defines, including item_map.  some of the defines messed with the use_xxx() routines, so test them
							to make sure that you can still use items properly.
					- created map sls for dungeons 1 to 8
			
			
    * 2/8/15 *
    			- created the mountain area map
    			- created the forest area map. 
    			- added both maps to the man source.
    					- still need to add the warps to them, though.			
			
			
    * 2/14/15 *			
					- all maps are created.
					- created warps and mostly debugged the mountain map. (world 50)
					- found an error in the drop ai.  it didnt check if the item was held.  so i modded item_amt() to check to see
							if the item was in the hand or not. - seems to have some redundant code in add_item_inv() now. (above item_amt())
					- an error was pointed out:  if slingshooting around and you get hit, then you will drop the slingshot and then
							stop where you are and then reel back.  to fix this, i modded gfx_reel_back() to check if link is hookshooting.
							if he is, then skip everything and do nothing.  also, the main link animation routine was modded if link
							was hookshooting, then reel_back() would not activate.  now, link should only blink when he gets hit while
							hookshooting.
					- found out that i broke the msg system when i imped the new shields for the mobs.  this was b/c i originally used
							the shield position for the msg_id.  then i kept on getting msg id out of bounds error, b/c i had set the shield.
							i switched it to use the mob_item spot instead.  now the npcs can talk again.
					- forgot to change rmapx/y to rmapx2/y2 in the explosion() for bombs.  this prevented the other side of the wall from
							being blown away too.  now both sides of the wall are boomed.  also, the unlocking of doors on both sides works.
					- level 9 has warping issues.
			

    * 2/16/15 *			
					- updated the zelda map editor.  added lots to it and fixed some bugs
					- found a bug that when after you died, mobs didnt show back up.  fixed it.  look at planning.c for more info.
			
			
		* 2/18/15 *
					- added the warps to the forrest. 
					- created the split road from warp #2 to the other 2, #2's.
					- found an error in the warp routine.  it only checked to see if the rmapx/y was correct to determine if we should warp
							well if you had warps from another world in there with the same rmapx/y, then it would warp you indiscriminately.
							so i added in a check to see if we were in the correct world as well.  i had to mod get_map_vars() so it would 
							add the current room number if it was the same_room.  also, i had to mod the warper in the dungeons editor to 
							force it to add in the in this check.  also, warp[][] was upped in size as well.  also, new warp defines were
							added and the code was modified accordingly.
							*** a warning though: do not add the same_map warps of different maps to the same warp file.  this will cause
									a strange dissaster.   			
			
		* 2/21/15 *
					- added the white sword
					- had to adjust the gfx_slash() to allow for only 2 sprites, instead of 3.  also, i had to adust the rotate()
							to allow for rot_180+1. this allows me to rotate the sword at 180 degrees.  before, the 180 was set for 
							the horizontal flip.  this did not work at all on a diagnal sword.
					- finished up the warp points and finished modding the water area map.  now i need ot add the treasure boxes
							and test to make sure that the levels are working.  also, i need to add in the 1 directional warps out
							of the levels.
					- added the ability for the game to check game numbers and delete the save files of other game numbers
					- added in the delete function of the previous sword if the new one's damage> old one.			

		* 2/22/15 *	
					- added in exit warps for the dungeons - test them
					- added in the master sword
					- added in the treasure boxes for the world maps
					- worked on the shop sls - but some are still broken.
					- made prolouge and added it to the opening sl
					- wrote credits - still need to add it to the ending.		
					- tested dungeon 1-4 and seem to have gotten things to work
					- dungeon 5 has an issue: you cant get the hookshot, b/c you need it to get it. - fix this.
					- got about half way done with the things that i wanted to get done before release
					
		* 2/23/15 *					
					- found an error with g/set_treasure_marker().  i forgot to reduce "which" to less than 30.  this caused errors b/c
							i attempted to get a spot in the array that was oob.  after forcing which to reduce itself, things worked.
					- found the issue with the nesting of the sl - the nester works fine, but the define "either" was incorrect, so i corrected
							it and then things worked correctly.  - although the storyline checking could use optimazation
					- check the sl marker system for the same bugs
					- tweaked md_link() to remove redundancy and to prevent oob errors. - saved like 60 bytes
					- found that gfx_reel_back() didnt move the raft when link was hit, so i changed it so that instead of move_link(), i 
							used walking() instead.  this moves the raft as well.
					- added func_defines.h so i could make a whole bunch of function defines. - this will be used for when i do more
							optimization.
					- made a new routine for modding the treasure/story markers.  - imp this after the release.  it is pointless now.



		* 2/24/15 *	
					- modded animate_drop_obj() so the push stones dont show up when the room is dark.  they used to show up, but it shows
							which one is the push one.
					- i more or less finished checking the dungeons for correct warp points and treasure boxes.
					- found out the problem with zelda not exiting when running the prologue and stuff and exiting from the sl:
							- it was due to being out of memory. - as the game is played, there seems to be memory leaks.  it stayes in ram
								until the dll refuses to load.  well to fix this, i added in the ability to reset the calc in then event of
								failing to load the game.  - added it in for the greyscale part, too.

		* 2/25/15 *
					- modified the mob blink routine and put it in drawimage() in ezelda.  
					- modified animatemob() so it would not stun the mob when i hit it with a sword.  
					- found out that the gfx_reel_back() hit the mob 3 times.  i reduced this to 1 time, instead.
					- found out that the defines in the mob creator didnt work like expected, so i had to make a whole bunch of
							variables in its place and had to redo all the mobs and recode the generic routines.  - now the mobs work
							right and display correctly.
					- created the dissappear define so the objects will use dissappear instead a_xor.  using a_xor made the mobs dissapper
								or at least mob 0.  - it was always invisible.
					- now when displaying the mobs, you will pass in the mob_id (who) into draw_type, instead of a_normal or a_reverse.	
					- i more or less removed the chicken and dog "hop" routines from the game.				
					- found that the arrows did not kill the creatures that were death_by_arrow.  so i fixed this.  it looked for "arrow"
							define, not the ammo_arrow define
					- i have had to redo the snake, knight, wizard to all darker mobs, so i could see them in the levels.  i will keep both
							light and dark versions of it for the other games so i can use them if necessary.		
					- added in the mobs for level 1->7  - ive tested up to level 3.  up to level 3 are working right.
					- finally decided on the bosses for the levels.

		* 2/26/15 *
					- made it so that gfx_reel_back() would not make the mob move if i hit it with a spinglsah - i got tired of the mobs
							moving when i hit them with that.
					- added in mob_stun().  this will prevent the pedes from being stunned and from any mob with a shield of 6000+
					- finished adding the mobs to the dungeons.  
					- modded some gfx of mobs to make them show up better in their background.
					- made it so that mobs would not show up within 24 pixels of link when link first walks into a room (if doing 
								random_mob_placement())
					- i had to imp the nostun defines (>6000).  they will prevent the mob from being stunned while adding shield protection.
							** the evil eye was stunnable.  this was an issue, so to prevent it, i simply just imped the nostun stuff.			
					- oops, forgot to skip dealing damage to link when !skip_animate_mob - fixed - this caused link to die when the faerie was
								around him and when touching a mob at the same time
					- i allowed the mobs to continue to display when link was being healed by a faerie.  this allows the mobs to move to 
							somewhere else while link is healing. - seems to help a bit
					- I upped the power of the wand to do 7 damage per every 3 loops, instead of 2 damage.  now it will do about 35 damage.
							- it can take out most things in 2 hits.
					
					
		* 2/27/15 *					
						*** final countdown ***
					- added nostun_shield_immune_magic
					- added mobs to the mtn area.
					- created the 3 sages boss
					- set_link_save_info() had issues with saving. when i redid the may system, old stuff still lingered.  
							- save_world_map is now used in place of save_rset_id.  save_rset_id is now depreciated.
					- i still cant get the key_normal with the boomerang
					- fixed the diag_dir of mob shooting weapons. - just added the fix_diagh_dir() to the direction of which to shoot the 
							object
					- made it so that you could walk on top of mob explosions (when they die)
					- game testing done
					- removed debug cheating and reinnited the contrast.  added back in the debug stuff, too.
					- packaged for release.

		* 2/28/15 *	
					- simple quest released
					- tried the idea of condising all my get set routines - it increased the main zelda() by 2k.  no. bad bad idea.
					- added mod_marker
					

		* 3/5/15 *
					- started on rewriting the object displaying routines.
					- 2-28-15 is the rollback.
					
					
		* 3/7/15 *
					- rewrote the entire set of object routines.  - i aimed to make them faster and use less cycles.  everything
							was rewritten from scratch.
					- all that remains to rewrite is the leaf routine and the lif object routines - the main code is about 1k lighter
							and the dll is 1k lighter - so about 2k saved by rewriting everything.
					- i had to add another stat to the object list, but i shrunk it down by 10 objects total. - saved about 300 bytes.
					- i converted over all of the old object types used by jason to item_xxx types.  - a lot of new defines were made
					- bugs that i am aware of are fixed.
					- the boomerang works better now :)

		* 3/8/15 *					
				- worked on the transistion effects.  it has been a pain in the ass to do.  still not 100% yet, but at least it is working 
						a lot better than in the beginning.	

		* 3/9/15 *
				- transistion effects are fixed and working - at the cost of things being a little slower. - looks nice though,
				- fixed the broken faerie - didnt do the new draw_object()
				- added transistion effects into sl.
				- fixed the broken wand.  had to add in the wand_ammo item type.  
				- added slash_terrain() to the bombs and wand, so the bomb blows up 4 spots and the wand burns away any grass
						or plant it touches.
				- spinslash() now does the super slash in a perfect "circle" with the slash terrain		
				
		* 3/10/15 *
				- redid the leaf routine.  it is about 400 bytes smaller now, but it doesnt do the exploding rock...
							- the animate leaf seems faster now, so i had to extend how long it displayed.
				- found an error where link did not get hurt by mob weapons or explosions - fixed it - forgot to add them into
						obj_touch_link()
				- added in the exploding rock - took like 50 bytes.
				- redid the animate terrain and created a simple one room array (current_room[9][10]).  this stores the 
						array for the current room.  instead of using get_all_maps(), you use use current_room[][] instead.
						also, i forced the current_room[][]	to store all the sprites of the room that link is in, upon entering.
						it also does all the checks and converts over all the sprites when the new room is loaded.  before, it
						had to do 400 if checks to display the room.  now all 400 checks are done in the beginning, thus saving
						on cpu cycles a lot.  now the only checks that exists is the animation checks.  it took about 350 bytes to do
						this.  the speed increase is drastic.  now, i have to use speed limiter #3, instead of number 2.  it seems a 
						little off, so i may adjust the slowdown a little.
				- ezelda is still about 130 bytes lighter than it was before i redid the leaf routine. - much progress has been made.
				- redid the animate_throw_object().  saved about 250 or so bytes.  now all of the object routines have been rewritten. 
				- you redid the main routine, so things dont work as well anymore... 

		* 3/11/15 *
				- rewrote the gfx_slash routine and broke it up into 3 routines.
				- redid the circle_dir and made it counterclockwise.
				- rewrote the spinslash routine - i had to, to make it work.
				- in the end, i saved about 1k and it is a LOT less to look at in code... the other old code was a dissaster and
						overwhealming.
				- i need to go through all the vars and see which .c files use their variables and which dont.  no point in having
						extern vars in a file that doesnt use them.
				- fixed the mysteriously appearing boomerang - added item_used() - the mystery was that i used 1 var to decide what item 
						i used.  however, that var got reset and then looped to the drawing stuff, thus displaying the boomerang. i needed
						2 vars for this.  instead, i simply just used button_pressed and link_stat() to get the correct item, thus eliminating 
						the need for vars altogether.  		
				- fixed where i broke dark rooms.  they work again and so do light orbs		
				- the wand stopped rappid fire - adjusted it to work again.
				- found an issue where blowing a hole in current wall, blew hole in opposite side of room - fixed.
				- started the addition of x_ko (ie button c).  there are errors...

		* 3/12/15 *
				- got the idea (again) to buffer the rotate objects to speed things up.  well i decided against it after things didnt
						work so good.  so now, for simplicity sake, i decided to just remove the rotating from the move_objects(), under the
						mob weapons (which used the most rotating).  this should speed things up, but make them look not as good... oh well.
						- on 2nd thought, make it so only arrow_foe_rotate works - just for the boomerang
				- the problem with using alpha for button c is the fact that it is a dual state button (ie alpha and alock) - this dual
						shift messes with the button press.  you would need both addresses (states) to confirm to make it work right.
				- the raft is hacked.  it doesnt work perfectly, but it is working a little...  doesnt work right with the treadmill
						waterway.  it will need to be fixed. - but the whole animate link needs to be redone from scratch and not be a hack.
				
		* 3/13/15 *
				- ok c button is now the diamond and lift is esc
				- alpha still has huge issues with wanting to stay perm on when you press it...
				- renamed esc_ko to x_ko... just for simplicity
				
		* 10/22/15 *				
				- began on the rewriting of the animate_link.
					- transformed dual animation system into a "primary and sub" system - meaning that there are 4 primary link states: 
							normal, walking, attack, stunned.  each of these primary systems have a set of sub systems assigned to them. for example:
							walking has the following sub systems: push, sword, carry (lift 2), holding shield.  instead of one major 
							dual_animation(), it is divided unto the 4 primary systems. 
							- so far, the original system requires 2464 bytes.
				- working on removing link_frame2, so i only have to deal with link_frame
			  - the work is progressing.  been having to change the mod_link(state...  to mod_link(dual_state... to match the new
			  		way of animation.
				- the raft seems to be flawless.
				
			* 10/23/15 *
				- still rewriting the gfx routine.  i seem to have used 300 more bytes than the orig, however, it seems to work a 
						a little more correctly.
				- still have bugs with the object carry system.	- for example, switching states, like to stun, will cause the item 
						to break.  reel_back() seems to delete the item., however, the using  of a->c does toss the item instead of 
						deleteing the object.
				- terminate=TRUE tends to make link reset his state when you stop pressing keys.  however, if you leave it as
						terminate=FALSE, then it will cause link to contiune on with whatever key was last pressed.
				- still need to test the hookshot to make sure it still works.
				- managed to get the hold object to keep from lagging behind link.  actually, the obj_quick_draw() reduced the amount
						of bytes needed to compile.	- about 500 bytes less than what i started with.
				- there have been so many changes that i cannot remember them, but the rewriting of the link gfx system is almost done.
				- added preset_obj() into weapons.c - this helped to reduce space by 150 bytes.  - it can be reduced even more.  weapons.c
						needs to be cleaned up, though.
				- tossing the bomb does not display right (when throwing down), so bomb toss needs to be fixed.
					- actually, it does do right, the game displays link after the object, so link is always on top.
				- test hookshot.

			* 10/24/15 *				
				- remove_hookshot() was unused, so i deleted it and saved a few bytes.
				- removed the terrain_animation speed and saved a few bytes.
				- had to use link_rand_var1 as a marker for the hookshot, so it would display the correct pic
				- had to add the toss_object() into stun() and reel_back()
				- now things seem to be working correctly after the rewrite.  
				- so far, i have saved 2k of space from engine 0.9 (first release) in the main dll.
				- fixed some bugs.
				- releasing as v 0.9.2 as an RC for simple quest - delayed until bugs fixed
				
			* 10/25/15 *				
				- found that if you use the boomerang while in a shop, specifically, when shop_active, then it will
						catch that item and make link buy it.  so i put in an if statement into use_item() that if shop active then return.
				- rewrote the core message system from scratch and added in the concept that link's name could be displayed anywhere in
					the midst of a message if @@@@@@ was used.  - this is only partially tested, but the main routine works correctly with
					the testing done.  saved 400 bytes so far.		
				- the link getting from the treasure box does not display correctly.
				
			* 10/26/15 *					
				- modded wait_for_key() to have a loop system that delayes when detecting a keypress.  this helps with the message system
						from blinking through the whole message in an instant.
				- fixed errors in msg() so it would display the name corretly.  come to find out, int 0 == char \0, so the 0's in the 
						name would cause the "string termination" to kick in, so i did a check for it first and if 0, then space instead.
				- the treasure box items would not display, when gotten.  it was under "link_get_item" state.  the reason why they were 
						not displaying was, b/c the quickdraw routine needed the pic_id from the obj_gfx_list to display the object.  however,
						the item numbers of 1000+ are way oob, so it would display blank pics instead.  to fix this, i did a check to see
						if hold_carry>=1000.  if so, then get the item pic and display it.  now the majority of errors are fixed :)
				- also, you will need the new msg #1 file if you use this, b/c the reprogrammed msg system requires messages not in
						simple quest.		
				- slash terrain is really off with walking sword, so i think i will remove it.
						- i did remove it, but it did some odd things... when i walk, it tends to switch states from walking to attack.
							 when that happens, the terrain slashing still happens, so now, you have to hold down 2nd then press a dir
							 button for it to slash the terrain.  you cannot simply walk over it and have it go poof.
				- now im about 2.5k less in the main program than v0.9, but there are more features and less bugs, but still some new,
						partially noticeable bugs... like when link walks into a room and attacks, it will attack the slime at the very
						end of the wall....  only seen this happen in one room though.  #4,5,w1 - not sure why.
				- removed hold_d and changed it to hold_carry.  hold_carry is the spot where link is carrying an item.  it is also used
						for when link gets an item and holds it above his head.
						
			* 10/27/15 *						
						- turned the sword slash damage routine into a proactive instead of reactive solution.
							- now, while the mobs are being displayed through their loop, it will check to see if the sword is active and if
									it is, then it will check for a collide with that sword.  before, it would loop through all mobs to see if it
									hit one.  well that caused slowdowns.  so instead, it will just do a simple collission check while the mobs are
									being animated, so there is no more of that multiple looping every round to figure out if i hit a mob or not.
						- i discovered why a simple slash, while holding the lrud keys, would slash more than one thing of grass: 
									the spinslash_active was not being deactived correctly, so i forced it to deactivate when walking and
									within the reset_base()
						- however, i still have random mobs being killed for no apparent reason in the right hand corner of the screen.
								- is the sword being send to a really far location and the checks come fouth as being hit?  this is unknown
										because it is so random, meaning that it is due to a glitch where something is not being cleared out correctly.			
						- cleaned and commented more code today
						- fixed the problem in the naming code where it would default link to all terminator strings '\0'.  the numeric code
								for space is 32.  so i made it so that if 0 was in the name, that it would change it to 32.
						- the bomb would not explode when out of bounds.  technically, the object_oob() saw that the explosion was oob.
								and deleted the explosion, b/c it was oob.  well a simple if statement fixed that.
						- rewrote the get_key() after learning some new stuff.  now it is a lot cleaner and nicer.  however, there still seems
								to be some glitches.  the get_key() was really slowing things down.  a lot of speed was gained afterwords.
							- after the rewrite, spinslash is odd.  the very first spinslash causes all sorts of strange objects to fly around.
									however, after the first spinslash, it is all good...?  
							- after the rewrite, link was able to use dual buttons on ako and bko during spinslash.  when this happened, it would
									cause the sword to dissappear and the object of b/cko to appear in the swords place.  i fixed this by putting
									link_spin_slash	into link_stun.  now link is stunned when he spinslashes.  yay.  this fixes the half spins that
									he did before.	
							- the rewrite fixed the annoying re-attack when holding ako and then pressing lrud.
							- the rewrite allowed me to use alpha as "d", so now, d is check_for_xxx
				
			* 10/28/15 *				
					-fixed the bomb throwing issue when changng rooms.  however, i think it makes the bomb stop charging when you
						change rooms.  - fixed the non charging issues.
					- fixed the problem where the sword did not hit the mob and where it would cut the grass when you let go of a lrud key.
							had to add in case 3: to let it charge.  before the terminate=TRUE; caused the sword_active = false.  this prevented
							the mobs from being hit during the next animate loop.  now the sword charges on loop 3, instead of 2.  and 2 cuts
							grass, instead of 3.  
					- changed out the memset() in clr_screen() to an extgraph routine.  now it is a few miliseconds faster.
					- made get_key() return if transistion was active.  now the transistion is faster.
					- using alpha is 1k years bad juju still, so dont use it
					- odd error with the spinslash was due to hold_carry having a value in the beginning, so when spinslash was activated
							it would attempt to toss the object.  a simple mod_link(hold_carry,-1,TRUE); in restore_link_config(); fixed the problem,
							b/c it calls that routine it after loading the save.  the object it attempted to toss was the leaf.
					
			* 10/31/15 *					
					-modded the rotate object, based off of lionel's advice.  seems a bit faster.
					- had to use a double left rotate to rotate the spinslash diagnal sword upside down...
					- modded the slowdown routine and added game_speed() and num_of_atk_objects() to ezelda.
							- now the slowdown routine will mod the "250" instead of "slowdown" to do minor incrimental decreases based
							off of number of mobs and the number of objects they shoot.  right now, it incrimental decreases of 15 and it works
							well.  it is hard to tell that the terrain is slowing down or speeding up, except when diagnal weapons are used.
					- right now, this build of zelda should be good enough for a release candidate for simple quest.
					- good news, the double rotation has removed the graphical error of adding a single white pixel line of the spinslash 
							sword that was really annoying.
					- the only error i am still aware of is the fact that the bomb does not blink when link is holding it.
					
			* 11/1/15 * (release v 0.9.2)
					- noticed that my inventory menu drawing routines with drawline() could be condensed into a routine that could draw a
							box at a specific location, so i made 2 simple routines for this: one to accept the line color and one to do a 
							default display.  these routines are ff_box() and ff_box_color().  this allowed me to remove about 3 or 4 arrays
							of numbers.  this saved about 1k in the end.


			* 11/2/15 *
					- found out why the sword got stuck in the up position:  gfx_slash() had its "default" removed from the switch.  this 
							caused the frame to continue w/o anything happening.  once default was readded, the issues were solved.					
					- i changed the dll id and version numbers.
					- modded the speed limiter to have #5 in slowness, compliments of being able to go so fast
					- created the explanation point to display over link or somewhere else.
					- created the "music note" for the flute
					- lowered the pause on the beginning menu
					- created the compass system.
							- added a new "pointer" (simply a triangle) in select().  added the value of 1234 to signify the compass.
							- added a new define of type_compass - this will be used for the item type of compass
							- added new routines of compass_exists(), compass_x(), compass_add(), compass_got()
							- increased dungeon maps rows by 1 to add in the compass.  
							- added defines of map_rows, map_cols for dungeon maps
							- added define overworld_compass.. this will use world[11][5] - which is the only unused spot left in the world[][]
									- this will use a single variable in yx format, meaning it will look like "47", meaning y=4 x=7, so go 4 down 
											and 7 over.  dont forget about the spot of 0
					- you will need to add "over_world[6+num][5] = world_map[11][5];" into convert_world_to_over_world() in the map creators			
					- i internalized the room_map sprite, so i dont have to have an external file for it.
					- added the compass sprites and item. items are now maxed out.
					
			* 11/3/15 *	
					- numbers of the hold a/b/c in the inventory did not display in the right place, so i fixed that. - i forgot to mod them
							after repositioning the a/b/c buttons in the start menu.				
					- the mobs die randomly, b/c your sword was active while entering another room, you change state, like to spinslash, and
							it forces the sword to be active, which sees the mob located there and then poof, magical mobkill.
					- added in the "if boss_key>1, boss key=1;" into add_item_inv() - this should prevent people from abusing the infinite
							boss key bug.
					- created the wait_for_a_sec() as a call for waiting for a period of time.  20 = 1 second.
					- modded the wait_for_key() to have wait_for_a_sec() before trying to get the keypress.
					- ok. somehow, you got hit, then pressed right, or pressed right and then got hit and it forced you back into the steps
							which causes the warper to not function right, or maybe transistion is not transistioning correctly.
					- moved the slashing of the mob to the end to allow mobs to be hit when stunned.
					- found a place where dark_room had its base sprite showing, so i moved the darkroom check up a bit in the fix_pic() in 
							ezelda - test at level 7
					- fixed - using the wand will cause the sword to charge
					- modded the sword so that it will not be usable for 6 loops if you use the walking sword on a mob.  it prevents the sword
							from being too powerful and from killing tche pede in one hit.
					- modded the down unlocking of a door, so you can be closer to the door to unlock it.
					
			* 11/7/15 *
					- finally finished recoding the pede.  now the pede works better - a lot better.  and it is smaller
							basically, i asked god to show me how to do it.  then he gave me the idea for it.		
					- now im at that point where i could add this to the crystal engine and then add a patch for it and have it work
							well.					
					- changed the engine to Engine v.0.9.3
					- fixed - still need to fix the pede where it change the sprite when going l/r  and need to fix the walk sprite
					- i redid the sprites for the pede and made a new pede.  it now looks more mean...
	
			* 11/8/15 *
					- combined move_diag() with move_obj().  before, move_diag() called move_obj() 2x, as well as, doing other calculations
							this lead to the diagnal objects being slow.  now one check is done to see if diagnal.  if it is, then it will pull
							the diagnal and move the object fast in the diagnal dir and then proceed to move it like normal then do the oob 
							checks.  now it is much faster.
					- modded movable() to check to see if link was hit by a mob projectile.  if so, then keep moving, instead of trying to 
							do a push stone.				
					- found that i could reduce the number of loops if i split the touch_mob() routine and made a routine that would just 
							calculate a mob being touched then run that routine to see if link was being touched by a mob during the animate_mob
							loop.  i also modded pain() to be usable with this new setup.  i saved a lot of calculations and 8 loops, with a max
							of 16 loops saved when touching a mob.
					- the faerie hearts that circle around link didnt display correctly, when the screen schifted, so i added the 
							fix_row_gain() to it to make sure it would display in the correct place.
					- removed the compass stuff for simple release. - readd compass stuff for v 0.9.4

			* 11/9/15 *
					- condinsed the follow_mob()
					- modded 	try_to_move_mob() so it would not loop the mob_follow or mob_bat routines.  these types would get stuck and
							would go in the quin-loop of try_to_move_mob() with the changing of directions.  this was slowing things down on
							the screen.  now it seems to be moving like normal. 
					
			* 11/13/15 *	(v 0.9.3  released)				
					- created the wait_for_keys() and made a wait_for_key() define
					- created the key_is_pressed() and removed the global vars for keya,b,c,...
					- made a patch for simple quest to allow v 0.9.3 to work.
						- found an error where it allowed the talk (x_ko) to infinite loop in msg(), b/c i did not keyx=TRUE in the \
							wait_for_key(), so i made the previously listed routines to fix it.


			* 11/14/15 *  (start of v 0.9.4) 
					- made the sprites for the flute and added them
					- increased the max_list_size to 42 (this is for the total number of items i can have)
					- added the flute to the item list.  
							- 1 item spot left.
					- modded the dll versioning again to make sure the new stuff wont load with the old.							
					- added type_flute to the defines					
					- created the displaying of the input box for the flute song
					- redid the note() to be lines instead of a sprite, b/c the sprites were not showing up.
					- did a basic coding of getting the song and executing the sl for it, but it needs to be tested.
				
			* 11/15/15 *			
					- changed the dungeon map system so it would have another sprite to let me know if i had been in that room or not.
					- added the flute menu to the start menu.
					- shortened the music list to 8x25.
							- 10 songs was ok, but i didnt feel like making a 2nd menu, then to add in the buttons for it would be annoying,
								so i reduced to 8 and made it look a little nicer.  now the song name is 15, instead of 20 in size.
					- as of right now, you can only learn a song via the sl (#28).			
					- the flute works now.  it even executes the sl assigned to it.
					- the new mapping changes work :)
			
			* 11/16/15 *			
					- got the algo on how to make the spikes from jesus.  worked perfectly the first time.
							- had errors only b/c change_dir() needed info from "case2" added to it.	
					- condinsed prevent_mob_oob()
			
			* 11/17/15 *			
					- added OBJECT to movable()
					- modded chk_obj_oob() to include spike and to condinse it
					- modded contact_link() to include spikes w/ the pain
					- modded the move_spike() to be an object instead of a mob
					- fixed bugs in with the spike and all the movable issues
							- now it deals damage.  
							- now it is the only object aware of its surroundings, with reguard of moving.
					- added item_spike to the defines.  
					- made sprite_id in the world[][] gfx, of 503 = item_spike, meaning that spikes will auto spawn
							like rocks and pots.
			
			* 11/18/15 *			
					- increased items to 45.
					- added toggle_switch to defines and as an item
					- added change_toggle_switch() to ezelda - sprite #13 and #135 are now locked as toggle switches
					- modded obj_contact() to check for toggle switch hit with the wand, boomerang, and arrow.
					- completed and tested, the toggle switch works well.
					- found an error with the auto spike settigs:  the moveable() did not take into consideration that sprite #503 was 
							movable. since this was the case, the spikes (#503) would not move from their spot b/c it was in a "no move"
							zone.  after 503 was added, the spikes worked normally.
					- i modded movable() to check to see if spikes would hit each other.  if they did, then they would reset themselves.
					- if you do not want link to walk on the toggle switch, then do not add it using a sl.  always make sure it is 
							instered via the map sprite #504.  this will keep link from moving onto that spot.		
			
			
			* 11/30/15 *			
					- added sword_eater, sword_giver, warp_hand to the creature lists
					- warp_hand uses reload(), but that adds like 400 bytes to the game, so i made it
						execute an sl, instead.  now sl #44 is perm sl number.  it will call reload()
						and that is it.\
					- added surprise(), reload(), obj_quickdraw(), and change_toggle_switch(), to the sl
						- this means that you can add an sl to a mob when it dies to have it toggle switch upon death.	
						- obj_quickdraw() was added so i could draw objects on the start menu via sl.
					- added exec_sl() to the start menu, so it will load the sl for the quests.	sl #46 is now perm sl number
					- added the warp_hand as a moving mob - needs to be tested though.
					- now its time for map making for crystaline destiny
			
			* various dates *
					- modded the map designer gui to include the compass and to make pictures of the maps
					- made more maps of dungeons for crystaline destiny
					- played the original zelda through and saw some various design things.
							- the original zelda seemed to have 4 different shoot object modes:
									1) lrud direction
									2) at link - the angle is desided based upon links angle at time of shooting
											- the sucker calculates based off of slope - with origin point vs link point = slope.
									3) boomerang type
									4) arrow_foe_multi_3  - this also operates off of slope. - changingthe diagnal move based off of slope
												might make things faster.
											
							- also, the enemy projectiles operated as if it used can_move(). if unable to move, then del_obj()
								
			* 12/08/15 *
					- modded gfx_reel_back() and made it so that link does not reel back out of the room in the even he is hit by
							something. - fixed this, b/c the original zelda did not do this.
											
			* 12/09/15 *			
					-redid the object and mob counting system.  instead of looping, i added in a set of vars that keeps track of the num
						of mobs/objects.  this prevents me from having to do 50 extra loops (via whiles) when calculating game_speed()
					- redid a the hookshot and made it so that it relied more on obj_var1, instead of dir.  it now uses the new obj 
							movement system.  instead of using return_dir, it uses var1=100 and it will make a perfect return every time.
					- removed the roman_candle() and replaced it with qslope()
					- readded arrow_at_link, since qslope() was added.	
					- modded qslope() to allow for mobs as well.  now everything that can follow link pretty much uses qslope().
					- added set_obj_stats() in weapons.c.  this allows you to reuse it in different routines.  game is a little smaller now.
					- removed init_multi_weapons()
					- added init_super_weap() in place of the old one.
			
			* 12/11/15 *				
					- fixed the bugs that redoing the obj moving system created
							- fixed spike, throw object, hookshot, boomerang.
					- added item_held_where(int item) in ezelda.  then did some shrinking of code. - saved about 100 bytes
					- i removed some "if i<inv_cols" statements from in front of the s_inv(), in various routines under the 
							link_stats.c.  they were there to prevent i=555, then trying to do a s_inv(555,num);  
							watch for funniness.
					-modded mob_exists(int id) in ezelda
			
			
			
			
			
			
			
			
			
			
			
					for the transistion effect - the new one, use 2 of the GrayDrawRect() to make the black area.  put them in the main 
							loop routine.  have them display after the terrain does.  also, add a transistion global var.  if it is active,
							then dont display the mobs or allow the keys to work for moving link. - only allow the terrain and link to
							be displayed.  when the transistion effect is over, set the transistion global var as false.
							
					for the sl tf markers, in the 200+ sl markers, have it set checked==TRUE.  - you will need a checked var.  
							if false, then find the false id.  if true, then find the true id.   when you reach the end if stmt, then
							set checked=FALSE.  if it comes accross anther if stmt, then check to see if checked==TRUE.  if true, then
							continue on.  if false, then find the corresponding end if location.  - this should remove the need for 
							the nester[].  and the nester functions.  it will allow for you to not pay attention if things are nested.
							it will only rely on the "checked" var.  granted, the "checked" var will become false if there is a nested 
							statement, but if it reaches an "end if", then it wont care.  it will just continue one.  but if it reaches
							another if statement, then it will search for its end and then skip it.  the nester should no longer be necessary, 
							thus freeing up space. 		

 */   			