// C Source File
// Created 7/12/2014; 6:24:24 PM

#include <tigcclib.h>
#include "all.h"

void pede_spacing_ok(int loc)
{

/*

both would have to be travelling the same dir.  if not, then forget the spacing

if the space between > move_speed, then increase travelling by (space-move_speed) - depends on dir travelling

if space between < move_speed, then move the body part back by (move_speed + space_needed) - depends on dir travelling


*/

				int spacer=2;// this decides how much space will be between the pede segments. - so 2 pixels currently.
				int a1=0, a2=0, wh1=0, wh2=0, dir=0, mdir1=up, mdir2=down;
				int who=loc-1;
				int wh=mob_w;
				int dir_loc=get_mob_stat(loc,mob_dir);
				int dir_who=get_mob_stat(who,mob_dir);		
				if (dir_who!=dir_loc){return;}//if not the same dir, then dont do anything.						
				int xy=mob_x;
				if ((dir_who==up) || (dir_who==down)){xy=mob_y;wh=mob_h;}				
				a1=get_mob_stat(loc,xy);// loc is chasing who
				a2=get_mob_stat(who,xy);
					
				wh1=mob_stat_flip(loc,wh);
				wh2=mob_stat_flip(who,wh);
				int gg=0;
				int sp_loc=offset_calculate(a1, wh1)-a1;
				int sp_who=offset_calculate(a2, wh2)-a2;
				int fix=0;
			
				switch (dir_who)
				{
					case up:
					case left:
						if (((a1+sp_loc)-(a2+16-sp_who))>spacer)// if the spacing is >spacer
						{fix=(((a1+sp_loc)-(a2+16-sp_who))-spacer)*(-1);}// be sure to decrease the spacing
						else if (((a1+sp_loc)-(a2+16-sp_who))<spacer)
						{fix=spacer-((a1+sp_loc)-(a2+16-sp_who));}
					break;
					case down:
					case right:
						if (((a2+sp_who)-(a1+16-sp_loc))>spacer)
						{fix=(((a2+sp_who)-(a1+16-sp_loc))-spacer);}
						else if (((a2+sp_who)-(a1+16-sp_loc))<spacer)
						{fix=((spacer-((a2+sp_who)-(a1+16-sp_loc)))*(-1));}						
					break;
				}// end switch dir


	
				mod_mob(loc,xy, fix,FALSE);

}

void pede_flag_adder(int loc, int dir)
{
	if ((loc>=max_mobs) || (get_mob_stat(loc,mob_type)!=pede_body)){return;}
	if (get_mob_stat(loc,mob_rand_var1)<0){mod_mob(loc, mob_rand_var1,dir,TRUE);}
	else if (get_mob_stat(loc,mob_rand_var2)<0){mod_mob(loc, mob_rand_var2,dir,TRUE);}
	else if (get_mob_stat(loc,mob_stops)<0){mod_mob(loc, mob_stops,dir,TRUE);}
	else {
		
//char bb[30];
//sprintf(bb,"%i %i %i %i %i ",loc, dir, get_mob_stat(loc,mob_rand_var1), get_mob_stat(loc,mob_rand_var2), get_mob_stat(loc,mob_stops));
//28 = mob_h
//add_print(0,70,bb);				
//disp_error(bb);			
		
	}
	
}// end flag adder

void change_pede_dir(int i)
{

			
			mod_mob(i, mob_dir,get_mob_stat(i,mob_rand_var1),TRUE);
			mod_mob(i, mob_rand_var1, (-100) , TRUE);// delete out the move flag
			
			
// force all the move flags to move up.			
			if (get_mob_stat(i,mob_rand_var2)>=0){mod_mob(i, mob_rand_var1,get_mob_stat(i,mob_rand_var2),TRUE);
					mod_mob(i, mob_rand_var2, (-100) , TRUE);}
			
			if (get_mob_stat(i,mob_stops)>=0){mod_mob(i, mob_rand_var2,get_mob_stat(i,mob_stops),TRUE); 
					mod_mob(i, mob_stops, (-100) , TRUE);}

// if you happen to have a -100 move, then force it to look at the previous mob to find which way to go.
			if ((get_mob_stat(i,mob_dir)<up) || (get_mob_stat(i,mob_dir)>right))
			{
				int q=i;
				while (q>=0)
				{
						
					q--;
					if ((get_mob_stat(q,mob_dir)>=up) && (get_mob_stat(q,mob_dir)<=right))
							{mod_mob(i, mob_dir,get_mob_stat(q,mob_dir),TRUE);q=(-1);}
				}// end while
				
			}// end if
			move_mob(i,  MOB_CONSTANT, get_mob_stat(i,mob_speed));
// force the new dir to be added to the next mob.
			pede_flag_adder(i+1, get_mob_stat(i,mob_dir) );
}

int pede_header(int loc)
{
	// use mob_stops for the direction, that is only used in one routine in the entire game and this is not
	// using that routine.
	// mob_rand_var2 and mob_rand_var1 for x/y postion of the previous
// this works for the simple stuff.  need some more logic to keep the sprites exactly "8" pixels apart
// also, it doesnt work if the head changes the direction before the pede_body reaches its destination - need some logic
// for that too.	
	int i=loc+1;
	int px=0, py=0, dir=0;
		px=get_mob_stat(loc,mob_x);
		py=get_mob_stat(loc,mob_y);
		dir=get_mob_stat(loc,mob_dir);
		if (can_move(loc, get_mob_stat(loc,mob_dir)))
				{	move_mob(loc,  MOB_CONSTANT, get_mob_stat(loc,mob_speed));}
				else {change_dir(loc);}
				prevent_mob_oob(loc);
		if (dir!=get_mob_stat(loc,mob_dir)){pede_flag_adder(i, get_mob_stat(loc,mob_dir));}
DrawImage(MOB, picture_rotator(loc, get_mob_stat(loc, mob_current_sprite)),get_mob_stat(loc,mob_x) , get_mob_stat(loc,mob_y), A_NORMAL, TRUE,0);

	if (i>=max_mobs){return loc;}


	while ((get_mob_stat(i,mob_type)==pede_body) && (i<max_mobs))
	{
//char bb[30];
//sprintf(bb,"%i %i %i %i %i %i %i %i",gg, a1, a2, mob_stat_flip(loc,wh), mob_stat_flip(who,wh),wh, offset_calculate(a2, wh2), offset_calculate(a1, wh1));
//28 = mob_h
//add_print(0,70,bb);				
//disp_error(bb);	
		if (can_move(i, get_mob_stat(i,mob_dir))) {move_mob(i,  MOB_CONSTANT, get_mob_stat(i,mob_speed));}
		else {

			change_pede_dir(i);

		}// end else
		prevent_pede_oob(i);
		pede_spacing_ok(i);
			
		
		DrawImage(MOB, picture_rotator(i, get_mob_stat(i, mob_current_sprite)),get_mob_stat(i,mob_x) , get_mob_stat(i,mob_y), A_NORMAL, TRUE,0);
		i++;
		// only on the event of change dir, do we change the dir of the previous and the x/y coords
		
	}// end while
	return i-1;
}// end pede head