// C Source File
// Created 7/15/2011; 3:31:25 AM
/*******************************************************************************/
/* Zelda Crystal Engine                                                       */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
/*

		this will have all of the actions of the weapons.  i believe you will load the wepaon gfx
		into this area as well, or maybe they will be included in a different file.  undecided at
		this point and time.

*/
#include "all.h"
extern int sword_charge,spinslash_active ,button_pressed;
extern int link_frame, link_x, link_y, link_direction, link_picture, dark_room;
/*void item_sword()
{
					//sword_charge=0;
	if (link_stat(dual_state) != LINK_SWORD)
		{link_frame = 0;sword_charge=0;spinslash_active=FALSE;}
	mod_link(dual_state,LINK_SWORD, TRUE);
			//		if ((link_stat(dual_state) != LINK_THRUST) &&(link_stat(dual_state) != LINK_WALKING_SWORD))
			//		{link_frame = 0;mod_link(dual_state,LINK_THRUST, TRUE);sword_charge=0;spinslash_active=FALSE;}
}// end use sword.*/

//=================================================================================================



void use_boomerang(int item)
{
	
	
	int id=0;
		if (obj_loc(item)==555){id=add_object(item_boomerang, fix_xy(link_x, 1), fix_xy(link_y,2), item_boomerang);
		if (id==555){return;}//prevent more than 1 boomerang on screen
		preset_obj(id, boomerang, -5, -5, item, 5);

	}
}

//=================================================================================================

void item_shield(){mod_link(dual_state,LINK_SHIELD, TRUE);}

//=================================================================================================

void use_wand(){mod_link(dual_state,LINK_WAND, TRUE);}// end wand

//=================================================================================================

void use_bottle(int item)
{

	if (link_stat(hp) < link_stat(max_hp)){
				switch (link_stat(button_pressed+18))
				{
					case 1 ... 2:	add_item_inv(item, -1);	break;
					case 3:				use_faerie(item);				return;
					default: return; 
				}// end switch
			mod_link(hp,512, TRUE);// max his hp
		}// end if hp < max
}
//=================================================================================================

void use_faerie(int item)
{
	add_item_inv(item, -4);
	add_object(item_faerie, link_x, link_y, item_faerie);// add a faerie to links location
}

//=================================================================================================

void use_light_orb(int item)
{// the light orb will change a room from dark to light, but it is a one shot item.
	if (link_stat(button_pressed+18)>0){// if you have more than zero items...
			if (dark_room==TRUE){dark_room=FALSE; add_item_inv(item, -1);set_object_animate_info(link_direction, dark_room);fill_current_room();}
			//else {msg(1, 13, TRUE, message);}// show that the room is already lit
		}
}// end light orb

//=================================================================================================

void use_arrow(int item)
{
	
	
	int id=0;
	if (link_stat(button_pressed+18)>0){
	id=add_object(item_arrow, fix_xy(link_x, 1), fix_xy(link_y,2), item_arrow);
	if (id==555){return;}
		preset_obj(id, friendly_arrow, 0, 0, item,5);
		add_item_inv(item, -1);// remove the arrows from the inventory.
	}// end if you have the arrows to do it.

}

//=================================================================================================
int bomb_dir_modder(int a)
{// this fixes the wierd offset for the bombs.
	int q=dir_to_sprite_xy_modder(link_direction, a, 6);
	if ((link_direction==up && a==2) || (link_direction==left && a==1)){q-=8;}
	return q;
}// end bomb dir modder

void use_bomb(int item)
{
	int id=0;
	if (link_stat(button_pressed+18)>0){
	id=add_object(item,fix_xy(link_x+bomb_dir_modder(1), 1), fix_xy(link_y+bomb_dir_modder(2),2), item);
	if (id==555){return;}
		preset_obj2(id, boom_bomb, 0, 0, item);
		add_item_inv(item, -1);// remove the bombs from the inventory.
	}
}


//=================================================================================================

void use_hookshot(int item)
{
	
	
	int id=0;
	if (obj_loc(item_hookshot)==555){
		id=add_object(item_hookshot, fix_xy(link_x, 1), fix_xy(link_y,2), item);
		if (id==555){return;}

		preset_obj(id, hookshot, 0, 0, item, 5);
		set_object(id, obj_pic, get_item_info(item,item_pic_2));

	}// end if you have the hookshot.

}

//=================================================================================================

//60585 ->60431

void set_obj_stats(int id, int dam, int type, int v1, int v2){
		set_object(id, obj_type, type);
		set_object(id, obj_var1, v1);
		set_object(id, obj_var2, v2);
		set_object(id, obj_dam,	dam);
}

void preset_obj2(int id, int typ, int v1, int v2, int item)
{
		// seperated specifically for the bomb, so we dont change its direction
		// this will prevent sideways and upsidedown bombs - save 40 bytes
		set_obj_stats(id, get_item_info(item, item_damage), typ, v1, v2);
		//set_object(id, obj_type, typ);
	//	set_object(id, obj_var1, v1);
	//	set_object(id, obj_var2, v2);
		//set_object(id, obj_dam, get_item_info(item, item_damage));
		link_frame = 0;mod_link(dual_state,LINK_GENERIC_ITEM, TRUE);
		
}

void preset_obj(int id, int typ, int v1, int v2, int item, int speed)
{
		preset_obj2(id, typ, v1,  v2,  item);
	//	set_object(id, obj_dir, link_direction);
		obj_dir_set(id, speed, link_direction);
		set_object(id, obj_rotate, dir_to_rotate(link_direction));
}