// C Source File
// Created 10/11/2012; 1:00:58 AM

/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"


unsigned short object_pic_light[object_gfx_size][16];
unsigned short object_pic_dark[object_gfx_size][16];
unsigned short object_pic_mask[object_gfx_size][16];
// 62683

//unsigned short rotated_pic_light[12][16];
//unsigned short rotated_pic_dark[12][16];// 1150 bytes
//unsigned short rotated_pic_mask[12][16];

extern char *light2;                    
extern char *dark2; 

extern int dk_room;
/*
void fill_rotated_pics()
{
unsigned short obj_t_light[16];// keeps the held items in buffer
unsigned short obj_t_dark[16];// keeps the held items in buffer
unsigned short obj_t_mask[16];// keeps the held items in buffer
int a=7, i=0, k=0, rotate=0, pic=quick_rotate_sprite_1, loc=0, q=0;
	for (q=0; q<3; q++){
		
		switch (q)
		{
			case 1: pic=quick_rotate_sprite_2; break;
			case 2: pic=quick_rotate_sprite_3; break;
		}		
	
		for (i=0; i<4; i++){
			
			switch (i)
			{
				case up:
					for (k=0; k<16; k++){
						obj_t_light[k]=object_pic_light[pic][k];
						obj_t_dark[k]=object_pic_dark[pic][k];
						obj_t_mask[k]=object_pic_mask[pic][k];
					}// end for
				break;
				default:
					if (i==left){a=8;rotate=rot_270;}else if (i==right){rotate=rot_90;}else {rotate=180;a=7;}
					RotateSprite16_R(object_pic_light[pic],obj_t_light, 16,a,8,rotate);
					RotateSprite16_R(object_pic_dark[pic], obj_t_dark, 16,a,8,rotate);
					RotateSprite16_R(object_pic_mask[pic], obj_t_mask, 16,a,8,rotate);
				break;
					
			}
			for (k=0; k<16; k++){
					rotated_pic_light[i+loc][k]=obj_t_light[k];
					rotated_pic_dark[i+loc][k]=obj_t_dark[k];
					rotated_pic_mask[i+loc][k]=obj_t_mask[k];
			}// end for k
		}// end for i
		loc+=4;
	}// end for q
}//*/


void obj_quickdraw(int x, int y, int pic, int draw_type, int rotate)
{
		char *lp=light2, *dp=dark2;
		if (draw_type==A_REVERSE){lp=dark2; dp=light2;}
		
	//	y -= (screen_shift+screen_row_gain*16);
		if (pic >=object_gfx_size){pic=object_gfx_size-1;}
		if (pic<0){pic=0;}
		if (rotate>0){if (rotate_image(x, y, rotate, pic, draw_type)){return;}}
		
		GrayClipSprite16_SMASK_R(x,y,16,object_pic_light[pic], object_pic_dark[pic], 
					object_pic_mask[pic],  lp , dp);
}

//=======================================================================================================


void draw_object(int loc)
{
		
		int draw_type=get_object(loc,obj_draw_type);
		if (draw_type==dissappear) {return;}
		int typ=get_object(loc,obj_type);
		if ((typ==pushable)&& (dk_room)){return;}
		
				//	int pic=get_object(loc,obj_pic);		
				//	int y=fix_row_gain(get_object(loc,obj_y));
				//	int x=get_object(loc,obj_x);
				//	int rotate=get_object(loc,obj_rotate);

		
		if (get_object(loc, obj_num)>=0){
		switch (typ)
		{
			case leaf:			animate_leaf(loc, TRUE);	return;//,item_leaf_pic,4
			case shatter:		animate_leaf(loc, 0); return;//,get_object(loc, obj_var1),get_object(loc, obj_var2)
			case explosion:	animate_bomb_explode(loc);				return;
			default:

		//		if ((pic>=600) && (pic<609)){pic =(pic-600)+rotate_to_dir(rotate);
		//			GrayClipSprite16_SMASK_R(x,y,16,rotated_pic_light[pic], rotated_pic_dark[pic], 
		//			rotated_pic_mask[pic],  light2 , dark2); return;}
		//	obj_quickdraw(x, y, pic,draw_type, rotate);
		obj_quickdraw(get_object(loc,obj_x), fix_row_gain(get_object(loc,obj_y)), get_object(loc,obj_pic),draw_type, get_object(loc,obj_rotate));
			break;
		}
	}

}//*/


//=======================================================================================================

void s_object_pic(int x, int y,unsigned short num, int which){// this is used
		if ((x<0) || (x>=object_gfx_size) || (y<0) || (y>=16)){return;}
		
		switch (which)
		{
			case 1:
				object_pic_light[x][y]=num;
			break;
			case 2:
				object_pic_dark[x][y]=num;
			break;
			case 3:
				object_pic_mask[x][y]=num;
			break;
		}
		
	
}// end set mob pic



//=======================================================================================================






int rotate_image(int pic_x, int pic_y, int rotate, int num,int draw_type)
{//rotate,pic_type, pic_num, button_pressed
	// obj_type was never used, b/c it was assumed that you would always rotate an object

		if (draw_type==A_REVERSE){return TRUE;}
		if ((rotate<=0) || (rotate>270)){return FALSE;}
		if ((num<0) || (num>=object_gfx_size)){return FALSE;}

unsigned short obj_t_light[16];// keeps the held items in buffer
unsigned short obj_t_dark[16];// keeps the held items in buffer
unsigned short obj_t_mask[16];// keeps the held items in buffer

				unsigned short obj_t_light2[16];// keeps the held items in buffer
				unsigned short obj_t_dark2[16];// keeps the held items in buffer
				unsigned short obj_t_mask2[16];// keeps the held items in buffer

		switch (rotate)
		{
			case rot_90:
				
				SpriteX8X8_ROTATE_RIGHT_R(16, object_pic_light[num], 2, obj_t_light);
				SpriteX8X8_ROTATE_RIGHT_R(16, object_pic_dark[num], 2, obj_t_dark);
				SpriteX8X8_ROTATE_RIGHT_R(16, object_pic_mask[num], 2, obj_t_mask);
			break;
			case rot_180:
				UpsideDownGrayClipSprite16_MASK_R(pic_x,pic_y,16 , object_pic_light[num], object_pic_dark[num], 
				object_pic_mask[num], object_pic_mask[num], light2 , dark2);
				
			return TRUE;
			case rot_270:		
			
				SpriteX8X8_ROTATE_LEFT_R(16, object_pic_light[num], 2, obj_t_light);
				SpriteX8X8_ROTATE_LEFT_R(16, object_pic_dark[num], 2, obj_t_dark);
				SpriteX8X8_ROTATE_LEFT_R(16, object_pic_mask[num], 2, obj_t_mask);

			break;
			case 100:// special to rotate the diagnal spinslash sword upside down.
				SpriteX8X8_ROTATE_LEFT_R(16, object_pic_light[num], 2, obj_t_light2);
				SpriteX8X8_ROTATE_LEFT_R(16, object_pic_dark[num], 2, obj_t_dark2);
				SpriteX8X8_ROTATE_LEFT_R(16, object_pic_mask[num], 2, obj_t_mask2);
									
				SpriteX8X8_ROTATE_LEFT_R(16, obj_t_light2, 2, obj_t_light);
				SpriteX8X8_ROTATE_LEFT_R(16, obj_t_dark2, 2, obj_t_dark);
				SpriteX8X8_ROTATE_LEFT_R(16, obj_t_mask2, 2, obj_t_mask);
			break;			
			default: return FALSE;
		}

			GrayClipSprite16_SMASK_R(pic_x,pic_y,16, obj_t_light, obj_t_dark, 
					obj_t_mask, light2 , dark2);
					
					
		return TRUE;			

}//*/



//=======================================================================================================




void animate_leaf(int loc, int which)
{
	int i=0, k=0,frame=get_object(loc, obj_frame), y=(get_object(loc, obj_y)-8), x=(get_object(loc, obj_x)-8);
	int x2=12, pic=get_object(loc,obj_pic), num=10; 
	
	if (which){
		
		switch (frame)
		{
			case 2 ... 3: x+=8; x2=4; y+=4; num=8; break;
			case 4 ... 5: x+=4; x2=9; y+=2;  break;
			case 6 ... 7: x+=10; x2=1; y+=4; num=6;  break;
		}// END SWITCH
	}// end if which
	else {
		y+=16; x+=16; num=4;x2=4;
		frame=2*frame;y-=frame;x-=frame;num+=frame;x2+=frame;
		if (frame>5){increase_object(loc,obj_frame,10);}// dont let it last more than 5 frames.
	}// end if the other type
	
		for (i=0; i<2; i++){for (k=0; k<2; k++){
			GrayClipSprite16_SMASK_R(x+(k*x2),fix_row_gain(y+(i*x2)),16,object_pic_light[pic], object_pic_dark[pic], 
																object_pic_mask[pic],  light2 , dark2);
			if (which){pic++;}												
	
		}
		y+=num;
	}// end fors
}//63557*/


//=======================================================================================================

void animate_bomb_explode(int loc)
{
		int pic=item_bomb_explode_pic, frame=get_object(loc,obj_frame), i=0, k=0;
		
		while (i<2){while (k<2){
			if (frame>=6 && frame<=10){pic=item_bomb_explode_pic+4;}// the last pic
			GrayClipSprite16_SMASK_R(get_object(loc,obj_x)+(k*16), fix_row_gain(get_object(loc,obj_y)+(i*16)),
					16,object_pic_light[pic], object_pic_dark[pic], object_pic_mask[pic],  light2 , dark2);
			pic++;
			k++;
		}// end while k
		i++;k=0;
	}// end while i	
}// end animate bomb explode
//=======================================================================================================


