// C Source File
// Created 2/3/2013; 3:29:52 AM
/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"

int  link_dir=0, dk_room=0;


void set_object_animate_info(int dir, int dk)
{

	link_dir=dir;
	dk_room=dk;
}






//============================================================================================

void slash_terrain(int row, int col)
{
	if ((row>7) || (row<0) || (col<0) || (col>9)){return;}
	switch (get_all_maps(rmapx, rmapy,row,col))
	{
		//--------------------------------------------------------
		// If Link slashes PLANT1 or GRASS1, change it to GRASS2
		//--------------------------------------------------------
		case 0:	//plant (aka sprite #0)
		case 82: //GRASS1

			set_all_maps(rmapx, rmapy,row,col, get_room_info(base_sprite));
			// this will change the sprite to what the room base sprite should be.
			// that way it can be anything and not just 25 all of the time, which is gay.

			//---------------------------------------------------
			// Add the dissolving leaf animation to object_list
			//---------------------------------------------------
		
			add_object(item_leaf, col*16, row*16,item_leaf);
			//---------------------------------------------------
			// Random chance of getting a heart or crystal
			//---------------------------------------------------
			
			drop_item(col*16, row*16,-1);
		break;
	}// end switch
}// end slash terrain.


//============================================================================================
/*  drop item with ai */
void drop_item(int x,int y,int who)
{// change rnd to 7
//65327 -> 65533 ~206 bytes more
//	ths will decide if an item should be dropped or not.

		int item=get_mob_stat(who,mob_item);
		if (item>999){add_object(item, x,y,item);goto end;}
		int rnd=7,type=item_rupie, lhp=link_stat(hp), lmhp=link_stat(max_hp);//, type2=0;
		int bombs_exists=item_type_exists( bomb, either), arrows_exists=item_type_exists( arrow, either);
		int bombs_amt=item_amt(item_bomb, FALSE), arrows_amt=item_amt(item_bow, FALSE);
		if (lhp<((int)(lmhp*.3))){rnd-=2;}
	 item=0;
	if (!random(rnd))//x>0)//!random(8))//8
	{
	
		if ((lhp>((int)(lmhp/2))) && (bombs_exists) && (bombs_amt<=0)){item=item_bomb; goto bypass;}//type2=bomb;type=BOMB2;
		if ((lhp>((int)(lmhp/2))) && (arrows_exists) && (arrows_amt<=0)){item=item_arrow;goto bypass;}//type2=arrow;type=ARROW2;
		if (lhp>=lmhp)
		{
			if ((bombs_amt<link_stat(max_bombs))&& (bombs_exists)){item=item_bomb;}//type2=bomb;type=BOMB2;
			else if ((arrows_amt<link_stat(max_arrows)) && (arrows_exists)){item=item_arrow;}//type2=arrow;type=ARROW2;
			else {item=item_rupie;}//type=CRYSTAL1;
			
		}else {
			//type=HEART1;item=0;
			item=item_heart;
			if (!random(120)){type=item=item_faerie;}
		}		

		bypass:
	//	if ((type2==arrow) || (type2==bomb)){item=item_type_exists(type2,3);}
		add_object(item, x,y,item);
	}// end if rand()
	end:
}// end drop item*/


//============================================================================================





//============================================================================================

int fix_xy(int x, int which)
{
	if (x<object_x_min_oob){x=object_x_min_oob;}
	if (which==1)// for x.  any other number will be for y
	{	if (x>object_x_max_oob){x=object_x_max_oob;}}
	else if (which==2){if (x>object_y_max_oob){x=object_y_max_oob;}}// for y
	
	return x;
}

//============================================================================================



//============================================================================================
//
//============================================================================================




//=================================================================================================




//============================================================================================



//============================================================================================

