// C Source File
// Created 7/17/2011; 2:29:45 PM
/*******************************************************************************/
/* Zelda Crystal Engine                                                       */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"


extern char *light, *dark;


void add_print(short x,short y,const char* s) {
  
    GraySetAMSPlane(DARK_PLANE);
    DrawStr(x,y,s,A_NORMAL);
    GraySetAMSPlane(LIGHT_PLANE);
    DrawStr(x,y,s,A_NORMAL);

}
void debug()
{
	GrayDrawRect(0,78,144,88,COLOR_WHITE,RECT_FILLED);
	add_print(0,80,dbg);
	wait_for_key(x_ko);
}//*/
void disp_error(const char* s)
{
	GrayDrawRect(0,78,144,88,COLOR_WHITE,RECT_FILLED);
	add_print(0,80,s);
wait_for_key(x_ko);
	//wait_for_a_sec(2);
}

void disp_error_num(int a, int b, int c)
{
	GrayDrawRect(0,78,144,88,COLOR_WHITE,RECT_FILLED);
	char s[50];
	sprintf(s,"a=%i, b=%i, c=%i",a,b,c);
	add_print(0,80,s);
	//wait_for_a_sec(2);
	wait_for_key(x_ko);
}

void blk_menu(int x, int y, int torp, int box_color, int line_color){

//COLOR_BLACK, COLOR_WHITE, COLOR_DARKGRAY
			if ((torp<1) || (torp>4) || (x<0) || (x>96) || (y<0) || (y>37)){return;}// if out of bounds, then do nothing.
						
			int xmaxor=0,ymaxor=0;
			if (torp==1){xmaxor=159;ymaxor=34;}// end if torp==1  maxor = 153 
			else if (torp==2){xmaxor=64+x;ymaxor=64+y;}
			else if (torp==3){xmaxor=64+x;ymaxor=34+y;}
			else if (torp==4){xmaxor=159;ymaxor=99;}// this is for the prologue - uses black background and white lines
			// warning, if you go above 3, then you will have to adjust below, or the grey line array will get an oob error and crash
			// the calculator.

			GrayDrawRect(x,y,xmaxor,ymaxor,box_color,RECT_FILLED);
			if (torp==4){x++;y++;xmaxor=157;ymaxor=97;}
		
		
	int n=0; if (torp==3){n=30;torp=2;}
	/*		int arr[2 * 8 * 4]=
			// i readjusted the main gfx, so i could adjust the size of the display box to whatever i wanted. - just adjust the 
			// x/ymaxors and the passed in params for the blank box.
			{x+1,y,xmaxor-1,y, x+1,ymaxor-1,xmaxor-1,ymaxor-1, x+3,y+2,xmaxor-3,y+2, x+3,ymaxor-3,xmaxor-3,ymaxor-3, 
				x,y+1,x,ymaxor-2, xmaxor,y+1,xmaxor,ymaxor-2, x+2,y+3,x+2,ymaxor-4, xmaxor-2,y+3,xmaxor-2,ymaxor-4, // torp ==1
		//	{6,0,152,0, 6,33,152,33, 8,2,150,2, 8,31,150,31, 5,1,5,32, 153,1,153,32, 7,3,7,30, 151,3,151,30, // torp ==1
			 x+1,y,x+62,y, x+1,y+63-n,x+62,y+63-n, x+3,y+2,x+60,y+2, x+3,y+61-n,x+60,y+61-n, x,y+1,x,y+62-n, 
			 x+63,y+1,x+63,y+62-n, x+2,y+3,x+2,y+60-n, x+61,y+3,x+61,y+60-n};// adjusted so it could be put anywhere.

			if (torp==4){torp=1;}
			int chk=(torp-1)*8*4;
			while (chk<torp*8*4)
			{	
			 	GrayDrawLine(arr[chk + 0],arr[chk + 1],arr[chk + 2],arr[chk + 3], line_color);
			 	chk+=4;
			}// end while		*/
			ff_box_color(x,  y, xmaxor, ymaxor,line_color);
			if (n==30){add_print(x+28, y+6, "Yes"); add_print(x+28, y+20, "No");}

}// end blk menu

/*
void blk_menu(int x, int y, int torp){


			if ((torp<1) || (torp>3) || (x<0) || (x>96) || (y<0) || (y>37)){return;}// if out of bounds, then do nothing.
						
			int xmaxor=0,ymaxor=0;
			if (torp==1){xmaxor=159;ymaxor=34;}// end if torp==1  maxor = 153 
			else if (torp==2){xmaxor=64+x;ymaxor=64+y;}
			else if (torp==3){xmaxor=64+x;ymaxor=34+y;}

			GrayDrawRect(x,y,xmaxor,ymaxor,COLOR_WHITE,RECT_FILLED);
		
		
		
	int n=0; if (torp==3){n=30;torp=2;}
			int arr[2 * 8 * 4]=
			// i readjusted the main gfx, so i could adjust the size of the display box to whatever i wanted. - just adjust the 
			// x/ymaxors and the passed in params for the blank box.
			{x+1,y,xmaxor-1,y, x+1,ymaxor-1,xmaxor-1,ymaxor-1, x+3,y+2,xmaxor-3,y+2, x+3,ymaxor-3,xmaxor-3,ymaxor-3, 
				x,y+1,x,ymaxor-2, xmaxor,y+1,xmaxor,ymaxor-2, x+2,y+3,x+2,ymaxor-4, xmaxor-2,y+3,xmaxor-2,ymaxor-4, // torp ==1
		//	{6,0,152,0, 6,33,152,33, 8,2,150,2, 8,31,150,31, 5,1,5,32, 153,1,153,32, 7,3,7,30, 151,3,151,30, // torp ==1
			 x+1,y,x+62,y, x+1,y+63-n,x+62,y+63-n, x+3,y+2,x+60,y+2, x+3,y+61-n,x+60,y+61-n, x,y+1,x,y+62-n, 
			 x+63,y+1,x+63,y+62-n, x+2,y+3,x+2,y+60-n, x+61,y+3,x+61,y+60-n};// adjusted so it could be put anywhere.

		
			int chk=(torp-1)*8*4;
			while (chk<torp*8*4)
			{	
			 	GrayDrawLine(arr[chk + 0],arr[chk + 1],arr[chk + 2],arr[chk + 3], COLOR_DARKGRAY);
			 	chk+=4;
			}// end while		

			if (n==30){add_print(x+28, y+6, "Yes"); add_print(x+28, y+20, "No");}

}// end blk menu*/
void disp_pointer(int x, int y)
{
		unsigned char pointer_l[]={0xe7,0xe7,0xc3,0xc3,0x81,0x81,0xFF,0xff};
		GraySprite8_AND(x, y, 8, pointer_l, pointer_l, light, dark);
}



//===============================================================================================


//===============================================================================================


void select(int x, int y, int type, int which)
{
	int arr[6][4]={{0,0,0,16},{1,0,1,0},{1,16,1,16},{28,0,28,16},{27,0,27,0},{27,16,27,16}};
	int i=0,k=0;int e=0;
	if ((which==arrow) || (which ==white_arrow)){// creates the arrow.
		while (i<6){
			while (k<3){arr[i][k]=i;k++;	}
			arr[i][3]=(10-i);
			i++;k=0;
			
	}
	}// end if arrow
	
	
	if (which==chi_arrow){// creates the arrow.
		e=2;i=2;
		while (i<6){
	
		
				while (k<3){arr[i][k]=i;k++;	}
				arr[i][3]=(10-i);
		
			i++;k=0;
			
	}
	}// end if chi arrow	
	
	 
	if (which==msg_arrow){// creates the arrow.
		e=2;i=2;
		while (i<6){
		//	if (i<2){while (k<4){arr[i][k]=0;k++;	}}
		
				while (k<4){
				if (k==2){arr[i][2]=(10-i);}
				else {arr[i][k]=i;}
				k++;	}// end while
				
		
			i++;k=0;
			
	}
	}// end if arrow	
	if (which==LINK){
		e=i=4;k=0;
		
		while (k<3){
			arr[4][k]=1;//+(i-4);
			arr[5][k]=2;
			k++;
		}
		arr[4][3]=2;
		arr[5][3]=1;
		
	}// end if link
/*	if (which==1234){// creates the compass arrow.
		e=2;i=2;
		while (i<6){
	
		
				while (k<4){arr[i][k]=i;k++;	}
				arr[i][3]=(10-i);
		
			i++;k=0;
			
	}
	}// end if chi arrow*/
	if (which==1234){// creates the arrow.
		e=2;i=2;
		while (i<6){
		//	if (i<2){while (k<4){arr[i][k]=0;k++;	}}
		//  0, 0, 1, 0
		// -1, 1, 2, 1
		// -2, 2, 3, 2
				while (k<4){
				if (k==2){arr[i][2]=i-1;}
				else if (k==0){arr[i][0]=i-e;}
				else {arr[i][k]=i-2;}
				k++;	}// end while
				
		
			i++;k=0;e+=2;
			
	}
	e=2;
	}// end if arrow	
				 	if (which == white_arrow)
			 	{
			 		
			 		if (type==COLOR_BLACK){type=COLOR_WHITE;}
			 		else {type=COLOR_BLACK;}// reverse them to allow for a black background

			 		
			 	}
			while (e<6)
			{
			 	
				GrayDrawLine(arr[e][0]+x,arr[e][1]+y,arr[e][2]+x,arr[e][3]+y, type) ;

			 	e++;
			}// end while
			
			
}// end selector

//===============================================================================================

/*
		this draw hearts routine is designed for faster display of hearts

*/
void draw_hearts2(int x, int y, int reverse)
{
// draw hearts with lines instead of pics. - uses 12 or 15 lines - first dark, then grey/white
//256 loops w/ full hearts
int m_hp=link_stat(max_hp);
int current_hp=link_stat(hp);
int m_d_hearts=(int)(m_hp/16);// get how many double hearts
if (m_hp>(m_d_hearts*16)){m_d_hearts++;}


int a=x-16+4,b=y;
// 76 x 24

// predefined hearts for link.  there are single hearts and 2x hearts, where there are 2 hearts on one sprite
// this is designed this way to speed up the heart drawing routine.
unsigned short hearts_gfx_l[8][16]={
// 1x heart
	{0x0000,0x0000,0x0000,0x0000,0x0000,0x06c0,0x0920,0x0820,0x0820,0x0440,0x0280,0x0100,0x0000,0x0000,0x0000,0x0000}, // blank heart
	{0x0000,0x0000,0x0000,0x0000,0x0000,0x06c0,0x0f20,0x0d20,0x0c20,0x0640,0x0380,0x0100,0x0000,0x0000,0x0000,0x0000}, // half heart
	{0x0000,0x0000,0x0000,0x0000,0x0000,0x06C0,0x0FE0,0x0D60,0x0C60,0x06C0,0x0380,0x0100,0x0000,0x0000,0x0000,0x0000},	//Heart1
// 2x hearts
  {0x0000,0x0000,0x0000,0x0000,0x0000,0x6c6c,0x9292,0x8282,0x8282,0x4444,0x2828,0x1010,0x0000,0x0000,0x0000,0x0000},// 2 e 
  {0x0000,0x0000,0x0000,0x0000,0x0000,0x6c6c,0xf292,0xd282,0xc282,0x6444,0x3828,0x1010,0x0000,0x0000,0x0000,0x0000},// 1h 1 e 
  {0x0000,0x0000,0x0000,0x0000,0x0000,0x6c6c,0xfe92,0xd682,0xc682,0x6c44,0x3828,0x1010,0x0000,0x0000,0x0000,0x0000},//1 f 1 e 
  {0x0000,0x0000,0x0000,0x0000,0x0000,0x6c6c,0xfef2,0xd6d2,0xc6c2,0x6c64,0x3838,0x1010,0x0000,0x0000,0x0000,0x0000},// 1f 1 h	
  {0x0000,0x0000,0x0000,0x0000,0x0000,0x6c6c,0xfefe,0xd6d6,0xc6c6,0x6c6c,0x3838,0x1010,0x0000,0x0000,0x0000,0x0000},//2x full
  
};// end light hearts 
 
unsigned short hearts_gfx_d[8][16]={
// 1x heart
	{0x0000,0x0000,0x0000,0x0000,0x0000,0x06c0,0x0920,0x0820,0x0820,0x0440,0x0280,0x0100,0x0000,0x0000,0x0000,0x0000},// blank heart
	{0x0000,0x0000,0x0000,0x0000,0x0000,0x06c0,0x0920,0x0a20,0x0b20,0x0540,0x0280,0x0100,0x0000,0x0000,0x0000,0x0000}, // half heart
	{0x0000,0x0000,0x0000,0x0000,0x0000,0x06C0,0x0920,0x0AA0,0x0BA0,0x0540,0x0280,0x0100,0x0000,0x0000,0x0000,0x0000},	//Heart1
// 2x hearts	
	{0x0000,0x0000,0x0000,0x0000,0x0000,0x6c6c,0x9292,0x8282,0x8282,0x4444,0x2828,0x1010,0x0000,0x0000,0x0000,0x0000},// 2e
	{0x0000,0x0000,0x0000,0x0000,0x0000,0x6c6c,0x9292,0xa282,0xb282,0x5444,0x2828,0x1010,0x0000,0x0000,0x0000,0x0000},// 1h 1e
	{0x0000,0x0000,0x0000,0x0000,0x0000,0x6c6c,0x9292,0xaa82,0xba82,0x5444,0x2828,0x1010,0x0000,0x0000,0x0000,0x0000},// 1 f 1 e
	{0x0000,0x0000,0x0000,0x0000,0x0000,0x6c6c,0x9292,0xaaa2,0xbab2,0x5454,0x2828,0x1010,0x0000,0x0000,0x0000,0x0000},// 1f 1 h
	{0x0000,0x0000,0x0000,0x0000,0x0000,0x6c6c,0x9292,0xaaaa,0xbaba,0x5454,0x2828,0x1010,0x0000,0x0000,0x0000,0x0000},//2x full

};// end dark hearts

unsigned short hearts_gfx_m[2][16]={
{~0x0000,~0x0000,~0x0000,~0x0000,~0x0000,~0x06C0,~0x0FE0,~0x0FE0,~0x0FE0,~0x07C0,~0x0380,~0x0100,~0x0000,~0x0000,~0x0000,~0x0000},	//Heart1
{~0x0000,~0x0000,~0x0000,~0x0000,~0x0000,~0x6c6c,~0xfefe,~0xfefe,~0xfefe,~0x7c7c,~0x3838,~0x1010,~0x0000,~0x0000,~0x0000,~0x0000},//2x mask
};// end mask hearts


//3,4,5,6,7
//16, 12, 8,4,0
	int i=0, pic=0, pic_m=1;

		if (reverse){a+=(((a+16*4)-(a+(m_d_hearts*16))));if (m_hp<(m_d_hearts*16)){a+=8;}}
		if (a<(x-16+4)){a=(x-16+4);}// [revent the negative offset.
		// simply find the offset of max total from current total.  the +12 is for the single heart offset.

				redo:
				if (i>=m_d_hearts){return;}
				if (m_hp>=16){
					if (current_hp>=16){pic=7;}else {pic=3+(int)(current_hp/4);}
					if ((current_hp-=16)<0){current_hp=0;}
					a+=16;// do this after the display, otherwise it will look funny...
				}
				else {pic=(int)(current_hp/4);pic_m=0;a+=12;}// end if max hp is <16
					
				GrayClipSprite16_SMASK_R(a,b, 16, hearts_gfx_l[pic], hearts_gfx_d[pic], hearts_gfx_m[pic_m],light,dark);

				
				if (a>((x-16+4)+(8*7))){a=x-16+4;b+=8;}// when you draw all the hearts, if there are more, then drop down a line.
				if ((m_hp-=16)<0){m_hp=8;}
				i++;
		goto redo;


}// end draw hearts


//=======================================================================================================

/*/59313
void draw_line_heart(int x, int y, int clr) - bad bad bad - doesnt display
{	// y1, y2, x1, x2
// black lines
//COLOR_WHITE=0, COLOR_LIGHTGRAY=1, COLOR_LGRAY=1, COLOR_DARKGRAY=2, COLOR_DGRAY=2, COLOR_BLACK=
	int max=0, i=0, color=0;
	switch (clr)
	{
		case 1: max=7;color=COLOR_BLACK; break;
		case 2: i=7; max=12;color=COLOR_LGRAY; break;
	}
	
	int arr[12][4]=
	{{x, y+1, x, y+3},//+1, +3, 0, 0
	{x+6, y+1, x+6, y+3},//+1, +3, +6, +6
	{x+1, y, x+1, y+4},// 0, 4, 1,1
	{x+5, y, x+5, y+4},// 0, 4, 5,5
	{x+2, y, x+2, y+5},// 0, 5, 2,2
	{x+4, y, x+4, y+5},// 0, 5, 4,4
	{x+3, y+1, x+3, y+6},// 1, 6, 3,3
	
// grey	/ white

	{x+1, y+1, x+1, y+3},// 1, 3, 1,1
	{x+5, y+1, x+5, y+3},// 1, 3, 5,5
	{x+2, y+1, x+2, y+4},// 1, 4, 2,2
	{x+4, y+1, x+4, y+4},// 1, 4, 4,4
	{x+3, y+2, x+3, y+5}};// 2, 5, 3,3

			
			while (i<max)
			{
			 //	GrayFastDrawLine2B_R(plane0, *plane1, x1,y1,x2,y2, color) - this takes up about 150 more bytes...
			 //		GrayFastDrawLine2B_R(light, dark, arr[e][0],arr[e][1],arr[e][2],arr[e][3], COLOR_DARKGRAY);
			 	GrayDrawLine(arr[i][0],arr[i][1],arr[i][2],arr[i][3], color) ;
			 	//58858
			 //	GrayFastDrawLine2B(arr[i][0],arr[i][1],arr[i][2],arr[i][3], color, GrayGetPlane(light), GrayGetPlane(dark)) ;
			 	//DrawLine (short x0, short y0, short x1, short y1, short Attr);
			// 	DrawLine(arr[e][0],arr[e][1],arr[e][2],arr[e][3],A_NORMAL);
			 i++;
			}// end while
}// end draw line heart
//void draw_hearts3(int x, int y)*/

//=======================================================================================================
extern int link_y, link_x;
void wait_for_a_sec(int time)
{
	OSFreeTimer (USER_TIMER);
	OSRegisterTimer (USER_TIMER, time);
	while (!OSTimerExpired (USER_TIMER));
}
void suprise(int x, int y, int time)
{
	if (x>999){x=link_x; y=link_y-16;}
	if ((x<-5) || (y<-5) || (x>155) || (y>90)){return;}
	unsigned short explan[2][16]={
		{0x07e0,0x1818,0x2184,0x43c2,0x43c2,0x83c1,0x83c1,0x8181,0x8181,0x4182,0x4002,0x2184,0x1998,0x0420,0x0240,0x0180},
		{~0x07e0,~0x1ff8,~0x3ffc,~0x7ffe,~0x7ffe,~0xffff,~0xffff,~0xffff,~0xffff,~0x7ffe,~0x7ffe,~0x3ffc,~0x1ff8,~0x07e0,~0x03c0,~0x0180}};//end exp

	GrayClipSprite16_SMASK_R(x,fix_row_gain(y), 16, explan[0], explan[0], explan[1],light,dark);
	save_scr();
	//disp_error_num(x,y,link_y);
		wait_for_a_sec(time*4);
	//wait_for_key(b_ko);
}//end suprise

void note(int x, int y)
{
	unsigned char no[]={0x04,0x04,0x04,0x04,0x3c,0x7c,0x7c,0x38};
	GraySprite8_MASK_R(x, y, 8, no, no, no, no, light, dark);
}

//=======================================================================================================
void map_room(int x,int y)//59785
{
	unsigned short rm[2][16]={
			{0x0000,0x0000,0x0000,0x0000,0x0180,0x1ff8,0x1008,0x300c,0x300c,0x1008,0x1ff8,0x0180,0x0000,0x0000,0x0000,0x0000},
			{~0x0000,~0x0000,~0x0000,~0x0000,~0x0180,~0x1ff8,~0x1ff8,~0x3ffc,~0x3ffc,~0x1ff8,~0x1ff8,~0x0180,~0x0000,~0x0000,~0x0000,~0x0000}};
	GrayClipSprite16_SMASK_R(x,y,16,rm[0],rm[0],rm[1],light,dark);
}
