// C Source File
// Created 7/15/2011; 3:13:36 AM
/*******************************************************************************/
/* Zelda Crystal Engine                                                       */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"
#include "dung_maps.h"
#include "rooms.h"

/*

		this will handle the inventory system.  the inv[] is in the save section, so use extern int
		for it.  this will be a pictoral like inventory system, so it may have the items / weapons
		gfx shared with this.  the items will have a section which will tell this which gfx to use
		(ie the arr location)

		use item type 

*/
extern char *light, *dark;
//keya, keyb, keyl, keyr, keyu, keyd, keys, keye, 
extern int  disp_hearts, heart_x, heart_y,heart_reverse;
extern int exited,link_direction,slowdown;//ter_ani_speed,
extern int button_pressed,dark_room,debug_mode;
int inventory_active=FALSE;
//extern int inv[10][30];// about 600 bytes.
//key_is_pressed(
void save_link_config()
{
// save the config you did with link.
	mod_link(save_heart_xpos, heart_x, TRUE);
	mod_link(save_heart_ypos, heart_y, TRUE);
//	mod_link(save_animation_speed, ter_ani_speed, TRUE);
	mod_link(save_disp_hearts, disp_hearts, TRUE);
	mod_link(save_debug_mode, debug_mode, TRUE);
	mod_link(save_speed_limiter, slowdown, TRUE);
}// end save link config


void restore_link_config()
{
// restore the config you did with link.
	heart_x=link_stat(save_heart_xpos);
	heart_y=link_stat(save_heart_ypos);
//	ter_ani_speed=link_stat(save_animation_speed);
	disp_hearts=link_stat(save_disp_hearts);
	debug_mode=link_stat(save_debug_mode);
	slowdown=link_stat(save_speed_limiter);
	mod_link(hold_carry,-1,TRUE);
}// end restore_link_config


void clr_planes(){GrayClearScreen2B_R(light,dark);}
/*
void clr_scr()
{
//GrayClearScreen() ;
//	char *bb=0;
//	FastCopyScreen(0,GetPlane(LIGHT_PLANE));
//	FastCopyScreen(0,GetPlane(DARK_PLANE));
//	memset(GetPlane(LIGHT_PLANE),0,LCD_SIZE);
//	memset(GetPlane(DARK_PLANE),0,LCD_SIZE);
	clr_planes();
//	memset(light,0,LCD_SIZE);
//	memset(dark,0,LCD_SIZE);
}// end clear the screen*/

void save_scr()
{
				FastCopyScreen(light, GetPlane(0));
	 			FastCopyScreen(dark, GetPlane(1));
			//	memcpy(GetPlane(0),light,LCD_SIZE);
			//	memcpy(GetPlane(1),dark,LCD_SIZE);
}


// cause the displayer to be a set of drawlines.  

//=================================================================================================



	/*
	key code:
	0 = no key pressed
	1 = 2nd
	2 = shift
	3 = up
	4 = down
	5 = left
	6 = right
	7 = start
	8 = escape key
	*/
	

//=================================================================================================

	
void inventory()
{
	//LCD_BUFFER screen; //SAVE THE SCREEN SO YOU CAN RETURN IT BACK TO NORMAL AFTERWARDS.

				// use an erase var that if true, then erase, if false, then dont erase
 			  // LCD_save(screen); 
	clr_scr();// clear out the screen
//	inventory_active=TRUE;
	disp_inv();
	inv_selector(1,1, 4, 1,1, 1, 3, 1, 2, box);

}// end inventory

//=================================================================================================
void ff_box_color(int x, int y, int w, int h, int color)
{// 0,0, 76h, 159w
	if (y+h>99){h=h-y;}
	if (w+x>159){w=w-x;}//allow lazy boxes
	int arr[8][4]={
	{x+1, y, x+w-1, y},//{1,0,158,0}
	{x+3, y+2, x+w-3, y+2},// first top line hor {3,2,156,2}
	
	{x+1, y+h, x+w-1, y+h},// bottom line hor  {1,76,158,76}
	{x+3, y+h-2, x+w-3, y+h-2}, //{3,74,156,74}
	
	{x, y+1, x, y+h-1},//{0,1,0,75}
	{x+2, y+3, x+2, y+h-3},//{2,3,2,73}
	
	{x+w, y+1, x+w, y+h-1},//{159,1,159,75}
	{x+w-2, y+3, x+w-2, y+h-3}};//{157,3,157,73}
	
//	int arr[15][4]={{1,0,158,0},{3,2,156,2},{3,74,156,74},{1,76,158,76},{3,78,156,78},
//			{3,97,156,97},{1,99,158,99},{0,1,0,75},{0,77,0,98},{2,3,2,73},{2,79,2,96},
//			{157,3,157,73},{157,79,157,96},{159,77,159,98},{159,1,159,75}};ff_box(0, 76, 159, 99)
			int e=0;
			while (e<8)
			{
			 //	GrayFastDrawLine2B_R(plane0, *plane1, x1,y1,x2,y2, color) - this takes up about 150 more bytes...
			 //		GrayFastDrawLine2B_R(light, dark, arr[e][0],arr[e][1],arr[e][2],arr[e][3], COLOR_DARKGRAY);
			 	GrayDrawLine(arr[e][0],arr[e][1],arr[e][2],arr[e][3], color) ;
			 	//58858
			 //	GrayFastDrawLine2B(arr[e][0],arr[e][1],arr[e][2],arr[e][3], color, GrayGetPlane(light), GrayGetPlane(dark)) ;
			 	//DrawLine (short x0, short y0, short x1, short y1, short Attr);
			// 	DrawLine(arr[e][0],arr[e][1],arr[e][2],arr[e][3],A_NORMAL);
			 	e++;
			}// end while
}


int bottle_pic_modder(int i, int which)
{
	int pc=0, item=0;

			if (which==1){pc=g_inv(2,i);item=g_inv(1,i);}
			else {pc=link_stat(i+18);item=link_stat(i);}
	if (pc>3){pc=3;} if (pc<0){pc=0;}// prevent oob errors.
	if (get_item_info(item,item_type)!=bottle){pc=0;}// end if
	return get_item_info(item,item_pic_id)+pc;

}

void disp_inv()
{
	
			
		//	DrawImage(short pic_type, short pic_num, short pic_x, short pic_y, short draw_type)
			//	DrawImage(OBJECT, CRYSTAL1, 76, 80, A_NORMAL, FALSE);
				
				/*
				#define item_id 0
#define item_type 1
#define item_pic_id 2
#define item_cost 3
#define item_damage 4
#define item_hold 5
#define item_duration 6
*/				//inventory_active=TRUE;
					
					int i=0,x=0,y=0, item=0;
					char n[5];
					while (i<12)// this is the max size of the current inventory is 12
					{
						
						//select(10+(27*x)+(10*x),8+(5*y)+(16*y),type);
					//	item=g_inv(1,i);
						if (g_inv(1,i)>999){obj_quickdraw(10+(27*x)+(10*x), 8+(5*y)+(16*y), bottle_pic_modder(i, 1), A_NORMAL, 0);}//DrawImage(OBJECT, bottle_pic_modder(i, 1), 10+(27*x)+(10*x), 8+(5*y)+(16*y), A_NORMAL, FALSE,0);}
						x++;
						if (x>3){x=0;y++;}// these 2 lines should cycle through properly.
						if (y>2){y=2;}
						i++;
					}// end while
				
			//	*/
				
			if (link_stat(hold_a)>999)	{obj_quickdraw(16, 80,bottle_pic_modder(hold_a, 2), A_NORMAL, 0);}//DrawImage(OBJECT, bottle_pic_modder(hold_a, 2), 47, 80, A_NORMAL, FALSE,0);}
			if (link_stat(hold_b)>999)	{obj_quickdraw(67, 80,bottle_pic_modder(hold_b, 2), A_NORMAL, 0);}//DrawImage(OBJECT, bottle_pic_modder(hold_b, 2), 10, 80, A_NORMAL, FALSE,0);}
			if (link_stat(hold_c)>999)	{obj_quickdraw(118, 80,bottle_pic_modder(hold_c, 2), A_NORMAL, 0);}
				//DrawImage(OBJECT, SWORD3, 10, 108, A_NORMAL);// these are for the a and b
				//DrawImage(OBJECT, SWORD3, 47, 108, A_NORMAL);
			//	gfx_disp_hearts(90,80);
				
				save_scr();
				//memcpy(GetPlane(0),light,LCD_SIZE);
			//	memcpy(GetPlane(1),dark,LCD_SIZE);
				
			//	printf_xy(88,87,"%i",link_stat(rupies));
			if (get_item_info(link_stat(hold_b),item_type)!=bottle){	
				if (link_stat(hold_b_amt)>0){sprintf(n, "%i",link_stat(hold_b_amt));add_print(67+15,87,n);}}
			if (get_item_info(link_stat(hold_a),item_type)!=bottle){	
				if (link_stat(hold_a_amt)>0){sprintf(n, "%i",link_stat(hold_a_amt));add_print(16+15,87,n);}}
			if (get_item_info(link_stat(hold_c),item_type)!=bottle){	
				if (link_stat(hold_c_amt)>0){sprintf(n, "%i",link_stat(hold_c_amt));add_print(118+15,87,n);}}
			ff_box(0, 0, 159, 75);//0, 76,99, 159 
			ff_box(0, 75, 159, 99);
		/*	int arr[15][4]={{1,0,158,0},{3,2,156,2},{3,74,156,74},{1,76,158,76},{3,78,156,78},
			{3,97,156,97},{1,99,158,99},{0,1,0,75},{0,77,0,98},{2,3,2,73},{2,79,2,96},
			{157,3,157,73},{157,79,157,96},{159,77,159,98},{159,1,159,75}};
			int e=0;
			while (e<15)
			{
			 //	GrayFastDrawLine2B_R(plane0, *plane1, x1,y1,x2,y2, color) - this takes up about 150 more bytes...
			 //		GrayFastDrawLine2B_R(light, dark, arr[e][0],arr[e][1],arr[e][2],arr[e][3], COLOR_DARKGRAY);
			 	GrayDrawLine(arr[e][0],arr[e][1],arr[e][2],arr[e][3], COLOR_DARKGRAY) ;
			 	//DrawLine (short x0, short y0, short x1, short y1, short Attr);
			// 	DrawLine(arr[e][0],arr[e][1],arr[e][2],arr[e][3],A_NORMAL);
			 	e++;
			}// end while*/

					i=0,x=0,y=0;
					while (i<12)// this is the max size of the current inventory is 12
					{// this will display the numbers of the items if they have numbers to them.
						
						//select(10+(27*x)+(10*x),8+(5*y)+(16*y),type);
						item=g_inv(1,i);
						if (item>999){ if ((g_inv(2,i)>0) && (get_item_info(g_inv(1,i),item_type)!=bottle)){
							sprintf(n, "%i",g_inv(2,i));
						add_print(15+10+(27*x)+(10*x), 7+8+(5*y)+(16*y),n);}}
						
						x++;
						if (x>3){x=0;y++;}// these 2 lines should cycle through properly.
						if (y>2){y=2;}
						i++;
					}// end while
			
			
			add_print(9,80,"A");
			add_print(60,80,"B");
			add_print(111,80,"C");
			
			
			select(16,79 ,COLOR_BLACK, box);// the selects for the a and b
			select(67,79 ,COLOR_BLACK, box);
			select(118,79 ,COLOR_BLACK, box);
			
			
	// sword3 is for the up sword
	/*
		concept: cycle through the inventory and if you find a certain object, then disp it.
		actually, the item list should have an object_pic_id on it so just pull that and then disp it.
		
		
		
	
	*/
}// this will display the inventoy


//=================================================================================================

void switch_item(int pos, int i)
{// 26557
	/*
	
		this will switch the item in the inventory for the a or b button.
	*/
	//(x*y)-1
 	int item=g_inv(1,i);// doing it this way actually takes up less bytes
 	int item_amount=g_inv(2,i);
 		

	s_inv(1,i,link_stat(pos));
	s_inv(2,i,link_stat(pos+18));// +18 is b/c it is 18 spaces between the hold item and the hold item's ammount
	mod_link(pos, item, TRUE);// add the item to link holding
	mod_link(pos+18, item_amount,TRUE);
	
	//int loc=inv_item_loc(item, FALSE);// get the item location...
	//remove_item_inv(item,-32000,FALSE);// subtract all items
	//add_item_inv(l_item, item_amt, FALSE);// add the item to the inventory.
	
}// end switch item


//=================================================================================================

void draw_gotten_objects()
{

	int loop=1;
	int itm=0, type=0;
	int x=88, y=55;
		
		obj_quickdraw(55, 55, get_item_info(item_key_normal,item_pic_id), A_NORMAL, 0);
				//DrawImage(OBJECT, get_item_info(item_key_normal,item_pic_id), 55, 55, A_NORMAL, FALSE,0);
		if (item_amt(item_key_boss,TRUE)>0)// only display in the event that you have this item
		{obj_quickdraw(73, 55, get_item_info(item_key_boss,item_pic_id), A_NORMAL, 0);}
	//	{DrawImage(OBJECT, get_item_info(item_key_boss,item_pic_id), 73, 55, A_NORMAL, FALSE,0);}

redo:

		switch(loop)
		{
			case 1: type=key_master;  itm=item_key_master;  break;
			case 2: type=gauntlet;    itm=item_gauntlet;    break;
			case 3: type=bomb_bag;    itm=item_bomb_bag;    break;
			case 4: type=rupie_bag;   itm=item_rupie_bag;   break;
			case 5: type=tunic;       itm=item_tunic;				break;
			case 6: type=ring;        itm=item_ring;				break;
			case 7: type=hover_boots; itm=item_hover_boots; break;
			case 8: type=raft;  		  itm=item_raft;				break;
			case 9: type=quiver;  		itm=item_quiver;			break;
			case 10: goto end; break;
			
		}
		
		
		if (loop==5){y-=20;x=59;}
		
		if (item_type_exists(type,4))
		{obj_quickdraw(x, y, get_item_info(itm,item_pic_id), A_NORMAL, 0);if (loop<5){x+=18;}else {x+=20;}}//DrawImage(OBJECT, get_item_info(itm,item_pic_id), x, y, A_NORMAL, FALSE,0);
		loop++;
goto redo;

end:		

	
}// gotten objects


void draw_menu_objects()
{
		//	clr_scr();
		draw_hearts2(89,76,0);
	//	gfx_disp_hearts(89,75);
		obj_quickdraw(55, 80, get_item_info(item_rupie,item_pic_id), A_NORMAL, 0);
		//DrawImage(OBJECT, CRYSTAL1, 55, 80, A_NORMAL, FALSE,0);
	//	if (item_type_exists(key_normal,4)) - i think ill always let this print. just be sure to add it to the inv in the beginning.

}

char *name(char *n)
{// this will be used for the message system as well..
	
	sprintf(n,"%c%c%c%c%c%c ",link_stat(link_letter_1),link_stat(link_letter_2),link_stat(link_letter_3),
		link_stat(link_letter_4),link_stat(link_letter_5),link_stat(link_letter_6));// quest	
	return n;
}

void disp_name(int x, int y)
{
		char n[7];
		name(n);
//		sprintf(n,"%c%c%c%c%c%c ",link_stat(link_letter_1),link_stat(link_letter_2),link_stat(link_letter_3),
//		link_stat(link_letter_4),link_stat(link_letter_5),link_stat(link_letter_6));// quest	
		add_print(x,y,n);
		 
}

void disp_menu(int disp_others)
{
		//57465
		char n[5];
		 FontSetSys (F_6x8);// redo the font so the item list will look better. - this is the normal font.
				sprintf(n,"%i",link_stat(rupies));
				add_print(67,87,n);
				//if (item_type_exists(key_normal,4)){
					
				if (disp_others){
					
					sprintf(n,"%i",item_amt(item_key_normal, TRUE));
					add_print(65,64, n);
					disp_name(58,7);
					}
				
	//	int e=0;
		
		// x1, x2 w, y1, y2 h
		//0,55, 0,99
		//55, 159, 0, 77
		// 55, 89 , 77, 99
		// 89, 159, 77, 99
		
		ff_box(0, 0, 55, 99);
		ff_box(55, 0, 159, 77);
		ff_box(55, 77, 89-55, 99);
		ff_box(89, 77, 159, 99);
//		int arr[22][4]={{1,0,158,0},{3,2,52,2},{56,2,156,2},/*{50,74,156,74},*/
//		/*{49,76,158,76}*/{3,97,52,97}/*{50,78,94,78},{98,78,156,78}*/,{56,97,88,97},
//		{92,97,156,97},{1,99,158,99},{0,1,0,98},{2,3,2,96},{53,3,53,96},
		/*{49,3,49,73},{49,79,49,96},{95,79,95,96},{97,79,97,96},*/
		/*{157,79,157,96},{157,3,157,73},{159,1,159,75},{159,77,159,98},*/
		
//		{56,73,156,73},{56,77,88,77}, {55,75,158,75}, {92,77,156,77},
//		{55,78,55,96},{157,78,157,96}, {89,78,89,96}, {159,76,159,98},
//		{91,78,91,96},{55,3,55,72},{159,1,159,74},{157,3,157,72}
//		};
/*			while (e<22)
			{
			 	GrayDrawLine(arr[e][0],arr[e][1],arr[e][2],arr[e][3], COLOR_DARKGRAY) ;
			 //	DrawLine(arr[e][0],arr[e][1],arr[e][2],arr[e][3],A_NORMAL);
			 	e++;
			}// end while*/
			add_print(15,10, "Items");// items
			add_print(15,25, "Quest");// quest
			add_print(15,40, "Map");// maps
			add_print(15,55, "Config");// config
			if (get_room_info(no_save)<=0){add_print(15,70, "Save");}
			else {add_print(15,70, "NoSave");}// save
			add_print(15,85, "Quit");// exit
		//	printf_xy(62,87, "Stats");
		//	print_gold();
			
	//}// end main menu		
}// end disp menu

void full_menu(int disp_others)
{
	clr_scr();
				draw_menu_objects();
				if (disp_others){draw_gotten_objects();}
				save_scr();
				disp_menu(disp_others);
			//	save_scr();
				
}

void start_menu()
{
		inventory_active=TRUE;
		full_menu(TRUE);
		
	int i=0, key=0, show_map=FALSE;
	
	while (i!=1)
	{
		
		//int inv_selector(int x,int xlow, int xhigh, int xmove, 
		//							int y, int ylow, int yhigh, int ymove, int menu)
		key= inv_selector(6,6,6,0, 8, 8, 83, 15, 1, arrow);
		
				switch (key)//60431
				{
					case 8:
						inventory();
						show_map=FALSE;
					break;
					case 23:
						show_map=FALSE;
					break;
					case 38:
						if (g_over_world_stat(overworld_dungeon_num, oob())>0){show_map=TRUE;}
						else {show_map=FALSE;}
					break;
					case 53:
						config();
						show_map=FALSE;
					break;
					case 68://save						
						if (get_room_info(no_save)>0){msg(1,10,TRUE);}// end if you cannot save here
						else{save();}	// end else if you can save here.
					break;
					case 83:// exit
						i=1;
						exited=TRUE;// exit the game
					break;
					case 555:// f1 was pressed.
					i=1;
					break;
				}// end switch
				if (show_map){disp_map();}
				else {full_menu(TRUE);}

	}// end while
	inventory_active=FALSE;
}//end start menu

//=================================================================================================

//=================================================================================================
void speeder()
{// 1 for terrain, 2 for speed
		full_menu(FALSE);
		FontSetSys(F_4x6);// redo the font so it is small again.
		char n[27];
	//	if (which==1){sprintf(n,"Terrain Animation Speed: %i",3);}
	//	else {sprintf(n,"Speed Limiter:  < %i >",slowdown);}
		sprintf(n,"Speed Limiter:  < %i >",slowdown);
		
		add_print(60,5, n);
		add_print(70,15, "0 - Fastest");
		add_print(70,25, "1");
		add_print(70,35, "2");
		add_print(70,45, "3");
		add_print(70,55, "4");
		add_print(70,65, "5 - Slowest");
}

int speeder_selector()
{
	int key=0;
	redo:		
		key= inv_selector(61,61,61,0, 12, 12, 62, 10, 1, chi_arrow);	
		if (key>=12 && key<=62){return (((key+3+5)/10)-2);}
		else if (key==555){return 555;}
	goto redo;		
	return 555;
}

/*void terrain_animation_speed()
{
	
	int i=0;
	beg:
		speeder(1);
		if ((i=speeder_selector())==555){return;}
	//	else {ter_ani_speed=i;}
	goto beg;	

}// end terrain animation speed
*/
void game_slowdown()
{
	
	int i=0;
	beg:
		speeder();
		if ((i=speeder_selector())==555){return;}
		else {slowdown=i;mod_link(save_speed_limiter, slowdown,TRUE);}
	goto beg;	

}// end game_slowdown()

//=================================================================================================



void heart_disp_loc()
{
		int i=0, key=0;
		redo:
		full_menu(FALSE);
		//disp_menu();
	FontSetSys (F_4x6);// redo the font so it is small again.
		add_print(60,10, "Hearts will be displayed in");
		add_print(60,20, "the:");
		if (heart_y==(-2)){add_print(80,20, "upper");} else {add_print(80,20, "lower");}
		if (heart_x==90){add_print(103,20, "right corner");} else {add_print(103,20, "left corner");}
		add_print(70,30, "upper left corner");
		add_print(70,40, "lower left corner");
		add_print(70,50, "upper right corner");
		add_print(70,60, "lower right corner");
	//	printf_xy(70,30, "5 - slowest");
				
				
				while (i!=1){
			
		key= inv_selector(61,61,61,0,27, 27, 57, 10, 1, chi_arrow);	
			
		
					switch (key)
				{

//gfx_disp_hearts(89,75)
					case 27:// upper left
						heart_x=0;
						heart_y=(-2);
						heart_reverse=FALSE;
						goto redo;
					break;
					case 37:// lower left
						heart_x=0;
						heart_y=(77);
						heart_reverse=FALSE;// this is so the hearts will appear in the right hand side of the screen instead
						// of somewhere in the middle.
						goto redo;
					break;
					case 47:// upper right
						heart_x=90;
						heart_y=(-2);
						heart_reverse=TRUE;
						goto redo;
					break;
					case 57:// lower right
						heart_x=90;
						heart_y=(77);
						heart_reverse=TRUE;
						goto redo;
					break;															
					case 555:// f1 was pressed.
					i=1;
					break;
				}// end switch
			}// end while	
			
		
}// end heart disp loc
// disp_hearts=1, heart_x=90, heart_y= -2;


//=================================================================================================




void config()
{// this menu system took about 2k to create.
	 //int inv_selector(int x,int xlow, int xhigh, int xmove, 
//									int y, int ylow, int yhigh, int ymove, int menu, int selector_type);
	 int key=0, i=0;
	 
	 
	 beg:
	 full_menu(FALSE);
	 
	// disp_menu();
	 FontSetSys (F_4x6);// redo the font so it is small again.
		add_print(70,20, "Speed Limiter");
	//	add_print(70,20, "Terrain Animation Speed");// quest
		add_print(70,30, "Heart Location");// maps
		if (disp_hearts){add_print(70,40, "Hearts Visible:     <YES>");}// config
		else {add_print(70,40, "Hearts Visible:     <NO>");}// config
		if (debug_mode){add_print(70,50, "<Debug Mode>    <ON>");}// config
		else {add_print(70,50, "<Debug Mode>    <OFF>");}
	//	add_print(70,60, "More");// config
		
		
		while (i!=1){
			
		key= inv_selector(61,61,61,0, 17, 17, 47, 10, 1, chi_arrow);	
			
		
					switch (key)
				{
				//	case 7:// removing contrast and makeing it in f3.f5 in the main routine reduced
				//		game_slowdown();
				//		goto beg;
				//	break;
					case 17:
						game_slowdown();
					//	terrain_animation_speed();
						goto beg;
					break;
					case 27:
						heart_disp_loc();
						goto beg;
					break;
					case 37:
						if (disp_hearts){disp_hearts=FALSE;}
						else {disp_hearts=TRUE;}
						goto beg;
					break;
					case 47://debug mode
						if (debug_mode){debug_mode=FALSE;}
						else {debug_mode=TRUE;}
						goto beg;
					break;	
					case 555:// f1 was pressed.
					i=1;
					break;
				}// end switch
			}// end while	
	// FontSetSys (F_6x8);// reset the font back to normal just in case something happens.
}
//=================================================================================================

void disp_map()
{
	
	int i=0,k=0,pic_x=57,pic_y=2,dm=0 ;//59354
	clr_scr();
	draw_menu_objects();
	while (i<8){
		while (k<8)
		{// obj#32 is the room.
	//	DrawImage(OBJECT, 32, pic_x, pic_y, A_NORMAL, 0,0);
	
			dm=g_dung_map(i,k);
			if ((dm==1) || (dm==2)){map_room(pic_x, pic_y);}
		//	{obj_quickdraw(pic_x, pic_y, 33, A_NORMAL, 0);}//DrawImage(OBJECT, 33, pic_x, pic_y, A_REVERSE, 0,0);}
		//	else if (g_dung_map(i,k)==2){obj_quickdraw(pic_x, pic_y, 33, A_NORMAL, 0);}//DrawImage(OBJECT, 33, pic_x, pic_y, A_NORMAL, 0,0);}
			pic_x+=12;
			
			k++;
		}// end while k
		
		pic_x=57;
		pic_y+=8;
	i++;k=0;
	}// end while i
	
		
		save_scr();
		disp_menu(FALSE);
/*
		in order to create the compass system, you will need to add teh compass in here.
		just like you did a check to see if the map existed, you will need to do the same
		you will need to have a room flag that says "special item room" which is what will
		draw the compass triangle., assumming that you want to do the compass system.
		hell, screw the compass system.  just expand the maps to 15 or 20 and make the 
		game really long.
*/		
		select(link_stat(map_y)*12+57+6, link_stat(map_x)*8+2+6, COLOR_BLACK,LINK);// this shows where like is located
	//	if (compass_exists()){select(compass_x(TRUE)*12+57+6+1, compass_x(FALSE)*8+2+6, COLOR_BLACK,1234);}
		// need another select for if compas exists 
		
}
          
          

//=================================================================================================

//=================================================================================================
//=================================================================================================

//=================================================================================================
//=================================================================================================

//=================================================================================================
//=================================================================================================

//=================================================================================================          