// C Source File
// Created 7/15/2011; 3:26:28 AM
/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"
/*

			this will be for the storyline stuff.  - like moving, msgs, load mobs into room, load treasure
			chest, if die then restore if you have farie, 

			mod_mob
			mod_link
			if link_stat()
			chk_xy (or check_sprite/sprite area)
			msg
			mod_sprite(rmapx, rmapy, y,x, new_sprite)
		
			would need at least 6 areas for info.

*/

int story_line[sl_max][sl_width];// this seems to be the only location of this variable.
int nester[15];
int last_story=0;//={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}, last_story=0;
//extern int warp_transistion, notransistion;
//extern int town_active,world[60][109];
//extern int pic;
int obj_id=0;
extern int  shop_active, link_x, link_y, link_direction, exited;


int arr_checker(int tag, int yn)
{
	int i=0;
	while (i<15)
	{/// yn is a t/f var that is used to determine whether i want if the tag exists or exact loc of tag.
		if (nester[i]==tag){if (yn){return TRUE;}else{return i;}}
		i++;
	}// end while
	if (yn){return FALSE;}
	return 555;
}
//arr_checker(0, FALSE)

int find_tag(int story_id,int tag, int iff_id)
{
	while (story_id<sl_max)
	{
		if ((story_line[story_id][0]==tag) && (iff_id <=0)){
			
				if ((story_line[story_id][0]>=11) && (story_line[story_id][0]<=14))
				{// if it is an iff stmt tag, then try to find if the unique iff tag id's match.
					if (story_line[story_id][4]==0) {disp_error("Error! Unique If tag id is 0 - fix it.");}
					else if (arr_checker(story_line[story_id][4], TRUE)){break;}// if it is the correct [4] tag,
					 // then quit out.  - it will still give the exact location, so you will need to i-- in order for it
					// to execute the the end iff stmt.  it is done here, so i will not have to create logic
					// for it in other places.  just remember what you did so you dont have problems down the road.
					// if the iff tag id == 0 then throw an error message.  they should all have unique id #'s
					else {story_id++;}// if not, then carry on and attemt to find the real one.
				}
				else{	break;}
		
		}
		else if ((story_line[story_id][0]==tag) && (iff_id == story_line[story_id][4]))
		{// this will find match the tag and iff id in the event the iff id is given. - the iff id should always
		// be greater than 1
			break;
		}// end if we want to match the id.
		else {story_id++;}
	}// end while
	//story_line++;// increase the store line once more, b/c if you found it, then you want the next line
	// of code after the if stmt.  if there is another use for the find tag, then update the code
//if (story_id>=sl_max){msg(1,4,TRUE);}// error! cannot find tag.
	return story_id;
}// end if true


void get_story(int story)
{
//sl_iftrue=0; sl_iffalse=0;// if you are getting a new one, then clear out the false an true stmts.
//printf("\ngetting story, ls=%i, st=%i, sl=%i",last_story,story, story_line[0][0]);
if ((story==0) || (story==last_story)){goto end;}// prevent the sl from being called if you have already called it.
TRY

    FILE *f = NULL;
    //short int fileio = TRUE;
		char messa[10];
		
		sprintf(messa,"zstry%i",story);
		FolderCur(SYMSTR("sl"),TRUE);
    // open file for reading in binary mode
    if ((f = fopen(messa,"rb")) == NULL) { // this opens up the message file
      //  fileio = FALSE;
    } else {
        // read data from file into inv
        if (fread(story_line,sizeof(story_line),1,f) != 1) {
             //fileio = FALSE;
        }
	
       // close the file
        fclose(f);
    }
 ONERR
 		//goto end;// if it fails, then dont do anything.
 ENDTRY
 last_story=story;   	
// printf("\ngot story, ls=%i, st=%i, sl=%i",last_story,story, story_line[0][0]);
 end:
}// end get story


		/*============================================
		
			the story checker was made to go through an 
			entire case switch routine so the same routine
			could be used by both the main and town reoutines
			otherwise this routine would have to be made 2x
			which would be really annoying and a waste of 
			space
		
		==============================================*/
/*

void print_nester()
{	
	int i=0;
	printf("\n");
	while (i<15)
	{
		printf("%i,",nester[i]);
		i++;
	}
}*/
int story_checker(int i, int tag)
{// 54 tags imped so far
	int answer=FALSE;//,b=0;//,prei=0;
	//char tmp[28];
	// 60381->60610
//	if (ypos>1500){tag=1;}
	//if (nest<0){nest=0;}if (nest>5){nest=5;}// this will prevent address errors if someone puts if stmts
	// before a checker.
	//printf("tag=%i  id=%i",tag,story_line[i][4] );ngetchx();
	//int pic=get_pic(TRUE);
switch(tag)
			{
	
		 /*
		 
		 		these are the things you need to add in:
		 		
		 		mod link
		 		mod mob
		 		mod room
		 		add object
		 		next_world_map
		 		load_rooms() - to load the current room after you change his x/y on world map
		 				- the teleport command could just force link to x/y in room ??? and do a check for that room and then set his x/y coords
		 		chk_for _stat(stat, <>=, number) - returns true or false.
		 		add_item_inv(
		 		msg
		 		yn box?
		 		pain
		 */
		 
		 case 1:
		 	
		 	mod_link(story_line[i][1],story_line[i][2],story_line[i][3]);// stat, amt, t/f
		 break;
		 case 2:
		 	add_item_inv(story_line[i][1],story_line[i][2]);//int item, int amt, int ext);
		 break;
		 case 3:// first cfall the add object.  then call the mod_obj, b/c the obj id will be stored
		 // in a global int after you call add object.  then you can mod the object how you want after
		 // you add it.  you must modify the object directly after you add it, otherwise you will
		 // be modding the unknown.
		 	obj_id=add_object(story_line[i][1],story_line[i][2],story_line[i][3],story_line[i][4]);//object pic#, x, y);
		 break;
		 case 4:
		 	set_object(obj_id,story_line[i][1],story_line[i][2]);//int id (list_num?), int stat, int num)
		 break;
		 case 5:
		 		init_terrain(story_line[i][1],story_line[i][2]);
		 	//next_world_map(story_line[i][1]);
		 break;
		 case 6:
		 	get_map_vars();
		 //	load_rooms();
		 break;
		 case 7:// activate shop
		 //	if (link_stat(map_x)==story_line[i][1] && link_stat(map_y)==story_line[i][2] && link_stat(ow_id)==story_line[i][3])
		 	  shop_active=TRUE;
		 break;
		 case 8:// set x/y
		 		link_x=story_line[i][1];
		 		link_y=story_line[i][2];
		 		set_inv_xy();
		 		
		 break;
		 case 9:// add_quest(int type, int num)
		 		add_quest(story_line[i][1],story_line[i][2]);
		 break;
		 // add the blow ones later on.
		 //set_room_maps(int a, int b, int c, int d,int num)
		 
		 
		 
		//==================================
		//	the if tags are identifyer tags
		//	they dont do anything but identify
		//	that this is where the if stmt 
		//	starts and ends.
		//==================================
		
				case	11: // if_true returned: <11>
					if (arr_checker(story_line[i][4], TRUE)){}
					//	if (nester[arr_checker(story_line[i][4], FALSE)][1]==TRUE){}// then execute the code beneith it.
						else{i=find_tag(i,12,story_line[i][4]);}// if not, then find its end tag.  - this should
						// skip all other nested stmts
				//if (nester[nest]==FALSE){i=find_tag(i,12);}// find the end of this stmt and then carry on.
//printf("nester[nest]=%i",nester[nest]);
				//sl_iftrue++;
				
			//		i= find_tag(i,11);
		break;   
				case	12: // end_if_true: <12>
				//	if (arr_checker(story_line[i][4], TRUE)){nester[arr_checker(story_line[i][4], FALSE)][0]=0;}
			//	printf("\narrchk=%i sl=%i arrloc=%i",arr_checker(story_line[i][4], TRUE), story_line[i][4],arr_checker(story_line[i][4], FALSE));
			//	b=arr_checker(story_line[i][4], FALSE);
		//	print_nester();
				if (arr_checker(story_line[i][4], TRUE)){nester[arr_checker(story_line[i][4], FALSE)]=0;}
			//	print_nester();
			//	printf("\naftereffect=%i",nester[b]);
				// if you did execute the correct code, then attempt this.
			//	sl_iftrue--;
				//	i=find_tag(i,12);
		break;   
				case	13: // if_false <13>
					//	if (nester[arr_checker(story_line[i][4], FALSE)][1]==FALSE){}
					//	b=arr_checker(story_line[i][4], FALSE);
				//	printf("\n13: arrchk=%i sl=%i arrloc=%i i=%i",arr_checker(story_line[i][4], TRUE), story_line[i][4],arr_checker(story_line[i][4], FALSE),i);	
				//	print_nester();
						if (arr_checker(story_line[i][4], TRUE)){}// then execute the code beneith it.
						else{i=find_tag(i,14,story_line[i][4]);}// if not, then find its end tag.  - this should
					//	print_nester();
				//	printf("\ni=%i b=%i",i,b);	
		break;   
				case	14: // end_if_false <14>
				//	if (arr_checker(story_line[i][4], TRUE)){nester[arr_checker(story_line[i][4], FALSE)][0]=0;}
			if (arr_checker(story_line[i][4], TRUE)){nester[arr_checker(story_line[i][4], FALSE)]=0;}
			//	sl_iffalse--;
			//		i=find_tag(i,14);
		break;   
				case	15:// goto <story_id>: <15>, <story_id>
					i=story_line[i][1];
					i--;// minus i, b/c it gets added to at the very end of this routine.
		break;   
				case	16:// goto new story line at story_id: <16>, <story_line>, <story_id>
					i=story_line[i][2];// reset the array location # first, otherwise the # will be wrong.
					i--;// remember, the i gets added to later on.
					get_story(story_line[i][1]);// call the new story line
					
		break; 
				case 17:// modify current room - you mgith want to redo it to make it work more right.
					set_all_maps(rmapx, rmapy,story_line[i][1],story_line[i][2],story_line[i][3]);//row,col, sprite/info);
				break;
//	case 18:// this is a redundant form that would allow you to set room info using the defines:
	//			set_room_info(rmapx(),rmapy(),story_line[i][1],story_line[i][2]);//int which, int num)
	//	break;
		// logic
				case 20://add a treasure box to the room.
				// <x_pos>,<y_pos>,<item held>,<quantity>,<sl marker>
				//story_line[i][1],story_line[i][2],story_line[i][3],story_line[i][4],story_line[i][5]
				if (!(get_treasure_marker(story_line[i][5]))){// simply put, it will only add a treasure box
				// in the event that the treasure box has already been gotten.  so essentially, you can simply
				// put an empty treasure box on the map and just put a treasure box item over the top of it.
							obj_id=add_object(item_treasure_chest,story_line[i][1],story_line[i][2],item_treasure_chest);
							//set_object(int id, int stat, int num)
							set_object(obj_id,obj_var1,story_line[i][3]);// mod the treasure box to have the correct items. -item
							set_object(obj_id,obj_var2,story_line[i][4]);//amt
							set_object(obj_id,obj_dam,story_line[i][5]);//slot
							set_object(obj_id,obj_type,treasure_box);// set it as a treasure box
						//	obj_var1, obj_var2, obj_dam,obj_type
						}// end if the treasure has not been gotten yet.
					//	#define treasure_amt 3// for either gold or item amount.
					//	#define treasure_slot 4// for the inventory slot to say that the treasure has been gotten.
					//	#define treasure_item 5// what item the treasure box holds.
//	printf(" %i %i",get_object(obj_id,treasure_amt), obj_id);wait_for_key(esc_ko);
				break;
				case 21:	set_rset(story_line[i][1]);														break;// find and set the ow's for an rset.
				case 22:	link_direction=story_line[i][1];											break;// set link direction
				case 23:	s_transistion(0);	s_transistion_active(1);						break;// first transistion effect (close screen)
				case 24:	prologue(story_line[i][1],story_line[i][2]);					break;// play a message
				case 25:	exited=TRUE; return sl_max+1;														break;// exit the game exited=20;
				case 26:	msg(story_line[i][1],story_line[i][2],TRUE);	break;// display a message
				case 27:	s_transistion(50);	s_transistion_active(2);						break;// 2nd transistion effect (open screen)
				
 		case 200:
 			answer=item_type_exists(story_line[i][1],story_line[i][2]);
 		//	sprintf(dbg, "%i %i %i", answer, story_line[i][1],story_line[i][2]);debug();
 		break;
		case 201:// this will check to see if you are in the correct room  <roomx> <roomy> <overworld>
//		link_stat(map_x), link_stat(map_y), g_world(link_stat(map_x),link_stat(map_y)
		//	answer=TRUE;// for now, do this 
			// add in for a check to see if the current room is correct, check roomx() and roomy();
			if (link_stat(map_x)==story_line[i][1] && link_stat(map_y)==story_line[i][2] && oob()==story_line[i][3])
			{answer=TRUE;}else {answer=FALSE;}// oob() gives back the overworld.
			/*if (i>15){
			sprintf(tmp,"%i %i %i %i %i %i %i", story_line[i][3], oob(), story_line[i][1], link_stat(map_x), story_line[i][2], link_stat(map_y), answer);
			disp_error(tmp);
			}*/
	//		if (rmapx()==story_line[i][1] && rmapy()==story_line[i][2]){answer=TRUE;}else {answer=FALSE;}
		break;

	}// end switch
/*--------------------------------
	if you happen upon a logic tag
	then go ahead and relocate the
	i pos to the correct if tag and
	then execute from there. 
---------------------------------*/		
		
		if ((tag>=200) && (tag<300))// ie if a logic tag
		{// a more extensive algo needed for this.  this is only good for 1 stmt at a time.  redo to have nested
		// stmts.  if it finds a true tag inside of a false tag, then increase true.  if it finds a end if stmt
		// within the main if stmt, then reduce the correct ifxxxx.  if the ifxxxx==0, then it is obviously the 
		// end of the stmt.  if they forgot tags, then it will be thier logic prblem.  if the loop hits eof, then
		// thow an error. lets say you are in an if_true cycle and you have nested iffs.  for every nested, true,
		// then it will increase.  once the sl_iftrue=0, then skip the if false stmt, entirely. (it will entirly
		// skip it when sl_iffalse==0), do the same for sl_iftrue, too.  once both sl_xxx==0, then carry on the
		// normal reading of the script.  
		
		
/*
ok. in the event you have nested stmts, you will need a var to let you know which smt you are currently
in.  you can put a cap on how many nested stmts you can have in total, maybe 3->5 ... 3 might be best
i dont plan to code much more.  you can create an array[5] and each area will be a marker for what
kind of stmt you are in.  it will start out as 2.  2 is for null.  0 is for false and 1 is for inside a
true stmt.  whenever it finds another logic tag, it will search throgh the array for a 2 and when it finds
it, it will go ahead and input the t/f val into the arr.  if the arr has a 1 in it and sl_ifture==0, then
throw an error.  when you come to an end_ifxxx, and the current stmt is of that type, then search the 
arr for that if stmt starting from 4 going backwards.  if it goes 2,1 and the end_ifxxx is an end_if_false,
then skip over and keep reading.  if the end_ifxxx is true, then reduce the sl_true by 1 and then make the 
arr a 2, to cancel the other one out.  then see if the next stmt is a if_false stmt, if not then read from 
the current line and execute, if it is, then scan through it until you find the end_if_false (run the 
find_tag) and hae that work out for you.
 
*/			//int q=arr_checker(0, FALSE);
				//printf("\nans=%i q=%i",answer,q);
				//print_nester();
					if (!answer){nester[arr_checker(0, FALSE)]=story_line[i][4]; i=find_tag(i,13,story_line[i][4]); }
			// find the tag with the matching tag id# then input that id# into the nester.  the arr chkr(0,FALSE)
			// will find the first posistion of 0 and then put the id # there.
			else if (answer){nester[arr_checker(0, FALSE)]=story_line[i][4]; i=find_tag(i,11,story_line[i][4]); }
		//	print_nester();
			/*
		int q=arr_checker(0, FALSE);
			if (!answer){i=find_tag(i,13,story_line[i][4]); nester[q][0]=story_line[i][4];i--;nester[q][1]=FALSE;}
			// find the tag with the matching tag id# then input that id# into the nester.  the arr chkr(0,FALSE)
			// will find the first posistion of 0 and then put the id # there.
			else if (answer){i=find_tag(i,11,story_line[i][4]); nester[q][0]=story_line[i][4];i--;nester[q][1]=TRUE;}*/
		}// end if a logic tag
		// i am aware that the nester setting should be first, but if it doesnt find the tag, then the nester
		// will most likely end up 0  - remember all logic tags and corresponding iff stmts should have all the
		// same iff id #'s, so whether you takt the id from the logic tag or the iff stmt, thenit shouldnt matter
		
		
		return i;
}

/*void clr_sl(){// this will clear out the story line to make sure it doesnt rexecute.
	int i=0, k=0;
	//		printf("\nin the eraser");
			while (i<sl_max)
			{
				while (k<5){story_line[i][k]=0;k++;}
				k=0;	
				i++;// increase after the if logic tag, b/c find tag returns exact location not loc+1
			}// end while
//printf("\neraser over"); 

}*/
	

void story_end()
{
//		- in the event that the story line ends, you need to erase all sprites but the main char from the sprite
//		list array.
	int i=0,k=0;
	while (i<15){if (nester[i]==0){k++;}i++;}
	if (k<14){disp_error("error somewhere.  not all if statements ended properly");}
	//clr_sl();
	/*
		clean up all variables and remove all sprites from the sprite list array except the main char.
		end all running routines.
	*/
}// end story end

void sec_exec(int beg, int end)
{// this will execute a simple section of the story line
	int i=1,tag=0;
	int exec=FALSE;
	
			while (i<sl_max)
			{
				tag=story_line[i][0];
				if (tag==beg){exec=TRUE;}// start executing if you find the beginning tag
				if (tag==end){exec=FALSE; i=sl_max;}// end execution.
				if (exec){if (tag>0){i=story_checker(i, tag);	}}
					
				i++;// increase after the if logic tag, b/c find tag returns exact location not loc+1
			}// end while
}




void story_main()
{
	// read in file.
	// loop through the file and read in the tag.  call the approperaite method from a case select statement.
//printf("in story main");ngetchx();ngetchx();
	
	int i=0,tag=0;
	while (i<15){nester[i]=0;i++;};//[0]=0;nester[i][1]=0;i++;}
	i=0;
	
			while (i<sl_max)
			{// 61227 (61412)
				tag=story_line[i][0];
				
				// the commented out code exists to make a sl executable when talking to people?
				/*if (tag>9999){// this was imped to bypass the 10000 sections.
					i++;
						tag=story_line[i][0];
					while (tag<10000)
					{
						i++;
						tag=story_line[i][0];
						
					}
				}// end if tag > 9999*/
		//	if (tag>0){printf("\nsl=%i tag=%i",i,tag);wait_for_key(b_ko);}
	//			printf("tag=%i i=%i ",tag,i);ngetchx();*/
				if (tag>0){i=story_checker(i, tag);	}
				//out:	
				i++;// increase after the if logic tag, b/c find tag returns exact location not loc+1
			}// end while
//printf("\nexit story");			
		story_end();
}// end story main