// C Source File
// Created 10/11/2012; 1:00:58 AM

/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"


unsigned short object_pic_light[object_gfx_size][16];
unsigned short object_pic_dark[object_gfx_size][16];
unsigned short object_pic_mask[object_gfx_size][16];

extern char *light2;                    
extern char *dark2; 



//=======================================================================================================

void s_object_pic(int x, int y,unsigned short num, int which){// this is used
		if ((x<0) || (x>=object_gfx_size) || (y<0) || (y>=16)){return;}
		
		switch (which)
		{
			case 1:
				object_pic_light[x][y]=num;
			break;
			case 2:
				object_pic_dark[x][y]=num;
			break;
			case 3:
				object_pic_mask[x][y]=num;
			break;
		}
		
	
}// end set mob pic



//=======================================================================================================






int rotate_image(int pic_x, int pic_y, int rotate, int num,int draw_type)
{//rotate,pic_type, pic_num, button_pressed
	// obj_type was never used, b/c it was assumed that you would always rotate an object

		if (draw_type==A_REVERSE){return TRUE;}
		if ((rotate<=0) || (rotate>270)){return FALSE;}
		if ((num<0) || (num>=object_gfx_size)){return FALSE;}

		if (rotate==rot_180){// used so i dont get a strange line on the side.
			UpsideDownGrayClipSprite16_MASK_R(pic_x,pic_y,16 , object_pic_light[num], object_pic_dark[num], 
				object_pic_mask[num], object_pic_mask[num], light2 , dark2);
			return TRUE;}
		if (rotate==rot_180+1){rotate=rot_180;}
unsigned short obj_t_light[16];// keeps the held items in buffer
unsigned short obj_t_dark[16];// keeps the held items in buffer
unsigned short obj_t_mask[16];// keeps the held items in buffer
int a=7;
if (rotate>rot_90){a=8;}
		
//UpsideDownGrayClipSprite16_MASK_R(x ,y,16 , *sprt0, *sprt1, *mask0, *mask1, *dest0 , *dest1)		
		
			RotateSprite16_R(object_pic_light[num],obj_t_light, 16,a,8,rotate);
			RotateSprite16_R(object_pic_dark[num], obj_t_dark, 16,a,8,rotate);
			RotateSprite16_R(object_pic_mask[num], obj_t_mask, 16,a,8,rotate);

			GrayClipSprite16_SMASK_R(pic_x,pic_y,16, obj_t_light, obj_t_dark, 
					obj_t_mask, light2 , dark2);
					
					
		return TRUE;			

}//*/



//=======================================================================================================


int dir_to_rotate(int dir)
{// pass in a direction that you are facing and it will return the correct direction that a sprite 
// should be rotated.
	switch (dir)
	{
		case right:dir=rot_90;break;
		case down:dir=rot_180;break;
		case left:dir=rot_270;break;
		default: dir=0;break;
		
	}// end switch
	return dir;
}// end dir to rotate*/

//=======================================================================================================


