// Header File -39781
// Created 10/10/2012; 1:55:50 PM
/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
inline int g_over_world(int x, int y);
inline void s_over_world(int x, int y, int amt);
int world_loc(int world);
int g_over_world_stat(int i, int world);
void s_over_world_stat(int i, int world, int num);

void set_planes(char *light,char *dark);
void clr_world();
void clr_gfx();
int fix_pic(int pic,int pic_type);
void DrawTerrain(int link_y);

void DrawImage(int pic_type, int pic_num, int pic_x, int pic_y, int draw_type, int shift, int rotate);
void s_gfx_light(int x, int y, unsigned short num);
void s_gfx_dark(int x, int y, unsigned short num);
void clr_room();								
								
inline	int g_animate();
inline	void s_animate(int x);
inline	int g_screen_shift();
inline	void s_screen_shift(int x);

int g_screen_row_gain();
void s_screen_row_gain(int x);							
void set_all_maps(int a, int b, int c, int d, int num);
int get_all_maps(int a, int b, int c, int d);
void s_link_pic(int w,int x, int y,unsigned short num, int which);
void s_mob_pic(int x, int y, unsigned short num, int which);