// C Source File
// Created 7/15/2011; 3:33:30 AM
/*******************************************************************************/
/* Zelda Crystal Engine                                                       */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
/*
		this will include the random spawn of crap when mobs dies and will disp the objects.
		this should have a gfx file all to itself.  i think the objects are 8x8?
		
		

*/ 
#include "all.h"






extern int link_y, link_x, link_picture, shop_active,link_direction, item_used, 
						link_frame, link_frame2, button_pressed, dark_room,skip_animate_mob;




//=================================================================================================


void object_gfx_loader(int id)
{
		char messa[10];
		FolderCur(SYMSTR("gfx"),TRUE);
		FILE *q = NULL;
		int x=0,y=0,loop=0;
		unsigned short tmp[object_gfx_size][16];
		
redo:

	TRY

		q = NULL;

			switch(loop)
			{
				case 0: sprintf(messa,"objl%i",id); break;
				case 1: sprintf(messa,"objd%i",id); break;
				case 2: sprintf(messa,"objm%i",id); break;
			}

    // open file for reading in binary mode
    if ((q = fopen(messa,"rb")) == NULL) {return;}else{
       if (fread(tmp,sizeof(tmp),1,q) != 1) {return;}else{
        	for (x=0;x<object_gfx_size;x++){for (y=0;y<16;y++){
        			s_object_pic(x,y,tmp[x][y],loop+1);
        		}}// end fors
        }
        fclose(q);
    }
 
	ONERR
	ENDTRY     
 
		loop++;
		if (loop<3){goto redo;}

}// end object loader


//=================================================================================================

void move_push_stone(int loc)
{
	 	if (get_object(loc,obj_dir)==(-66))
 		{//get_object(loc,obj_dir)
 			set_object(loc, obj_dir, link_direction);//object_list[loc][obj_dir]=link_direction;

 		}// end if obj dir
 		if ((get_object(loc,obj_dir)==link_direction) && (get_object(loc, obj_var1)<16)) {// only move is direction is the same dir as link
 				//	if (get_object(loc, obj_var1)<16){
//printf_xy(0,80,"try");slow(4000);								 						
 					//	mod_link(state,LINK_PUSH,TRUE);// make link look like he is pushing always.
 						//int precision_move(int x, int y, int dir, int amt)
 					//	move_object(loc, 2, get_object(loc,obj_dir));
 						if ((precision_move(get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), get_object(loc,obj_dir), 2)) ||
 						 (get_object(loc,obj_var2)==88))
 						{// if you can move, then let the move stay and move link with it.  otherwise, move it back
 						// to the original spot.
//	printf("precision move. dir=%i var%i",get_object(loc,obj_dir),get_object(loc, obj_var1));wait_for_key(esc_ko);								 						
 							move_object(loc, 2, get_object(loc,obj_dir));
 							increase_object(loc, obj_var1, 2);//object_list[loc][obj_var1]+=2;// keep track of the 16 places   
 							set_object(loc, obj_var2, 88); //object_list[loc][obj_var2]=88;// signal that we are already moving. - this should help with the fact that precision
 							// move() will not allow you to move onto walls.  we just need the first check of precision move and then move the object.
 							move_link(2);
 						//	if (get_object(loc, obj_var1)<12){move_link(2);}//move link with the stone. - this caused link to move funny, so it was removed
 						//	else {move_link(-2);}
 							// now doing the push stones look right. - but you can still walk through them
 					//	}
 					//	else {move_object(loc, -2, get_object(loc,obj_dir));}
 					//		if (get_object(loc, obj_var1)>=16){set_object(loc, obj_type,-22);}// remove the pushable type so you
 							// cant push it anymore.
 						// once you have moved 16 places, dont move it anymore.
 					}
 					//else {mod_link(state,LINK_WALK,TRUE);}
 				//	else {move_link(-4);}
 			}// end if the same direction
}// end move push stone



void animate_drop_obj(int loc)// cant put in ezelda
{
/*
		this will animate all of the drop objects that the mobs drop.
*/
					
// 50477 -> 50447
				int bb=1;// used for the rupies
				int	count1 = 0,picy=0, adj=0;
				int obj_num=get_object(loc,OBJECT_NUMBER); 
				int ob_frame=get_object(loc,OBJECT_FRAME);
				int ob_x=get_object(loc,OBJECT_X);
				int ob_y=get_object(loc,OBJECT_Y);
			if (obj_num<1000){	
				switch (ob_frame)
				{
					//--------------------------------------------------------------
					// These frames show any drop object as a bouncing item when it first appears.
					//--------------------------------------------------------------
					case 0:	 adj=(-4);	break;
					case 2:	 adj=4;		  break;
					case 4:	 adj=(-2);	break;
					case 6:	 adj=2;			break;
					case 8:	 adj=(-1);	break;
					case 10: adj=1;			break;
					
					//----------------------------------------------------------------------------
					// After a certain amount of time, the object starts flashing, and disappears.
					// count1 stores when to draw picture or not (to create flashing)
					//----------------------------------------------------------------------------
					case 120 ... 145:
						if (ob_frame % 2)
							count1 = 1;
						else
							count1 = 0;
						break;
				}
				
				if (ob_frame<11){increase_object(loc, OBJECT_Y, adj);ob_y=get_object(loc,OBJECT_Y);}
				if ((ob_frame==0) || (ob_frame==4) || (ob_frame==8)){DrawImage(OBJECT, SHADOW1, ob_x, ob_y, A_NORMAL, TRUE,0);}
				//----------------------------------------------
				// Draws the picture 
				//----------------------------------------------
					if (!count1){DrawImage(OBJECT, obj_num, ob_x, ob_y, A_NORMAL, TRUE,0);}
					
				}// end if not an item				
			//	else if ((obj_num<600) && (obj_num>=500) && (!dark_room)){DrawImage(OBJECT, get_object(loc,OBJECT_NUMBER)-500, get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), A_NORMAL,TRUE,0);}
				else if (obj_num>999)
				
				{
					set_object(loc, OBJECT_FRAME, 100);// object_list[loc][OBJECT_FRAME]=100;
				//	if (get_object(loc,OBJECT_NUMBER)==key_normal){picy=A_REVERSE;}// the key is really hard to see on the map
					picy=get_item_info(obj_num,item_pic_id);
					if ((get_item_info(obj_num,item_type)==raft) && ((link_direction==left) || (link_direction==right)))
					{// if a raft and facing left or right, then draw the left/right pic for the raft.
						picy=get_item_info(obj_num,item_pic_2);
					}// end if a raft
					if ((get_item_info(obj_num,item_type)==pushable)&& (dark_room)){}// this was added so push stones wont show up when 
					// the room is dark.
					else {DrawImage(OBJECT, picy, ob_x, ob_y, A_NORMAL, TRUE,0);}

				}
				
				//----------------------------------------------------------------
				// Checks if player gets a heart or crystal (the frame > 6 is so 
				// the player doesnt get the heart/crystal before he can see it
				//----------------------------------------------------------------
				int item=obj_num;//y3=link_y,x3=link_x;
				if (ob_frame > 6)
				{
					
					if (touch_object(link_x, link_y, LINK, loc, FALSE)==TRUE){
					
							switch (obj_num)
							{
								case HEART1://touch_object(int x, int y, int who, int loc, int ret)
							//		if (touch_object(link_x, link_y, LINK, loc, FALSE))
										 mod_link(hp,8,FALSE);// increase hp by 8
										// delete_obj(loc);}
										 // in here you might put the boomerang checking and make the heart move w/ the boomerang.
									break;
								case CRYSTAL1:
								//(CheckAreaCollision(link_x, link_y, 16, 16, get_object(loc,OBJECT_X)+4, get_object(loc,OBJECT_Y)+1,6,13))
								
								
								//	if (touch_object(link_x, link_y, LINK, loc, FALSE))
											
											if (!random(19)){bb=5;}// 1 in 25 chance of getting 5 rupies.
											if (!random(120)){bb=10;}// 1 in 500 chance of gettin 10 rupies
										 mod_link(rupies,bb,FALSE);// increase the number of rupies
										 //delete_obj(loc);//}
									break;
									case BOMB2:
								 case ARROW2:
										  if (item==BOMB2){ item=bomb;}	else {item=arrow;}
										  if (item_type_exists(item, either)){add_item_inv(item_type_exists(item,3),5,FALSE);	}// end if item type exists
										 //#3 tells it to return an exact item number.
									//	 delete_obj(loc);//}
								 break;	
								 case 1000 ... 3000:
								 		// this is used for the shop system.
								 		count1=get_item_info(item,item_type);
								 	
								 	if (count1==rock || count1==boulder || 	count1==slashable_terrain || count1==pushable || count1==boom_bomb
								 			|| count1==torch || count1==treasure_box || count1==raft)
								 				{	goto bypass;}
								 	else if (count1==faerie)
								 		{
								 			set_object(loc,OBJECT_Y, -20);// make it so it doesnt show up anymore
								 			goto bypass;
								 			//obj_var1, obj_var2,
								 		}// end if a faerie			
								 	else if(count1==key_normal || count1==key_boss || count1==key_master)
								 	{
								 		//	count1=1;
								 			add_item_inv(item,1,TRUE);// increase key by 1 if you get it.
								 			set_room_info(key_gotten,TRUE);
								 			// this allows you to access the external inventory. - keys are in the external inventory.
								 	}
								 	else if (count1==heart_container){delete_obj(loc);return;}// this makes sure you only get it from a treasure box
								 	else if ((count1==bomb_bag) || (count1==rupie_bag)  || (count1==quiver))
								 	{add_special_item(count1, item); break;	}
			//					 	else if(count1==bomb_bag){count1=1;mod_link(max_bombs,16,FALSE);}// add 8 bombs to the thing.
			//					 	else if(count1==rupie_bag){count1=1;mod_link(max_rupies,500,TRUE);}
			//					 	else if(count1==heart_container){mod_link(max_hp,8,FALSE);mod_link(hp,512,FALSE);break;}
			//					 	else if(count1==quiver){mod_link(max_arrows,15,FALSE);}
								 		else if (link_stat(rupies)>=get_item_info(item,item_cost) && link_stat(dual_state) != LINK_GET_ITEM)
								 		{
								 			
								 		//	count1=get_object(loc, obj_var1);
								 		if (count1==potion)
								 		{// prevents link from buying a potion if there is no empty bottle in hand
								 						int i=hold_a;
														while (i<hold_d){
															if ((get_item_info(link_stat(i), item_type)==bottle) && (link_stat(i+18)<=0))
															{goto cntu;}
															i++;
														}// end while
														goto bypass;
								 		}// end if a potion
								 		
								 		cntu:
								 			add_item_inv(item,get_object(loc, obj_var1),FALSE);
								 			mod_link(rupies,get_item_info(item,item_cost)*-1,FALSE);
								 			mod_link(dual_state,LINK_GET_ITEM,TRUE);
								 			mod_link(state,	LINK_STUN,TRUE);
								 			if (shop_active){clr_object(); shop_active=FALSE;}// if the shop is active, then clear out the
								 			// objects in the list, then add the new one above link.
								 			
								 			link_frame=0;
								 			
								 			mod_link(link_rand_var1,item,TRUE);// put the item in the rand var spot so i can delete it later.
								 		}// 37777 - added about 400 ish bytes to add in ahop system not bad.
								 		
								 		else {goto bypass;}
								 	//	add_item_inv(item, count1, FALSE);
								 break;
							}// end switch
						delete_obj(loc);
					}// end if touch object
				}// end if get_object(loc,OBJECT_FRAME) > 6
				bypass:
				
				if ((count1==faerie) && (get_object(loc, OBJECT_Y)<0))
				{// y_pos is -20 if link touches it.
				//	disp_error("in here");
					set_object(loc, obj_var2, disp_circle_object(get_object(loc,obj_var2), get_item_info(item,item_pic_2)));
					mod_link(hp,2,FALSE);
					mod_link(state,LINK_STUN,TRUE);
					skip_animate_mob=TRUE;// do this to make sure mobs dont attack you while being healed.
					set_object(loc,OBJECT_Y, link_y);// you have to do this, b/c if you dont, then it will delete the object, so
					// simply make it return to link_y and have it run... whatever.
					if (link_stat(hp)>=link_stat(max_hp)){delete_obj(loc);mod_link(state,LINK_NORMAL,TRUE);skip_animate_mob=FALSE;}
					return;
				}
				//-------------------------------------------------------
				// Disappears if the player didnt get the heart in time
				// and only items that are random drop
				//-------------------------------------------------------
				
				if ((ob_frame >= 146) && (obj_num<1000)){delete_obj(loc);}
				
				//------------------------------------
				// Increase the objects frame number
				//------------------------------------
				increase_object(loc, OBJECT_FRAME, 1);	
}// end animate drop object

//============================================================================================

int hookshot_mod(int loc)// uses terrain contact
{

 int blink=0;
			int x=get_object(loc,OBJECT_X);
			int y=get_object(loc,OBJECT_Y);
			int d=get_object(loc,obj_dir);
			 mod_link(state,LINK_STUN,TRUE);
			 mod_link(dual_state,LINK_HOOKSHOT,TRUE);
			 link_frame=0;
//printf_xy(0,60,"%i %i", link_x, link_y);
			 	if (get_object(loc, obj_var1)>50){
			 	// this will make the hookshot return to link	
					// get_object(blink,OBJECT_NUMBER)
					 	blink=touch_object(x, y, LINK,  loc, TRUE);
				
					 	if (get_object(blink,OBJECT_NUMBER)>=500 && get_object(blink,OBJECT_NUMBER)<600){delete_obj(blink);}
					 	
					 	move_object( loc, 6, opposite_dir(d));
					 	
					 	
					 	if (y<link_y+11 &&  y>link_y-6  &&
							x<link_x+11 &&  x>link_x-6)
							{      remove_hookshot(); return 77;}// delete if in the range of link
							
							return 66;
							
			 }// end if hookshot and var1>50
			 else if (get_object(loc, obj_var1)==33){
			 	// this will make link return to the hookshot
					 		link_direction=d;
					 		link_picture=13;// change the picture of link to that of the hole falling picture, just to make it funny.
					 		
					 	blink=touch_object(link_x, link_y, LINK,  0, TRUE);
				
					 	if (get_object(blink,OBJECT_NUMBER)>=500 && get_object(blink,OBJECT_NUMBER)<600){delete_obj(blink);}
					 		
					 		if (y<link_y+16 &&  y>link_y-4  &&	x<link_x+16 &&  x>link_x-4)// this is ok, link just moves
							// with the hookshot.  why?
							//  printf("ouch %i %i %i %i",get_object(loc,OBJECT_X),get_object(loc,OBJECT_Y),link_x, link_y ); 
							{    remove_hookshot(); return 77;}// delete if in the range of link*/
							
							move_link(6);// moving move_link() below everything should prevent link from moving at point blank shots
							link_direction=up;// make link up, so he shows a funny picture.
							return 66;
			 }// end if hookshot and var1==33*/
			//touching_sprite_range(int qx, int qy, int sprite_low, int sprite_high)
			if (touching_sprite_range(x, y,185, 191,FALSE))
			//(terrain_contact(get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), get_object(loc,obj_dir), 191, 185))
			{
			/*
					WARNING    WARNING    WARNING    WARNING    WARNING    
					if you modify the 194 and 195 numbers then you will have to change them in the terrain_contact() routine as
					well.  i had to add in an exception that uses these numbers.  if you dont change them in both places then
					the hookshot will stop working right.  refer to "notes 	* 11/22/13 *"  for more info. - changed 194 to 191 due 
					to the fact that i added in bombable walls
			
			*/
//printf("terrain contact %i", get_object(loc, obj_var1));wait_for_key(esc_ko);
					if (d==up || d==left){move_object( loc, 4, opposite_dir(d));}
					else{move_object( loc, 4, d);}// move the object in some more.
					set_object(loc, obj_var1, 33);//object_list[loc][obj_var1]=33;
					return 66;
			}// end if touching terrain
			 
			if (get_object(loc,OBJECT_FRAME)>=1){// add the chain
				
				add_object(get_item_info(item_type_exists(hookshot,3),item_pic_3), x, y,
				item_type_exists(hookshot,3));//this will add the chain
				set_object(loc, OBJECT_FRAME, -1);//object_list[loc][OBJECT_FRAME]=-1;
			}// end if frame is >=2
			 
			 // 234 - 332
	return 555;
}// end hookshot mod

//============================================================================================
void chk_obj_oob(int loc)
{
			if (get_object(loc,OBJECT_X)<=object_x_min_oob || get_object(loc,OBJECT_X) >=object_x_max_oob || 
					get_object(loc,OBJECT_Y)<=object_y_min_oob || get_object(loc,OBJECT_Y)>=object_y_max_oob)
			 		  {		  
				 		  	if (get_object(loc,obj_type)==hookshot){set_object(loc,obj_var1, 51);}
				 		  	
				 		  	else {delete_obj(loc);}
				 		 	
				 		 }// end if oob
}// end chk obj oob

int chk_obj_hit_link(int loc)
{
		if (touch_object(link_x, link_y, LINK, loc, FALSE)!=555)
	 	{
	 		pain(LINK, get_object(loc, obj_dam),get_object(loc, obj_type), loc);// obj damage will be the same as the damage
	 		delete_obj(loc);
	 		return TRUE;
	 	}
	return FALSE;
}// end check to see if the object hit link

void animate_generic_damager(int loc, int blink)// this should work for the arrow as well. - cant be put into ezelda
{/*

		when using the hookshot, stun link, until the hookshot is finished.  if link gets hit, then remove
		the hookshot
	*/
	
//	wait_for_key(esc_ko);

		int draw_type=A_NORMAL;
		int typ=get_object(loc,obj_type);
		int rotate=dir_to_rotate(get_object(loc,obj_dir));
		int dmg_type=0;
//printf_xy(70,0,"%i",get_object(loc,OBJECT_FRAME));		
			int speed=5;
	 if (typ==hookshot){
			
			blink=hookshot_mod( loc);
			if (blink==66){goto bypass;}
			if (blink==77){return;}// object has been deleted
			speed=6;
	 }// end if hookshot
	 // in the event that the hookshot is returing, then go in reverse 5 places.
				move_object( loc, speed, get_object(loc,obj_dir));
			
//	printf("in aere %i %i",get_object(loc,OBJECT_X),get_object(loc,OBJECT_Y));wait_for_key(b_ko);			
					
if (blink){		
		switch (get_object(loc,OBJECT_FRAME))
				{// makle it blink
					case 0 ... 1:
						draw_type=A_REVERSE;
					break;
					case 2 ... 3:
					break;
					default:
						set_object(loc, OBJECT_FRAME, -1);//object_list[loc][OBJECT_FRAME]=-1;
					break;
									
				
				}// end switch
			}// end if blink	
			//arrow_diagnal
			if mob_rotate_weaps{
				rotate=dir_to_rotate(get_object(loc, obj_var1));
				set_object(loc, obj_var1,circle_dir(get_object(loc, obj_var1))); 
			}
	//	if 	(get_object(loc,OBJECT_FRAME)%2==0){draw_type==A_REVERSE;} 		  
	bypass:
		DrawImage(OBJECT, get_object(loc, obj_var2), get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), draw_type,TRUE,rotate);



//	printf("in bere %i %i",get_object(loc,OBJECT_X),get_object(loc,OBJECT_Y));wait_for_key(esc_ko);		

		increase_object(loc, OBJECT_FRAME, 1);



	 int who=0;
	 
	 if mob_weaps
	 {
	 		if (chk_obj_hit_link(loc)){return;}
	 	
	 }// end if type is arrow foe
	 
	 else{
//printf("err2");wait_for_key(b_ko);	 	
	 
	 if ((who=touch_mob(get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), boomerang))!=555)
	 {// yea you could use the boomerang equ, b/c it should be able to have the same properties...
	 // we will see how it works.
			 		
	 		if (typ==wand){
	 			
//printf("err4");wait_for_key(esc_ko);	 			
	 		
	 			draw_type=add_object(FIRE, get_object(loc,OBJECT_X),get_object(loc,OBJECT_Y),0);
	 			set_object(draw_type, obj_var1,0);//set the var 1 to 0
	 			stun_mob(who, 30);// set the mobs stun to 30 so it will burn a lot
	 		}// end if a wand
	 		else {
	 			
//printf("err5");wait_for_key(esc_ko);
			if ((typ==arrow_ammo) || (typ==arrow)){dmg_type=type_arrow;}
	 		pain(who, get_object(loc, obj_dam),dmg_type,0);
	 		}// end if not a wand
	 		if (typ==hookshot){set_object(loc,obj_var1,51);}
				 		  	else {delete_obj(loc);}
	 		// if type==wand, then do fire!!!
	 	//	mod_mob(who, mob_stunned, 30, TRUE);// stun the mob for 30 loops.
	 	//	set_object(loc, obj_var2, 2);
	 }// end if touching a mob
	 else if ((typ==wand) &&
	 ((who=touch_object(get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y),OBJECT,  loc, TRUE))!=555))
	 {
//printf("err3");wait_for_key(b_ko);			 	
	// printf("obj=%i t=%i",who,object_list[who][obj_type]);wait_for_key(b_ko);
	 	 if (get_object(who,obj_type)==torch)
	 	 {
	 	 	draw_type=add_object(FIRE, get_object(loc,OBJECT_X),get_object(loc,OBJECT_Y),0);
	 			set_object(draw_type, obj_var1,0);//set the var 1 to 0
	 			delete_obj(who);
	 			delete_obj(loc);
	 			set_room_info(torches_lit,get_room_info(torches_lit)+1);
	 			if (get_room_info(room_lit)){dark_room=FALSE;}// end if all torches lit.
	 //			#define torches_to_be_lit 15
//#define torches_lit 16
	 	 }
	 }// end if toucing an object. and type wnd.
	 //get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), boomerang,  loc, TRUE)!=555
	 //touch_object(int x, int y, int who, int loc, int ret)
	 }// end else if not a mob arrows	


		chk_obj_oob(loc);
/*		if (get_object(loc,OBJECT_X)<=object_x_min_oob || get_object(loc,OBJECT_X) >=object_x_max_oob || 
		get_object(loc,OBJECT_Y)<=object_y_min_oob || get_object(loc,OBJECT_Y)>=object_y_max_oob)
			 		  {// if it goes out of bounds, then delete it.
//printf("in here %i %i",get_object(loc,OBJECT_X),get_object(loc,OBJECT_Y));wait_for_key(a_ko);				 		  
				 		  	if (typ==hookshot){set_object(loc,obj_var1, 51);}
				 		  	else {delete_obj(loc);}
				 		  	
				 		  }*/
	 		  

//printf("final %i %i %i",get_object(loc,OBJECT_X),get_object(loc,OBJECT_Y),get_object(loc, obj_var1));wait_for_key(a_ko);
}

//============================================================================================


/*===========================================================================*/
/* This function handles whatever an object needs to do: functionality,      */
/* animation, etc.                                                           */
/*===========================================================================*/
void AnimateObject()
{
	
	int loc = 0;
	int typ=0;
//	int count1 = 0;  //Used for temporary storage. NOT TO BE USED BETWEEN FRAMES!
//	int a=0,b=0,c=0,d=0,x1=0,x2=0,x3=0,x4=0,y1=0,y2=0,y3=0,y4=0;
	//-------------------------------------------------
	// Stops checking for objects if the number is -1
	//-------------------------------------------------
//	if (num_of_objects()==0){return;}
	while (loc<obj_list_size){
		
	
	if (get_object(loc,OBJECT_NUMBER) >= 0)
	{
		typ=get_object(loc,obj_type);
		if (typ==follow_object){goto end;}// if a follow object
		
		switch (get_object(loc,OBJECT_NUMBER))
		{//25851->26137 to routinealize the animation.
			//----------------------------------------------------------------------------
			// Crystals and Hearts essentially do the same thing, with minor differences
			//----------------------------------------------------------------------------
					case BOMB2:
					case ARROW2:
					case CRYSTAL1:
					case HEART1:
					 case 1000 ... 10000:
							
							if (typ==throw_object  || typ==flying_bomb){animate_throw_object(loc);}
							else if (typ==boom_bomb){animate_bomb(loc);}
							else if mob_weaps {animate_mob_weapons(loc);}
							else {animate_drop_obj(loc);}
						break;
					
					
					//-----------------------------
					// Displayed when a mob dies.
					//-----------------------------
					case EXPLODE1:
		
							animate_explode(loc);// these do take up more space, but they will end
							// up making this a lot faster
						break;
					case EXPLOSION:
						exploding_bomb(loc);
					break;
					//-------------------------------------------
					// Animated when Link chops a bush or grass
					//-------------------------------------------
					case LEAF1://17670->17649
								animate_leaf(loc,LEAF1,4);//LEAF1);
						//		animate_leaf(loc,35,4); - for the crystals
						//animate_leaf(loc,34,1); - for the rocks and jars
						break;
					case LEAF2:
						// this leaf is for the random breaking apart of thrown objects.
						animate_leaf(loc,get_object(loc, obj_var1),get_object(loc, obj_var2));
					break;	
					case BOOMERANG:
							animate_boomerang(loc);
					break;
					case HOOKSHOT:
					case ARROW:
					case WAND:
						animate_generic_damager(loc, FALSE);
					break;
					case 	FIRE:
						animate_fire(loc);
					break;
				//	case 500 ... 599:// this just draws a generic item on the field that has no effect
				//	  if (!dark_room){DrawImage(OBJECT, get_object(loc,OBJECT_NUMBER)-500, get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), A_NORMAL,TRUE,0);}
				//	break;
			}// end switch
		}// end if there exists an object here.
		end:
		//--------------------------
		// Moves on to next object
		//--------------------------
		loc++;
	}
}// end animate object

//============================================================================================

//extern short screen_row_gain, screen_shift;

void draw_prices()
{//get_object(i,OBJECT_NUMBER)
	int i=0, cst=0, modder=0;
	// not having add_print here decreases the size by 400 bytes...
	char c[5];
	while (i<obj_list_size){
			if (get_object(i,OBJECT_NUMBER) >= 1000)
			{
				cst=get_item_info(get_object(i,OBJECT_NUMBER),item_cost);
				modder=4;
				if (cst>9){modder-=3;}// this will center the cost of the object up to 999
				if (cst>99){modder-=3;}
				sprintf(c,"%i",cst);
				add_print(get_object(i,OBJECT_X)+modder,(get_object(i,OBJECT_Y)+18)	- (g_screen_shift()+g_screen_row_gain()*16),c);
			//	printf_xy(get_object(i,OBJECT_X)+modder,(get_object(i,OBJECT_Y)+18)	- (g_screen_shift()+g_screen_row_gain()*16),"%i",cst);
			}
			i++;
	}// end while
}// end clr object




//============================================================================================



void remove_hookshot()
{// this was made to completly remove all hookshot stuff.
//printf("im deleted");wait_for_key(esc_ko);
	delete_obj(obj_loc(HOOKSHOT));
	int i=0;
	int objn=get_item_info(item_type_exists(hookshot,3),item_pic_3);
		while (i<obj_list_size)
	{
		if (get_object(i,OBJECT_NUMBER) == objn){delete_obj(i);} 
		//add_object(get_item_info(item_type_exists(hookshot,3),item_pic_3), get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y)
		i++;
	}// end while
	mod_link(state,LINK_NORMAL,TRUE);
}//end remove hookshot.


//============================================================================================

//============================================================================================
void roman_candle(int loc)
{// the oject will follow link
			int speed=2, dir=left;
				if (get_object(loc,OBJECT_X) > link_stat(inv_link_x)){}else{dir=right;}

				set_object(loc,obj_dir, dir);
				move_object( loc, speed, dir);
				
				
			if (get_object(loc,OBJECT_Y) > link_stat(inv_link_y)){dir=up;}else{dir=down;}

				set_object(loc,obj_dir, dir);
				move_object( loc, speed, dir);
				

}

void obj_move_diag(int loc, int speed)
{
	// angle is to move the object + or - a certain amount on the x/y - so +2 will move it slightly, while +5 will move it at a wider 
	// angle
	// diag_dir is to let me know whether i want to move it left or right of the original position.  only use left or right
	int diag_dir=left, angle=0;
	int dir=get_object(loc,obj_dir);
	int diagnal=TRUE;
//		sprintf(dbg,"%i", dir );debug();
	switch (dir)
	{
			case up ... right: diagnal=FALSE;		break;
			case up_30_left ... right_30_left:
					dir-=10; diag_dir=left; angle=2;
			break;
			case up_30_right ... right_30_right:
					dir-=20; diag_dir=right; angle=2;
			break;
			case up_45_left ... right_45_left:
					dir-=30; diag_dir=left; angle=5;
			break;
			case up_45_right ... right_45_right:
					dir-=40; diag_dir=right; angle=5;
			break;		
			default: dir=0; diagnal=FALSE; break;
	}

	move_object( loc, speed, dir);
	if (diagnal){
		if (dir==left){	if (diag_dir==left){diag_dir=down;}else {diag_dir=up;}}
		if (dir==right){	if (diag_dir==right){diag_dir=up;}else {diag_dir=down;}}
		move_object( loc, angle, diag_dir);
	}
	
// up_30_left+dir = the flying weapon direction
}// end obj move diag

void animate_mob_weapons(int loc)
{
		int draw_type=A_NORMAL;
		int typ=get_object(loc,obj_type);
		int rotate=dir_to_rotate(get_object(loc,obj_dir));
		int dir=get_object(loc,obj_dir);
	//	sprintf(dbg,"%i", typ);debug();
		switch (typ)
		{
			case arrow_foe:
			case arrow_foe_rotate:
				move_object( loc, 5, dir);
			break;
			case arrow_foe_multi_3:
			case arrow_foe_multi_5:
			case arrow_foe_diagnal:
				obj_move_diag(loc, 3);
				// have it move in the normal direction, then just + or - the "y" loc as you move normally.
			break;
			case arrow_foe_rotate_follow:
			case arrow_foe_follow:
				roman_candle(loc);
			break;
		}
		
		if mob_rotate_weaps{
			rotate=dir_to_rotate(get_object(loc, obj_var1));
			set_object(loc, obj_var1,circle_dir(get_object(loc, obj_var1))); 
		}
		
		DrawImage(OBJECT, get_object(loc, obj_var2), get_object(loc,OBJECT_X), get_object(loc,OBJECT_Y), draw_type ,TRUE,rotate);
		chk_obj_hit_link(loc);
		chk_obj_oob(loc);	
}// end animate mob weapons

int xXx(int i, int dir, int num, int num2)
{
/*
		couldnt think of a name for it.  basically, you pass in 2 numbers (one for the x var and one for the y var)
		then you tell it which var (x or y) you need it to choose for.  then it will look at the direction you pass it
		and then will return the number based off of what direction and what var you want.
		
		it is used to choose the correct x/y pos of the multi_shooter mob weapons.  i needed even spacing for these objects
		but it proved to be a pain, so i just made this.

*/

	switch (i)
	{
	case 1:// if x
		if (dir==up || dir==down){return num;}
		else {return num2;}
	break;
	case 2:
		if (dir==left || dir==right){return num;}
		else {return num2;}
	break;
	}
	return 0;
}

//============================================================================================
void init_multi_weapons(int loc, int item)
{
/*
	
	to make it work pass in the location of the object

*/
	int typ=get_item_info(item,item_type), num=0;
	if (typ==arrow_foe_multi_3){num=2;}
	else if (typ==arrow_foe_multi_5){num=4;}
	else {return;}
	
	int x=get_object(loc,OBJECT_X), y=get_object(loc,OBJECT_Y);
	int x2=x, y2=y;
	int dir=get_object(loc,obj_dir);
	int dam=get_item_info(item,item_damage);
	int pc=get_item_info(item,item_pic_id);
	int obj=0;
	redo:
	switch (num)
	{// this chooses the correct spacing for the new objects.
		case 2:
			x2=xXx(1, dir, x+8,x);
			y2=xXx(2, dir, y+8,y);
		break;
		case 1:
			x2=xXx(1, dir, x-8,x);
			y2=xXx(2, dir, y-8,y);
		break;
		case 4:
			x2=xXx(1, dir, x+16,x);
			y2=xXx(2, dir, y+16,y);
		break;
		case 3:
			x2=xXx(1, dir, x-16,x);
			y2=xXx(2, dir, y-16,y);
		break;		
	}
		if ((obj=add_object(item, x2, y2,item))!=555)
		{
				set_object(obj,obj_dir, (up_30_left*num)+dir);
				set_object(obj,obj_dam, dam);
				set_object(obj,obj_var2, pc);
				set_object(obj,obj_type, typ);	
				set_object(loc,obj_var1,random(right)); 
		}
	num--;
	if (num>0){goto redo;}
}


//============================================================================================


void exploding_bomb(int loc)
{
	int i=0,k=0,n=25,chk=0,x=0,y=0,rmapx2=rmapx,rmapy2=rmapy;
	int link_x=link_stat(inv_link_x);// get link_x
	int link_y=link_stat(inv_link_y);// get link_y	
	//if (get_object(loc,OBJECT_FRAME)<5)
	int ax=0,ay=0;
	//{	
	while (i<2){
		while (k<2)
		{
			if (get_object(loc,OBJECT_FRAME)>=5 && get_object(loc,OBJECT_FRAME)<=7){n=29;}
			DrawImage(OBJECT,n , get_object(loc,OBJECT_X)+(k*16), get_object(loc,OBJECT_Y)+(i*16), A_NORMAL, TRUE,0);
			n++;
			k++;
		}// end while k
		i++;k=0;
	}// end while i	

	increase_object(loc, OBJECT_FRAME, 1);
	
	 if (get_object(loc,OBJECT_FRAME)>=8){
	i=0;
		while (i<max_mobs)
			{// this will deal damage to each mob that is caught in the blast
				if (get_mob_stat(i,mob_id)>0)
				{			
					if (collide(get_object(loc,OBJECT_X),32, get_object(loc,OBJECT_Y), 32, get_mob_stat(i,mob_x), 13, get_mob_stat(i,mob_y), 13))
						{
							if (get_mob_stat(i,mob_underground)<=0){pain(i, 8 , EXPLOSION,0);}// if the mob is not underground, then harm them
						}// end if they do collide
				}// end if stat>0
				i++;
			}// end while <max_mobs	
		if (collide(get_object(loc,OBJECT_X),32, get_object(loc,OBJECT_Y), 32, link_x+1, 14, link_y+1, 14)){
			pain(LINK, 8 , EXPLOSION,0);
		}// end if hits link
		i=192;
		while (i<200){// search through to see if a wall is bombed.
				ax=0;ay=0;
				while (ax<3){
				while (ay<3){
					if (touching_sprite( get_object(loc,OBJECT_X)+(ax*10)-2,get_object(loc,OBJECT_Y)+(ay*10)-2, i)){
							
							x=get_object(loc,OBJECT_X)+(ax*10)-2;
							y=get_object(loc,OBJECT_Y)+(ay*10)-2;	
							chk=precision_sprite_find(x, y,i);// get and fix the sprite location.
							if (chk>=100 && chk<200){x+=(chk-111);}
							else if (chk>=200){y+=(chk-211);}
							y=gter(y);x=gter(x);

							if ((chk=get_all_maps(rmapx, rmapy,y,x))<196){chk+=4;}
							chk-=150;// this does the same thing as the switch below.

						
							if (chk>45 && chk<50){set_all_maps(rmapx, rmapy,y,x, chk);
									// first replace the bombed part with a hole
									// then check to see if it was on the edge of the screen.
									// if it was, then attempt to look at the next room to the lrud
									// of it to see if it was a bombable place, too.  if it was, then 
									// replace that sprite too.  - the original zelda allowed this
									// and when trying to make their maps, it was a pain b/c the rooms could be
									// bombed from either side.  this was a real problem for me, so this should fix
									// it.
							
									if (y==0){y=7;rmapx2=rmapx-1;}
									else if (y==7){y=0;rmapx2=rmapx+1;}
									else if (x==0){x=9;rmapy2=rmapy-1;}
									else if (x==9){x=0;rmapy2=rmapy+1;}
									else {goto skip;}
								
									if ((chk=get_all_maps(rmapx2, rmapy2,y,x))<196){chk+=4;} chk-=150;
									if (chk>45 && chk<50){set_all_maps(rmapx2, rmapy2,y,x, chk);}
									
								skip:
							}// had strange atrifacts show up, so this will
							// prevent some odd out of bounds errors.
				}// end if touching sprite
				ay++;
			}// end ay
				ay=0;ax++;
			}//end while ax
			i++;
		}// end while search for wall bombed.
		
	delete_obj(loc);}

}// end exploding bomb


//============================================================================================


//============================================================================================


//============================================================================================


//============================================================================================


/*
void print_objs()
{// jsut a simple routine to help troublshoot objects.  it prints everything in the object list.
	int i=0;
	while (i<7)
	{
		printf("\nobj =%i, type = %i",get_object(i,OBJECT_NUMBER),object_list[i][obj_type]);
		i++;
	}
	wait_for_key(a_ko);
}// end print obj*/