// C Source File
// Created 7/20/2011; 3:40:15 AM
/*******************************************************************************/
/* Zelda Crystal Engine                                                        */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"
//#include "ext_vars.h"


extern char *light, *dark;
int current_mob_gfx=0,double_damamge=FALSE, skip_animate_mob=FALSE;
extern int link_direction, link_x, link_y, link_picture, button_pressed, spinslash_active, link_frame2;
extern int dark_room;
//=================================================================================================




//=================================================================================================



void mob_gfx_loader(int id)
{
	char messa[10];
	if ((id==current_mob_gfx) || (id<=0)){return;}// bypass if it is already loaded
	else {current_mob_gfx=id;}
	FolderCur(SYMSTR("mobs"),TRUE);// transfer to the mob filder.
	unsigned short tmp[mob_gfx_list_size*3][16];
	int x=0, y=0;
	FILE *q = NULL;
//55190  ->55172
TRY

	sprintf(messa,"zmb%i",id);
	q = NULL;

 if ((q = fopen(messa,"rb")) == NULL) {return;} else {
	        if (fread(tmp,sizeof(tmp),1,q) != 1) {return;}else{
	        	for (x=0;x<mob_gfx_list_size;x++){
	        		for (y=0;y<16;y++){
	        			s_mob_pic(x,y,tmp[x][y],1);
	        			s_mob_pic(x,y,tmp[x+mob_gfx_list_size][y],2);
	        			s_mob_pic(x,y,tmp[x+(mob_gfx_list_size*2)][y],3);
	        		}// 2nd for
	        	}// 1st for
	        }
	        fclose(q);
	        }
	 ONERR
	 ENDTRY 
/*
redo:
	TRY

			q = NULL;
			
			switch(loop)
			{
				case 0: sprintf(messa,"zmbl%i",id); break;
				case 1: sprintf(messa,"zmbd%i",id); break;
				case 2: sprintf(messa,"zmbm%i",id); break;
			}
	    
	    if ((q = fopen(messa,"rb")) == NULL) {return;} else {
	        if (fread(tmp,sizeof(tmp),1,q) != 1) {return;}else{
	        	for (x=0;x<mob_gfx_list_size;x++){
	        		for (y=0;y<16;y++){s_mob_pic(x,y,tmp[x][y],loop+1);}// 2nd for
	        	}// 1st for
	        }
	        fclose(q);
	    }
	 
	 
	 ONERR
	 ENDTRY     
 
		loop++;
		if (loop<3){goto redo;}

*/

}// end mob loader



//================================================================================================





//=================================================================================================


//================================================================================================




//================================================================================================




//================================================================================================




//================================================================================================




//================================================================================================
int rand_diag_dir(){return (((random(4)+1)*10)+random(4));}

void mob_attack(int i)
{
		int obj=0,item=0,typ=0;

		switch ((item=get_mob_stat(i,mob_special_atk)))
		{
			case 9000 ... 10000:// basically, just add an item to the mob and it will shoot it.
//disp_error("mob item");											
				if (random(67)==13)// && get_mob_stat(i,mob_rand_var2)<=0)
					{
						//	item=get_mob_stat(i,mob_special_atk);
//printf_xy(0,67," i=%i", item);							
					if ((obj=add_object(item, get_mob_stat(i,mob_x), get_mob_stat(i,mob_y),item))!=555)
						{
							set_object(obj,obj_dir, fix_diag_dir(get_mob_stat(i,mob_dir)));
							set_object(obj,obj_dam, get_item_info(item,item_damage));
							set_object(obj,obj_var2, get_item_info(item,item_pic_id));
							set_object(obj,obj_type, (typ=get_item_info(item,item_type)));
							if mob_rotate_weaps {set_object(obj,obj_var1,random(right));}
							if (typ==arrow_foe_diagnal){set_object(obj,obj_dir,rand_diag_dir());}
							init_multi_weapons(obj, item);
						//	arrow_modder(obj);
////printf_xy(0,80,"o=%i, t=%i, i=%i", obj, get_object(obj, obj_type), item);wait_for_key(esc_ko);								
						}// end if we added an item
//printf_xy(0,80,"it=%i o=%i d=%i p=%i", item, obj, get_item_info(item,item_damage), get_item_info(item,item_pic_id));wait_for_key(esc_ko);							
						//	mod_mob(i, mob_rand_var2,5,TRUE);
							//add_object(1009,5*16,4*16,1009);
		//	set_object(keye,obj_var1,50);
						}//end random
						break;
					case mob_replicator:
						add_a_mob(get_mob_stat(i,mob_x), get_mob_stat(i,mob_y), 0, get_room_info(mob_file));
					break;
				/*	case chicken_attack:
						mod_mob(i,mob_special_atk, 0,TRUE); 
						disp_error("in here");
						
						item=i;
						for (i=0;i<max_mobs;i++)
						{// technically this is not the location of the mob, b/c i is from the mob list, not the ow mob file.
							if (add_a_mob(get_mob_stat(item,mob_x), get_mob_stat(item,mob_y), get_mob_stat(item,mob_sl_exec), get_room_info(mob_file)))
							{
								mod_mob(i,mob_hp, 24,TRUE);
								mod_mob(i,mob_dam, 4,TRUE);
								mod_mob(i,mob_move_type, MOB_FOLLOW,TRUE); 
							}// end if
							
						}// end for	
					break;*/
					default:
					break;	
		}// end special attack switch
					
}

//================================================================================================

int fix_diag_dir(int dir)
{
	switch (dir)
	{
		case up ... right: return dir; 		break;
		case upleft: 
			case downleft:	 return left; 	break;
		case upright: 
			case downright:	 return right; 	break;
	}
	return up;
}

// the rotator is taken out of the animate generic, b/c it was used by more than one routine.
// it basically just rotates the pictures so the mob looks animated.
int picture_rotator(int loc, int pic)
{
//			int pic=get_mob_stat(loc, mob_current_sprite);
			int sprites=get_mob_stat(loc,mob_sprites);
			int sprite_id=get_mob_stat(loc, mob_sprite_id);
			int ani_speed=get_mob_stat(loc,mob_animation_speed);
			int frame=get_mob_stat(loc, mob_frame);
			if (frame<0){mod_mob(loc,mob_frame,0,TRUE);frame=0;}
			
			if ((sprites>=8) && (get_mob_stat(loc,mob_walk_sprites)==2))
			{
				pic=sprite_id+(fix_diag_dir(get_mob_stat(loc,mob_dir))*2);
				if (frame>ani_speed){	pic++;}
				if (frame>(ani_speed*2)){	mod_mob(loc,mob_frame,0,TRUE);}
			}
			else	if ((frame>ani_speed) && (sprites>=2)){
					if (pic>=(sprites+sprite_id)-1){
						
						pic=sprite_id;// reset the pic to the original sprite
						if (get_mob_stat(loc,mob_type)==digger){pic+=2;}
						//if (sprites==4)
					}// end if pic>sprites
					else {pic++;}
					mod_mob(loc,mob_frame,0,TRUE);
			}//*/
			return pic;
}// end picture rotator

//================================================================================================

void try_to_move_mob(int loc)
{
		if (get_mob_stat(loc,mob_speed)>0){
			
		int r=0;
		
		redo:
			if (can_move(loc, get_mob_stat(loc,mob_dir)))  {
				//this section determines if the mob can move on the map or not.
				// it does need to be modified so it takes in account flyers and ghosts.
			
				move_mob(loc, get_mob_stat(loc,mob_move_type), get_mob_stat(loc,mob_speed));}
				else {change_dir(loc);r++;if (r<5){goto redo;}}
				//try to change the direction 5 times to see if the mob can move, if not, then carry on.
			}// end if mob speed >0
}

void animate_generic1(int loc)// use mob_loc(<mob id>) to get the loc.
{
		/*
				this routine animates a generic mob.
		
		
		*/
		
		
			int pic=get_mob_stat(loc, mob_current_sprite);
	//		int sprites=get_mob_stat(loc,mob_sprites);
			int sprite_id=get_mob_stat(loc, mob_sprite_id);
	//		int ani_speed=get_mob_stat(loc,mob_animation_speed);
	//		int frame=get_mob_stat(loc, mob_frame);
	//		int under=get_mob_stat(loc, mob_underground);
	//		if (frame<0){mod_mob(loc,mob_frame,0,TRUE);frame=0;}
			
			
			// the above if stmt exists b/c soemtimes we forget to set the mob frames in the mob list
			// and the mob tends to start at frame -100; thus, preventing the mob from moving for a 
			// while.  this will prevent that stall from happening.
			
		//	DrawImage(MOB, pic, get_mob_stat(loc, mob_x), get_mob_stat(loc, mob_y), A_NORMAL);
				if (get_mob_stat(loc,mob_pause) > 0)
					{
				//	mob_list[loc][MOB_PAUSE]--;
							mod_mob(loc,mob_pause,-1,FALSE);
					//DrawImage(MOB, MONSTER1+count1, mob_list[loc][MOB_X], mob_list[loc][MOB_Y], A_NORMAL);
							DrawImage(MOB, pic, get_mob_stat(loc, mob_x), get_mob_stat(loc, mob_y), loc, TRUE,0);
							 goto end;
					}// end if pause>0
//hajimaddu			
			pic=picture_rotator(loc, pic);
/*			if ((sprites>=8) && (get_mob_stat(loc,mob_walk_sprites)==2))
			{
				pic=sprite_id+(get_mob_stat(loc,mob_dir)*2);
				if (frame>ani_speed){	pic++;mod_mob(loc,mob_frame,0,TRUE);}
			
			}
		//	if (sprites==4){pic+=get_mob_stat(loc,mob_dir);}
			// if there are more than 4 sprites and there are 2
			// walking sprites, then add the direction to the up*2=0, down*2=2, left*2=4, right*2=6//
//if (loc==0){printf_xy(0,0,"%i %i %i %i %i",loc, frame, ani_speed, sprites, pic 		);}
//else {printf_xy(0,8,"%i %i %i %i %i",loc, frame, ani_speed, sprites, pic 		);}
			else	if ((frame>ani_speed) && (sprites>=2)){
					if (pic>=(sprites+sprite_id)-1){
						
						pic=sprite_id;// reset the pic to the original sprite
						if (get_mob_stat(loc,mob_type)==digger){pic+=2;}
						//if (sprites==4)
					}// end if pic>sprites
					else {pic++;}
					mod_mob(loc,mob_frame,0,TRUE);
			}//*/
		//	pic=animation_pic_decider(loc, frame,ani_speed, sprites, pic, sprite_id);
	/*		switch (sprites)
			{
				case 0 ... 1:	break;// do nothing.
				case 2: 
						if frame>ani_speed)
						pic++;
						mod_mob(loc,mob_frame,0,TRUE);
						pic=get_mob_stat(loc, mob_sprite_id);
				break;
				case 3:
			}
			
			switch(get_mob_stat(loc, mob_frame))
				{
					case 0 ... 2:
					break;
					case 3 ... 4:
						pic++;
						//DrawImage(MOB, CRAB2, mob_list[loc][MOB_X], mob_list[loc,mob_y), A_NORMAL);
						break;
					default:	//This causes mob_frame reset when it has reached its max
					//pic=CRAB1;
					//	DrawImage(MOB, CRAB1, mob_list[loc][MOB_X], mob_list[loc][MOB_Y], A_NORMAL);
						mod_mob(loc,mob_frame,0,TRUE);
					//	set_mob_list[loc][MOB_FRAME] = 0;
						break;
				}*/
				int draw=TRUE;
				int typ=get_mob_stat(loc,mob_type);
				if ((typ==digger)|| (typ==wizard)){
						switch (get_mob_stat(loc, mob_underground))
						{

							case 1:
								pic=sprite_id;
							break;
							case 2:
								pic=sprite_id+1;
							break;
							case 3:
								draw=FALSE;
							break;
						}// end switch	
				
				}// end if type digger


				mod_mob(loc,mob_current_sprite,pic,TRUE);// reset the current mob sprite.
				if (draw){DrawImage(MOB, pic, get_mob_stat(loc, mob_x), get_mob_stat(loc, mob_y), loc, TRUE,0);}
			/*	if (get_mob_stat(loc,mob_pause) > 0)
					{
				//	mob_list[loc][MOB_PAUSE]--;
							mod_mob(loc,mob_pause,-1,FALSE);
					//DrawImage(MOB, MONSTER1+count1, mob_list[loc][MOB_X], mob_list[loc][MOB_Y], A_NORMAL);
							goto end;
					}// end if pause>0*/
				if (get_mob_stat(loc,mob_stops)==sometimes){
					if (get_mob_stat(loc,mob_pause)  <= 0 && !random(50)){mod_mob(loc,mob_pause,random(50)+25,FALSE);}
						//	mob_list[loc][MOB_PAUSE] = 10;
					
				}// end if mob stops sometimes.
				
			//	MoveMob(loc, MOB_FLUTTER, 2);
			try_to_move_mob(loc);
/*				if (get_mob_stat(loc,mob_speed)>0){
					
				r=0;
				
				redo:
				if (can_move(loc, get_mob_stat(loc,mob_dir)))  {
					//this section determines if the mob can move on the map or not.
					// it does need to be modified so it takes in account flyers and ghosts.
				
					move_mob(loc, get_mob_stat(loc,mob_move_type), get_mob_stat(loc,mob_speed));}
					else {change_dir(loc);r++;if (r<5){goto redo;}}
					//try to change the direction 5 times to see if the mob can move, if not, then carry on.
					}// end if mob speed >0*/
				end:
}

void pede_flag_adder(int loc, int dir)
{
	if ((loc>=max_mobs) || (get_mob_stat(loc,mob_type)!=pede_body)){return;}
	if (get_mob_stat(loc,mob_rand_var1)<0){mod_mob(loc, mob_rand_var1,dir,TRUE);}
	else if (get_mob_stat(loc,mob_rand_var2)<0){mod_mob(loc, mob_rand_var2,dir,TRUE);}
	else if (get_mob_stat(loc,mob_stops)<0){mod_mob(loc, mob_stops,dir,TRUE);}
	else {
		
//char bb[30];
//sprintf(bb,"%i %i %i %i %i ",loc, dir, get_mob_stat(loc,mob_rand_var1), get_mob_stat(loc,mob_rand_var2), get_mob_stat(loc,mob_stops));
//28 = mob_h
//add_print(0,70,bb);				
//disp_error(bb);			
		
	}
	
}// end flag adder

void change_pede_dir(int i)
{

			
			mod_mob(i, mob_dir,get_mob_stat(i,mob_rand_var1),TRUE);
			mod_mob(i, mob_rand_var1, (-100) , TRUE);// delete out the move flag
			
			
// force all the move flags to move up.			
			if (get_mob_stat(i,mob_rand_var2)>=0){mod_mob(i, mob_rand_var1,get_mob_stat(i,mob_rand_var2),TRUE);
					mod_mob(i, mob_rand_var2, (-100) , TRUE);}
			
			if (get_mob_stat(i,mob_stops)>=0){mod_mob(i, mob_rand_var2,get_mob_stat(i,mob_stops),TRUE); 
					mod_mob(i, mob_stops, (-100) , TRUE);}

// if you happen to have a -100 move, then force it to look at the previous mob to find which way to go.
			if ((get_mob_stat(i,mob_dir)<up) || (get_mob_stat(i,mob_dir)>right))
			{
				int q=i;
				while (q>=0)
				{
						
					q--;
					if ((get_mob_stat(q,mob_dir)>=up) && (get_mob_stat(q,mob_dir)<=right))
							{mod_mob(i, mob_dir,get_mob_stat(q,mob_dir),TRUE);q=(-1);}
				}// end while
				
			}// end if
			move_mob(i,  MOB_CONSTANT, get_mob_stat(i,mob_speed));
// force the new dir to be added to the next mob.
			pede_flag_adder(i+1, get_mob_stat(i,mob_dir) );
}

void prevent_pede_oob(int loc)
{
	//---------------------------------------------------------
	// In all cases, the mob must not go out of screen bounds
	// If the mob reaches edge of screen, walk other way
	//---------------------------------------------------------
	if (get_mob_stat(loc,mob_x) > 160-16)
	{
		mod_mob(loc,mob_x, 160-16, TRUE);
		change_pede_dir(loc);
	}
	if (get_mob_stat(loc,mob_x) < 0)
	{
		mod_mob(loc,mob_x, 0, TRUE);
		change_pede_dir(loc);
	}
	if (get_mob_stat(loc,mob_y) < 0)
	{
		mod_mob(loc,mob_y, 0,TRUE);
		change_pede_dir(loc);
	}
	if (get_mob_stat(loc,mob_y) > 8*16-16)
	{
		mod_mob(loc,mob_y, 8*16-16,TRUE);
		change_pede_dir(loc);
	}

}

void pede_spacing_ok(int loc)
{

/*

both would have to be travelling the same dir.  if not, then forget the spacing

if the space between > move_speed, then increase travelling by (space-move_speed) - depends on dir travelling

if space between < move_speed, then move the body part back by (move_speed + space_needed) - depends on dir travelling


*/

				int spacer=2;// this decides how much space will be between the pede segments. - so 2 pixels currently.
				int a1=0, a2=0, wh1=0, wh2=0;
				int who=loc-1;
				int wh=mob_w;
				int dir_loc=get_mob_stat(loc,mob_dir);
				int dir_who=get_mob_stat(who,mob_dir);		
				if (dir_who!=dir_loc){return;}//if not the same dir, then dont do anything.						
				int xy=mob_x;
				if ((dir_who==up) || (dir_who==down)){xy=mob_y;wh=mob_h;}				
				a1=get_mob_stat(loc,xy);// loc is chasing who
				a2=get_mob_stat(who,xy);
					
				wh1=mob_stat_flip(loc,wh);
				wh2=mob_stat_flip(who,wh);

				int sp_loc=offset_calculate(a1, wh1)-a1;
				int sp_who=offset_calculate(a2, wh2)-a2;
				int fix=0;
			
				switch (dir_who)
				{
					case up:
					case left:
						if (((a1+sp_loc)-(a2+16-sp_who))>spacer)// if the spacing is >spacer
						{fix=(((a1+sp_loc)-(a2+16-sp_who))-spacer)*(-1);}// be sure to decrease the spacing
						else if (((a1+sp_loc)-(a2+16-sp_who))<spacer)
						{fix=spacer-((a1+sp_loc)-(a2+16-sp_who));}
					break;
					case down:
					case right:
						if (((a2+sp_who)-(a1+16-sp_loc))>spacer)
						{fix=(((a2+sp_who)-(a1+16-sp_loc))-spacer);}
						else if (((a2+sp_who)-(a1+16-sp_loc))<spacer)
						{fix=((spacer-((a2+sp_who)-(a1+16-sp_loc)))*(-1));}						
					break;
				}// end switch dir


	
				mod_mob(loc,xy, fix,FALSE);

}





int pede_header(int loc)
{
	// use mob_stops for the direction, that is only used in one routine in the entire game and this is not
	// using that routine.
	// mob_rand_var2 and mob_rand_var1 for x/y postion of the previous
// this works for the simple stuff.  need some more logic to keep the sprites exactly "8" pixels apart
// also, it doesnt work if the head changes the direction before the pede_body reaches its destination - need some logic
// for that too.	
	int i=loc+1;
	int px=0, py=0, dir=0;
		px=get_mob_stat(loc,mob_x);
		py=get_mob_stat(loc,mob_y);
		dir=get_mob_stat(loc,mob_dir);
		if (can_move(loc, get_mob_stat(loc,mob_dir)))
				{	move_mob(loc,  MOB_CONSTANT, get_mob_stat(loc,mob_speed));}
				else {change_dir(loc);}
				prevent_mob_oob(loc);
		if (dir!=get_mob_stat(loc,mob_dir)){pede_flag_adder(i, get_mob_stat(loc,mob_dir));}
DrawImage(MOB, picture_rotator(loc, get_mob_stat(loc, mob_current_sprite)),get_mob_stat(loc,mob_x) , get_mob_stat(loc,mob_y), loc, TRUE,0);
		mob_attack(loc);// make the head attack if it has one.
	if (i>=max_mobs){return loc;}


	while ((get_mob_stat(i,mob_type)==pede_body) && (i<max_mobs))
	{
//char bb[30];
//sprintf(bb,"%i %i %i %i %i %i %i %i",gg, a1, a2, mob_stat_flip(loc,wh), mob_stat_flip(who,wh),wh, offset_calculate(a2, wh2), offset_calculate(a1, wh1));
//28 = mob_h
//add_print(0,70,bb);				
//disp_error(bb);	
		mob_attack(i);// make the body attack if it has an attack.
		if (can_move(i, get_mob_stat(i,mob_dir))) {move_mob(i,  MOB_CONSTANT, get_mob_stat(i,mob_speed));}
		else {

			change_pede_dir(i);

		}// end else
		prevent_pede_oob(i);
		pede_spacing_ok(i);
			
		
		DrawImage(MOB, picture_rotator(i, get_mob_stat(i, mob_current_sprite)),get_mob_stat(i,mob_x) , get_mob_stat(i,mob_y),i , TRUE,0);
		i++;
		// only on the event of change dir, do we change the dir of the previous and the x/y coords
		
	}// end while
	return i-1;
}// end pede head


void animate_evil_eye(int loc)
{
	
	animate_generic1(loc);
	//move_ghost(loc, ani_speed);// make it so it can move diagnal
	int i=get_mob_stat(loc,mob_rand_var1);
	int var2=get_mob_stat(loc,mob_rand_var2);
	int radius=24;
	switch (var2)
	{
		case 0 ... 12: break;// do nothing
		case 13 ... 100: radius+=((var2-12)/2); 	break;
		case 101 ... 180: radius=68; break;
		case 181 ... 268: radius=68-((var2-179)/2); break;
		case 269 ... 290: break;
		default: mod_mob(loc,mob_rand_var2, 0, TRUE); break;
	}// end switch
	
	if ((num_of_mobs()==1) && (get_mob_stat(loc,mob_rand_var1)!=(-88)))// this creature should be immortal then after you kill all
			{mod_mob(loc, mob_shield, immune_magic, TRUE); mod_mob(loc, mob_rand_var1, -88, TRUE);}// other mobs, it should become killable.
	else if (get_mob_stat(loc,mob_rand_var1)!=(-88))
				{mod_mob(loc,mob_rand_var1, disp_circle_mobs(get_mob_stat(loc,mob_x), get_mob_stat(loc,mob_y), radius, i),TRUE);}

	mod_mob(loc,mob_rand_var2, 1, FALSE);
	}

void animate_multi_sprite(int loc)
{
	// if 4, then loop through all 4
	// for now, there will not be any direction changing stuff, except it will make the mob go in reverse. otherwise
	// it will always point down.
	//mob_h, mob_w
	int w=get_mob_stat(loc,mob_w), max_i=0, max_k=0, i=0;
	int h=get_mob_stat(loc,mob_h);
	if ((w>16) && (w<=32)){max_i=2;}
	if ((w>32) && (w<=48)){max_i=3;}
	if ((h>16) && (h<=32)){max_k=2;}
	
	
			int sprite_id=get_mob_stat(loc, mob_sprite_id);
			int ani_speed=get_mob_stat(loc,mob_animation_speed);
			int frame=get_mob_stat(loc, mob_frame);
			int pic=sprite_id;
			if (frame<0){mod_mob(loc,mob_frame,0,TRUE);frame=0;}
			
			if (get_mob_stat(loc,mob_walk_sprites)==2)
			{
				
				if (frame>ani_speed){	pic=sprite_id+max_i+max_k;}
				if (frame>(ani_speed*2)){	mod_mob(loc,mob_frame,0,TRUE);}
			}
			

	/*
			the routine is set up like this:  
			
			if 16h x 32w, then it will pull gfx[i] & gfx[i+1]
			if 32h x 32w, then it will pull gfx[i] & gfx[i+1] (for row 1) i+=2; then ull gfx[i] & gfx[i+1](for row 2)
			in theory, there could be: if 32h x 16w, then it will pull: i+=2; gfx[i] & gfx[i+1]
	
	
	*/
	for (i=0;i<max_i;i++){DrawImage(MOB, pic+i, get_mob_stat(loc, mob_x), get_mob_stat(loc, mob_y), loc, TRUE,0);}
	for (i=0;i<max_k;i++){DrawImage(MOB, pic+max_i+i, get_mob_stat(loc, mob_x), get_mob_stat(loc, mob_y), loc, TRUE,0);}

}

void animate_spider(int loc)
{
			int sprites=get_mob_stat(loc,mob_sprites);
			int v1=0;
			//if (v1<0){v1=0;}//if (v1>=mob_gfx_list_size){v1=(mob_gfx_list_size-1);}// prevent oob errors
			switch (get_mob_stat(loc, mob_frame))
			{
				
				case 41: if (sprites>=3)	{v1=3;  mod_mob(loc,mob_shield, immortal, TRUE);}  break;
				case 52: if (sprites>=6)	{v1=3; } break;
				case 63: if (sprites>=9)	{v1=3; } break;
				case 70: v1=(sprites * (-1)); mod_mob(loc,mob_shield, death_by_arrow, TRUE); break;
			}// end switch
			mod_mob(loc,mob_sprite_id, v1, FALSE);
			try_to_move_mob(loc);
			animate_multi_sprite(loc);
}

void AnimateMob(void)
{
	//- you still need to determine if the mob is stunned, b/c if so, then it should not move
	// take into consideration mob_animation_type  and mob_stops
	// mob type should be taken into consideration when moving the mob, such as ghost.  if a ghost
	// then move through non-movable things.  fish to move through water, land to move only on land
	// flyer to be able to move through anything, but walls, digger to go underground, 
//	if (skip_animate_mob){return;}
	int i=0; //animate=TRUE;//,move_type=0;
	int typ=0, hit=0;
	while (i<max_mobs){
		
		typ=get_mob_stat(i,mob_type);
		if (typ>=0){
				hit=get_mob_stat(i,mob_hit);
	//34829			
				
				
				//		if the mob has been hit by a weapon, then force it to reel back
				//		instead of normal animation.
			
				
				
				
				if ((hit>=0) && (typ!=pede_body))	{	gfx_reel_back(i); }//if(hit>4){goto end;}}
				// if the mob has a stunned status >0, then make sure it doesnt move.
				if (get_mob_stat(i,mob_stunned)>0){mod_mob(i,mob_stunned,-1,FALSE);
				DrawImage(MOB, get_mob_stat(i,mob_sprite_id), get_mob_stat(i,mob_x), get_mob_stat(i,mob_y), i, TRUE,0);
				
				goto end;}
							
		//		else {			
							
				switch (typ)
				{
					case chicken:// dog and chicken in same routine.
						case dog:	animate_chicken(i);										break;
					case digger: mod_digger(i);	animate_generic1(i); 	break;
					case evil_eye: animate_evil_eye(i);      					break;
					case pede_head:	 i=pede_header(i);								break;
					case circle_eye:  break;
					case spider: animate_spider(i);									break;
					case crab: mod_crab(i);// no break, so it will continue to default.
						default:	animate_generic1(i);									break;
				}// end switch
				
				
					mob_attack(i);

					mod_mob(i,mob_frame,1,FALSE);// increase the frame of the mob.

		}// end if mob_type>=0
		end:
		i++;
	}// end while i
	
				
}// end animate mob*/


void gfx_reel_back(int who)
{
/*
		
		reel back simply animates the player/mob after it gets hit.  it makes link go back 21 spaces
		while the mob goes back maybe 6, however this is called like 5 times for the mob, while it is
		called only once for the player.
*/
		int i=0,dir=0,amt=0, shield_used=0;//, dmg_type=0;// 28548 -> 28534
		int info=get_mob_stat(who,mob_hit);
		int ld=link_direction;// so i can restore link dir after i tinker with it.
		int move=link_direction;
	//	int mob=touch_mob(link_x, link_y, LINK);//touch_link();// having this here makes it 100 bytes less?
		int maxer=6;
		if a_player{
			if (link_stat(dual_state)==LINK_HOOKSHOT){return;}// this will make sure link reaches his destination
			// if hookshooting around.  but link will still take damage.  this is here to prevent errors in the water world
			info=1;move=link_direction=opposite_dir(link_direction);maxer=21;
			//if (obj_loc(HOOKSHOT)!=555){remove_hookshot();} - made this so it would delete the hookshot if link got hit
		}
		else if a_mob{
			if (get_mob_stat(who,mob_type)==pede_head){ mod_mob(who,mob_hit,-1,TRUE); info=0;}
		}// end else if a mob
		
		
		if (info>0)//mod_mob(count1,mob_pause,-3,TRUE);// and to force it to reel back < 0)
		{
				if a_mob {mod_mob(who,mob_hit,-1,FALSE);}// increase the pause by 1
				while (i<maxer){
						if (can_move(who,move)){
								if a_mob {
										switch (move)
										{
											case up: dir=mob_y;	amt=-1;	break;
											case down:	dir=mob_y; amt=1;	break;
											case left:	dir=mob_x; amt=-1; break;
											case right:	dir=mob_x; amt=1;	break;
										}// end switch
										if (!spinslash_active){mod_mob(who,dir,amt,FALSE);prevent_mob_oob(who);}}// this is a lot smaller than movemob?
								else if a_player {walking(LINK_NORMAL, 1);}
						}// end if can move
						else {i+=100;}// if the mob cant move, then get out of the loop
				//	if a_mob {if ((get_mob_stat(who,mob_hit)%2)==0){type=A_REVERSE;}else {type=A_NORMAL;}}
					//DrawImage(MOB, get_mob_stat(who,mob_current_sprite), get_mob_stat(who,mob_x), get_mob_stat(who,mob_y),type, TRUE);
					i++;
				}// end while i<10
			}// end if pause <0
			if a_mob{DrawImage(MOB, get_mob_stat(who,mob_current_sprite), get_mob_stat(who,mob_x), get_mob_stat(who,mob_y), who, TRUE,0);}
			else if a_player{link_direction=ld;DrawImage(LINK, link_picture, link_x, link_y, A_NORMAL, TRUE,0);}
		//	printf("hit=%i hp=%i",get_mob_stat(who,mob_hit),get_mob_stat(who,mob_hp));
		//	wait_for_key();
			//---------------------------------------------------------------------
			// Once mob recovers from the blow, make him explode if he dies.
			//---------------------------------------------------------------------
			if a_mob{
			shield_used=get_mob_stat(who,mob_shield);
			if ((shield_used==immortal) || (shield_used==death_by_fire)|| (shield_used==death_by_arrow)|| 
					(shield_used==death_by_bomb)|| (shield_used==immune_magic))
			 {mod_mob(who,mob_hit,-1,TRUE);}// this makes the mob
			// just reel back a little and not be harmed
				if (get_mob_stat(who,mob_hit) <= 0)// used to be zero.  adjust this lower if the mob is taking
				/// too much damage., b/c there is a bad part when a mob gets hit, it will be stunned so if you
				// can minister multiple hits to him, then he will permantly stay stunned.
				{
			//		printf("koko ");
				//	if ((get_item_info(link_stat(button_pressed), item_type)==sword) && (double_damamge==TRUE))
				//	{// if you are doing spinslash, you want to do double the damage to the creature, so
					//this routine will do double the damage
				//		item_damage=item_damage*2;
						//if (double_damamge==TRUE){pain(who,get_item_info(link_stat(button_pressed), item_damage) ,0,0 );}
				//	}
				/*	switch (get_item_info(link_stat(button_pressed), item_type))
					{
						case arrow:
						case arrow_ammo:  dmg_type=type_arrow; break;
						case wand: dmg_type=type_magic; break;
					}
				  sprintf(dbg,"%i %i %i", link_stat(button_pressed), get_item_info(link_stat(button_pressed), item_damage), dmg_type );debug();
					*/
					pain(who,get_item_info(link_stat(button_pressed), item_damage) ,0,double_damamge );
					if (get_mob_stat(who,mob_hit)<=0){mod_mob(who,mob_hit,-1,TRUE);}// make it so that mob hit
					// only gets adjusted in the event that the mob is not stunned.  this way, the mob will
					// not stay in perm_stun state.
				}// end if the mob hit==0
			}// end if a mob
	//	}//end if pause*/
}// end hit mob


