// C Source File
// Created 7/15/2011; 3:17:42 AM
/*******************************************************************************/
/* Zelda Crystal Engine                                                       */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
#include "all.h"
#include "dung_maps.h"
/*
			load the main inv[] into this area.  also put in the saving routines in this part, too.
			you will need to save the inv[], and the map[] (ie the arrays that tell you which maps you 
			have already completed.  maps should be a 4d array i think.  arr map[8][8][8][2]  []#1 is for
			the 8 differnt maps, []#2[]#3 is for the exact copy of the map.  [2]#4 is to let me know if
			i have entered the room or not and whether it should be displayed or not.  if i have enetered
			into the room, then it would be {1,1}.  if not, then it would be {0,0} (do not disp room).  
			if i have the map, but have not entered the room, then it will be {0,1} (disp room as lighter 
			color);

			hmmm - the 4d map arr is about 1k in size... i think.  - actually, based upon other calcs, 
			it might end up being 2k in size....  you might have to split this up into an eight 8x8x2 arrs.
			
			
			
inv array: - inv[11][30]

	[0]	link - hp, mhp, *mana, *max_mana, rupies, max rupies, item a, item b, *item c, *item d,  
						worn a, worn b, worn c, worn d,max bombs, max arrows, map id#, map x, map y, 
						room x, room y, heart container 1/4th pieces gotten**.
	[1]	inventory 30 items (id#'s)
	[2]	inventory 30 items (# of those items for like bombs and arrows) (this is here for cross
												compatibility for afw 3.0)
		
	[3]	link- stat set 2 - x/y coords, name?, etc.
	[4?]	level info: 0>9 (maps)***, 10>19 (compasses)***, 20>29 (triforce/ dungeon complete)***
		- #4 is under quest_loc() in items.c (bottom) (quests_exists() - ezelda
	[5]	sl marker 30 places
	[6]	sl marker 30 places - set 2
	[7]????
	[8]	trasure box set 1
	[9]	trasure box set 2
	[10]	trasure box set 3  - total of 90 treasure boxes...
		
so... inv[9][30]  maybe inv[10][30] for that one last thing i forgot about.  ok. for now it will
be inv[10][30] and if i dont need #10, then i will delete it out in the final product.



* these items are note really needed, but are here for expandability. 
** - this will hold how many heart pieces you have already gotten and once it hits 4 then you get
			a new heart added (8 hp)
*** the maps, compasses and triforces will simply have the number corresponding to them.  for 
		example, if you get the map for dungeon 5, then a 5 will be placed into that section. the
		scanner will scan through that section to find out if you have the map for that dungeon or not.
		use a dungeon_stat_exists(map,5) or dungeon_stat_exists(compass,5)
(item x) - is for what item you are holding, so when you press that button, then you use it.
(room id# not needed - the room id will be gottem from the mapx mapy.)
*/

//int inv[inv_rows][inv_cols];
//int inv[11][30];// about 600 bytes.
int mapped_areas[8][8][8][2];//2k...
extern int current_game;
extern int link_x,link_y;

//=================================================================================================

void set_link_save_info(){
		mod_link(save_map_x, g_over_world_stat(overworld_rmapx_start, oob()),TRUE);
		mod_link(save_map_y, g_over_world_stat(overworld_rmapy_start, oob()),TRUE);
		mod_link(save_ow_id, g_over_world_stat(overworld_start_world_map, oob()),TRUE);// force it to always grab from the map
		// on where to save
		//mod_link(save_ow_id, link_stat(ow_id),TRUE);
		//mod_link(save_world_map, g_over_world_stat(overworld_start_world_map, oob()),TRUE); // set so i can load it during the save
		//mod_link(save_rset_id, g_over_world_stat(overworld_rset_start, oob()),TRUE); - this seems to be depreciated
		mod_link(save_world_map, g_over_world_stat(overworld_rset_start, oob()),TRUE);
		mod_link(save_x, g_over_world_stat(overworld_link_xpos_start, oob()),TRUE);
		mod_link(save_y, g_over_world_stat(overworld_link_ypos_start, oob()),TRUE);	
}//set_link_save_info()


//=================================================================================================


void save()// int fle
{
		int fle=current_game;
    int tmp[inv_rows][inv_cols];
//    mod_stuff(loc_x, xpos, TRUE);
//    mod_stuff(loc_y, ypos, TRUE);
//    mod_stuff(world_map, map, TRUE);
/*
*/
//=================================================================================================
/*
		the below code sets up the starting point where link will load from in the event that you
		continue.  this will prevent annoyances, like saving in the middle of the dungeon and having 
		it reload all mobs on you when you continue.  instead, you can start from the beginning of
		the dungeon instead and if you want to go through it again, then do so, if not, then dont
		worry about it and leave safely.
		
		see the below info for more on the stats and what they do:
		
		
[9][5] = link_x
[9][6]= link_y
[10][5] = beginning_warp_rmapx
[10][6]= beginning_warp_rmapy
[10][7]= set world - leave as 0 if you want it to stay default.
					otherwise you could force an override and make the 
					continueing link start elseware.		
*/
   	/*
   	
   	#define overworld_gfx_file 0
		#define overworld_dungeon_num 1
		#define overworld_mob_stat_list 2
		#define overworld_mob_gfx_file 3

		#define overworld_repop 10
		#define overworld_rset_start 11
		#define overworld_rmapx_start 12
		#define overworld_rmapy_start 13
		
		#define overworld_link_xpos_start 20
		#define overworld_link_ypos_start 21
		
		#define overworld_map_nums 20 // where all the map numbers are stored
   	*/

//=================================================================================================					

/*
		when loading from a save, do the following:
		get from the link_stats:
		load_ow_map(link_stat(save_ow_id));
		search for save_rset_id.  when you find it, xpos and ypos into link_stat(ow_x/y)
		if it does not exist, then error out and display (corrupt save file)
		if it does exist, 
		thebn set link map_x/y
		then world_init() (which sould have oob in it.)
		then load_rset(link_stat(save_rset_id))
		then set linkx/y
		
*/
	//printf("%i", g_over_world_stat(overworld_start_world_map, oob())); wait_for_key(esc_ko);
	if (g_over_world_stat(overworld_start_world_map, oob())!=999){
	set_link_save_info();
	save_link_config();
	}
//	printf("%i, %i %i, %i",link_stat(save_x),link_stat(save_y), g_world(9,5),g_world(9,6));wait_for_key(b_ko);
//wait_for_key(esc_ko);


/*	
TRY
if (FolderFind(SYMSTR ("saves"))==NOT_FOUND)	{FolderAdd (SYMSTR ("saves"));}
ONERR
ENDTRY
*/

 TRY   
    FILE *f = NULL;
     int yn = TRUE;
	char sav[5], sav2[20];
   // case save temp
    // open file for writing
    sprintf(sav,"zsv%i",fle);	
    sprintf(sav2,"zsv%i\\ZSAV%i",fle,fle);
    FolderCur(SYMSTR(sav),TRUE);
    sprintf(sav,"ZSAV%i",fle);
//    sprintf(sav2,"main\\SAV%i.AFW",fle);
    HSym sym = SymFind (SYMSTR (sav));
    TRY
    	/*
    			HSym sym= SymFind (SYMSTR ("world"));// find the variable
		if (sym.folder){SymDel(SYMSTR ("world"));}// if it exists, delete it
    	*/

    if (sym.folder){cmd_unarchiv(SYMSTR(sav));}// unarchive the save
    ONERR
    ENDTRY	
    int x=0,y=0;
    for (x=0;x<inv_rows;x++){ for (y=0;y<inv_cols;y++){tmp[x][y]=g_inv(x,y);}}
    
    if ((f = fopen(sav,"wb")) == NULL) {// write into temp - use the file saving routine for the
    // saving of the real file.  for everything else, use the temp file
        yn = FALSE;
    } else {
        // write inv data to the file
        if (fwrite(tmp,sizeof(tmp),1,f) != 1) {
            yn = FALSE;
        }
      
        // append the file ID tag
        // it is type AFW.  ie my game
        fputc(0,f);
        fputs("ZLD",f);
        fputc(0,f);
        fputc(OTH_TAG,f);

        // close the file
        fclose(f);
    }	
    save_dung_map(g_over_world_stat(overworld_dungeon_num, oob()));// save the current dungeon map as well.
    if (yn){msg(1,8,TRUE,message);cmd_archive(SYMSTR(sav2));}// if saved, then display saved,
    // rearchive the save file so if the game crashes, they wont lose thier save.
		else {msg(1,9,TRUE,message);}// else display not saved
ONERR
ENDTRY		
}// end save3

//===========================================================================

 int get_inv(int fle) {
   int yn = TRUE;
 int tmp[inv_rows][inv_cols];
 int x=0,y=0;
  TRY
    FILE *f = NULL;
    
		char sav[5];
   // case save temp
    // open file for writing
    sprintf(sav,"zsv%i",fle);			
    FolderCur(SYMSTR(sav),TRUE);
    sprintf(sav,"ZSAV%i",fle);
    // open file for reading in binary mode
   //HSym sym = SymFind (SYMSTR (sav));
 //  HSym sym = SymFind (SYMSTR (sav));
    
    	
//    			HSym sym= SymFind (SYMSTR ("world"));// find the variable
	//	if (!sym.folder){return FALSE;}// failsafe for 
    	

   // if (sym.folder){}// unarchive the save
   // else {return FALSE;}// failsafe for the main screen.
    if ((f = fopen(sav,"rb")) == NULL) { // this opens up the temp inventory
        yn = FALSE;
    } else {
        // read data from file into inv
        if (fread(tmp,sizeof(tmp),1,f) != 1) {
             yn = FALSE;
        }
			  else
        {
        	for (x=0;x<inv_rows;x++){ for (y=0;y<inv_cols;y++){s_inv(x,y,tmp[x][y]);}}
        }
       // close the file
        fclose(f);
    }
		
	//	xpos=stuff_info(loc_x);
	//	ypos=stuff_info(loc_y);
	//	map=stuff_info(world_map);
	ONERR
	yn = FALSE;
	ENDTRY
	
	if (yn){


	current_game=fle;// this will set the current game to the current save.
/*
		the new saves had to be created b/c originally it directly modified map_x and y
		but this put you back at the beginning screen, which is annoying, b/c when you
		saved normally, it would put you back at the start.  now it just modifies another section
		and leaves the map_x and y alone, so you can save and not be magically teleported back
		to the start screen.
		
		however, this could be troublesome, b/c it would allow you to go into a dungeon 
		and get an item and use the save/exit to teleport back to the beginning.  you could
		force a no_save stat onto the dungeon rooms to prevent saving in those rooms.

*/

	}
	
	FolderCur(SYMSTR("main"),TRUE);
    return yn;
}



//=================================================================================================


