// C Source File
// Created 7/15/2011; 3:31:25 AM
/*******************************************************************************/
/* Zelda Crystal Engine                                                       */
/* -------------------------------------------                                 */
/* By: Kyle ingalsbe                                                           */
/*                                                                             */
/* Email: kyle_ingalsbe@yahoo.com                                              */
/*                                                                             */
/*******************************************************************************/
#include <tigcclib.h>
/*

		this will have all of the actions of the weapons.  i believe you will load the wepaon gfx
		into this area as well, or maybe they will be included in a different file.  undecided at
		this point and time.

*/
#include "all.h"
extern int sword_charge,spinslash_active ,button_pressed,link_frame2;
extern int link_frame, link_x, link_y, link_direction, link_picture, dark_room;
void item_sword()
{
					//sword_charge=0;
					if ((link_stat(dual_state) != LINK_THRUST) &&(link_stat(dual_state) != LINK_WALKING_SWORD))
					{link_frame = 0;mod_link(dual_state,LINK_THRUST, TRUE);sword_charge=0;spinslash_active=FALSE;}
}// end use sword.

//=================================================================================================


void use_boomerang(int item)
{
	
	
	int id=0;//get_item_info(item, item_id);
	//int x = fix_xy(link_x, 1);
//	int y=fix_xy(link_y,2);
//	if (y<2){y=2;}// this will allow link to throw the boomerang when at the very top of the screen.
	if (obj_loc(BOOMERANG)==555){id=add_object(BOOMERANG, fix_xy(link_x, 1), fix_xy(link_y,2), item);
//	id =obj_loc(BOOMERANG);
		if (id==555){return;}
		set_object(id, obj_dir, link_direction);// these set up the objects
		set_object(id, obj_var1, 0);
		set_object(id, obj_var2, 0);
		set_object(id, obj_dam, get_item_info(item, item_damage));
	//set_object(id, int stat, int num)
	link_frame = 0;mod_link(dual_state,LINK_GENERIC_ITEM, TRUE);
	}
}

//=================================================================================================

void item_shield()
{// this will attempt to use the shield.
	link_frame = 0;
	mod_link(dual_state,LINK_SHIELD, TRUE);
//	link_picture=8;//walking(8, link_speed);// requires #7 in the gfx 
}

//=================================================================================================

void use_wand()// #7 in gfx
{

	link_frame = 0;mod_link(dual_state,LINK_WAND, TRUE);
	sword_charge=0;spinslash_active=FALSE;
}// end wand

//=================================================================================================

void use_bottle(int item)
{

	if (link_stat(hp) < link_stat(max_hp)){
	switch (link_stat(button_pressed+18))
	{
		case 0: return;	break;
		case 1:
		case 2:
		//	md_link(button_pressed+18,-1,FALSE);
			add_item_inv(item, -1, FALSE);
		break;
		case 3:
		//	md_link(button_pressed+18,-3,FALSE);
			use_faerie(item);
			return;
		break;
		default: return; break;
	}// end switch
		mod_link(hp,512, TRUE);// max his hp
		}// end if hp < max
}
//=================================================================================================

void use_faerie(int item)
{
	add_item_inv(item, -4, FALSE);
	add_object(item_faerie, link_x, link_y, item_faerie);// add a faerie to links location
}

//=================================================================================================

void use_light_orb(int item)
{// the light orb will change a room from dark to light, but it is a one shot item.
	if (link_stat(button_pressed+18)>0){// if you have more than zero items...
			if (dark_room==TRUE){dark_room=FALSE; add_item_inv(item, -1, FALSE);}
			//else {msg(1, 13, TRUE, message);}// show that the room is already lit
		}
}// end light orb

//=================================================================================================

void item_arrow(int item)
{
	
	
	int id=0;//get_item_info(item, item_id);
	if (link_stat(button_pressed+18)>0){
	id=add_object(ARROW, fix_xy(link_x, 1), fix_xy(link_y,2), item);
	if (id==555){return;}// if you do not add the object then do nothing.
//	id =obj_loc(BOOMERANG);
		set_object(id, obj_dir, link_direction);// these set up the objects
		set_object(id, obj_type, arrow);
		set_object(id, obj_var2, get_item_info(item,item_pic_2));
		set_object(id, obj_dam, get_item_info(item, item_damage));
	//set_object(id, int stat, int num)

	add_item_inv(item, -1, FALSE);// remove the arrows from the inventory.
	}// end if you have the arrows to do it.
		link_frame = 0;mod_link(dual_state,LINK_GENERIC_ITEM, TRUE);
	//}
}

//=================================================================================================
int bomb_dir_modder(int a)
{// this fixes the wierd offset for the bombs.
	int q=dir_to_sprite_xy_modder(link_direction, a, 6);
	if ((link_direction==up && a==2) || (link_direction==left && a==1)){q-=8;}
	return q;
}// end bomb dir modder

void use_bomb(int item)
{
	
	//	int x = fix_xy(link_x, 1);
	//int y=fix_xy(link_y,2);
	int id=0;//get_item_info(item, item_id);
	if (link_stat(button_pressed+18)>0){
	id=add_object(item,fix_xy(link_x+bomb_dir_modder(1), 1), fix_xy(link_y+bomb_dir_modder(2),2), item);
	if (id==555){return;}
		set_object(id, obj_var1, 0);
		set_object(id, obj_var2, 0);
		set_object(id, obj_dam, get_item_info(item, item_damage));
		set_object(id, obj_type,boom_bomb);// now the bomb will go boom
	link_frame = 0;mod_link(dual_state,LINK_GENERIC_ITEM, TRUE);
		add_item_inv(item, -1, FALSE);// remove the arrows from the inventory.
	}
}


//=================================================================================================

void use_hookshot(int item)
{
	
	
	int id=0;//get_item_info(item, item_id);
//	int x = fix_xy(link_x, 1);
//	int y=fix_xy(link_y,2);
	if (obj_loc(HOOKSHOT)==555){
//printf_xy(0,50,"new hs");		
	
	id=add_object(HOOKSHOT, fix_xy(link_x, 1), fix_xy(link_y,2), item);
	if (id==555){return;}
//	id =obj_loc(BOOMERANG);
		set_object(id, obj_dir, link_direction);// these set up the objects
		set_object(id, obj_type, hookshot);
			set_object(id, obj_var1, 0);// this will be used to tell whether the hookshot is returnint or not
		set_object(id, obj_var2, get_item_info(item,item_pic_2));
		set_object(id, obj_dam, get_item_info(item, item_damage));
	//set_object(id, int stat, int num)

//	add_item_inv(item, -1, FALSE);// remove the arrows from the inventory.
	}// end if you have the arrows to do it.
		link_frame = 0;mod_link(dual_state,LINK_GENERIC_ITEM, TRUE);
	//}
}

//=================================================================================================

